Package: CollocInfer
Version: 1.0.5
Date: 2024-11-04
Title: Collocation Inference for Dynamic Systems
Authors@R: c(person(given="Giles",family="Hooker",email="ghooker@wharton.upenn.edu",role=c("aut","cre")),
         person(given="Luo",family="Xiao",email="lxiao5@ncsu.edu",role="aut"),
         person(given="James",family="Ramsay",email="ramsay@psych.mcgill.ca", role="ctb"))
Maintainer: Giles Hooker <ghooker@wharton.upenn.edu>
Depends: R (>= 4.3.0), fda
Imports: MASS, Matrix, spam, deSolve, methods
Suggests: pomp, SparseM, subplex, trust, maxLik
Description: These functions implement collocation-inference
    for continuous-time and discrete-time stochastic processes.
    They provide model-based smoothing, gradient-matching,
    generalized profiling and forwards prediction error methods.
License: GPL (>= 2)
URL: http://www.gileshooker.com
LazyData: true
NeedsCompilation: no
Packaged: 2024-11-05 04:08:20 UTC; giles
Author: Giles Hooker [aut, cre],
  Luo Xiao [aut],
  James Ramsay [ctb]
Repository: CRAN
Date/Publication: 2024-11-05 08:50:01 UTC
Built: R 4.6.0; ; 2026-04-30 09:13:54 UTC; unix

import("Matrix","MASS")
importFrom("fda",is.basis,eval.basis,fd,is.fd,eval.fd)
importFrom("spam",is.spam,spam)
importFrom("deSolve",lsoda)
importFrom("methods","is")
importFrom("grDevices", "dev.new")
importFrom("graphics", "abline", "legend", "par","matplot")
importFrom("stats", "nlminb", "nls", "optim", "time")
importFrom("utils", "read.table", "write.table")
exportPattern("^[^\\.]")

############ squared measurement error ##############

#  This file defines functions for evaluating the total SSE for data 
#  and its derivative values:

#    fn      = SSE
#    dfdx    = dSSE.dx
#    dfdy    = dSSE.dy
#    dfdp    = dSSE.dp
#    d2fdx2  = d2SSE.dx2
#    d2fdxdy = d2SSE.dxdy
#    d2fdy2  = d2SSE.dy2
#    d2fdxdp = d2SSE.dxdp
#    d2fdydp = d2SSE.dydp

# as well as function checkweights

################################################################################

make.SSElik <- function()
{

  ##############################################################################

  SSE <- function(data,times,devals,pars,more)
  {
    #  Define the values of the process at observation times
    fdevals = more$fn(times,devals,pars,more$more)
    difs    = data - fdevals
    #  if process is unobserved, data[i] is NaN, and so is difs[i]
    difs[is.na(difs)] = 0    
    #  define weights   
    weights = checkweights(more$weights,more$whichobs,difs)
    #  compute total weighted error sum of squares
    f = apply( weights*difs^2, 1, sum )
    return(f)
  }

  ##############################################################################

  dSSE.dx <- function(data,times,devals,pars,more)
  {
    fdevals = more$fn(times,devals,pars,more$more)
    difs    = data-fdevals
    difs[is.na(difs)] = 0       
    weights = checkweights(more$weights,more$whichobs,difs)
    difs = weights*difs
    dfdx = more$dfdx(times,devals,pars,more$more)    
    g = c()
    for(i in 1:dim(dfdx)[3]){               
        g = cbind(g,apply(difs*dfdx[,,i],1,sum))
    }   
    return(-2*g)
  }

  ##############################################################################

  dSSE.dy <- function(data,times,devals,pars,more)
  {
    fdevals = more$fn(times,devals,pars,more$more)
    difs    = data-fdevals
    difs[is.na(difs)] = 0
    weights = checkweights(more$weights,more$whichobs,difs)
    difs    = weights*difs
    return(2*difs)
  }

  ##############################################################################

  dSSE.dp <- function(data,times,devals,pars,more)
  {
    fdevals = more$fn(times,devals,pars,more$more)
    difs    = data-fdevals
    difs[is.na(difs)] = 0
    weights = checkweights(more$weights,more$whichobs,difs)
    difs    = weights*difs
    dfdp = more$dfdp(times,devals,pars,more$more)
    g = c()
    for(i in 1:dim(dfdp)[3]){           
        g  = cbind(g,apply(difs*dfdp[,,i],1,sum))
    }   
    return(-2*g)
  }

  ##############################################################################

  d2SSE.dx2 <- function(data,times,devals,pars,more)
  {
    fdevals = more$fn(times,devals,pars,more$more)
    difs    = data-fdevals
    dfdx    = more$dfdx(times,devals,pars,more$more)
    d2fdx2  = more$d2fdx2(times,devals,pars,more$more)   
    difs[is.na(difs)] = 0
    weights = checkweights(more$weights,more$whichobs,difs)
    difs   = weights*difs
    H = array(0,c(dim(devals),dim(devals)[2]))
    for(i in 1:dim(d2fdx2)[3]){
        for(j in 1:dim(d2fdx2)[4]){
            H[,i,j] = apply(-difs*d2fdx2[,,i,j] +  weights*dfdx[,,j]*dfdx[,,i],1,sum)
       }
    }

    return(2*H)
  }

  ##############################################################################

  d2SSE.dxdy <- function(data,times,devals,pars,more)
  {
    dfdx   = more$dfdx(times,devals,pars,more$more)
    weights = checkweights(more$weights,more$whichobs,dfdx[,,1])
    weights[is.na(data)] = 0    
    for(i in 1:dim(dfdx)[3]){
        dfdx[,,i] = weights*dfdx[,,i]
    }    
    return(-2*aperm(dfdx,c(1,3,2)))    
  }

  ##############################################################################

  d2SSE.dy2 <- function(data,times,devals,pars,more)
  {
    r = array(0,c(dim(data),dim(data)[2]))    
    ind = cbind(rep(1:dim(data)[1],dim(data)[2]),
        kronecker(cbind(1:dim(data)[2],1:dim(data)[2]),rep(1,dim(data)[1])))
    weights = checkweights(more$weights,more$whichobs,data)
    r[ind]  = weights
    return(2*r)
  }

  ##############################################################################

  d2SSE.dxdp <- function(data,times,devals,pars,more)
  {
    fdevals = more$fn(times,devals,pars,more$more)
    difs = data-fdevals
    difs[is.na(difs)] = 0   
    weights = checkweights(more$weights,more$whichobs,difs)
    difs = weights*difs
    dfdx = more$dfdx(times,devals,pars,more$more)
    dfdp = more$dfdp(times,devals,pars,more$more)
    d2fdxdp = more$d2fdxdp(times,devals,pars,more$more) 
    H = array(0,c(dim(devals),length(pars)))
    for(i in 1:dim(d2fdxdp)[3]){
        for(j in 1:dim(d2fdxdp)[4]){
            H[,i,j] = apply(-difs*d2fdxdp[,,i,j] + weights*dfdx[,,i]*dfdp[,,j],1,sum)
       }
    }
    return(2*H)
  }

  ##############################################################################

  d2SSE.dydp <- function(data,times,devals,pars,more)
  {
    dfdp = more$dfdp(times,devals,pars,more$more)
    weights = checkweights(more$weights,more$whichobs,dfdp[,,1])
    weights[is.na(data)] = 0
    for(i in 1:dim(dfdp)[3]){
        dfdp[,,i] = weights*dfdp[,,i]
    }
    return(-2*dfdp)
  }

  ##############################################################################

  return(
        list(
            fn      = SSE,
            dfdx    = dSSE.dx,
            dfdy    = dSSE.dy,
            dfdp    = dSSE.dp,
            d2fdx2  = d2SSE.dx2,
            d2fdxdy = d2SSE.dxdy,
            d2fdy2  = d2SSE.dy2,
            d2fdxdp = d2SSE.dxdp,
            d2fdydp = d2SSE.dydp
        )
  )
}
 
################################################################################

checkweights <- function(weights,whichrows,diffs){
  if(is.null(whichrows)){ whichrows = 1:nrow(diffs) }
  
  if(is.null(weights)){ return(matrix(1,dim(diffs))) }
  else if( length(weights) == ncol(diffs)){ return( matrix(weights,nrow(diffs),ncol(diffs),byrow=TRUE)) }
  else if( length(weights[whichrows]) == nrow(diffs)){ return( matrix(weights,nrow(diffs),ncol(diffs),byrow=FALSE)) }
  else if( prod( dim(weights[whichrows,]) == dim(diffs)) ){ return(weights[whichrows,]) }
  else if( ncol(weights[whichrows,]) > ncol(diffs) & nrow(weights) > nrow(diffs) ){
    warning('Dimension of weights does not match that of data')
    return( weights[whichrows[1:nrow(diffs)],1:ncol(diffs)] )
  }
  else{
     stop('Dimension of weights does not match that of data')
  }

}              

# An example file fitting the FitzHugh-Nagumo equations to data in the
# new R Profiling Code. This will eventually be interfaced with the new R 
# "Partially Observed Markov Process (pomp)" class of objects. 

library(fda)
library(odesolve)
library(maxLik)
library(MASS)
library('Matrix')
library('SparseM')

source('../R/ProfileR.R')
source('../R/fhn.R')
source('exp2fhn.R')
source('../R/findif.ode.R')
source('../R/SSElik.R')
source('../R/SSEproc.R')
source('../R/makeid.R')
source('../R/genlin.R')
source('../R/cvar.R')
source('../R/Multinorm.R')
source('../R/Cproc.R')
source('../R/exp.Cproc.R')
source('../R/multinorm.shortcut.R')
source('../R/sse.shortcut.R')
source('../R/inneropt.R')
source('../R/makeexp.R')
source('../R/logtrans.R')

###############################
####   Data Generation  #######
###############################

t = seq(0,20,0.05)

pars = c(0.2,0.2,3)
names(pars) = c('a','b','c')
x0 = c(-1,1)
names(x0) = c('V','R')
fhn = make.fhn()
y = lsoda(x0,times=t,func=fhn$fn.ode,pars)
y = y[,2:3]

data = exp(y) + 0.05*array(rnorm(802),dim(y))


###############################
####  Basis Object      #######
###############################

knots = seq(0,20,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)


# Initial values for coefficients will be obtained by smoothing

fd.data = array(log(data),c(dim(data)[1],1,dim(data)[2]))

DEfd = data2fd(fd.data,t,bbasis,fdnames=list(NULL,NULL,c('V','R')) )

coefs = matrix(as.vector(DEfd$coefs),dim(DEfd$coefs)[1],dim(DEfd$coefs)[3])
colnames(coefs) = DEfd$fdnames[[3]]

###############################
####  Optimization Control  ###
###############################


control=list()                # Control parameters 
control$trace = 0
control$maxit = 1000
control$maxtry = 10
control$reltol = 1e-6
control$meth = "BFGS"

control.in = control
control.in$reltol = 1e-12
control.out = control
control.out$trace = 2

control.in$print.level = 0
control.in$iterlim = 1000



###############################
####     Optimization       ###
###############################

spars = c(0.2,0.2,2)          # Perturbed parameters
names(spars)=names(pars)
lambda = 10000

### SSE ####

res1 = Profile.sse(make.exp2fhn(),data,t,pars=spars,coefs,bbasis,lambda=lambda,in.meth='nlminb',out.meth='nls',
	control.in=control.in,control.out=control.out,pos=1,discrete=0)
	
### SSE with ProfileErr ###
profile.obj = sse.setup(pars=spars,coefs=coefs,fn=make.exp2fhn(),basisvals=bbasis,lambda=lambda,times=t,pos=1,discrete=0)
lik = profile.obj$lik
proc= profile.obj$proc

#res0 = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
#	control=control.out,times=t,data=data,lik=lik,proc=proc,pars=spars)
#
#ncoefs = array(res0$par,c(bbasis$nbasis,ncol(data)))
#
#res2 = optim(spars,ProfileErr,allpars=spars,times=t,data=data,coef=ncoefs,lik=lik,proc=proc,hessian=T,
#	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP,method="BFGS")
#
#res3 = nlminb(spars,ProfileErr,allpars=spars,times=t,data=data,coef=ncoefs,lik=lik,proc=proc,
#	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP)
#

Ires2 = inneropt(data,times=t,pars,coefs,lik,proc,in.meth='nlminb',control.in)

Ores2 = outeropt(data=data,times=t,pars=pars,coefs=coefs,lik=lik,proc=proc,in.meth="nlminb",out.meth="nlminb",
    control.in=control.in,control.out=control.out)




### Multinorm ####


var = c(1,0.01)
res4 = Profile.multinorm(make.exp2fhn(),data,t,pars=spars,coefs,bbasis,var=var, out.meth='BFGS', in.meth='nlminb',control.in=control.in,control.out=control.out,pos=1)

## Example Diagnostics -- Learning the FitzHugh-Nagumo Equations
#
# Demonstration estimation of function functions. This also provides
# a template for random-effects treatment within profiling.

library(fda)
library(odesolve)
library(MASS)
library('CollocInfer')

source('../Devel/Diagnostics.R')

# First Create Some Data

t = seq(0,20,0.05)

pars = c(0.2,0.2,3)
names(pars) = c('a','b','c')

x0 = c(-1,1)
names(x0)= c('V','R')
y = lsoda(x0,t,make.fhn()$fn.ode,pars)
y = y[,2:3]

data = y + 0.2*matrix(rnorm(802),401,2)

# Now a basis object

knots = seq(0,20,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)


# Initial values for coefficients will be obtained by smoothing

DEfd = data2fd(data,t,bbasis)
coefs = DEfd$coefs

names(coefs) = c('V','R')

# Usual meta-parameters; quadrature points, weights and knots

lambda = c(100,100)
qpts = knots
qwts = rep(1/length(knots),length(knots))

qwts = qwts%*%t(lambda)
weights = array(1,dim(data))


# Now I define a measurement process log likelihood along with some
# additional features: in this case it's squared error. 

varnames = c('V','R')
parnames = c('a','b','c')


likmore = make.id()
likmore$weights = weights

lik = make.SSElik()
lik$more = likmore
lik$bvals = eval.basis(t,bbasis)


# Proc is a process log likelihood -- in this case treated as squared
# discrepancy from the ODE definition. 

procmore = make.genlin()
procmore$names = varnames
procmore$parnames = parnames
procmore$more = list(mat=matrix(0,2,2),sub= matrix(c(1,1,1,1,2,2,2,1,3,2,2,4),4,3,byrow=TRUE))


procmore$weights = qwts
procmore$qpts = qpts


proc = make.SSEproc()
proc$more = procmore
proc$bvals = list(bvals=eval.basis(procmore$qpts,bbasis,0),
		dbvals = eval.basis(procmore$qpts,bbasis,1))



spars = c(0,1,-1,0)

Ires = inneropt(data,times=t,spars,coefs,lik,proc,in.meth='nlminb')

Ores = outeropt(data=data,times=t,pars=spars,coefs=Ires$coefs,lik=lik,proc=proc,
  in.meth="nlminb",out.meth="nlminb")



traj = as.matrix(proc$bvals$bvals %*% Ores$coefs)
dtraj = as.matrix(proc$bvals$dbvals %*% Ores$coefs)
ftraj = dtraj - proc$more$fn(proc$more$qpts,dtraj,Ores$pars,proc$more$more)



par(mfrow=c(2,2))
for(i in 1:2){
  for(j in 1:2){
    plot(traj[,i],ftraj[,j],type='l')
  }
}




## Now we estimate some forcing functions

fbasis = create.bspline.basis(range=range,nbasis=23,norder=4)


dproc = make.SSEproc()
dproc$more = make.diagnostics()
dproc$more$qpts = procmore$qpts
dproc$more$weights = procmore$weights
dproc$more$more = procmore
dproc$more$more$p = Ores$pars
dproc$more$more$which = 1:2
dproc$more$more$psi = eval.basis(procmore$qpts,fbasis)
dproc$bvals = list(bvals=eval.basis(procmore$qpts,bbasis,0),
		dbvals = eval.basis(procmore$qpts,bbasis,1))


dpars = rep(0,2*fbasis$nbasis)  
  
dOres = outeropt(data=data,times=t,pars=dpars,coefs=Ires$coefs,lik=lik,proc=dproc,
  in.meth="nlminb",out.meth="nlminb")  


# Trajectories

force = dproc$more$more$psi %*% matrix(dOres$par,fbasis$nbasis,2)
traj = dproc$bvals$bvals %*% dOres$coefs

plot(traj[,1],force[,1],type='l')

## Groundwater level measurements as a function of rainfall.  
#
# The data were collected in North Vancouver near a site of a 
# mud slide that caused two fatalities in 2004.
#
# The groundwater levels are a relatively smooth process with a
# rather high signal to noise ratio.  Rainfall events, however,
# are sporadic and can be considered as events with times and 
# intensities, called a marked point process in statistical theory.
#
# Groundwater level is modeled by a first order linear differential
# equation forced by rainfall.
#
# A constant coefficient version of the equation is
# 
# $$\dot{G}(t) = - \beta G(t) + \alpha R(t - \delta) + \mu$$
#
# and a variable coefficient version is
#
# $$\dot{G}(t) = - \beta(t) G(t) + \alpha(t) R(t - \delta) + \mu(t)$$
#
# Coefficient \beta controls the speed of the response
# of groundwater to a rainfall event.  
#
# Coefficient \alpha controls the size of the response
# of groundwater to a rainfall event.   The gain in the system
# is defined as K = \alpha / \beta.
#
# Constant \mu is an adjustment to the overall level of
# groundwater required because the origin of the measurements
# can be viewed as arbitrary or irrelevant.
#
# Lag constant \delta allows a time lapse before groundwater
# begins to respond to a rainfall event.  It was estimated by
# inspecting plots to be three hours for the purposes of these
# analyses, and is therefore not actually estimated by these
# analyses themselves.
#
# The following code allows for each of the remaining three
# parameters to be either constant, or themselves functions 
# of time.  That is,
#
# Although the constant model does a fair job of 
# describing the data, allowing for a mild time-variation in
# these parameters substantially improved the fit.  We used
# five order 4 B-splines to model this time dependency.  
#
# Last modified 26 April 2010
#
## Setting up the data 
#

# The analyses requires access to the profiled estimation software.

library("CollocInfer")

# Input the data to be analyzed.

#load("groundwater")
#load("rainfall")

#  rainfall should be lagged by about three hours

#Ninput = length(rainfall)
#lag    = 3
#rainfall = c(rep(0,2*lag), rainfall[1:(Ninput-2*lag)])

#  a subset of the data are selected, running from day 79 into day 92
#  if all the data are used, R has to allocate additional storage

# index = 1597:3024  
#index = 1907:2221  #  here we select a smaller set of data 
#yobs = as.matrix(groundwater[index])
#zobs = as.matrix(rainfall[index])
#N = length(yobs)
#tobs = (index - index[1])


data(NSdata)

yobs = NSgroundwater
zobs = NSrainfall
tobs = NStimes

N    = length(tobs)
rangeval = c(0,N-1)



#  plot the groundwater data

par(mfrow = c(2,1))
plot(tobs, yobs, "p",  xlab="Time (hours)", 
                       ylab="Groundwater level (metres)")
plot(tobs, zobs, "p",  xlab="Time (hours)", 
                       ylab="Hourly rainfall (millimetres)")

#  set up cumulative rainfall

#  Set up a basis for rainfall itself: 
#     An order 1 or piece-wise constant spline

norder = 1
nbasis = N + norder - 2
rainbasis  = create.bspline.basis(rangeval, nbasis, norder)
rainfd = smooth.basis(tobs, zobs, rainbasis)$fd

#  plot the data

plotfit.fd(zobs, tobs, rainfd, nfine=N)

## The basis for representing groundwater: G(t)

# Define the knot sequence.  A knot is placed at each mid-hour
# point, giving maximum capacity to fit the data.  Variable
# rangeval is a vector of length 2 containing the lower and
# upper time limits of the observations, and is in file 
# NorthShoreData.mat


knots  = c(rangeval[1],
           seq(rangeval[1]+0.5, rangeval[2]-0.5, len=N-1), 
           rangeval[2])
norder   = 3
nbasis   = length(knots) + norder - 2
basisobj = create.bspline.basis(rangeval, nbasis, norder, knots)
 
# The constant coefficient basis is required for constant beta and alpha.  

conbasis = create.constant.basis(rangeval)

## Definition of functional basis objects for the coefficient functions

# Set up the basis for the coefficient function \beta(t) or
# \beta(G) determining the speed of response and recovery
#
# select the command that specifies the argument of \beta
#
# This basis is for \beta(t) as a function of time.  You may
# change the number of basis functions that are used.
#
# Here we use a constant basis for each coefficient, but at end
# we can do that analysis again with five order 5 B-spline basis functions.

nbetabasis = 1
#nbetabasis = 5
if (nbetabasis > 1) {
    betabasis = create.bspline.basis(rangeval, nbetabasis)
} else {
    betabasis = conbasis
}

# Set up the basis for the coefficient function \alpha(t)
# multiplying rainfall

nalphabasis = 1
#nalphabasis = 5
if (nalphabasis > 1) {
    alphabasis = create.bspline.basis(rangeval, nalphabasis)
} else {
    alphabasis = conbasis
}

#  store the bases and rainfall object in a list "more"

more = vector("list",0)
more$betabasis  = betabasis
more$alphabasis = alphabasis
more$rainfd     = rainfd

# Definition of the required named list containing the right side
#  evaluation functions.  

NSfn = make.NS()

## Prepare the constant coefficient analysis

# Set up the functional parameter object that defines the
# roughness penalty.  Here an important choice must be made:
# how large should the smoothing parameter \lambda be?
# One may be advised to begin with a lowish value, such as
# \lambda = 1, complete the analysis with this value, then
# increase the value to something like \lambda = 100, using
# as starting values for the parameter array pars at this stage
# the array newpars computed at the profiled estimation analysis
# for the previous smaller value.  

lambdaDE = 1e0  # A good value for the initial analysis.     
penorder = 1    # The penalty is first order
GfdPar   = fdPar(basisobj,penorder,lambdaDE)     

# Smooth the data with this roughness penalty to get initial
# values for coefficients defining G(t).

DEfd0 = smooth.basis(tobs, yobs, GfdPar)$fd

# plot the data and the fit

plotfit.fd(yobs, tobs, DEfd0, 
           xlab="Time (hours)", ylab="Groundwater level (metres)", 
           title="")

# extract the coefficient array

coefs0 = DEfd0$coefs

# Initial parameter values for constant bases

pars0 = matrix(0, nbetabasis + nalphabasis, 1) 

#pars0 = matrix(c(rep(res1$pars[1],nbetabasis), 
#                 rep(res1$pars[1],nalphabasis)), 
#                 nbetabasis + nalphabasis, 1) 

## Profiled estimation step

control.out = list()
control.out$trace  = 6
control.out$tol    = 1e-6

# This is the main optimization for profiled estimation.  
# It uses initial values for parameters and coefficients that
# are set up above.  This requires a lot of computation, and
# will take a number of minutes per iteration.  Find something
# else to do in the meantime.

lambda = 1e0

#  estimate the parameters using differencing

res0 = Profile.LS(make.NS()$fn, yobs, tobs, pars0, coefs0, basisobj, 
                  lambda, more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res0$pars  #  display the parameter estimates

res0$outer.result$value  # display the final function value


#  estimate the parameters using the derivative evaluation functions

lambda = 1e0

res1 = Profile.LS(NSfn, yobs, tobs, pars0, coefs0, basisobj, lambda,
                  more=more, out.meth='ProfileGN', 
                  control.out=control.out)

res1$pars  #  display the parameter estimates

res1$outer.result$value  # display the final function value

#  set up the functional data object for the fit

DEfd1 = fd(res1$coefs, basisobj)

#  increase lambda a few times, starting each time with 
#  parameters estimated from the last value

lambda = 1e2

res2 = Profile.LS(NSfn, yobs, tobs, res1$pars, res1$coefs, basisobj, lambda,
                  more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res2$pars  #  display the parameter estimates

DEfd2 = fd(res2$coefs, basisobj)

lambda = 1e4

res3 = Profile.LS(NSfn, yobs, tobs, res2$pars, res2$coefs, basisobj, lambda,
                  more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res3$pars  #  display the parameter estimates

DEfd3 = fd(res3$coefs, basisobj)

lambda = 1e6

res4 = Profile.LS(NSfn, yobs, tobs, res3$pars, res3$coefs, basisobj, lambda,
                  more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res4$pars  #  display the parameter estimates

DEfd4 = fd(res4$coefs, basisobj)

lambda = 1e8

res5 = Profile.LS(NSfn, yobs, tobs, res4$pars, res4$coefs, basisobj, lambda,
                  more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res5$pars  #  display the parameter estimates

DEfd5 = fd(res5$coefs, basisobj)

#  compare fits to the data

par(mfrow=c(1,1))
plotfit.fd(yobs, tobs, DEfd1, 
           xlab="Time (hours)", ylab="Groundwater level (metres)", 
           title="")
lines(DEfd2)
lines(DEfd3)
lines(DEfd4)
lines(DEfd5, lty=2)

#  By the time we get to res4, the fit to the data is essentially
#  a soluton to the differential equation.  We see that it has
#  rather less capacity to fit the data, but still captures some
#  of the shapes in the data.

#  This file contains many of the service routines required by
#  CollocInfer for optimization given a user-defined 
#  lik and proc functions.

###############################################################

SplineCoefsList = function(coefs,times,data,lik,proc,pars,sgn=1)  
{
  value    = SplineCoefsErr(coefs,times,data,lik,proc,pars,sgn)
  gradient = SplineCoefsDC(coefs,times,data,lik,proc,pars,sgn)
  hessian  = SplineCoefsDC2(coefs,times,data,lik,proc,pars,sgn)
  return(list(value=value,gradient=gradient,hessian=hessian))
}

###############################################################

SplineCoefsErr = function(coefs,times,data,lik,proc,pars,sgn=1)  
{
  coefs = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
  devals = as.matrix(lik$bvals%*%coefs)

  colnames(devals) = proc$more$names  
    
  f = sum(lik$fn(data,times,devals,pars,lik$more)) + 
          proc$fn(coefs,proc$bvals,pars,proc$more)
  if(!is.null(proc$report)) print(f)    
  return(sgn*f)
}

###############################################################

SplineCoefsDC = function(coefs,times,data,lik,proc,pars,sgn=1)  
{
    #  Inner gradient with respect to coefficients
    coefs  = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
    devals = as.matrix(lik$bvals%*%coefs)
    colnames(devals) = proc$more$names

    g = as.matrix(t(lik$bvals)%*%lik$dfdx(data,times,devals,pars,lik$more)) + 
        proc$dfdc(coefs,proc$bvals,pars,proc$more)

    g = as.vector(g)
    return(sgn*g)
}

###############################################################

SplineCoefsDP = function(coefs,times,data,lik,proc,pars,sgn=1)  
{
    #  Inner gradient with respect to parameters
    coefs = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
    devals = as.matrix(lik$bvals%*%coefs)
    colnames(devals) = proc$more$names
    
    g = apply(lik$dfdp(data,times,devals,pars,lik$more),2,sum)    + 
        proc$dfdp(coefs,proc$bvals,pars,proc$more)

    g = as.vector(g)
    return(sgn*g)
}

###############################################################

SplineCoefsDC2 = function(coefs,times,data,lik,proc,pars,sgn=1) 
{
    #  Inner Hessian with respect to coefficients
    coefs = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
    devals = as.matrix(lik$bvals%*%coefs)
    colnames(devals) = proc$more$names
    d2lik = lik$d2fdx2(data,times,devals,pars,lik$more)
    H = list(len=ncol(lik$bvals))
    for(i in 1:dim(d2lik)[2]){
      H[[i]] = list(len=ncol(devals))
        for(j in 1:dim(d2lik)[3]){
            H[[i]][[j]] = as.matrix(t(lik$bvals)%*%diag(d2lik[,i,j])%*%lik$bvals)
        }
    }

    H = blocks2mat(H) + proc$d2fdc2(coefs,proc$bvals,pars,proc$more)
    

    return( as.matrix(sgn*H) )
}

###############################################################

SplineCoefsDCDP = function(coefs,times,data,lik,proc,pars,sgn=1) 
{
    # Inner cross derivatives with respect to coefficients and parameters
    coefs = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
    devals = as.matrix(lik$bvals%*%coefs)
    colnames(devals) = proc$more$names
    
    d2lik = lik$d2fdxdp(data,times,devals,pars,lik$more)

    H = c()
    for(i in 1:length(pars)){
        H = cbind(H,as.vector(as.matrix(t(lik$bvals)%*%d2lik[,,i])))
    }

    H = H + proc$d2fdcdp(coefs,proc$bvals,pars,proc$more)
    
    return( as.matrix(sgn*H ))
}

###############################################################

ParsMatchErr = function(pars,coefs,proc,active=1:length(pars),allpars,sgn=1)    # "Gradient Matching": fix the state and minimize proc
{
   allpars[active] = pars
   
   f = proc$fn(coefs,proc$bvals,allpars,proc$more)

   return(sgn*f)
}

###############################################################

ParsMatchDP = function(pars,coefs,proc,active=1:length(pars),allpars,sgn=1)   # Derivative for Gradient Matching
{
    allpars[active] = pars

   g = proc$dfdp(coefs,proc$bvals,allpars,proc$more)
   
   return(sgn*g[active])
}

###############################################################

ParsMatchList = function(pars,coefs,proc,active=1:length(pars),allpars,sgn=1)  # Inner Objective
{
  value = ParsMatchErr(pars,coefs,proc,active=1:length(pars),allpars,sgn=1)
  gradient = ParsMatchDP(pars,coefs,proc,active=1:length(pars),allpars,sgn=1)

  return(list(value=value,gradient=gradient))

}

###############################################################

FitMatchErr = function(coefs,allcoefs,which,pars,proc,sgn=1)       # Matching unmeasured components
{                                                                  # which represents columns of
    allcoefs[,which] = matrix(coefs,nrow(allcoefs),length(which))  # allcoefs to be optimized

    g = proc$fn(allcoefs,proc$bvals,pars,proc$more)

    return(sgn*g)
}

###############################################################

FitMatchDC = function(coefs,allcoefs,which,pars,proc,sgn=1)    # Derivatives for matching unmeasured components
{
    allcoefs[,which] = matrix(coefs,nrow(allcoefs),length(which))

    g = matrix( proc$dfdc(allcoefs,proc$bvals,pars,proc$more), dim(allcoefs) )

    g = as.vector( g[,which] )

    return(sgn*g)
}

###############################################################

FitMatchDC2 = function(coefs,allcoefs,which,pars,proc,sgn=1)    # Hessian for matching unmeasured components
{
    allcoefs[,which] = matrix(coefs,nrow(allcoefs),length(which))
    
    ind = array(1:length(allcoefs),dim(allcoefs))
    ind = as.vector(ind[,which])

    H = proc$d2fdc2(allcoefs,proc$bvals,pars,proc$more)

    return(as.matrix(sgn*H[ind,ind]))
}

###############################################################

FitMatchList = function(coefs,allcoefs,which,pars,proc,sgn=1)  # Inner Objective
{
  value = FitMatchErr(coefs,allcoefs,which,pars,proc,sgn=1)
  gradient = FitMatchDC(coefs,allcoefs,which,pars,proc,sgn=1)
  hessian = FitMatchDC2(coefs,allcoefs,which,pars,proc,sgn=1)

  return(list(value=value,gradient=gradient,hessian=hessian))

}

###############################################################

ProfileErr.AllPar = function(pars,times,data,coefs,lik,proc,in.meth = "house",control.in=NULL,sgn=1)
{                                                          # Outer Optimization Objective

    coefs = as.vector(coefs)  # First run the inner optimization
    
    if(file.exists('curcoefs.tmp')) {                      # This is enough to make me swear, we'll just
      altcoefs = as.matrix(read.table('curcoefs.tmp'))               # write out to a .tmp file
      if( !(length(altcoefs)==length(coefs)) ){
        stop('Variables in curcoefs.tmp do not conform; file exists from previous experiments?')
       }
    }
    else{
      altcoefs = coefs
    }
    
    if(file.exists('counter.tmp')){                       # And we'll keep track of the
      counter = read.table('counter.tmp')                 # evaluation history
      niter = counter[nrow(counter),1]
    }
    else{
      counter = matrix(c(1,0,pars),1,length(pars)+2)
      niter = 0
    }
    
           
    altdevals = as.matrix(lik$bvals%*%matrix(altcoefs,ncol(lik$bvals),length(altcoefs)/ncol(lik$bvals)))

    colnames(altdevals) = proc$more$names
    
    f1 = SplineCoefsErr(coefs,times,data,lik,proc,pars)
    f2 = SplineCoefsErr(as.vector(altcoefs),times,data,lik,proc,pars)    

    if(f2 < f1){ coefs = altcoefs }

    Ires = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    ncoefs = Ires$coefs


    devals = as.matrix(lik$bvals%*%ncoefs)
    colnames(devals) = proc$more$names
    
    f = sum(lik$fn(data,times,devals,pars,lik$more))

    f2 = sum(lik$fn(data,times,altdevals,pars,lik$more))

#    wout = 0
    if(f <= f2){
       write.table(ncoefs,file='curcoefs.tmp',col.names=FALSE,row.names=FALSE)  
 #      save(ncoefs,niter,pars,file='bestcoefs.Rdata')
    }                                                                   
    write.table(ncoefs,file='optcoefs.tmp',col.names=FALSE,row.names=FALSE)

    if(niter==0){ 
      counter[1,2] = f
      write.table(counter,file='counter.tmp',col.names=FALSE,row.names=FALSE) 
    }
 
    if(niter>=1){
      if(f < counter[niter,2]){
       counter = rbind(counter,c(niter+1,f,pars))
       write.table(counter,file='counter.tmp',col.names=FALSE,row.names=FALSE)
      }
    }

     if(!is.null(lik$report)){ print(f) }
    f = sgn*f
    
#    if(file.exists('ProfHistory.Rdata')){ load('ProfHistory.Rdata') }
#    else{ 
#      parmat = c()
#      fvec = c()
#      coefmat = c()    
#      wvec = c()
#    }
#    
#    parmat = cbind(parmat,pars)
#    coefmat = cbind(coefmat,as.vector(ncoefs))
#    fvec = c(fvec,f)
#    wvec = c(wvec,wout)
#    
#    save(parmat,coefmat,fvec,wvec,file='ProfHistory.Rdata')
    

#    print(c(f,pars))
    return(f)
}

###############################################################

ProfileDP.AllPar = function(pars,times,data,coefs,lik,proc,in.meth=NULL,control.in=NULL,sgn=1,sumlik=1)
{

    if(file.exists('optcoefs.tmp')){
      altcoefs = as.matrix(read.table('optcoefs.tmp'))
      if( !(length(altcoefs)==length(coefs)) ){
        stop('Variables in curcoefs.tmp do not conform; file exists from previous experiments?')
      }else{
        coefs = altcoefs
      }      
    }

    coefs = as.matrix(coefs)
    devals = as.matrix(lik$bvals%*%coefs)
    colnames(devals) = proc$more$names

    coefs = as.vector(coefs)    

    d2Hdc2 = SplineCoefsDC2(coefs,times,data,lik,proc,pars)
    d2Hdcdp = SplineCoefsDCDP(coefs,times,data,lik,proc,pars)
  
    dcdp = -ginv(d2Hdc2)%*%d2Hdcdp
  
   
    if(sumlik){
        dlikdc = as.vector(t(lik$bvals)%*%lik$dfdx(data,times,devals,pars,lik$more))
        df = t(dcdp)%*%(dlikdc) + apply(lik$dfdp(data,times,devals,pars,lik$more),2,sum)    
    
        df = as.vector(sgn*df)
     #   print(df)
        return(df)
    }
    else{
        dlikdx = lik$dfdx(data,times,devals,pars,lik$more)

        dlikdp = lik$dfdp(data,times,devals,pars,lik$more)

        dlikdc = c()
        for(i in 1:dim(dlikdx)[2]){
            dlikdc = cbind(dlikdc,as.matrix(diag(dlikdx[,i])%*%lik$bvals))            
        }       
        
        df = dlikdc%*%dcdp + dlikdp
        
        return(df)
    }
}

###############################################################

ProfileErr = function(pars,allpars,times,data,coefs,lik,proc,in.meth = "house",
        control.in=NULL,sgn=1,active=1:length(allpars))
{
    allpars[active] = pars
    
    f = ProfileErr.AllPar(allpars,times,data,coefs,lik,proc,in.meth,control.in,sgn)
    return(f)
}

###############################################################

ProfileDP = function(pars,allpars,times,data,coefs,lik,proc,in.meth = "house",
                control.in=NULL,sgn=1,sumlik=1,active=1:length(allpars))
{
    allpars[active] = pars

    g = ProfileDP.AllPar(allpars,times,data,coefs,lik,proc,in.meth,control.in,sgn,sumlik)


    if(sumlik){ 
        names(g) = names(allpars)
        g = g[active] 
    }
    else{ 
        colnames(g) = names(allpars)
        g = g[,active] 
    }
    
    return(g)        
}

###############################################################

ProfileList = function(pars,allpars,times,data,coefs,lik,proc,in.meth = "house",
        control.in=NULL,sgn=1,active=1:length(allpars))
{
  value = ProfileErr(pars,allpars,times,data,coefs,lik,proc,in.meth,control.in,sgn,active)
  gradient = ProfileDP(pars,allpars,times,data,coefs,lik,proc,in.meth,control.in,sgn,active)
  
  return(list(value=value,gradient=gradient))
}

###############################################################

ProfileSSE = function(pars,allpars,times,data,coefs,lik,proc,in.meth='nlminb',control.in=NULL,   # Squared Error
                    active=1:length(pars),dcdp=NULL,oldpars=NULL,use.nls=TRUE,sgn=1)                            # outer criterion
{
  allpars[active] = pars

  f = ProfileSSE.AllPar(pars=allpars,times=times,data=data,coefs=coefs,lik=lik,proc=proc,in.meth=in.meth,
      control.in=control.in,dcdp=dcdp,oldpars=oldpars,use.nls=use.nls,sgn=sgn)
  
    if(use.nls){
#        attr(f,'gradient') = attr(f,'gradient')[,active]
    }
    else{
        f$gradient = f$gradient[,active]
        f$dcdp = f$dcdp[,active]
    }
    return(f)
}

###############################################################

ProfileSSE.AllPar = function(pars,times,data,coefs,lik,proc,in.meth='nlminb',control.in=NULL,   # Squared Error
                    dcdp=NULL,oldpars=NULL,use.nls=TRUE,sgn=1)                            # outer criterion
{           

    coefs = as.vector(coefs)  # First run the inner optimization
    f1 = SplineCoefsErr(coefs,times,data,lik,proc,pars)

    if(use.nls){                                        # If using NLS, we need to keep track
        if(file.exists('curcoefs.tmp')){
          altcoefs = as.matrix(read.table('curcoefs.tmp'))
          if( !(length(altcoefs)==length(coefs)) ){
            stop('Variables in curcoefs.tmp do not conform; file exists from previous experiments?')
          }
        }
        else{
          altcoefs = coefs
        }
        if(file.exists('counter.tmp')){                       # And we'll keep track of the
          counter = read.table('counter.tmp')                 # evaluation history
          niter = counter[nrow(counter),1]
        }
        else{
          counter = matrix(c(1,0,pars),1,length(pars)+2)
          niter = 0
        }

        f2 = SplineCoefsErr(as.vector(altcoefs),times,data,lik,proc,pars)    
    
        if(f2 < f1){
          coefs = altcoefs
          f1 = f2
        }
        
        altdevals = as.matrix(lik$bvals%*%matrix(altcoefs,ncol(lik$bvals),length(altcoefs)/ncol(lik$bvals)))
        colnames(altdevals) = proc$more$names
    }

    if( !is.null(dcdp) ){
        tcoefs = coefs + dcdp%*%(pars-oldpars);
        f2 = SplineCoefsErr(as.vector(tcoefs),times,data,lik,proc,pars)
        if(f2 < f1){
          coefs = tcoefs
          f1 = f2
        }         
    }

    Ires = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    ncoefs = Ires$coefs
    
    devals = as.matrix(lik$bvals%*%ncoefs)
    colnames(devals) = proc$more$names


    weights = checkweights(lik$more$weights,lik$more$whichobs,data)
    f = as.vector( as.matrix(data - lik$more$fn(times,devals,pars,lik$more$more))*sqrt(weights) )
    isnaf = is.na(f)
    f[isnaf] = 0

    # Now a gradient

    dlikdp = lik$more$dfdp(times,devals,pars,lik$more$more)
    dlikdp = matrix(dlikdp,dim(dlikdp)[1]*dim(dlikdp)[2],dim(dlikdp)[3])

    dlikdx = lik$more$dfdx(times,devals,pars,lik$more$more)

    dlikdc = c()
    for(i in 1:dim(dlikdx)[2]){
        tH = c()
        for(j in 1:dim(dlikdx)[3]){
            tH = cbind(tH,as.matrix(diag(dlikdx[,i,j])%*%lik$bvals))            
        }
        dlikdc = rbind(dlikdc,tH)
    }

    d2Hdc2 = SplineCoefsDC2(ncoefs,times,data,lik,proc,pars)
    d2Hdcdp = SplineCoefsDCDP(ncoefs,times,data,lik,proc,pars)

    dcdp = ginv(d2Hdc2)%*%d2Hdcdp

    df = dlikdc%*%dcdp + dlikdp
    df[isnaf,] = 0
    colnames(df) = proc$more$parnames

    if(!is.null(lik$report)){ print(f) }

    f = sgn*f
    df = sgn*df

    if(use.nls){
        tf = sum(lik$fn(data,times,devals,pars,lik$more))
        tf2 = sum(lik$fn(data,times,altdevals,pars,lik$more))
                                                                                                      
        if(tf <= tf2){
            write.table(ncoefs,file='curcoefs.tmp',row.names=FALSE,col.names=FALSE)
            niter = counter[nrow(counter),1]
        }
        
        if(niter==0){ 
          counter[1,2] = tf
          write.table(counter,file='counter.tmp',col.names=FALSE,row.names=FALSE) 
        }

     if(niter > 1){
      if(tf < counter[niter,2]){
       counter = rbind(counter,c(niter+1,tf,pars))
       write.table(counter,file='counter.tmp',col.names=FALSE,row.names=FALSE)
      }
    }
        
        write.table(ncoefs,file='optcoefs.tmp',col.names=FALSE,row.names=FALSE)       
        attr(f,'gradient') = df
        return(f)
    }
    else{
        return(list(value=f,gradient=df,coefs=ncoefs,dcdp=dcdp))
    }
}

###############################################################

Profile.GausNewt = function(pars,times,data,coefs,lik,proc,   # Gauss-Newton routine for squared error outer
    in.meth='nlminb',control.in=NULL,active=1:length(pars),   # objective
    control=list(reltol=1e-6,maxit=50,maxtry=15,trace=1)) 
{
    res0 = ProfileSSE.AllPar(pars,times,data,coefs,lik,proc,in.meth,control.in,use.nls=FALSE)

    ind = names(pars)
    if(is.null(ind)){ ind = 1:length(pars) }                # Allows some pars to be
    ind = ind[active]                                       # fixed

    pars0 = pars
    pars1 = pars
    F0 = sum(res0$value^2)
    F1 = F0
    iter = 0
    fundif = 1

    gradnorm0 = mean(abs(t(res0$gradient[,ind])%*%res0$value))
    gradnorm1 = 1
    dcdp = c()

    while( gradnorm1 > control$reltol & fundif > control$reltol & iter < control$maxit){
  
        iter = iter + 1

        Dpars = solve(t(res0$gradient[,ind])%*%res0$gradient[,ind],t(res0$gradient[,ind])%*%res0$value)
    
        ntry = 0
        
        while(F1 >= F0 & t(Dpars)%*%Dpars > control$reltol & ntry < control$maxtry){
            pars1[ind] = pars0[ind] - 0.5*Dpars
            tres = ProfileSSE.AllPar(pars1,times,data,res0$coefs,lik,proc,in.meth,control.in,res0$dcdp,pars0,use.nls=FALSE)
            F1 = sum(tres$value^2)
#            print(c(F0,F1,t(Dpars)%*%Dpars,pars1))
            Dpars = Dpars/2
            ntry = ntry + 1
        }

        res0 = tres
        dcdp = tres$dcdp
        gradnorm1 = abs(mean(t(res0$gradient[,ind])%*%res0$value))
        fundif = (F0-F1)/abs(F0)

        pars0 = pars1
        res0 = tres
        F0 = F1
        gradnorm0 = gradnorm1
        
        if(control$trace>0){ print(c(iter,ntry,F0,pars0)) }
    }

    newpars = pars0
     
    return(list(pars=newpars,in.res=res0,value=F0))
}

###############################################################

SplineEst.NewtRaph = function(coefs,times,data,lik,proc,pars,   # Newton-Raphson routine for 
    control=list(reltol=1e-12,maxit=1000,maxtry=10,trace=0))    # Inner optimization
{
    f0 = SplineCoefsErr(coefs,times,data,lik,proc,pars)
    g = SplineCoefsDC(coefs,times,data,lik,proc,pars)
    H = SplineCoefsDC2(coefs,times,data,lik,proc,pars)

    DC = -ginv(H)%*%g

    gradnorm1 = 1
    fundif = 1
    iter = 0
    f1 = f0

    coefs0 = as.vector(coefs)

    while( gradnorm1 > control$reltol & fundif > 0 & iter < control$maxit){
  
        iter = iter + 1    
        DC = -ginv(H)%*%g
   
        ntry = 0
        
        coefs1 = coefs0 

        while( (f1 >= f0) & (t(DC)%*%DC > control$reltol) & (ntry < control$maxtry) ){
            
            
            coefs1 = coefs0 + DC
            f1 = SplineCoefsErr(coefs1,times,data,lik,proc,pars)
            DC = DC/2
            ntry = ntry + 1
  #          print(c(f1,f0, t(DC)%*%DC,control$reltonl,ntry,control$maxtry))
  #          print((f1 >= f0) & (t(DC)%*%DC > control$reltol) & (ntry < control$maxtry))
            
        }

        coefs0 = coefs1
        
        g = SplineCoefsDC(coefs0,times,data,lik,proc,pars)
        H = SplineCoefsDC2(coefs0,times,data,lik,proc,pars)    

        gradnorm1 = mean(abs(DC))
        fundif = (f0-f1)/abs(f0)
  
        f0 = f1      
        if(control$trace>1){ print(c(iter,ntry,f0,gradnorm1,fundif)) }

    }
    if(control$trace>0){ print(c(f0,gradnorm1,iter)) }
     
    return(list(coefs=coefs0,g=g,value=f0,H=H))
}

###############################################################

NeweyWest.Var = function(H,g,maxlag)       
{
    V = solve(H)

    I = 0*H
    
    if(is.null(maxlag)){ 
        n = nrow(g)
        maxlag = max(5,n^(0.25))
    }

    if(maxlag > 0){
        for(i in 1:(ncol(g)-1)){
            for(j in (i+1):ncol(g)){
                I[i,j] = Newey.West(g[,i],g[,j],maxlag)
                I[j,i] = I[i,j]
            }    
        }
     
    }

    return( V%*%(I+ t(g)%*%g)%*%V )

}

###############################################################

Profile.covariance <- function(pars,active=NULL,times,data,coefs,lik,proc,in.meth='nlminb',control.in=NULL,eps=1e-6)
{
    if(is.null(active)){ active = 1:length(pars) }

    apars = pars[active]
    
    H = matrix(0,length(apars),length(apars))

    g = ProfileDP(pars=apars,allpars=pars,times=times,data=data,coefs=coefs,lik=lik,proc=proc,active=active,sumlik=FALSE)
    gg = apply(g,2,sum)

    for(i in 1:length(apars)){        
      if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
      if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
      if(file.exists('counter.tmp')){file.remove('counter.tmp')}

        tpars = apars
        tpars[i] = tpars[i] + eps

        tf = ProfileErr(tpars,pars,times,data,coefs,lik,proc,in.meth=in.meth,control.in=control.in,active=active)  
        tg = ProfileDP(tpars,pars,times,data,coefs,lik,proc,active=active,sumlik=TRUE)                            

        H[,i] = (tg-gg)/eps

      if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
      if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
      if(file.exists('counter.tmp')){file.remove('counter.tmp')}
    }
               
    Covar = NeweyWest.Var( 0.5*(t(H)+H) ,g,5)
        
    return( Covar )
}

############################################################################################
#
# Some Utilities
#
############################################################################################


#blocks2mat = function(H)  # List of matrices -> large matrix
#{
#
#    out = c()
#
#    for(i in 1:dim(H)[3]){
#
#    tout = c()
#    for(j in 1:dim(H)[4]){
#        tout = cbind(tout,H[,,i,j])
#    }
#
#    out = rbind(out,tout)
#    }
#
#}

blocks2mat = function(H)  # List of matrices -> large matrix
{

    out = c()

    for(i in 1:length(H)){
      tout = H[[i]][[1]]
      if(length(H[[i]])>1){
        for(j in 2:length(H[[i]])){
            if(inherits(H[[i]][[j]],'dgCMatrix')|inherits(H[[i]][[j]],'dgeMatrix')){ tout=cBind(tout,H[[i]][[j]]) }
            else{ tout = cbind(tout,H[[i]][[j]]) }
        }
      }
      if(i > 1){ 
        if(inherits(tout,'dgCMatrix')|inherits(tout,'dgeMatrix')){ out=rBind(out,tout) }
        else{ out = rbind(out,tout) }
      } 
      else{ out = tout }
    }

    return(out)
}

## Newey West Calculations, with thanks to Steve Ellner


## GAUSS trimr function: trims n1 rows from the start and n2 rows from the end
## of a matrix or vector 
trimr <- function (a,n1,n2) {
        da<-dim(a); 
        if(is.null(da)) {a[(n1+1):(length(a)-n2)]}
        else {a[(n1+1):(da[1]-n2),]}
}

Newey.West <-function(x,y,maxlag) {
        w=1-(1:maxlag)/(maxlag+1); w=w/length(x); 
        out=mean(x*y); 
        for(i in 1:maxlag) {
            out=out+w[i]*sum(trimr(x,i,0)*trimr(y,0,i))+w[i]*sum(trimr(y,i,0)*trimr(x,0,i))
        }
        return(out)     
} 

########### Likelihood for Rates of Change ################ 
# 
# Here we note that the derivative is modeled as a respose
# dependent on the state, and represented as "y" in 
# in calls to gradient evalutations
########################################################### 

make.Cproc <- function()
{

Cproc <- function(coefs,bvals,pars,more) 
{ 
   devals = as.matrix(bvals$bvals%*%coefs)
   ddevals = as.matrix(bvals$dbvals%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames
   
   f = more$fn(ddevals,more$qpts,devals,pars,more$more)

   return( sum(f) )
}


dCproc.dc <- function(coefs,bvals,pars,more) 
{ 
   devals = as.matrix(bvals$bvals%*%coefs)
   ddevals =as.matrix( bvals$dbvals%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

   g1 = more$dfdx(ddevals,more$qpts,devals,pars,more$more)
   g2 = more$dfdy(ddevals,more$qpts,devals,pars,more$more)

  g = as.vector( t(bvals$bvals)%*%g1 + t(bvals$dbvals)%*%g2 )

  return(g)
}


dCproc.dp <- function(coefs,bvals,pars,more) 
{ 
  devals = as.matrix(bvals$bvals%*%coefs)
  ddevals = as.matrix(bvals$dbvals%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  g = more$dfdp(ddevals,more$qpts,devals,pars,more$more)

  g = apply(g,2,sum)

  return(g)
}



d2Cproc.dc2 <- function(coefs,bvals,pars,more) 
{ 
  devals = as.matrix(bvals$bvals%*%coefs)
  ddevals = as.matrix(bvals$dbvals%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  H1 = more$d2fdx2(ddevals,more$qpts,devals,pars,more$more)
  H2 = more$d2fdxdy(ddevals,more$qpts,devals,pars,more$more)
  H3 = more$d2fdy2(ddevals,more$qpts,devals,pars,more$more)

#  H = array(0,c(rep(dim(bvals$bvals)[2],2),rep(dim(devals)[2],2)))

#  for(i in 1:dim(devals)[2]){
#	for(j in 1:dim(devals)[2]){
#		H[,,i,j] = t(bvals$bvals)%*%diag(H1[,i,j])%*%bvals$bvals +
#            t(bvals$bvals)%*%diag(H2[,i,j])%*%bvals$dbvals + 
#            t(bvals$dbvals)%*%diag(H2[,j,i])%*%bvals$bvals + 
#            t(bvals$dbvals)%*%diag(H3[,i,j])%*%bvals$dbvals 
#	}
#  }

#  H = array(0,c(rep(dim(bvals$bvals)[2],2),rep(dim(devals)[2],2)))

 H = list(len=dim(bvals$bvals)[2])
  for(i in 1:dim(devals)[2]){
  H[[i]] = list(len=dim(devals))
    for(j in 1:dim(devals)[2]){
        H[[i]][[j]] = t(bvals$bvals)%*%diag(H1[,i,j])%*%bvals$bvals +
            t(bvals$bvals)%*%diag(H2[,i,j])%*%bvals$dbvals + 
            t(bvals$dbvals)%*%diag(H2[,j,i])%*%bvals$bvals + 
            t(bvals$dbvals)%*%diag(H3[,i,j])%*%bvals$dbvals             
    }
  }


  H = blocks2mat(H)

  return(H)
}



d2Cproc.dcdp <- function(coefs,bvals,pars,more) 
{ 
  devals = as.matrix(bvals$bvals%*%coefs)
  ddevals = as.matrix(bvals$dbvals%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  H1 = more$d2fdxdp(ddevals,more$qpts,devals,pars,more$more)
  H2 = more$d2fdydp(ddevals,more$qpts,devals,pars,more$more)

  H = c()

  for(i in 1:length(pars)){
	  H = cbind(H,as.vector(t(bvals$bvals)%*%H1[,,i] +
			t(bvals$dbvals)%*%H2[,,i]))
  }

  return(H)
}



    return(
        list(
            fn = Cproc,
            dfdc = dCproc.dc,
            dfdp = dCproc.dp,
            d2fdc2 = d2Cproc.dc2,
            d2fdcdp = d2Cproc.dcdp
        )
    ) 
} 

#####
# This file contains functions defining the inner optimization of the Profile
# estimation regime. It provides functions
#
# - inneropt: which calls various optimization routines 
# - SplineEst.NewtRaph: a quick and dirty Newton-Raphson scheme
# - SplineCoefs*: functions that define the inner objective function and its 
# derivatives. 
#####


inneropt <- function(data,times,pars,coefs,lik,proc,in.meth='nlminb',
                     control.in=list())
{              
#  The multivariate data in argment data are observations of one or more
#  functional variables or processes at time points in argument time.

#  The function optimizes the coefficients of the basis expansions for the
#  representations of the variables or processes in what is called the
#  inner optimization loop.  The parameter values are held fixed.

#  The fitting criterion for both the data and the differential equation
#  are user-defined in arguments lik and proc, respectively.

#  The optimization method for the inner loop is defined by argument in.meth.

#  The function returns the optimized coefficients and the residual values.

  check.lik.proc.data.coefs(lik,proc,data,times,coefs)

  if(in.meth=="SplineEst"){
    #  optimization by Newton-Raphson using function SplineEst.NewtRaph
      if(is.null(control.in$reltol)){ control.in$reltol = 1e-12 }
      if(is.null(control.in$maxit)){ control.in$maxit = 1000}
      if(is.null(control.in$maxtry)){ control.in$maxtry = 10 }
      if(is.null(control.in$trace)){ control.in$trace = 0 }
        res = SplineEst.NewtRaph(coefs,times,data,lik,proc,pars,control.in)
        ncoefs = matrix(res$coefs,ncol(lik$bvals),length(res$coefs)/ncol(lik$bvals))
    }
    else if(in.meth=="optim"){
        #  optimization using function optim which in turn calls function SplineCoefsErr
      if( is.null(control.in$trace) ){ control.in$trace = 0 }
      if( is.null(control.in$maxit) ){ control.in$maxit = 1000 }
      if( is.null(control.in$reltol) ){ control.in$reltol = 1e-12}
      if( is.null(control.in$meth) ){ control.in$meth = "BFGS" }
      if( is.null(control.in$reportHessian)){ control.in$reportHessian = TRUE }
      
      imeth = control.in$meth
      control.in$meth = NULL
      
        res = optim(coefs,SplineCoefsErr,gr=SplineCoefsDC,hessian=control.in$reportHessian,
            control=control.in,times=times,data=data,lik=lik,proc=proc,pars=pars,method=imeth)

        ncoefs = matrix(res$par,ncol(lik$bvals),length(res$par)/ncol(lik$bvals))
    }    
    else if(in.meth=="nlminb"){
    #  optimization using function nlminb
      if( is.null(control.in$trace) ){ control.in$trace = 0 }
      if( is.null(control.in$eval.max) ){ control.in$eval.max = 2000 }
      if( is.null(control.in$iter.max) ){ control.in$iter.max = 1000 }
      if( is.null(control.in$rel.tol) ){ control.in$rel.tol = 1e-12 }  
      if( is.null(control.in$useHessian) ){ Hessian = SplineCoefsDC2 }
      else{ Hessian = NULL } 
          
        res = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=Hessian,
            control=control.in,times=times,data=data,lik=lik,proc=proc,pars=pars)

        ncoefs = matrix(res$par,ncol(lik$bvals),length(res$par)/ncol(lik$bvals))
    }
    else if(in.meth=="maxNR"){
    #  optimizaton using function maxNR
        if(is.null(control.in$print.level)){control.in$print.level = 1}
        if(is.null(control.in$iterlim)){control.in$iterlim = 1000}
        if(is.null(control.in$reltol)){control.in$reltol = 1e-12}
        if( is.null(control.in$useHessian) ){ Hessian = SplineCoefsDC2 }
        else{ Hessian = NULL } 
    
        res = maxNR(SplineCoefsErr,coefs,times=times,data=data,lik=lik,proc=proc,pars=pars,sgn=-1,
            grad=SplineCoefsDC,hess=Hessian,print.level=control.in$print.level,
            iterlim = control.in$iterlim)

        ncoefs = matrix(res$estimate,ncol(lik$bvals),length(res$estimate)/ncol(lik$bvals))
    }
    else if(in.meth=='trust'){
    #  optimization using function trust
        if(is.null(control.in$rinit)){ control.in$rinit = 1}
        if(is.null(control.in$rmax)){ control.in$rmax = 100}
        if(is.null(control.in$parscale)){ control.in$parscale = abs(coefs)}
        if(is.null(control.in$iterlim)){ control.in$iterlim = 100}
        
        res = trust(SplineCoefsList,coefs,rinit=control.in$rinit,
                    rmax=control.in$rmax,parscale=control.in$parscale,
                    iterlim=control.in$iterlim,
                    times=time,data=data,lik=lik,proc=proc,pars=pars,sgn=1)
    
        ncoefs = matrix(res$argument,dim(coefs))
    }
    else{
      stop('Unknown optimizer specified')
    }

    if(!is.null(proc$more$names)){ colnames(ncoefs) = proc$more$names }
  
    return(list(coefs=ncoefs,res=res))
}

################  Newton-Raphson routine   #######################

SplineEst.NewtRaph = function(coefs,times,data,lik,proc,pars,    
    control=list(reltol=1e-12,maxit=1000,maxtry=10,trace=0))    
{
    if(is.null(control)){ control = list() }
    if(is.null(control$reltol)){ control$reltol = 1e-12 }
    if(is.null(control$maxit)){ control$maxit = 1000}
    if(is.null(control$maxtry)){ control$maxtry = 10 }
    if(is.null(control$trace)){ control$trace = 0 }

  check.lik.proc.data.coefs(lik,proc,data,times,coefs)
  
    f0 = SplineCoefsErr(coefs,times,data,lik,proc,pars)
    g = SplineCoefsDC(coefs,times,data,lik,proc,pars)
    H = SplineCoefsDC2sparse(coefs,times,data,lik,proc,pars)

    if(is.matrix(H)){ DC = -ginv(H)%*%g  }
    else{ DC = -as.matrix(solve(H,g)) }

    gradnorm1 = 1
    fundif = 1
    iter = 0
    f1 = f0

    coefs0 = as.vector(coefs)

    while( gradnorm1 > control$reltol & fundif > 0 & iter < control$maxit){
  
        iter = iter + 1    
        if( is.matrix(H) ){ DC = -ginv(H)%*%g }
        else{ DC = -as.matrix(solve(H,g)) }
   
        ntry = 0
        
        coefs1 = coefs0 
        
        if(control$trace >0){ print(c(f0,mean(abs(DC)),0)) }

        while( (f1 >= f0) & (t(DC)%*%DC > control$reltol) & (ntry < control$maxtry) ){
            
            
            coefs1 = coefs0 + DC
            f1 = SplineCoefsErr(coefs1,times,data,lik,proc,pars)
            DC = DC/2
            ntry = ntry + 1
  #          print(c(f1,f0, t(DC)%*%DC,control$reltonl,ntry,control$maxtry))
  #          print((f1 >= f0) & (t(DC)%*%DC > control$reltol) & (ntry < control$maxtry))
            
        }

        coefs0 = coefs1
        
        g = SplineCoefsDC(coefs0,times,data,lik,proc,pars)
        H = SplineCoefsDC2sparse(coefs0,times,data,lik,proc,pars)    

        gradnorm1 = mean(abs(DC))
        fundif = (f0-f1)/abs(f0)
  
        f0 = f1      
        if(control$trace>1){ print(c(iter,ntry,f0,gradnorm1,fundif)) }

    }
    if(control$trace>0){ print(c(f0,gradnorm1,iter)) }
     
    return(list(coefs=coefs0,g=g,value=f0,H=H))
}


###############################################################

SplineCoefsList = function(coefs,times,data,lik,proc,pars,sgn=1)  # Inner Objective
{                              
  #  called in function inneropt by function trust
  value = SplineCoefsErr(coefs,times,data,lik,proc,pars,sgn)
  gradient = SplineCoefsDC(coefs,times,data,lik,proc,pars,sgn)
  hessian = SplineCoefsDC2(coefs,times,data,lik,proc,pars,sgn)

  return(list(value=value,gradient=gradient,hessian=hessian))
}

###############################################################

SplineCoefsErr = function(coefs,times,data,lik,proc,pars,sgn=1)  # Inner Objective
{
  #  evaluates the objective function for inner optimization
  #  called in function inneropt by functions optim, nlminb, maxNR

  coefs2 = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
  devals = as.matrix(lik$bvals %*% coefs2)

  colnames(devals) = proc$more$names  
    
  f = sum(lik$fn(data,times,devals,pars,lik$more)) + 
          proc$fn(coefs2,proc$bvals,pars,proc$more)

if(!is.null(proc$report)){ print(f) }    
  return(sgn*f)
}

###############################################################

SplineCoefsDC = function(coefs,times,data,lik,proc,pars,sgn=1)  
{
    #  Inner gradient with respect to coefficients
    coefs2 = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
    devals = as.matrix(lik$bvals%*%coefs2)
    colnames(devals) = proc$more$names

    g = as.matrix(t(lik$bvals)%*%lik$dfdx(data,times,devals,pars,lik$more)) + 
        proc$dfdc(coefs2,proc$bvals,pars,proc$more)

    g = as.vector(g)
    return(sgn*g)
}

###############################################################

SplineCoefsDP = function(coefs,times,data,lik,proc,pars,sgn=1)  # Inner gradient
{
    #  Inner gradient with respect to parameters
    coefs2 = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
    devals = as.matrix(lik$bvals%*%coefs2)
    colnames(devals) = proc$more$names
    
    g = apply(lik$dfdp(data,times,devals,pars,lik$more),2,sum)    + 
        proc$dfdp(coefs2,proc$bvals,pars,proc$more)

    g = as.vector(g)
    return(sgn*g)
}

###############################################################

SplineCoefsDC2sparse = function(coefs,times,data,lik,proc,pars,sgn=1) 
{
  #  Inner Hessian with respect to coefficients
    coefs2 = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
    devals = as.matrix(lik$bvals%*%coefs2)
    colnames(devals) = proc$more$names
    
    d2lik = lik$d2fdx2(data,times,devals,pars,lik$more)

    H = list(len=ncol(lik$bvals))
    for(i in 1:dim(d2lik)[2]){
      H[[i]] = list(len=ncol(devals))
        for(j in 1:dim(d2lik)[3]){
            H[[i]][[j]] = t(lik$bvals)%*%diag(d2lik[,i,j])%*%lik$bvals
        }
    }

    H = blocks2mat(H) 

    H = H + proc$d2fdc2(coefs2,proc$bvals,pars,proc$more)

    return(sgn*H)
}

SplineCoefsDC2 = function(coefs,times,data,lik,proc,pars,sgn=1)
{
  result = as.matrix(SplineCoefsDC2sparse(coefs,times,data,lik,proc,pars,sgn))
  return(result)
}

###############################################################

SplineCoefsDCDP = function(coefs,times,data,lik,proc,pars,sgn=1) 
{
    # Inner cross derivatives with respect to coefficients and parameters
    coefs2 = matrix(coefs,ncol(lik$bvals),length(coefs)/ncol(lik$bvals))
    devals = as.matrix(lik$bvals%*%coefs2)
    colnames(devals) = proc$more$names
    
    d2lik = lik$d2fdxdp(data,times,devals,pars,lik$more)

    H = c()
    for(i in 1:length(pars)){
        H = cbind(H,as.vector(as.matrix(t(lik$bvals)%*%d2lik[,,i])))
    }

    H = H + proc$d2fdcdp(coefs2,proc$bvals,pars,proc$more)
    
    return( as.matrix(sgn*H ))
}

# An example file fitting the FitzHugh-Nagumo equations to data in the
# new R Profiling Code. This will eventually be interfaced with the new R 
# "Partially Observed Markov Process (pomp)" class of objects. 

#################################################
####  Define list fhn containing rhs functions ##
#################################################

fhn = make.fhn()

#################################################
####   Data Generation (1) 41 time values #######
#################################################

times = seq(0,20,0.5)
pars  = c(0.2,0.2,3)
names(pars) = c('a','b','c')
x0 = c(-1,1)
names(x0) = c('V','R')
y = lsoda(x0,times=times,func=make.fhn()$fn.ode,pars)
y = y[,2:3]
data = y + 0.2*array(rnorm(82),dim(y))
                    
################################################
####   Data Generation (2) 401 time values  ####
################################################

times = seq(0,20,0.05)
pars  = c(0.2,0.2,3)
names(pars) = c('a','b','c')
x0 = c(-1,1)
names(x0) = c('V','R')
z=matrix(rep(0,80002),,2)
z[1,1]=-1
z[1,2]=1
w=matrix(rnorm(80000),,2)
for (i in 2:40001)
{ 
  z[i,1] = z[i-1,1]+.0005*3*(z[i-1,1]- z[i-1,1]^3/3+z[i-1,2])+ 
           .011*w[i-1,1]
  z[i,2] = z[i-1,2]-.0005*  (z[i-1,1]-.2+.2* z[i-1,2])/3 + 
           .011*w[i-1,2]
}
y= matrix(rep(0,802),,2)
for (i in 0:400)
y[i+1,]=z[i*100+1,]
data = y + 0.05*array(rnorm(802),dim(y))

###############################
####  Basis Object      #######
###############################

knots  = seq(-0.1,20.1,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range  = c(-0.1,20.1)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)

# Initial values for coefficients will be obtained by smoothing

fd.data = array(data,c(dim(data)[1],1,dim(data)[2]))

DEfd = data2fd(fd.data,times,bbasis,fdnames=list(NULL,NULL,c('V','R')) )

coefs = DEfd$coefs[,1,]

####################################
####  Optimization Control Lists ###
####################################

control=list()                 
control$trace  = 0
control$maxit  = 1000
control$maxtry = 10
control$reltol = 1e-6
control$meth   = "BFGS"

control.in = control
control.in$reltol      = 1e-12
control.in$print.level = 0
control.in$iterlim     = 1000

control.out = control
control.out$trace = 2

#################################
### Initial Parameter Guesses ###
#################################

profile.obj = LS.setup(pars=pars,fn=make.fhn(),lambda=10000,
                       times=times,fd.obj=DEfd)
lik = profile.obj$lik
proc= profile.obj$proc

pres = ParsMatchOpt(pars,coefs,proc)

npars = pres$pars

#############################################################
### If We Only Observe One State, We Can Re-Smooth Others ### 
#############################################################

tcoefs = coefs
tcoefs[,2] = 0

fres = FitMatchOpt(coefs=tcoefs,which=2,pars=pars,proc)

ncoefs = fres$coefs

###############################
#### Parameter Optimization ###
###############################

spars = c(0.2,0.2,2)          # Perturbed parameters
names(spars)=names(pars)
lambda = 10000

### SSE Shortcuts ####

Ires1	= Smooth.LS(make.fhn(),data,t,pars=spars,coefs,bbasis,lambda=lambda,
  in.meth='nlminb')
  
Ores1 = Profile.LS(make.fhn(),data=data,times=t,pars=spars,coefs=coefs,
  basisvals=bbasis,lambda=lambda,in.meth='nlminb',out.meth='ProfileGN')
#	control.in=control.in,control.out=control.out)
	

### SSE with ProfileErr ###


Ires2 = inneropt(data,times=times,pars,coefs,lik,proc,in.meth='nlminb') #,control.in)

Ores2 = outeropt(data=data,times=times,pars=pars,coefs=coefs,lik=lik,proc=proc,
  in.meth="nlminb",out.meth="optim")#,control.in=control.in,control.out=control.out)


### Multinorm ####

var = c(1,0.01)

Ires3 = Smooth.multinorm(make.fhn(),data,t,pars=spars,coefs,bbasis,var=var,in.meth='nlminb')#,control.in=control.in)

Ores3 = Profile.multinorm(make.fhn(),data,t,pars=spars,coefs,bbasis,var=var, 
  out.meth='nlminb',in.meth='nlminb')#,control.in=control.in,control.out=control.out)



# Lets look at the result

DEfd = fd(Ores1$coefs,bbasis)   # Data and reconstructed trajectory

par(mfrow=c(2,1))
 plotfit.fd(data,t,DEfd)
 

traj = as.matrix(Ores1$proc$bvals$bvals%*%Ores1$coefs)    # Look at how well the
colnames(traj) = Ores1$proc$more$names                    # derivative of the
dtraj = as.matrix(Ores1$proc$bvals$dbvals%*%Ores1$coefs)  # trajectory fits the 
ftraj = Ores1$proc$more$fn(t,traj,Ores1$pars)             # right hand side. 

matplot(dtraj,type='l',col=2)
matplot(ftraj,type='l',col=4,add=TRUE) 
 
 
Profile.covariance(pars=Ores1$pars,times=t,data=data,coefs=Ores1$coefs,
  lik=Ores1$lik,proc=Ores1$proc)
  
  
#################################################################
#### We can also estimate derivatives by finite differencing ####
#### if we don't feel like calculating them analytically.    ####
#################################################################

Ires1	= Smooth.LS(make.fhn()$fn,data,t,pars=spars,fd.obj=DEfd,lambda=lambda,
  in.meth='nlminb',control.in=control.in)
  

Ores1 = Profile.LS(make.fhn()$fn,data=data,times=t,pars=spars,fd.obj=DEfd,
  lambda=lambda,in.meth='nlminb',out.meth='nls',control.in=control.in,control.out=control.out)  
	

#  This file defines three functions:

#  Profile.multinorm:  Optimizing parameter values using outer optimization
#  Smooth.multinorm:   Smoothing data using the inner coefficient optimization
#  multinorm.setup:    Set up multivariate normal negative log density functions

################################################################################

Profile.multinorm <- function(fn,data,times,pars,coefs=NULL,basisvals=NULL,var=c(1,0.01),
                              fd.obj=NULL,more=NULL,quadrature=NULL,
                              in.meth='nlminb',out.meth='optim',
                              control.in,control.out,eps=1e-6,active=NULL,pos=0,
                              discrete=0)
{
    if(is.null(active)){ active = 1:length(pars) }

    profile.obj = multinorm.setup(pars,coefs,fn,basisvals,var,fd.obj,more,
                                  times,quadrature,eps=1e-6,pos=pos,
                                  discrete=discrete)
    
    lik   = profile.obj$lik
    proc  = profile.obj$proc
    coefs = profile.obj$coefs
         
    Ires = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    
    apars = pars[active]
    aparamnames = names(apars)
    
    res = outeropt(data,times,pars,Ires$coefs,lik,proc,in.meth,out.meth,
                   control.in,control.out,active)
    
    apars = res$pars[active]
    names(apars) = aparamnames
    ncoefs = as.matrix(res$coefs)
    
    pars[active] = apars
    
    if(!is.null(fd.obj)){
      fd.obj = fd(ncoefs,fd.obj$basis)
      return( list(pars=pars,fd=fd.obj,lik=lik,proc=proc,res=res$res) )
    }
    else{
      return( list(pars=pars,coefs=ncoefs,lik=lik,proc=proc,res$res) )
    }
}

################################################################################

Smooth.multinorm <- function(fn,data,times,pars,coefs=NULL,basisvals=NULL,var=c(1,0.01),
                             fd.obj=NULL,more=NULL,quadrature=NULL,
                             in.meth='nlminb',control.in,eps=1e-6,pos=0,discrete=0)
{

    profile.obj = multinorm.setup(pars,coefs,fn,basisvals,var,fd.obj,more,
                                  times,quadrature,eps=1e-6,pos=pos,discrete=discrete)

    lik  = profile.obj$lik
    proc = profile.obj$proc
    coefs = profile.obj$coefs
    
    dims = dim(data)

    if(length(dims)>2){
      data = matrix(data,dim(data)[1]*dim(data)[2],dim(data)[3])
      dims[1] = length(coefs)/(dims[2]*dims[3])
    }
    else{
      dims = dim(coefs)
    }

    Ires = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    ncoefs = Ires$coefs
    Ires = Ires$res
    ncoefs = array(ncoefs,dims)

    if(!is.null(fd.obj)){
      fd.obj = fd(ncoefs,fd.obj$basis)
      return( list(fd=fd.obj,lik=lik,proc=proc,res=Ires) )
    }
    else{
      return( list(coefs=ncoefs,lik=lik,proc=proc,res=Ires) )
    }


}

################################################################################

multinorm.setup = function(pars,coefs=NULL,fn,basisvals=NULL,var=c(1,0.01),fd.obj=NULL,
                           more=NULL,times=NULL,quadrature=NULL,eps=1e-6,pos=0,discrete=0)
{

    if(!is.null(fd.obj)){                 # If an fd object is provided, it overrides
      basisvals = fd.obj$basis            # the basis and function values

      if(!is.null(fd.obj$coefs)){
        coefs = fd.obj$coefs
      }

      colnames = fd.obj$fdnames[[3]]
    }
    else{
      colnames = NULL
    }


    lik = make.multinorm()
    
    if(pos==0){ lik$more = c(make.id(),make.cvar())}
    else { lik$more = c(make.exp(),make.cvar())}
    
    lik$more$f.more = NULL
    lik$more$v.more= list(mat=var[1]*diag(rep(1,2)),sub=matrix(0,0,3))
    
    if(length(dim(coefs))>2){
      if(is.null(colnames)){
        colnames = dimnames(coefs)[[3]]
      }
      nrep = dim(coefs)[2]
      coefs = matrix(coefs,dim(coefs)[1]*dim(coefs)[2],dim(coefs)[3])
    }
    else{
      nrep = 1
      colnames = colnames(coefs)
    }

    if(pos==0){
    	if(discrete==0) proc = make.Cproc()
    	else 
    	 proc = make.Dproc()
    	}
    else{
    	if(discrete==0) proc = make.exp.Cproc()
    	else 
    	 proc = make.exp.Dproc()
    }
    
    proc$more = make.multinorm()

    if(is.list(fn)){
      proc$more$more = c(fn,make.cvar())
      proc$more$more$f.more = NULL
      proc$more$more$v.more = list(mat=var[2]*diag(rep(1,2)),sub=matrix(0,0,3))
      proc$more$more$more = more
    }
    else if(is.function(fn)){
      proc$more$more = c(make.findif.ode(),make.cvar())
      proc$more$more$f.more$eps = eps
      proc$more$more$f.more$fn = fn
      proc$more$more$more = more
    }
    else{
      stop('fn must be either a list of functions or a function')
    }

    proc$more$names = colnames
    proc$more$parnames = names(pars)


    if(is.basis(basisvals)){
      if(is.null(times)){
        stop('if basisvals is is a basis object, you must specify the observation times')
      }

       lik$bvals = Matrix(diag(rep(1,nrep)) %x% eval.basis(times,basisvals),sparse=TRUE)
       
      if(is.null(quadrature) | is.null(quadrature$qpts)){
        knots = c(basisvals$rangeval[1],basisvals$params,basisvals$rangeval[2])
        qpts = knots[-length(knots)] + diff(knots)
      
      }
      else{
        qpts = quadrature$qpts
      }

      proc$bvals = list()
     
      if(discrete==0){
        proc$bvals$bvals  = Matrix(diag(rep(1,nrep))%x%eval.basis(qpts,basisvals,0),sparse=TRUE)
        proc$bvals$dbvals = Matrix(diag(rep(1,nrep))%x%eval.basis(qpts,basisvals,1),sparse=TRUE)
        proc$more$qpts = qpts
      }
      else{
       len = length(times)
       proc$bvals = Matrix(diag(rep(1,nrep))%x%eval.basis(times,basisvals,0),sparse=TRUE)
       proc$more$qpts = times[1:(len-1)]
      }
    }
    else{    
      if(discrete & (is.matrix(basisvals) | is.null(basisvals))){
        if(is.null(basisvals)){ basisvals = Diagonal(nrow(coefs)) }
        lik$bvals = basisvals
        proc$bvals = basisvals
        proc$more$qpts = times[1:(length(times)-1)]
      }                                    
      else{                                  
        lik$bvals = basisvals$bvals.obs
  
        proc$bvals =  list(bvals=basisvals$bvals,dbvals=basisvals$dbvals)
        proc$more$qpts = basisvals$qpts
      } 
       
    }

    return( list(lik=lik,proc=proc,coefs=coefs) )

}

require(pomp)
library(CollocInfer)


## euler.sim pomp object from the pomp library

data(euler.sir)

## Parameters

pars = coef(euler.sir)
parnames = names(pars)


## Observations and observation times; we'll start by assuming that the 
## observations are given by a scaled version of the infectives. 

Y = t(data.array(euler.sir))
times = time(euler.sir)

Data = matrix(NA,nrow(Y),5)   ## Easiest way to specify that we only observe
Data[,2] = log(Y) + 1.217     ## the infectives. 


## Solve the ODE to get a trajectory and state names

x <- trajectory(euler.sir)
varnames =  dimnames(x)[[1]]  ## I really wish I could extract this sort of thing
x = t(x[,1,])                 ## directly from the pomp object

x[,5] = 1

## Now set up a basis representation for the ODE and start by smoothing the 
## solved trajectory

ebasis = create.bspline.basis(c(0,4),norder=4,breaks=seq(0,4,0.1))

trajfd = smooth.basis(times,log(x[-1,]),fdPar(ebasis,int2Lfd(2),0.01))

coefs = trajfd$fd$coefs
colnames(coefs) = varnames

## Now we'll set up the CollocInfer objects

objs = LS.setup(pars=pars, coefs=coefs, fn=euler.sir,
                basisvals=ebasis, lambda = 1e1, 
                data = Data, times=times, posproc=TRUE)

## And try smoothing

res1 = inneropt(Data,times,pars,coefs,objs$lik,objs$proc,control.in=list(trace=6))


## And the outer optimization

res2 = outeropt(Data,times,pars,res1$coefs,objs$lik,objs$proc,active=1:3)

##########################
## Try without logging
#############################

Data = exp(Data)

trajfd = smooth.basis(times,x[-1,],fdPar(ebasis,int2Lfd(2),0.00001))

coefs = trajfd$fd$coefs
colnames(coefs) = varnames

coefs[,2] = smooth.basis(times,Data[,2],fdPar(ebasis,int2Lfd(2),0.00001))$fd$coef


## Now we'll set up the CollocInfer objects

objs = LS.setup(pars=pars, coefs=coefs, fn=euler.sir,
                basisvals=ebasis, lambda = 1e-3, 
                data = Data, times=times, posproc=FALSE)

## And try smoothing

res1 = inneropt(Data,times,pars,coefs,objs$lik,objs$proc,control.in=list(trace=6))

## And the outer optimization

res2 = outeropt(Data,times,pars,res1$coefs,objs$lik,objs$proc,active=1:3)



##### Now something more curious on the observation process; we'll use the difference
##### in the cases state variable.

proc = objs$proc
lik = objs$lik

lik$bvals = eval.basis(times,ebasis) - eval.basis(c(0,times[-208]),ebasis)

Data = matrix(0,208,5)
Data[,4] = Y

## And try smoothing

res1 = inneropt(Data,times,pars,coefs,lik,proc,control.in=list(trace=6))

## And the outer optimization

res2 = outeropt(Data,times,pars,res1$coefs,lik,proc,active=1:3)

########### Likelihood for Discrete-Time Dynamics ################ 

make.exp.Dproc <- function()
{

exp.Dproc <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs))
   ddevals = exp(as.matrix(bvals[2:nrow(bvals),]%*%coefs))

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames
    
   f = more$fn(ddevals,more$qpts,devals,pars,more$more)

   return( sum(f) )
}


exp.dDproc.dc <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs))
   ddevals = exp(as.matrix(bvals[2:nrow(bvals),]%*%coefs))

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

   g1 = more$dfdx(ddevals,more$qpts,devals,pars,more$more)*devals
   g2 = more$dfdy(ddevals,more$qpts,devals,pars,more$more)*ddevals

  g = as.vector( t(bvals[1:(nrow(bvals)-1),])%*%g1 + t(bvals[2:nrow(bvals),])%*%g2 )

  return(g)
}


exp.dDproc.dp <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs))
   ddevals = exp(as.matrix(bvals[2:nrow(bvals),]%*%coefs))

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  g = more$dfdp(ddevals,more$qpts,devals,pars,more$more)

  g = apply(g,2,sum)

  return(g)
}



exp.d2Dproc.dc2 <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs))
   ddevals = exp(as.matrix(bvals[2:nrow(bvals),]%*%coefs))

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames
   
   g1 = more$dfdx(ddevals,more$qpts,devals,pars,more$more)*devals
   g2 = more$dfdy(ddevals,more$qpts,devals,pars,more$more)*ddevals   

  H1 = more$d2fdx2(ddevals,more$qpts,devals,pars,more$more)
  H2 = more$d2fdxdy(ddevals,more$qpts,devals,pars,more$more)
  H3 = more$d2fdy2(ddevals,more$qpts,devals,pars,more$more)

  #H = array(0,c(rep(dim(bvals[1:(nrow(bvals)-1),])[2],2),rep(dim(devals)[2],2)))
   H = list(len=dim(bvals)[2])
   
  for(i in 1:dim(devals)[2]){
    H[[i]] = list(len=dim(devals))
    for(j in 1:dim(devals)[2]){
        H[[i]][[j]] = t(bvals[1:(nrow(bvals)-1),])%*%diag(devals[,i]*H1[,i,j]*devals[,j])%*%bvals[1:(nrow(bvals)-1),] +
            t(bvals[1:(nrow(bvals)-1),])%*%diag(devals[,i]*H2[,i,j]*ddevals[,j])%*%bvals[2:nrow(bvals),] + 
            t(bvals[2:nrow(bvals),])%*%diag(ddevals[,i]*H2[,j,i]*devals[,j])%*%bvals[1:(nrow(bvals)-1),] + 
            t(bvals[2:nrow(bvals),])%*%diag(ddevals[,i]*H3[,i,j]*ddevals[,j])%*%bvals[2:nrow(bvals),] 
    }
    H[[i]][[i]] = H[[i]][[i]] + t(bvals[1:(nrow(bvals)-1),])%*%diag(g1[,i])%*%bvals[1:(nrow(bvals)-1),] +
                t(bvals[2:nrow(bvals),])%*%diag(g2[,i])%*%bvals[2:nrow(bvals),]
  }

  H = blocks2mat(H)

  return(H)
}



exp.d2Dproc.dcdp <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs))
   ddevals = exp(as.matrix(bvals[2:nrow(bvals),]%*%coefs))

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  H1 = more$d2fdxdp(ddevals,more$qpts,devals,pars,more$more)
  H2 = more$d2fdydp(ddevals,more$qpts,devals,pars,more$more)

  H = c()

  for(i in 1:length(pars)){
      H = cbind(H,as.vector(t(bvals[1:(nrow(bvals)-1),])%*%(devals*H1[,,i]) +
            t(bvals[2:nrow(bvals),])%*%(ddevals*H2[,,i])))
  }

  return(H)
}



    return(
        list(
            fn = exp.Dproc,
            dfdc = exp.dDproc.dc,
            dfdp = exp.dDproc.dp,
            d2fdc2 = exp.d2Dproc.dc2,
            d2fdcdp = exp.d2Dproc.dcdp
        )
    ) 
} 

#### A general multivariate normal function; some of this 
# should be coded as C
make.multinorm <- function()
{

#########################################################################

multinorm = list()
multinorm$fn <- function(y,times,x,pars,more)
{
    #  computes negative log density for multivariate normal distribution
    F = more$fn(times,x,pars,more$f.more)    
    S = more$var.fn(times,x,pars,more$v.more)   
    d = rep(0, dim(F)[1])
    if( dim(S)[1] == 1) {
      #  if variance is constant, inverse of S is computed once
      Sinv = solve(S[1,,])     
      lognormconst = -0.5*log(det(Sinv)) 
    }                                                     
    for(i in 1:dim(F)[1]){
        if( dim(S)[1] > 1) { 
          Sinv = solve(S[i,,]) 
          lognormconst = -0.5*log(det(Sinv)) 
        }
        resi = y[i,]-F[i,]
        d[i] = 0.5*t(resi) %*% Sinv %*% resi + lognormconst
    }
    return(d)
}

#########################################################################

multinorm$dfdy <- function(y,times,x,pars,more)
{
     F = more$fn(times,x,pars,more$f.more)
     S = more$var.fn(times,x,pars,more$v.more)

     d = array(0,dim(y))

     if( dim(S)[1] == 1){ SS = solve(S[1,,]) }
     
     for(i in 1:dim(y)[1]){
        if( dim(S)[1] > 1){ SS = solve(S[i,,]) }
        d[i,] = SS%*%(y[i,]-F[i,])
     }
     return(d)
}

#########################################################################

multinorm$dfdx <- function(y,times,x,pars,more)
{
     F = more$fn(times,x,pars,more$f.more)
     dF = more$dfdx(times,x,pars,more$f.more)
     
     S = more$var.fn(times,x,pars,more$v.more)
     dS = more$var.dfdx(times,x,pars,more$v.more)

     d = array(0,dim(x))
     
     
     if( dim(S)[1] == 1){ 
        SS = solve(S[1,,]) 
        dSS = array(dS[1,,,],dim(dS)[2:4])
    }

     for(i in 1:dim(x)[1]){
        if( dim(S)[1] > 1){
            SS = solve(S[i,,])
            dSS = array(dS[i,,,],dim(dS)[2:4])
        }
        wdifs = SS%*%(y[i,]-F[i,])

        d[i,] = -t(t(array(dF[i,,],dim(dF)[2:3]))%*%wdifs) 
            for(j in 1:dim(x)[2]){

              d[i,j] = d[i,j] - 0.5*t(wdifs)%*%dSS[,,j]%*%wdifs +
                    0.5*sum(diag(SS%*%dSS[,,j])) 
            }
     }
     return(d)
}

#########################################################################

multinorm$dfdp <- function(y,times,x,pars,more)
{
     F = more$fn(times,x,pars,more$f.more)
     dF = more$dfdp(times,x,pars,more$f.more)
     
     S = more$var.fn(times,x,pars,more$v.more)
     dS = more$var.dfdp(times,x,pars,more$v.more)

     d = matrix(0,dim(x)[1],length(pars))

     if( dim(S)[1] == 1){ 
        SS = solve(S[1,,]) 
        dSS = array(dS[1,,,],dim(dS)[2:4])
    }

     for(i in 1:dim(x)[1]){
        if( dim(S)[1] > 1){
            SS = solve(S[i,,])
            dSS = array(dS[i,,,],dim(dS)[2:4])
        }
        wdifs = SS%*%(y[i,]-F[i,])
        d[i,] = -t(array(dF[i,,],dim(dF)[2:3]))%*%wdifs 
           for(j in 1:length(pars)){
                d[i,j] = d[i,j] - 0.5*t(wdifs)%*%dSS[,,j]%*%wdifs +
                    0.5*sum(diag(SS%*%dSS[,,j])) 
           }    
    }

    return(d)

}

#########################################################################

multinorm$d2fdx2 <- function(y,times,x,pars,more)
{
     F = more$fn(times,x,pars,more$f.more)
     dF = more$dfdx(times,x,pars,more$f.more)
     d2F = more$d2fdx2(times,x,pars,more$f.more)
     
     S = more$var.fn(times,x,pars,more$v.more)
     dS = more$var.dfdx(times,x,pars,more$v.more)
     d2S = more$var.d2fdx2(times,x,pars,more$v.more)

     d = array(0,c(dim(x)[1],dim(x)[2],dim(x)[2]))

     if( dim(S)[1] == 1){
        SS = solve(S[1,,])
        dSS = array(dS[1,,,],dim(dS)[2:4])
        d2SS = array(d2S[1,,,,],dim(d2S)[2:5])
     }

     for(i in 1:dim(x)[1]){
        if( dim(S)[1] > 1){
            SS = solve(S[i,,])
            dSS = array(dS[i,,,],dim(dS)[2:4])
            d2SS = array(d2S[i,,,,],dim(d2S)[2:5])
        }
        wdifs = SS%*%(y[i,]-F[i,])
        
        for(j in 1:dim(x)[2]){     
            for(k in j:dim(x)[2]){
                d[i,j,k] = -(d2F[i,,j,k]-dF[i,,j]%*%SS%*%dSS[,,k]-dF[i,,k]%*%SS%*%dSS[,,j])%*%wdifs +
                   0.5*t(wdifs)%*%(dSS[,,j]%*%SS%*%dSS[,,k]+dSS[,,k]%*%SS%*%dSS[,,j]-d2SS[,,j,k])%*%wdifs +
                   t(dF[i,,j])%*%SS%*%dF[i,,k] - 0.5*sum(diag(SS%*%(dSS[,,j]%*%SS%*%dSS[,,k] - d2SS[,,j,k])))
                d[i,k,j] = d[i,j,k]
            }     
        }
     }
     return(d)
}

#########################################################################

multinorm$d2fdy2 <- function(y,times,x,pars,more)
{
    S = more$var.fn(times,x,pars,more$v.more)
    
    d = array(0,c(dim(y),dim(y)[2]))
    
    if( dim(S)[1] == 1){ SS = solve(S[1,,]) }  
    
    for(i in 1:dim(x)[1]){ 
        if( dim(S)[1] > 1){ SS = solve(S[i,,]) }
        d[i,,] = 0.5*(t(SS) + SS) 
    }
    
    return(d)
    
}

#########################################################################

multinorm$d2fdxdy <- function(y,times,x,pars,more)
{
     F = more$fn(times,x,pars,more$f.more)
     dF = more$dfdx(times,x,pars,more$f.more)
 
     S = more$var.fn(times,x,pars,more$v.more)
     dS = more$var.dfdx(times,x,pars,more$v.more)
     d = array(0,c(dim(x)[1],dim(x)[2],dim(y)[2]))

     if( dim(S)[1] == 1){
        SS = solve(S[1,,])
        dSS = array(dS[1,,,],dim(dS)[2:4])
     }
     for(i in 1:dim(x)[1]){
        if( dim(S)[1] > 1){
            SS = solve(S[i,,])
            dSS = array(dS[i,,,],dim(dS)[2:5])
        }
        for(j in 1:dim(x)[2]){
            d[i,j,] = -SS%*%dSS[,,j]%*%SS%*%(y[i,]-F[i,]) - SS%*%dF[i,,j]        
        }     
     }

    return(d)
}

#########################################################################

multinorm$d2fdxdp <- function(y,times,x,pars,more)
{
     F = more$fn(times,x,pars,more$f.more)
     dFx = more$dfdx(times,x,pars,more$f.more)
     dFp = more$dfdp(times,x,pars,more$f.more)
     d2F = more$d2fdxdp(times,x,pars,more$f.more)
     
     S = more$var.fn(times,x,pars,more$v.more)
     dSx = more$var.dfdx(times,x,pars,more$v.more)
     dSp = more$var.dfdp(times,x,pars,more$v.more)
     d2S = more$var.d2fdxdp(times,x,pars,more$v.more)

     d = array(0,c(dim(x)[1],dim(x)[2],length(pars)))

     if( dim(S)[1] == 1){
       SS = solve(S[1,,])
       dSSx = array(dSx[1,,,],dim(dSx)[2:4])
       dSSp = array(dSp[1,,,],dim(dSp)[2:4])
       d2SS = array( d2S[1,,,,],dim(d2S)[2:5])
     }

     for(i in 1:dim(x)[1]){
        if( dim(S)[1] > 1){
            SS = solve(S[i,,])
            dSSx = array(dSx[i,,,],dim(dSx)[2:4])
            dSSp = array(dSp[i,,,],dim(dSp)[2:4])
            d2SS = array(d2S[i,,,,],dim(d2S)[2:5])
        }
        wdifs = SS%*%(y[i,]-F[i,])
        for(j in 1:dim(x)[2]){     
            for(k in 1:length(pars)){
                d[i,j,k] = -(d2F[i,,j,k]-dFx[i,,j]%*%SS%*%dSSp[,,k]-dFp[i,,k]%*%SS%*%dSSx[,,j])%*%wdifs +
                   0.5*t(wdifs)%*%(dSSx[,,j]%*%SS%*%dSSp[,,k]+dSSp[,,k]%*%SS%*%dSSx[,,j]-d2SS[,,j,k])%*%wdifs + 
                   t(dFx[i,,j])%*%SS%*%dFp[i,,k] - 0.5*sum(diag(SS%*%(dSSx[,,j]%*%SS%*%dSSp[,,k] - d2SS[,,j,k])))
            }     
        }
     }
     return(d)
}

#########################################################################

multinorm$d2fdydp <- function(y,times,x,pars,more)
{
     F = more$fn(times,x,pars,more$f.more)
     dF = more$dfdp(times,x,pars,more$f.more)
   
     S = more$var.fn(times,x,pars,more$v.more)
     dS = more$var.dfdp(times,x,pars,more$v.more)

     d = array(0,c(dim(y)[1],dim(y)[2],length(pars)))

     if( dim(S)[1] == 1){ 
        SS = solve(S[1,,]) 
        dSS = array(dS[1,,,],dim(dS)[2:4])
     }     
     for(i in 1:dim(y)[1]){
        if( dim(S)[1] > 1){ 
            SS = solve(S[i,,]) 
            dSS = array(dS[i,,,],dim(dS)[2:4])
        }
        for(j in 1:length(pars)){
            d[i,,j] = -SS%*%(dSS[,,j]%*%SS%*%(y[i,]-F[i,]) + dF[i,,j])
        }
     }
     return(d)
}

  return(multinorm)
    
}

library('CollocInfer')
source('../../R/ls.shortcut.r')
source('LV.R')

#data  = read.table('LynxHare.dat',head=TRUE)
data = read.table('LynxHare2.dat',head=TRUE)
times = data[,1]
data = as.matrix(data[,2:3])



plot(data,type='l')

matplot(times,data,type='b')

bbasis = create.bspline.basis(range(times),norder=4,nbasis=40)
fdobj = smooth.basis(times,data,fdPar(bbasis,2,lambda=0.1))

plotfit.fd(data,times,fdobj$fd)


coefs = fdobj$fd$coefs

fn = make.LV()

setup.obj = LS.setup(rep(0,4),fn=fn,basisvals=bbasis,coefs=coefs,lambda=1e5,data=data,times=times)
lik = setup.obj$lik
proc = setup.obj$proc

proc$more$weights = 1e5 + 0*proc$more$weights


# First some parameters

fvals = eval.fd(proc$more$qpts,fdobj$fd)
Y = eval.fd(proc$more$qpts,fdobj$fd,1)

X1 = cbind(fvals[,1],-fvals[,1]*fvals[,2])
p1 = solve(t(X1)%*%X1,t(X1)%*%Y[,1])

X2 = cbind(-fvals[,2],fvals[,1]*fvals[,2])
p2 = solve(t(X2)%*%X2,t(X2)%*%Y[,2])

pars = c(p1,p2)

#resP = ParsMatchOpt(rep(0,4),coefs,proc)
#pars = resP$pars

# Let's look at the trajectories

y0 = as.vector(eval.fd(times[1],fdobj$fd))
out = lsoda(y0,times,oderhs,parms=list(proc=proc,pars=pars))
matplot(out[,1],out[,2:3],type='l',lty=1)
matplot(times,data,add=TRUE,pch=1,type='b',lty=2)

# Now let's try some trajectory matching

objectivefn = function(pars)
{
  print(pars)
  parms = list(proc=proc,pars=pars[3:6])
  out = lsoda(pars[1:2],times,oderhs,parms)
  traj = out[,2:3]
  val = sum(lik$fn(data,times,traj,pars,lik$more))
  print(val)
  return(val)
}

resT = optim(c(y0,pars),objectivefn,lower=0,method='L-BFGS-B')

y0T = resT$par[1:2]
parsT = resT$par[3:6]

out = lsoda(y0T,proc$more$qpts,oderhs,parms=list(proc=proc,pars=parsT))
matplot(out[,1],out[,2:3],type='l',lty=1)
matplot(times,data,add=TRUE,pch=1,type='b',lty=2)


# Now some profiling

resI = inneropt(data,times,pars,coefs,lik,proc)

matplot(proc$more$qpts,proc$bvals$bvals%*%resI$coefs,type='l',lty=1)
matplot(times,data,type='b',pch=1,lty=2,add=TRUE)


resO = outeropt(data,times,pars,resI$coefs,lik,proc,out.meth='optim')

matplot(times,lik$bvals%*%resO$coefs,type='l',lty=1)
matplot(times,data,type='b',pch=1,lty=2,add=TRUE)


fd5 = fd(resO$coefs,bbasis)
plotfit.fd(data,times,fd5)


### and up the weight factor

proc2 = proc
proc2$more$weights = 1e12 + proc$more$weights*0

resI2 = inneropt(data,times,pars,coefs,lik,proc2)

matplot(proc$more$qpts,proc$bvals$bvals%*%resI2$coefs,type='l',lty=1)
matplot(times,data,type='b',pch=1,lty=2,add=TRUE)

resO2 = outeropt(data,times,pars,resI2$coefs,lik,proc2,out.meth='optim')

matplot(proc$more$qpts,proc$bvals$bvals%*%resO2$coefs,type='l',lty=1)
matplot(times,data,type='b',pch=1,lty=2,add=TRUE)

fd12 = fd(resO2$coefs,bbasis)
plotfit.fd(data,times,fd12)


### Now lets try a larger basis

bbasis = create.bspline.basis(range(times),norder=4,nbasis=200)

setup.obj = LS.setup(rep(0,4),fn=fn,basisvals=bbasis,coefs=coefs,lambda=1e5,data=data,times=times)
lik = setup.obj$lik
proc = setup.obj$proc


fdobj = smooth.basis(proc$more$qpts,eval.fd(proc$more$qpts,fd5),fdPar(bbasis,2,0.001))

coefs = fdobj$fd$coefs

resO.2 = outeropt(data,times,resO$pars,coefs,lik,proc,out.meth='optim')

matplot(proc$more$qpts,proc$bvals$bvals%*%resO.2$coefs,type='l',lty=1)
matplot(times,data,type='b',pch=1,lty=2,add=TRUE)


fdobj = smooth.basis(proc$more$qpts,eval.fd(proc$more$qpts,fd12),fdPar(bbasis,2,0.001))
proc2 = proc
proc2$more$weights = 1e12/5 + proc$more$weights*0


coefs = fdobj$fd$coefs

res2O.2 = outeropt(data,times,resO2$pars,coefs,lik,proc2,out.meth='optim')

matplot(proc$more$qpts,proc$bvals$bvals%*%res2O.2$coefs,type='l',lty=1)
matplot(times,data,type='b',pch=1,lty=2,add=TRUE)

### This transforms a likelihood for data given a state x given in the
### functions in "more" into a likelihood given exp(x) and associated
### derivatives

make.logstate.lik <- function()
{

logstate.lik.fun <- function(data,times,y,p,more)
{
    y = exp(y)
    x = more$fn(data,times,y,p,more$more)
    
    return(x)
}

logstate.lik.dfdx <- function(data,times,y,p,more)
{
     y = exp(y)
     x = more$dfdx(data,times,y,p,more$more)

     for(i in 1:dim(x)[2]){
        x[,i] = x[,i]*y[,i]
     }
     return(x)
}

logstate.lik.dfdp <- function(data,times,y,p,more)
{
     y = exp(y)
     x = more$dfdp(data,times,y,p,more$more)
     return(x)
}

logstate.lik.d2fdx2 <- function(data,times,y,p,more)
{
     x1 = logstate.lik.dfdx(data,times,y,p,more)
     
     y = exp(y)
     x = more$d2fdx2(data,times,y,p,more$more)

     for(i in 1:dim(x)[2]){
        for(j in 1:dim(x)[3]){
              x[,i,j] = x[,i,j]*y[,i]*y[,j]
        }
        x[,i,i] = x[,i,i] + x1[,i]
     }
     return(x)
}

logstate.lik.d2fdxdp <- function(data,times,y,p,more)
{
     y = exp(y)
     x = more$d2fdxdp(data,times,y,p,more$more)

     for(i in 1:dim(x)[2]){
        for(j in 1:dim(x)[3]){
           x[,i,j] = x[,i,j]*y[,i]
        }
     }
     return(x)
}



    return( 
        list(
            fn = logstate.lik.fun,
            dfdx = logstate.lik.dfdx,
            dfdp = logstate.lik.dfdp,
            d2fdx2 = logstate.lik.d2fdx2,
            d2fdxdp = logstate.lik.d2fdxdp
        )
    )
}

#MCMC E step for EM collocation
Estep.MCMC = function(times,data,pars,coefs,lik,proc,prior,walk.var,cscale,nstep,in.meth='SplineEst',control.in=NULL)
{
    parhist = matrix(0,nstep,length(pars))                     # Store parameter history
    coefhist = matrix(0,nstep,length(coefs))
    bestcoefhist = matrix(0,nstep,length(coefs))
    acc = rep(0,nstep)

    f = SplineCoefsErr(coefs,times,data,lik,proc,pars,sgn=-1)   # Complete data log posterior

    tcoefs = coefs


    parhist[1,] = pars                              # Initialize
    bestcoefhist[1,]=tcoefs
    coefhist[1,] = tcoefs

    eta = 0        # cscale = 0 defaults to Collocation MCMC

    for(i in 2:nstep){
       print(i)
        if(cscale>0){
          eta = rnorm(length(coefs))*cscale
        }
    tf =  SplineCoefsErr(as.vector(tcoefs)+eta,times,data,lik,proc,pars,sgn=-1)

    print(c(tf,f))
       if( runif(1) < exp( tf-f)){             # Acceptance probability
          coefs = as.vector(tcoefs)+eta
          f = tf
          acc[i] = 1
       }

       parhist[i,] = pars
       coefhist[i,] = coefs
    #   bestcoefhist[i,] = res$coefs
    }

   return(list(parhist=parhist, coefhist=coefhist, acc = acc))
}

#  This file defines four functions:
#  inneropt:  optimization with respect to coefficients given parameter values
#  outeropt:  optimization of parameters
#  FitMatchOpt:  
#  ParsMatchOpt:

##############################################################################

inneropt <- function(data, times, pars, coefs, lik, proc, in.meth='nlminb', 
                     control.in=NULL)
{

#  The multivariate data in argment data are observations of one or more
#  functional variables or processes at time points in argument time.

#  The data are smoothed using differential operators.  These operators are 
#  defined by the functions in argument fn.  

#  The function optimizes the coefficients of the basis expansions for the
#  representations of the variables or processes in what is called the
#  inner optimization loop.

#  The fitting criterion for both the data and the differential equation
#  is user-defined in arguments lik and proc, respectively.

#  The optimization method for the inner loop is defined by argument in.meth.

#  The function returns the optimized coefficients and the residual values.

  if (in.meth=="SplineEst"){
    #  optimization by Newton-Raphson using function SplineEst.NewtRaph
        res = SplineEst.NewtRaph(coefs,times,data,lik,proc,pars,control.in)
        ncoefs = matrix(res$coefs,ncol(lik$bvals),length(res$coefs)/ncol(lik$bvals))
    }
    else if(in.meth=="optim"){
    #  optimization using function optim
        res = optim(coefs,SplineCoefsErr,gr=SplineCoefsDC,hessian=T,
            control=control.in,times=times,data=data,lik=lik,proc=proc,pars=pars,method="BFGS")

        ncoefs = matrix(res$par,ncol(lik$bvals),length(res$par)/ncol(lik$bvals))
    }    
    else if(in.meth=="nlminb"){
    #  optimization using function nlminb
        res = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
            control=control.in,times=times,data=data,lik=lik,proc=proc,pars=pars)

        ncoefs = matrix(res$par,ncol(lik$bvals),length(res$par)/ncol(lik$bvals))
    }
    else if(in.meth=="maxNR"){
    #  optimizaton using function maxNR
        if(is.null(control.in$print.level)){control.in$print.level = 1}
        if(is.null(control.in$iterlim)){control.in$iterlim = 1000}    
        res = maxNR(SplineCoefsErr,coefs,times=times,data=data,lik=lik,proc=proc,pars=pars,sgn=-1,
            grad=SplineCoefsDC,hess=SplineCoefsDC2,print.level=control.in$print.level,
            iterlim = control.in$iterlim)

        ncoefs = matrix(res$estimate,ncol(lik$bvals),length(res$estimate)/ncol(lik$bvals))
    }
    else if(in.meth=='trust'){
    #  optimization using functon trust
        if(is.null(control.in$rinit)){ control.in$rinit = 1}
        if(is.null(control.in$rmax)){ control.in$rinit = 100}
        if(is.null(control.in$parscale)){ control.in$parscale = abs(coefs)}
        if(is.null(control.in$iterlim)){ control.in$iterlim = 100}
        
        res = trust(SplineCoefsList,coefs,rinit=control.in$rinit,rmax=control.in$rmax,parscale=control.in$parscale,iterlim=control.in$iterlim,
          times=time,data=data,lik=lik,proc=proc,pars=pars,sgn=1)
    
        ncoefs = matrix(res$argument,dim(coefs))
    }

    if(!is.null(proc$more$names)){ colnames(ncoefs) = proc$more$names }
  
    return(list(coefs=ncoefs,res=res))
}

##############################################################################

outeropt <- function(data, times, pars, coefs, lik, proc,
                     in.meth='nlminb', out.meth='nlminb',
                     control.in=NULL, control.out=NULL,
                     active=1:length(pars))
{

#  The multivariate data in argment data are observations of one or more
#  functional variables or processes at time points in argument times.

#  The data are smoothed using differential operators.  

#  The operators typically depend on a number of parameters whose values
#  are in argument pars.  The function optimizes these parameter values.

#  The fitting criterion for both the data and the differential equation
#  is user-defined in arguments lik and proc, respectively.

#  The function optimizes the coefficients of the basis expansions for the
#  representations of the variables or processes in what is called the
#  inner optimization loop, implemented by function Inneropt.  It optimizes the
#  parameter values in the outer optimization loop.

#  The optimization method for the inner loop is defined by argument in.meth.
#  The optimization method for the outer loop is defined by argument out.meth.

#  The function returns the optimized parameter values, a functional data object defining 
#  the smoothing functions, the likelihood and process functions, and the
#  residual values.

    if(file.exists('curcoefs.tmp')) file.remove('curcoefs.tmp')
    if(file.exists('optcoefs.tmp')) file.remove('optcoefs.tmp')
    if(file.exists('counter.tmp'))  file.remove('counter.tmp')


    Ires   = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    ncoefs = matrix(Ires$coefs,dim(coefs))

    write.table(ncoefs,file='optcoefs.tmp',col.names=FALSE,row.names=FALSE)
    write.table(ncoefs,file='curcoefs.tmp',col.names=FALSE,row.names=FALSE)

    if(out.meth=="optim")
    {
      if( is.null(control.out$meth) ){ control.out$meth = "BFGS" }
    	res = optim(pars[active],ProfileErr,allpars=pars,times=times,data=data,coef=coefs,lik=lik,proc=proc,active=active,
        hessian=T,in.meth=in.meth,control.in=control.in,control=control.out,gr=ProfileDP,method=control.out$meth)
    	npar = res$par
   	}

    else if(out.meth=="nlminb")
    {
        res = nlminb(pars[active],ProfileErr,allpars=pars,times=times,data=data,coef=coefs,lik=lik,proc=proc,
    	   in.meth=in.meth,control.in=control.in,control=control.out,gr=ProfileDP,active=active)
        npar = res$par
    }

    else if(out.meth=="maxNR")
    {
        if(is.null(control.out$print.level)){control.out$print.level = 2}
        if(is.null(control.out$iterlim)){control.out$iterlim = 100}
    
        res = maxNR(ProfileErr,start=pars[active],allpars=pars,times=times,data=data,coef=coefs,lik=lik,proc=proc,
    	   in.meth=in.meth,control.in=control.in,active=active,sgn=-1,
         grad=ProfileDP,print.level=control.out$print.level,iterlim=control.out$iterlim)
        npar = res$estimate
     }
     else if(out.meth=="subplex")
     {
        res = subplex(pars[active],ProfileErr,control=control.out,hessian=FALSE,
         allpars=pars,times=times,data=data,coef=coefs,lik=lik,proc=proc,
    	   in.meth=in.meth,control.in=control.in,active=active)
        npar = res$par
     }
     else if(out.meth=="trust")
     {
        if(is.null(control.out$rinit)){ control.out$rinit = 1}
        if(is.null(control.out$rmax)){ control.out$rinit = 100}
        if(is.null(control.out$parscale)){ control.out$parscale = abs(pars[active]) }
        if(is.null(control.out$iterlim)){ control.out$iterlim = 100}
     
        res = trust(ProfileList,pars[active],rinit=control.out$rinit,
        rmax=control.out$rmax,parscale=control.out$parscale,iterlim=control.out$iterlim,
          allpars=pars,times=times,data=data,coef=coefs,lik=lik,proc=proc,
    	    in.meth=in.meth,control.in=control.in,active=active)
        npar = res$argument
     }
     else if(out.meth == "ProfileGN"){
      res=Profile.GausNewt(pars=pars,times=times,data=data,coefs=ncoefs,
		    lik=lik,proc=proc,in.meth=in.meth,control.in=control.in,
		    active=active,control=control.out)
      npar = res$pars[active]

      ncoefs = res$in.res$coefs
      g = res$in.res$df
      resid = res$in.res$f
    }
    else if(out.meth == "nls"){
      res = nls(~ProfileSSE(pars,allpars,times,data,coefs,lik,proc,in.meth,control.in,active),
        data = list(allpars=pars,times=times,data=data,coefs=ncoefs,lik=lik,proc=proc,
        in.meth=in.meth,control.in=control.in,active=active),
        start = list(pars=pars[active]),trace=control.out$trace)
      npar = res$m$getPars()

      g = res$m$gradient()
      resid = res$m$resid()
    }
     
     if(file.exists('curcoefs.tmp')){
      	 ncoefs = as.matrix(read.table('curcoefs.tmp'))
   	 }
   	 else{ ncoefs = c() }
     if(file.exists('counter.tmp')){
      counter = as.matrix(read.table('counter.tmp'))
     } 	 
     else{  counter = c() }
    
    if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
    if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
    if(file.exists('counter.tmp')){file.remove('counter.tmp')}
        
    pars[active] = npar
    if(!is.null(proc$more$names)){ colnames(ncoefs) = proc$more$names }
    
    return(list(pars=pars,coefs=ncoefs,res=res,counter=counter))
}

##############################################################################

FitMatchOpt <- function(coefs,which,pars,proc,meth='nlminb',control=NULL)
{

   if(meth=="optim"){
        res = optim(coefs[,which],FitMatchErr,gr=FitMatchDC,hessian=T,
                    control=control,allcoefs=coefs,which=which,pars=pars,
                    proc=proc,method="BFGS")
        ncoefs = matrix(res$par,length(which),length(res$par)/length(which))
    }
    else if(meth=="nlminb"){
        res = nlminb(start=coefs[,which],objective=FitMatchErr,gradient=FitMatchDC,
                     hessian=FitMatchDC2,control=control,allcoefs=coefs,which=which,
                     pars=pars,proc=proc)
        ncoefs = matrix(res$par,length(which),length(res$par)/length(which))
    }
    else if(meth=="maxNR"){
        res = maxNR(FitMatchErr,coefs[,which],allcoefs=coefs,which=which,pars=pars,
                    proc=proc,sgn=-1,grad=FitMatchDC,hess=FitMatchDC2,
                    print.level=control$print.level,iterlim = control$iterlim)
        ncoefs = matrix(res$estimate,length(which),length(res$estimate)/length(which))
    }
    else if(meth=='trust'){
        if(is.null(control$rinit))   control$rinit = 1
        if(is.null(control$rmax))    control$rinit = 100
        if(is.null(control$parscale))control$parscale = length(length(which)*nrow(coefs))
        if(is.null(control$iterlim)) control$iterlim = 100
        res = trust(FitMatchList,coefs[,which],rinit=control$rinit,rmax=control$rmax,
                    parscale=control$parscale,iterlim=control$iterlim,
                    allcoefs=coefs,which=which,pars=pars,proc=proc)
        ncoefs = matrix(res$argument,length(which),length(res$estimate)/length(which))
    }
    coefs[,which] = ncoefs

    return(list(coefs=coefs,res=res))
}

##############################################################################

ParsMatchOpt <- function(pars,coefs,proc,active=1:length(pars),meth='nlminb',control=NULL)
{

   if(meth=="optim"){
        res = optim(pars[active],ParsMatchErr,gr=ParsMatchDP,hessian=T,
            control=control,coefs=coefs,proc=proc,active=active,allpars=pars,method="BFGS")
        npars = res$par
    }
    else if(meth=="nlminb"){
        res = nlminb(pars[active],ParsMatchErr,gradient=ParsMatchDP,
            control=control,coefs=coefs,proc=proc,active=active,allpars=pars)
        npars = res$par
    }
    else if(meth=="maxNR"){
        res = maxNR(ParsMatchErr,pars[active],coefs=coefs,proc=proc,active=active,
                    allpars=pars,sgn=-1,grad=ParsMatchDP,print.level=control$print.level,
                    iterlim = control$iterlim)
        npars = res$estimate
    }
    else if(meth=="trust")
    {
        if(is.null(control$rinit)){ control$rinit = 1}
        if(is.null(control$rmax)){ control$rinit = 100}
        if(is.null(control$parscale)){ control$parscale = length(active)}
        if(is.null(control$iterlim)){ control$iterlim = 100}

        res = trust(ParsMatchList,pars[active],rinit=control$rinit,rmax=control$rmax,
                    parscale=control$parscale,iterlim=control$iterlim,
                    coefs=coefs,proc=proc,active=active,allpars=pars)
        npars = res$argument
    }
    
    
    pars[active] = npars

    return(list(pars=pars,res=res))
}

source('Devel/Colloc.MCMC.R')

walk.var = diag(c(0.001,0.001,0.01))
cscale = 0.000001

prior = function(pars){ return( sum(dnorm(pars/c(1,1,10),log=TRUE))) }
nstep = 100


hmm = Colloc.MCMC(times,data,pars+c(-0.1,0.1,-1),coefs,lik,proc,prior,walk.var,cscale,nstep,in.meth='SplineEst',control.in=control.in)

# This demonstration file is intended to accompany the CollocInfer manual. 

library(CollocInfer)


# To ensure reproducibility
set.seed((2004*2007)/2014)

# The first section of this demo file provides the code to generate simulation data
# from the FitzHugh-Nagumo model. We will delete it later and call a standard set of data
# with data(FhNdata). This is for the purposes of providing reproducible results; the data we
# will use were generated with exactly the commands below. 


# First we will define some variable and parameter names

FhNvarnames = c('V','R')
FhNparnames = c('a','b','c')

# and initial conditions and parameters

x0 = c(-1,1)
names(x0) = FhNvarnames

FhNpars = c(0.2,0.2,3)
names(FhNpars) = FhNparnames


# The following is a function specifying the FitzHugh-Nagumo model in a form that
# lsoda works with 

fhn.ode <- function(times,x,p)
{
 dx = x;
 dimnames(dx) = dimnames(x);
 dx['V'] = p['c']*(x['V'] - x['V']^3/3 + x['R'])
 dx['R'] = -(x['V'] -p['a'] + p['b']*x['R'])/p['c']

 return(list(dx))
}
 
# We need the times at which we will observe the system
 
FhNplottimes = seq(0,20,0.05)

# And now we can create solutions to the equations

out = lsoda(x0,times=FhNplottimes,fhn.ode,FhNpars)

# and plot what the solutions look like

par(mar=c(5,5,1,1))
matplot(out[,1],out[,2:3],type='l',xlab='time',ylab='(V,R)',lwd=3,cex.lab=2.5,cex.axis=2.5)
legend('bottomleft',c('V','R'),lwd=3,col=1:2,lty=1:2,cex=1.5)

par(mar=c(5,5,1,1))
plot(out[,2],out[,3],type='l',lwd=3,xlab='V',ylab='R',cex.lab=2.5,cex.axis=2.5)

# We now add some noise to the values of the curves at a reduced set of sampling times:

FhNtimes = seq(0,20,0.5)
FhNn = length(FhNtimes)
y = lsoda(x0,times=FhNtimes,fhn.ode,FhNpars)
FhNdata = out[,2:3] + 0.06*matrix(2*FhNn,FhNn,2)


## Let's undo all this work and call a standard data set generated from this
# code with which to run the profiling proceedures. 

rm(list=ls())
data(FhNdata)


# In order to run the profiling proceedures, we need to define some objects. 

# The following code will define a basis

range = c(0,20)
knots = seq(0,20,0.5)
norder = 4

FhNbasis = create.bspline.basis(range=range,norder=norder,breaks=knots)

# And this will smooth the data

DEfd0 = smooth.basis(FhNtimes,FhNdata,fdPar(FhNbasis,int2Lfd(2),1))$fd

#  and produce a plot of how well this agrees with the smooth
par(mfrow=c(2,1),mar=c(5,5,2,1))
plotfit.fd(FhNdata, FhNtimes, DEfd0, cex.axis=2.5, cex.lab=2.5, lwd=2, cex=1.5)


# We can now extract the coefficients, which we will also require

coefs0 = DEfd0$coef
colnames(coefs0) = FhNvarnames

# CollocInfer requires the right hand side function to be defined somewhat differently
# to lsoda. Here we allow a matrix of values as input 

fhn.fun <- function(times,x,p,more)
{
 dx = x;
 dx[,'V'] = p['c']*(x[,'V'] - x[,'V']^3/3 + x[,'R'])
 dx[,'R'] = -(x[,'V'] -p['a'] + p['b']*x[,'R'])/p['c']
 return(dx)
}           


# Now we can choose a trade-off parameter and set up the objects that the profiling
# functions will use. 

lambda = 1000

profile.obj = LS.setup(pars=FhNpars,fn=fhn.fun,lambda=lambda,times=FhNtimes,
                       coefs=coefs0,basisvals=FhNbasis)
                       
proc = profile.obj$proc
lik = profile.obj$lik
                       
## Gradient matching can be obtained thr ParsMatchOpt and produces useful initial
# parameter estimates

Pres0  = ParsMatchOpt(FhNpars,coefs0,proc)
pars1 = Pres0$pars

## Inner optimisation to smooth the data using the differential equation as a penalty

Ires1 = inneropt(FhNdata,times=FhNtimes,pars1,coefs0,lik,proc)
coefs1 = Ires1$coefs

# Alternatively, Smooth.LS avoids the need to run LS.setup, and it also returs
# the lik and proc objects. 

Ires1.2 = Smooth.LS(fhn.fun,FhNdata,FhNtimes,FhNpars,coefs0,FhNbasis,lambda)

# And outer optimization to choose parameters

Ores2 = outeropt(FhNdata,FhNtimes,pars1,coefs1,lik,proc)

# Here the relevant objects to extract are parameter estimates and the corresponding
# coefficients. 

pars2 = Ores2$pars
coefs2 = Ores2$coefs

# Alternatively, Profile.LS will do both setup and profiling

Ores2.2 = Profile.LS(fhn.fun,FhNdata,FhNtimes,FhNpars,coefs0,FhNbasis,lambda)


# Forwards Prediction Error can be used to choose lambda

# We need to define a matrix where each row gives the index of the observation
# time to start solving the ODE from, and the observation time to stop. 
whichtimes = cbind(1:31,11:41)

# then we call

FPE = forward.prediction.error(FhNtimes,FhNdata,coefs2,lik,proc,pars2,whichtimes)

# Usually we would do this over a selection of lambda values

lambdas = 10^seq(1:8)
FPEs = 0*lambdas
for(ilam in 1:length(lambdas)){
  t.Ores = Profile.LS(fhn.fun,FhNdata,FhNtimes,FhNpars,coefs0,FhNbasis,lambdas[ilam])
  FPEs[ilam] = forward.prediction.error(FhNtimes,FhNdata,t.Ores$coefs,lik,proc,t.Ores$pars,whichtimes)
}

# And look at these values

FPEs


# FPE makes use of a function IntegrateForward which interfaces a proc object to
# lsoda. We can use it directly to solve the ODE at the estimated parameters and compre
# this to data as follows (assuming we know x0):

x0 = c(-1,1)
names(x0) = FhNvarnames

sol1 = IntegrateForward(x0,FhNtimes,Ores2$pars,proc)
par(mar=c(5,5,1,1))
matplot(FhNtimes,FhNdata,pch=c('V','R'),cex=1.5,cex.lab=2.5,cex.axis=2.5)
matplot(sol1$times,sol1$states,type='l',lwd=3,add=TRUE)



# Some diagnostic plots help to work out if there are problems with the model fit to the data
# or with the smooth fit to the model. 


out1 = CollocInferPlots(Ores2$coefs,Ores2$pars,lik,proc,times=FhNtimes,data=FhNdata,
                            cex.lab=2.5,cex.axis=2.5,cex=1.5,lwd=3)


# Covariance of parameters can be obtained from 

covar = Profile.covariance(Ores2$pars,times=FhNtimes,data=FhNdata,coefs=Ores2$coefs,lik=lik,proc=proc)

covar

# and we can look at confidence intervals

CIs = cbind( Ores2$pars - 2*sqrt(diag(covar)), Ores2$pars + 2*sqrt(diag(covar)) )
rownames(CIs) = FhNparnames
CIs

## When only some state variables are observed, we can still conduct profiling. 
# to mimic this, first set the second column of data to be NA

data2 = FhNdata
data2[,2] = NA

# and remember that we also don't get coefficients, we'll set these to zero

coefs0.2 = coefs0
coefs0.2[,2] = 0

# The function FitMatchOpt allows us to pull some columns of the coefficient
# matrix into line with the differential equation (keeping the other columns fixed):

Fres3 = FitMatchOpt(coefs0.2,2,pars1,proc)

# And we can now proceed with profiling as before:

Ores4 = outeropt(FhNdata,FhNtimes,pars1,Fres3$coefs,lik,proc)
Ores4$pars

out2 = CollocInferPlots(Ores4$coefs,Ores4$pars,lik,proc,times=FhNtimes,data=data2)

covar4 = Profile.covariance(Ores4$pars,times=FhNtimes,data=data2,coefs=Ores4$coefs,lik=lik,proc=proc)
CI4 = cbind( Ores4$pars - 2*sqrt(diag(covar4)), Ores4$pars + 2*sqrt(diag(covar4)) )
rownames(CI4) = FhNparnames
CI4

make.SSEproc <- function()
{

  ##############################################################################

  SSEproc <- function(coefs,bvals,pars,more)
  {
    devals  = as.matrix(bvals$bvals%*%coefs)
    ddevals = as.matrix(bvals$dbvals%*%coefs)
    colnames(devals)  = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames
    f = make.SSElik()$fn(ddevals,more$qpts,devals,pars,more)
    return( sum(f) )
  }

  ##############################################################################

  dSSEproc.dc <- function(coefs,bvals,pars,more)
  {
    devals  = as.matrix(bvals$bvals%*%coefs)
    ddevals = as.matrix(bvals$dbvals%*%coefs)
    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames    
    #  g1 = dSSE.dx(ddevals,more$qpts,devals,pars,more)
    g1 = make.SSElik()$dfdx(ddevals,more$qpts,devals,pars,more)
    weights = checkweights(more$weights,more$whichobs,g1)
    g2 = weights*(ddevals-more$fn(more$qpts,devals,pars,more$more))
    g = as.vector( as.matrix(t(bvals$bvals)%*%g1 + 2*t(bvals$dbvals)%*%g2) )
    return(g)
  }

  ##############################################################################

  dSSEproc.dp <- function(coefs,bvals,pars,more)
  {
    devals  = as.matrix(bvals$bvals%*%coefs)
    ddevals = as.matrix(bvals$dbvals%*%coefs)
    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames    
    #  g = dSSE.dp(ddevals,more$qpts,devals,pars,more)
    g = make.SSElik()$dfdp(ddevals,more$qpts,devals,pars,more)
    g = apply(g,2,sum)
    return(g)
  }

  ##############################################################################

  d2SSEproc.dc2 <- function(coefs,bvals,pars,more)
  {
    devals = as.matrix(bvals$bvals%*%coefs)
    ddevals =  as.matrix(bvals$dbvals%*%coefs)
    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames    
    #  H1 = d2SSE.dx2(ddevals,more$qpts,devals,pars,more)
    H1 = make.SSElik()$d2fdx2(ddevals,more$qpts,devals,pars,more)
    H2 = more$dfdx(more$qpts,devals,pars,more$more)
    #  H = array(0,c(rep(dim(bvals$bvals)[2],2),rep(dim(devals)[2],2)))
    weights = checkweights(more$weights,more$whichobs,H1[,,1])
    H = list(len=dim(bvals$bvals)[2])
    for(i in 1:dim(devals)[2]){
      H[[i]] = list(len=dim(devals))
      for(j in 1:dim(devals)[2]){
        H[[i]][[j]] = t(bvals$bvals)%*%diag(H1[,i,j])%*%bvals$bvals - 
            2*t(bvals$dbvals)%*%diag(H2[,i,j]*weights[,i])%*%bvals$bvals -
            2*t(bvals$bvals)%*%diag(H2[,j,i]*weights[,j])%*%bvals$dbvals
      }
      H[[i]][[i]] = H[[i]][[i]] + 2*t(bvals$dbvals)%*%diag(weights[,i])%*%bvals$dbvals 
    }
    H = blocks2mat(H)
    return(H)
  }

  ##############################################################################

  d2SSEproc.dcdp <- function(coefs,bvals,pars,more)
  {
    devals  =  as.matrix(bvals$bvals%*%coefs)
    ddevals =  as.matrix(bvals$dbvals%*%coefs)
    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames    
    #  H1 = d2SSE.dxdp(ddevals,more$qpts,devals,pars,more)
    H1 = make.SSElik()$d2fdxdp(ddevals,more$qpts,devals,pars,more)
    H2 = 2*more$dfdp(more$qpts,devals,pars,more$more)
    weights = checkweights(more$weights,more$whichobs,H1[,,1])
    H = c()
    for(i in 1:length(pars)){
      H = cbind(H,as.vector(as.matrix(t(bvals$bvals)%*%H1[,,i] -
            t(bvals$dbvals)%*%(weights*H2[,,i]))))
    }
    return(H)
  }

  ##############################################################################

  return(
        list(
            fn      = SSEproc,
            dfdc    = dSSEproc.dc,
            dfdp    = dSSEproc.dp,
            d2fdc2  = d2SSEproc.dc2,
            d2fdcdp = d2SSEproc.dcdp
       )
  )
}

#### Henon map examples

library('fda')
library('maxLik')
library('MASS')
library('Matrix')
library('SparseM')
source('Henon.R')
source('ProfileR.R')
source('Dproc.R')
source('Multinorm.R')
source('genlin.R')
source('cvar.R')
source('makeid.R')
source('SSEproc.R')
source('SSElik.R')
source('inneropt.R')


hpars = c(1.4,0.3)

ntimes = 200

x = c(-1,1)
X = matrix(0,ntimes+20,2)
X[1,] = x

for(i in 2:(ntimes+20)){ X[i,] = make.Henon()$ode(i,X[i-1,],hpars,NULL) }

X = X[20+1:ntimes,]

Y = X + 0.05*matrix(rnorm(ntimes*2),ntimes,2)

t = 1:ntimes

# Define a discrete-time basis

bbasis = create.bspline.basis(c(0.5,200.5),nbasis=200,norder=1,breaks=seq(0.5,200.5,1))
basisvals = Matrix(eval.basis(1:ntimes,bbasis),sparse=TRUE)


# Now lets define a process likelihood:

proc = make.Dproc()                            # Use discrete-time process likelihood
proc$bvals = basisvals                         # I need basis values 

proc$more = make.multinorm()                   # x_{t+1}|F(x_{t}) is multivariate normalproc$more$qpts = t[1:(ntimes-1)]
                                               # Evaluation times
proc$more$more = c(make.Henon(),make.cvar())   # F = Henon map, variance is constant
proc$more$more$f.more = NULL                   # I don't need any extra inputs into F
proc$more$more$v.more = list(mat=0.04*diag(rep(1,2)),sub=matrix(0,0,3))
                                               # covariance is known diagonal
proc$more$qpts = 1:199


# And an observation likelihood:

lik = make.multinorm()
lik$bvals = basisvals
lik$more = c(make.id(),make.cvar())
lik$more$f.more = NULL
lik$more$v.more = list(mat=diag(rep(1,2)),sub=matrix(0,0,3))


# I need some optimization control variables

control=list(trace = 0,maxit = 1000,maxtry = 10,reltol = 1e-6,meth = "BFGS")

control.in = control
control.in$reltol = 1e-12

control.out = control
control.out$trace = 2


# First thing is to generate a smooth of the data:

coefs = as.vector(Y)

res = optim(coefs,SplineCoefsErr,gr=SplineCoefsDC,hessian=T,   
        method="BFGS",control=control.out,
        times=t,data=Y,lik=lik,proc=proc,pars=hpars)

res1 = SplineEst.NewtRaph(coefs,t,data=Y,lik,proc,hpars,control=control.out)


res2 = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
        control=control.out,times=t,data=Y,lik=lik,proc=proc,pars=hpars)

ncoefs = matrix(res2$par,200,2)

#ProfileEnv = new.env()
#assign('optcoefs',ncoefs,3,ProfileEnv)
#assign('curcoefs',ncoefs,3,ProfileEnv)

f = ProfileErr(hpars,hpars,t,X,ncoefs,lik,proc,in.meth="nlminb",control.in=control)  # outer objective
g = ProfileDP(hpars,hpars,t,X,ncoefs,lik,proc)                             # outer gradient

# Comparison to SSE

sproc = make.SSEproc()
sproc$bvals = list(bvals=basisvals[1:(ntimes-1),],dbvals=basisvals[2:ntimes,])
sproc$more = make.Henon()
sproc$more$weights = matrix(1e6,ntimes-1,2)
sproc$more$qpts = 1:(ntimes-1)

slik = make.SSElik()
slik$more = make.id()
slik$more$weights = matrix(1,ntimes,2)
slik$bvals = basisvals

res2 = SplineEst.NewtRaph(coefs,t,Y,slik,sproc,hpars,control=control.out)


res3 = optim(coefs,SplineCoefsErr,gr=SplineCoefsDC,hessian=T,   
          method="BFGS",control=control.out,
          times=t,data=Y,lik=slik,proc=sproc,pars=hpars)

res4 = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
        control=control.out,times=t,data=Y,lik=slik,proc=sproc,pars=hpars)


# Now we'll estimate some parameters

res5 = nlminb(hpars+c(0.4,0.1),ProfileErr,allpars=hpars+c(0.4,0.1),times=t,data=Y,coefs=ncoefs,lik=lik,proc=proc,
    control.in=control.in,control=control.out,gr=ProfileDP,in.meth="nlminb")



# As an alternative, consider squared error

res6 = Profile.GausNewt(hpars+c(0.4,0.1),t,Y,coefs=ncoefs,slik,sproc,in.meth="nlminb",control.in=control.in)

res7 = optim(hpars+c(0.4,0.1),ProfileErr,allpars=hpars+c(0.4,0.1),times=t,data=Y,coefs=ncoefs,lik=slik,proc=sproc,
    control.in=control.in,control=control.in,gr=ProfileDP,method="BFGS")

res8 = nlminb(hpars,ProfileErr,allpars=hpars+c(0.4,0.1),times=t,data=Y,coefs=ncoefs,lik=slik,proc=sproc,
    control.in=control.in,control=control.out,gradient=ProfileDP)


res9 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
    data = list(times=t,data=Y,coefs=ncoefs,lik=slik,proc=proc,
    in.meth='nlminb',control.in=control.in),
    start = list(pars=hpars),trace=TRUE,control=control.out)

g = res9$m$gradient()
df = diag(res9$m$resid())%*%g
C6 = NeweyWest.Var(t(g)%*%g, df[1:200,]+df[201:400,],5)




# lets make the system stochastic

x = c(-1,1)
X = matrix(0,ntimes+20,2)
X[1,] = x

for(i in 2:(ntimes+20)){ X[i,] = Henon.ode(i,X[i-1,],hpars,NULL) + 0.01*rnorm(2) }

X = X[20+1:ntimes,]

Y = X + 0.05*matrix(rnorm(ntimes*2),ntimes,2)

proc$more$more$v.more$mat = diag(rep(0.001,2))

res10 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
    data = list(times=t,data=Y,coefs=ncoefs,lik=slik,proc=proc,
    in.meth='nlminb',control.in=control.in),
    start = list(pars=hpars),trace=TRUE)



res11 = nlminb(hpars,ProfileErr,allpars=hpars,times=t,data=Y,coefs=ncoefs,lik=slik,proc=sproc,
    control.in=control.in,control=control.out,gradient=ProfileDP)


g = res10$m$gradient()
df = diag(res10$m$resid())%*%g
C10 = NeweyWest.Var(t(g)%*%g, df[1:200,]+df[201:400,],5)



# Now lets try EM

proc$more$more$v.more = list(mat = diag(rep(1e-4,2)))
lik$more$v.more = list(mat = diag(rep(0.0025,2)))

res12 = nlminb(ncoefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
        control=control,times=t,data=Y,lik=lik,proc=proc,pars=hpars)

res13 = optim(hpars,Qfn,method="BFGS",control=control,times=t,data=Y,coefs=res$par,
    lik=lik,proc=proc,oldpars=hpars)


proc$more$more$v.more = list(mat=NULL,sub=matrix(c(1,1,3,2,2,3),2,3,byrow=T))
lik$more$v.more = list(mat=NULL,sub=matrix(c(1,1,4,2,2,4),2,3,byrow=T))

hpars2 = c(hpars,log(c(1e-4,0.0025)))

trfn = function(pars){ return( c(pars[1:2],exp(pars[3:4])) ) }

res14 = EM(hpars2,t,Y,ncoefs,lik,proc,50,control,tfn=trfn)

make.findif.loglik = function()
{
findif.loglik.fun <- function(data,times,y,p,more)
{
    x = more$fn(data,times,y,p,more$more)
}

findif.loglik.dfdx <- function(data,times,y,p,more)  # deriv wrt state
{
    x1 = more$fn(data,times,y,p,more$more)
    x = array(0,dim(y))

    for(i in 1:ncol(y)){
        ty = y
        ty[,i] = y[,i] + more$eps
        x[,i] = (more$fn(data,times,ty,p,more$more)-x1)/more$eps
    }
    return(x)
}


findif.loglik.dfdy <- function(data,times,y,p,more)  # deriv wrt response
{
    x1 = more$fn(data,times,y,p,more$more)
    x = array(0,dim(data))

    for(i in 1:ncol(data)){
        tdata = data
        tdata[,i] = data[,i] + more$eps
        x[,i] = (more$fn(tdata,times,y,p,more$more)-x1)/more$eps
    }
    return(x)
}


findif.loglik.dfdp <- function(data,times,y,p,more)
{

    x1 = more$fn(data,times,y,p,more$more)
    x = array(0,c(length(x1),length(p)))

    for(i in 1:length(p)){
        tp = p
        tp[i] = p[i] + more$eps
        x[,i] = (more$fn(data,times,y,tp,more$more)-x1)/more$eps        
    }
    return(x)
}

findif.loglik.d2fdx2 <- function(data,times,y,p,more)
{
    x1 = findif.loglik.dfdx(data,times,y,p,more)
    x = array(0,c(dim(x1),ncol(y)))

    for(i in 1:ncol(y)){
        ty = y
        ty[,i] = y[,i] + more$eps
        x[,,i] = (findif.loglik.dfdx(data,times,ty,p,more)-x1)/more$eps
    }
    return(x)
}

findif.loglik.d2fdy2 <- function(data,times,y,p,more)
{
    x1 = findif.loglik.dfdy(data,times,y,p,more)
    x = array(0,c(dim(x1),ncol(data)))

    for(i in 1:ncol(data)){
        tdata = data
        tdata[,i] = data[,i] + more$eps
        x[,,i] = (findif.loglik.dfdy(tdata,times,y,p,more)-x1)/more$eps
    }
    return(x)
}

findif.loglik.d2fdxdy <- function(data,times,y,p,more)
{
    x1 = findif.loglik.dfdx(data,times,y,p,more)
    x = array(0,c(dim(x1),ncol(data)))

    for(i in 1:ncol(data)){
        tdata = data
        tdata[,i] = data[,i] + more$eps
        x[,,i] = (findif.loglik.dfdx(tdata,times,y,p,more)-x1)/more$eps
    }
    return(x)
}


findif.loglik.d2fdxdp <- function(data,times,y,p,more)
{
    x1 = findif.loglik.dfdx(data,times,y,p,more)
    x = array(0,c(dim(x1),length(p)))
    
    for(i in 1:length(p)){
        tp = p
        tp[i] = p[i] + more$eps
        x[,,i] = (findif.loglik.dfdx(data,times,y,tp,more)-x1)/more$eps
    }

    return(x)
}


findif.loglik.d2fdydp <- function(data,times,y,p,more)
{
    x1 = findif.loglik.dfdy(data,times,y,p,more)
    x = array(0,c(dim(x1),length(p)))
    
    for(i in 1:length(p)){
        tp = p
        tp[i] = p[i] + more$eps
        x[,,i] = (findif.loglik.dfdy(data,times,y,tp,more)-x1)/more$eps
    }

    return(x)
}

#make.findif.loglik <- function()
#{
    return(
        list(
            fn = findif.loglik.fun,
            dfdx = findif.loglik.dfdx,
            dfdy = findif.loglik.dfdy,
            dfdp = findif.loglik.dfdp,
            d2fdx2 = findif.loglik.d2fdx2,
            d2fdy2 = findif.loglik.d2fdy2,
            d2fdxdy = findif.loglik.d2fdxdy,
            d2fdxdp = findif.loglik.d2fdxdp,
            d2fdydp = findif.loglik.d2fdydp
        )
    )
}

smooth.skeleton <- function(pomp,data,times,params,coefs,basisvals,lambda,in.meth,control.in,eps=1e-6)
{

    profile.obj = setup.profile(pomp,coefs,basisvals,lambda,params,eps)

    lik = profile.obj$lik
    proc= profile.obj$proc


    if(in.meth=="house"){
        res = SplineEst.NewtRaph(coefs,times,data,lik,proc,params,control.in)
        ncoefs = matrix(res$coefs,ncol(lik$bvals),length(res$coefs)/ncol(lik$bvals))
    }
    else if(in.meth=="BFGS"){
        res = optim(coefs,SplineCoefsErr,gr=SplineCoefsDC,hessian=TRUE,
            control=control.in,times=times,data=data,lik=lik,proc=proc,pars=params,method="BFGS")

        ncoefs = matrix(res$par,ncol(lik$bvals),length(res$par)/ncol(lik$bvals))
    }    
    else if(in.meth=="nlminb"){
        res = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
            control=control.in,times=times,data=data,lik=lik,proc=proc,pars=params)

        ncoefs = matrix(res$par,ncol(lik$bvals),length(res$par)/ncol(lik$bvals))
    }
    else if(in.meth=="maxNR"){
        res = maxNR(SplineCoefsErr,coefs,times=times,data=data,lik=lik,proc=proc,pars=params,sgn=-1,
            grad=SplineCoefsDC,hess=SplineCoefsDC2,print.level=control.in$print.level,
            iterlim = control.in$iterlim)

        ncoefs = matrix(res$estimate,ncol(lik$bvals),length(res$estimate)/ncol(lik$bvals))
    }

    attr(ncoefs,'lik') = lik
    attr(ncoefs,'proc') = proc

    return( ncoefs )

}


profile.skeleton <- function(pomp,data,times,params,coefs,basisvals,lambda,
                                in.meth,out.meth,control.in,control.out,eps=1e-6,active=NULL,covariance=FALSE)
{
    if(is.null(active)){ active = 1:length(params) }

    profile.obj = setup.profile(pomp,coefs,basisvals,lambda,params,eps)

    lik = profile.obj$lik
    proc= profile.obj$proc

#    ProfileEnv = new.env()
#    assign('optcoefs',coefs,3,ProfileEnv)
#    assign('curcoefs',coefs,3,ProfileEnv)

    write.table(coefs,file='optcoefs.tmp',col.names=FALSE,row.names=FALSE)
    write.table(coefs,file='curcoefs.tmp',col.names=FALSE,row.names=FALSE)
    write.table(0,file='counter.tmp',col.names=FALSE,row.names=FALSE)
    
    aparams = params[active]
    aparamnames = names(aparams)

    if(out.meth == "BFGS"){
        res = optim(aparams,ProfileErr,pars=params,times=t,data=data,coefs=coefs,lik=lik,proc=proc,hessian=T,
           in.meth=in.meth,control.in=control.in,active=active,control=control.out,gr=ProfileDP.Active,method="BFGS")
        aparams = res$par
    }
    else if(out.meth == "nlminb"){    
        res = nlminb(aparams,ProfileErr,pars=params,times=t,data=data,coefs=coefs,lik=lik,proc=proc,
           in.meth=in.meth,control.in=control.in,active=active,control=control.out,gr=ProfileDP.Active)
        aparams = res$par
    }
    else if(out.meth == "maxNR"){
        require('maxLik')
        res = maxNR(ProfileErr,start=aparams,pars=params,times=t,data=data3,coefs=coefs,lik=lik3,proc=proc,
            in.meth=in.meth,control.in=control.in,active=active,sgn=-1,grad=ProfileDP.Active,
            print.level=control.out$print.level,iterlim=control.out$iterlim,active.par = control.out$activepar)
        aparams = res$est
    }

    names(aparams) = aparamnames

    params[active] = aparams

    #ncoefs = get('optcoefs',envir=ProfileEnv)

    ncoefs = as.matrix(read.table(file='curcoefs.tmp'))
    
    Covar = NULL
    
    if(covariance){
        Covar = profile.covariance(params,active,t,data,ncoefs,lik,proc)
    }


    file.remove('counter.tmp')
    file.remove('curcoefs.tmp')
    file.remove('optcoefs.tmp')

    return( list( params=params, Cov=Covar, res=res, lik=lik, proc=proc ) )
}



setup.profile = function(pomp,coefs,basisvals,lambda,params,eps=1e-6)
{
    lik = make.findif.dmeasure()
    lik$more = list(pomp=pomp,eps=eps)    

    lik$bvals = basisvals$basis.obs
    
    lik$more$names = colnames(coefs)
    lik$more$parnames = names(params)

    proc = make.SSEproc()
    proc$bvals = list(bvals=basisvals$bvals,dbvals=basisvals$dbvals)
    proc$more = make.findif.skeleton()


    if(is.basis(basisvals)){
      if(is.null(quadrature) & is.null(times)){
        error('if basisvals is is a basis object, you must specify the observation times')
      }

      lik$bvals = eval.basis(times,basisvals)

      qpts = basisvals$params[-length(basisvals$params)] + diff(basisvals$params)

      proc$bvals = list()
      proc$bvals$bvals = eval.basis(qpts,basisvals)
      proc$bvals$dbvals = eval.basis(qpts,basisvals,1)

      proc$more$weights = rep(1,length(qpts))
      
    }
    else{

      lik$bvals = basisvals$bvals.obs

      proc$bvals =  list(bvals=basisvals$bvals,dbvals=basisvals$dbvals)
      proc$more$qpts = basisvals$qpts
      proc$more$weights = basisvals$qwts
      if(is.null(proc$more$weights)){
          proc$more$weights = array(1,c(length(proc$more$qpts),dim(coefs)[2]))    
      }
    }
 
    if(length(lambda)==1){ lambda = rep(lambda,dim(coefs,2)) }
    
    
    proc$more$weights = proc$more$weights%*%diag(lambda)

    proc$more$names = colnames(coefs)
    proc$more$parnames = names(params)
    
    proc$more$more = list(pomp=pomp,eps=eps)    

    return( list(lik=lik,proc=proc) )

}

## Example Diagnostics -- Learning the FitzHugh-Nagumo Equations
#
# Demonstration estimation of function functions. 

library('CollocInfer')

# First Create Some data from the FitzHugh-Nagumo equations. We will first estimate
# a linear differential equation to mimic this, and then we will try to work 
# out how to fix it up

t = seq(0,20,0.05)

pars = c(0.2,0.2,3)
names(pars) = c('a','b','c')

x0 = c(-1,1)
names(x0)= c('V','R')
y = lsoda(x0,t,make.fhn()$fn.ode,pars)
y = y[,2:3]

data = y + 0.2*matrix(rnorm(802),401,2)

# Now define a basis object

knots = seq(0,20,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)


# Initial values for coefficients will be obtained by smoothing

DEfd = smooth.basis(t,data,fdPar(bbasis,1,0.5)) 
coefs = DEfd$fd$coefs

names(coefs) = c('V','R')

# Starting parameter estimates correspond to circular motion

spars = c(0,1,-1,0)

# Now set up some profiling; make.genlin() produces a linear ODE using parameters
# in row-wise order in the equaiton Dx = Ax

out = LS.setup(coefs=coefs,pars=spars,times=t,fn=make.genlin(),basisvals=bbasis,
                  lambda=c(100,100),names=c('V','R'))

lik = out$lik
proc = out$proc

# With this we can run model-based smoothing

Ires = inneropt(data,times=t,spars,coefs,lik,proc)

# and profiling

Ores = outeropt(data=data,times=t,pars=spars,coefs=Ires$coefs,lik=lik,proc=proc,
  in.meth="nlminb",out.meth="nlminb")

# There is some clear lack of fit here

out2 = CollocInferPlots(Ores$coefs,Ores$pars,lik,proc,times=t,data=data)

# And we will attempt to relate the mis-match in Dx and f(x) to the value of x
# to see how we might be able to fix them up. 

par(mfrow=c(2,2))
plot( out2$traj[,1], out2$dtraj[,1]-out2$ftraj[,1],type='l')
plot( out2$traj[,2], out2$dtraj[,1]-out2$ftraj[,1],type='l')
plot( out2$traj[,1], out2$dtraj[,2]-out2$ftraj[,2],type='l')
plot( out2$traj[,2], out2$dtraj[,2]-out2$ftraj[,2],type='l')

## Now set up empirical forcing functions to get a more precise handle on this
# by examining the equations  Dx = f(x) + Psi(t) P where f(x) is the equation we
# estimated above, Psi is a new basis system and we will estimate the coefficients
# P as parameters via the same method.               

# The additional functions g(t) = Psi(t) P are known as "empirical forcing
# functions", hence the "f" in front of various objects employed below.

# First we need a set of basis functions at which to evaluate the forcing
# functions and their evaluation at the quadrature points

fbasis = create.bspline.basis(range=range,nbasis=23,norder=4)
fbvals = eval.basis(proc$more$qpts,fbasis)

# Now we can call the steup functions, in this case we need to give a lot
# to the more object. In particular, we start off with the first more
# element of the proc object we just used

procmore = proc$more

# and we have to add to this the estimated parameters

procmore$p = Ores$pars

# and which elements to add the forcing functions to

procmore$which = 1:2

# and the evalution of fbasis at the quadrature points

procmore$psi = fbvals

# Now we call the setup function

out3 = LS.setup(coefs=Ores$coefs,pars=rep(0,fbasis$nbasis),times=t,
                  fn=make.diagnostics(),basisvals=bbasis,
                  lambda=c(100,100),names=c('V','R'),more=procmore)
                  
lik2 = out3$lik
proc2 = out3$proc                  


# With this we can run model-based smoothing

Ires2 = inneropt(data,times=t,rep(0,2*fbasis$nbasis),Ores$coefs,lik2,proc2)

# and profiling

Ores2 = outeropt(data=data,times=t,pars=rep(0,2*fbasis$nbasis),coefs=Ires2$coefs,
            lik=lik2,proc=proc2,in.meth="nlminb",out.meth="nlminb")

# Usual CollocInferPlots

out4 = CollocInferPlots(Ores2$coefs,Ores2$pars,lik2,proc2,times=t,data=data)

# Now we can look at the values of the time-varying forcing functions. These 
# values are given by combining the forcing function basis and the parameters

fvals = eval.basis(out4$timevec,fbasis)%*%matrix(Ores2$pars,fbasis$nbasis,2)

# which we can plot

matplot(out4$timevec,fvals,type='l')

# And relate to the estimated trajectories where the mising cubic term can
# be discerned.

par(mfrow=c(2,1))
matplot(out4$traj[,1],fvals,type='l')
matplot(out4$traj[,2],fvals,type='l')




## Manual set-up. 

# This is the equivalent analysis to what we have done above, but
# we create the lik and proc objects manually -- we believe that the structures
# we work with should not be hidden from the user. 

# Usual meta-parameters; quadrature points, weights and knots

lambda = c(100,100)
qpts = knots
qwts = rep(1/length(knots),length(knots))

qwts = qwts%*%t(lambda)
weights = array(1,dim(data))


# Now I define a measurement process log likelihood along with some
# additional features: in this case it's squared error. 

varnames = c('V','R')
parnames = c('a','b','c')


likmore = make.id()
likmore$weights = weights

lik = make.SSElik()
lik$more = likmore
lik$bvals = eval.basis(t,bbasis)


# Proc is a process log likelihood -- in this case treated as squared
# discrepancy from the ODE definition. 

procmore = make.genlin()
procmore$names = varnames
procmore$parnames = parnames
procmore$more = list(mat=matrix(0,2,2),sub= matrix(c(1,1,1,1,2,2,2,1,3,2,2,4),4,3,byrow=TRUE))


procmore$weights = qwts
procmore$qpts = qpts


proc = make.SSEproc()
proc$more = procmore
proc$bvals = list(bvals=eval.basis(procmore$qpts,bbasis,0),
		dbvals = eval.basis(procmore$qpts,bbasis,1))



spars = c(0,1,-1,0)

Ires = inneropt(data,times=t,spars,coefs,lik,proc,in.meth='nlminb')

Ores = outeropt(data=data,times=t,pars=spars,coefs=Ires$coefs,lik=lik,proc=proc,
  in.meth="nlminb",out.meth="nlminb")



traj = as.matrix(proc$bvals$bvals %*% Ores$coefs)
dtraj = as.matrix(proc$bvals$dbvals %*% Ores$coefs)
ftraj = dtraj - proc$more$fn(proc$more$qpts,dtraj,Ores$pars,proc$more$more)



par(mfrow=c(2,2))
for(i in 1:2){
  for(j in 1:2){
    plot(traj[,i],ftraj[,j],type='l')
  }
}




## Now we estimate some forcing functions

fbasis = create.bspline.basis(range=range,nbasis=23,norder=4)


dproc = make.SSEproc()
dproc$more = make.diagnostics()
dproc$more$qpts = procmore$qpts
dproc$more$weights = procmore$weights
dproc$more$more = procmore
dproc$more$more$p = Ores$pars
dproc$more$more$which = 1:2
dproc$more$more$psi = eval.basis(procmore$qpts,fbasis)
dproc$bvals = list(bvals=eval.basis(procmore$qpts,bbasis,0),
		dbvals = eval.basis(procmore$qpts,bbasis,1))


dpars = rep(0,2*fbasis$nbasis)  
  
dOres = outeropt(data=data,times=t,pars=dpars,coefs=Ires$coefs,lik=lik,proc=dproc,
  in.meth="nlminb",out.meth="nlminb")  


# Trajectories

force = dproc$more$more$psi %*% matrix(dOres$par,fbasis$nbasis,2)
traj = dproc$bvals$bvals %*% dOres$coefs

plot(traj[,1],force[,1],type='l')

########### Likelihood for Discrete-Time Dynamics ################ 

make.Dproc <- function()
{

Dproc <- function(coefs,bvals,pars,more) 
{ 
   devals = as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs)
   ddevals = as.matrix(bvals[2:nrow(bvals),]%*%coefs)
   
   colnames(devals) = more$names
   colnames(ddevals) = more$names
   names(pars) = more$parnames   

   f = more$fn(ddevals,more$qpts,devals,pars,more$more)
 
#   return(list(ddevals,devals,pars,f))
 
   return( sum(f) )
}


dDproc.dc <- function(coefs,bvals,pars,more) 
{ 
   devals = as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs)
   ddevals =as.matrix( bvals[2:nrow(bvals),]%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

   g1 = more$dfdx(ddevals,more$qpts,devals,pars,more$more)
   g2 = more$dfdy(ddevals,more$qpts,devals,pars,more$more)

  g = as.vector( t(bvals[1:(nrow(bvals)-1),])%*%g1 + t(bvals[2:nrow(bvals),])%*%g2 )

  return(g)
}


dDproc.dp <- function(coefs,bvals,pars,more) 
{ 
  devals = as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs)
  ddevals = as.matrix(bvals[2:nrow(bvals),]%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  g = more$dfdp(ddevals,more$qpts,devals,pars,more$more)

  g = apply(g,2,sum)

  return(g)
}



d2Dproc.dc2 <- function(coefs,bvals,pars,more) 
{ 
  devals = as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs)
  ddevals = as.matrix(bvals[2:nrow(bvals),]%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  H1 = more$d2fdx2(ddevals,more$qpts,devals,pars,more$more)
  H2 = more$d2fdxdy(ddevals,more$qpts,devals,pars,more$more)
  H3 = more$d2fdy2(ddevals,more$qpts,devals,pars,more$more)

#  H = array(0,c(rep(dim(bvals[1:(nrow(bvals)-1),])[2],2),rep(dim(devals)[2],2)))

#  for(i in 1:dim(devals)[2]){
#	for(j in 1:dim(devals)[2]){
#		H[,,i,j] = t(bvals[1:(nrow(bvals)-1),])%*%diag(H1[,i,j])%*%bvals[1:(nrow(bvals)-1),] +
#            t(bvals[1:(nrow(bvals)-1),])%*%diag(H2[,i,j])%*%bvals[2:nrow(bvals),] + 
#            t(bvals[2:nrow(bvals),])%*%diag(H2[,j,i])%*%bvals[1:(nrow(bvals)-1),] + 
#            t(bvals[2:nrow(bvals),])%*%diag(H3[,i,j])%*%bvals[2:nrow(bvals),] 
#	}
#  }
H = list(len=dim(bvals)[2])
  for(i in 1:dim(devals)[2]){
  H[[i]] = list(len=dim(devals))
    for(j in 1:dim(devals)[2]){
        H[[i]][[j]]= t(bvals[1:(nrow(bvals)-1),])%*%diag(H1[,i,j])%*%bvals[1:(nrow(bvals)-1),] +
            t(bvals[1:(nrow(bvals)-1),])%*%diag(H2[,i,j])%*%bvals[2:nrow(bvals),] + 
            t(bvals[2:nrow(bvals),])%*%diag(H2[,j,i])%*%bvals[1:(nrow(bvals)-1),] + 
            t(bvals[2:nrow(bvals),])%*%diag(H3[,i,j])%*%bvals[2:nrow(bvals),] 
    } 
  }


  H = blocks2mat(H)

  return(H)
}



d2Dproc.dcdp <- function(coefs,bvals,pars,more) 
{ 
  devals = as.matrix(bvals[1:(nrow(bvals)-1),]%*%coefs)
  ddevals = as.matrix(bvals[2:nrow(bvals),]%*%coefs)

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  H1 = more$d2fdxdp(ddevals,more$qpts,devals,pars,more$more)
  H2 = more$d2fdydp(ddevals,more$qpts,devals,pars,more$more)

  H = c()

  for(i in 1:length(pars)){
	  H = cbind(H,as.vector(t(bvals[1:(nrow(bvals)-1),])%*%H1[,,i] +
			t(bvals[2:nrow(bvals),])%*%H2[,,i]))
  }

  return(H)
}



    return(
        list(
            fn = Dproc,
            dfdc = dDproc.dc,
            dfdp = dDproc.dp,
            d2fdc2 = d2Dproc.dc2,
            d2fdcdp = d2Dproc.dcdp
        )
    ) 
} 

Circle.fun <- function(times,y,p,more)
{
  r = y;
  r[,1] = p[1]*y[2];
  r[,2] = -p[2]*y[1];
  return(r)
}



Circle.dfdx <- function(times,y,p,more)
{
  r = array(0,c(dim(y),ncol(y)))
  r[,1,2] = p[1];
  r[,2,1] = -p[2]; 
  return(r)
}


Circle.dfdp <- function(times,y,p,more)
{
  r = array(0,c(dim(y),length(p)))
  r[,1,1] = y[2];
  r[,2,2] = -y[1];
  return(r)
}


Circle.d2fdx2 <- function(times,y,p,more)
{
  r = array(0,c(dim(y),ncol(y),ncol(y)))
  return(r)
}


Circle.d2fdxdp <- function(times,y,p,more)
{
  r = array(0,c(dim(y),2,length(p)))
  r[,1,2,1] = 1;
  r[,2,1,2] = -1;
  return(r)
}


make.Circle <- function()
{
  return( 
    list(
        fn = Circle.fun,
        dfdx = Circle.dfdx,
        dfdp = Circle.dfdp,
        d2fdx2 = Circle.d2fdx2,
        d2fdxdp = Circle.d2fdxdp
    )
  )
}

##########
# This demonstration illustrates the use of log transformations with
# CollocInfer. 
#  We use the SEIR equations, various modifications of which are used to model
#  the spread of disease in epidemeiology.  The letters stand for:
#
#  Susceptibles:  the large subpopulation of those who have not been infected
#  Exposed:       the smaller subpopulation of those who have been infected,
#                 but are not yet infectious
#  Infectious:    those who have already been infected, and are now also 
#                 able to infect others
#  Recovered:     these were infected, but are now recovered and are, usually,
#                 immune to further infections.
#
#  The equations are used to model measles infections in the Canadian province
#  of Ontario over a two-year period.  The data analyzed here are derived from
#  a larger dataset analyzed in greater detail by Hooker, Ellner, De Vargas
#  Roditi and Earn (2011).  
#
#  The basic equations are here modified to all for a seasonally varying
#  infection rate, a realistic feature for modeling childhood diseases where
#  the infection rate increases during the school year.  The function that
#  provides the seasonal variability is beta(t).
#
# The equations are as follows.  Each equation has been organized so that
# the first term on the right defines the exponential decline of the 
# subpopulation if it were left to itself, and the remaining terms, called
# "forcing" terms, define the inputs from the other variables and external
# sources that cause the population to increase (or decline further).
#
# Sdot = -nu*S         + mu - beta(t)*S*(I+i) (Susceptibles)
# Edot = -(sigma+nu)*E + beta(t)*S*(I+i)      (Exposed)
# Idot = -(gamma+nu)*I + sigma*E              (Infectious)
# Rdot = -nu*R         + gamma*I               (Recovered)
# 
# Here beta(t) is parameterized by a sinusoidal function plus a constant,
#      beta(t) = p_1 + p_2 sin(2 pi t) + p_3 cos(2 pi t)
# where the period is one year.
#
# Other parameters in the equations are
# mu    - the arrival rate of new individuals into the population at large
# nu    - the death rate in the population at large
# i     - an external source of infected individuals
# sigma - the rate of movement from Exposed to Infectious.
# gamma - the rate of recovery from infection.
#
# Because the number of susceptibles is usually many times the number of
# infected individuals, S is on a quite different scale than E and I. 
# In these data, S varies around about 450,000, but E and I vary between
# about 400 and 9000. 
# Moreover, all of these variables cannot in preinciple be negative.  Both 
# computational efficiency and positivity argue for fitting the logarithm of the 
# data, and also modelling the logarithm of each variable. 
# This requires a simple modification of the SEIR equations above, consisting
# of dividing the right side of the equations by the exponential of the 
# respective variables.
# The CollocInfer package contains a number of useful tools that let you make 
# this transition without needing to re-code all of your differential equations.


library('CollocInfer')
                        
# The following  objects are a part of the package:

SEIRvarnames # the names of the variables
SEIRparnames # the names of the parameters

SEIRtimes    # the times of observation
SEIRdata     # the number of infected individuals
SEIRpars     # the initial estimates of parameter values

# Now augment the data for I  so that S and E measurements are listed as NA

data = cbind(matrix(NA,length(SEIRdata),2),SEIRdata)

# Calculate the natural logs of the observations  
# Note: using common logs would have made the results easier for clients to
# interpret, and would have required dividing the SEIR right sides above by
# 10 to the power of the variable values rather than vy their exponentials.

logdata = log(data)

# Function make.SEIR is distributed with the package, and defines 
# the right sides of the differential equations as well as various of their
# partial derivatives required during the computation.   The code can be 
# viewed by typing "make.SEIR" into the command window in R.

SEIRfn = make.SEIR()

# Define the time-varying infection rate beta  as a sinusoid with period
# one year plus a constant

beta.fun = function(t,p,more){
    return( p['b0'] + p['b1']*sin(2*pi*t) + p['b2']*cos(2*pi*t) )
}

# Define as well its partial derivatives with respect to the coefficients

beta.dfdp = function(t,p,more){
    dfdp =  cbind(rep(1,length(t)), sin(2*pi*t), cos(2*pi*t)) 
    colnames(dfdp) = c('b0','b1','b2')
    return(dfdp)
}

#  Bundle these two functions as well as the names of their coefficients
#  into a list object called betamore

betamore = list(beta.fun =beta.fun,
                beta.dfdp=beta.dfdp,
                beta.ind =c('b0','b1','b2'))

# Set up a B-spline functional basis object to represent the state vector

rr     = range(SEIRtimes)       #  the range of observations times
knots  = seq(rr[1],rr[2],2/52)  #  knots at 52 equally spaced values
norder = 3                      #  the order of the B-spline basis functions,
                                #  in this case piece-wise quadratic
nbasis = length(knots)+norder-2 #  the number of basis functions

#  set up the basis object

bbasis = create.bspline.basis(range=rr, norder=norder, nbasis=nbasis, 
                              breaks=knots)

# To get an initial estimate of the states we smooth the observed I component
# and set the other coefficients to zero.  

# smooth the log I values

DEfd = smooth.basis(SEIRtimes,logdata[,3],fdPar(bbasis,1,0.1))

# plot the smooth plus data

plotfit.fd(log(SEIRdata),SEIRtimes,DEfd$fd)

# Augment the coefficient vector by two columns.  The first column
# contains all 13's, which is about the logarithm of the susceptible 
# population size, and the second contains all 7's, about the estimated
# size of the exposed subpopulation.  The ratio of the two population sizes
# is here approximated by exp(13-7), or about 400.

coefs = cbind(matrix(13,bbasis$nbasis,1),
              matrix( 7,bbasis$nbasis,1),
              DEfd$fd$coefs)

# set up the functional data object for the three variables

DEfd = fd(coefs,bbasis)

# We use the usual least squares measures of the fidelity of the estimated
# functions S(t), E(t) and I(t) to the data and to the differential equation.
# This means that we can save the user the effort of setting up the lik and
# proc objects by calling function LS.setup, which output these objects.

# We will want to represent the state variables on the log scale so that they 
# remain always positive. To do this, we set the 'posproc' argument of 
# LS.setup to 1. We will also compare the log I(t) to the log of the data 
# directly, and therefore set argument 'poslik' to 0, the default.

#  Here, too, we specify the level of emphasis on fitting each differential
#  equation by setting the corresponding smoothing or bandwidth parameter
#  lambda.  The following two statements specify the lambda to be 100 for
#  S, and 1 for E and I.

SEIRlambda = rep(1,3)
SEIRlambda[1] = 100

#  list object betamore is now passed into LS.setup, too, in order to make
#  it available as a functional parameter defined by its three coefficients

#  run LS.setup

objs = LS.setup(SEIRpars, fn=SEIRfn, fd.obj=DEfd, more=betamore, data=data, 
                times=SEIRtimes, posproc=1, poslik=0, names=SEIRvarnames, 
                lambda=SEIRlambda)
                
#  Set up the proc and lik objects for this problem
                
SEIRproc = objs$proc
SEIRlik  = objs$lik

#  The next task is to improve the initial coefficient estimates 13 and 7
#  defined above for S and E, respectively by using function FitMatchOpt
#  that optimize coefficients for unobserved variables.  The 'which' argument
#  of this function indicates which variables's coefficients are to be
#  optimized with respect to the fit to the observed data for I.
#  Function proc.time is used here to show the elapsed time, the time
#  titled 'user' is the current elapsed session time in seconds.
#  The optimization function to be used is function nlminb.


res1 = FitMatchOpt(coefs=coefs, which=1:2, proc=SEIRproc, pars=SEIRpars,
                   meth='nlminb')


# Let's have a look at the three functions and the fit to the I data

DEfd1 = fd(res1$coefs,bbasis)

plot(DEfd1,lwd=2,ylim=c(5,14),col=c(4,2,3),lty=c(1:3))
points(SEIRtimes,logdata[,3])  #  plot the data for I
legend(0,12,SEIRvarnames,col=c(4,2,3),lty=c(1:3),lwd=2)

# We can now run an initial smooth using the estimated coefficients as 
# starting points. 
# The optimization function to be used is function nlminb.

res2 = inneropt(data=logdata, times=SEIRtimes, pars=SEIRpars,
                proc=SEIRproc,lik=SEIRlik, coefs=res1$coefs, in.meth='nlminb')

#  define the new function estimates

DEfd2 = fd(res2$coefs,bbasis)

# Has this changed much?  Plot the new function estimates along with the old

plot(DEfd2,lwd=2,ylim=c(5,14),col=c(4,2,3),lty=c(1:3))
lines(DEfd1)
legend(0,12,SEIRvarnames,col=c(4,2,3),lty=c(1:3),lwd=2)

# All these analyses have been using the initial parameter estimates in
# order to get starting values for the coefficients defining the three
# functions.  Now we are ready to optimize the fit to the data with
# respect to the parameters in SEIRpars.  Here, however, we only optimize
# the values of the 'i' parameter defining the external input of infectives
# and the three coefficients defining the time-varying infection rate beta. 
# These are selected using the argument 'active' of outer optimization
# function outeropt.

# The computation time involved in this step is substantial (around 10 minutes
# on the computer used while preparing these notes).   You may
# want to disable output buffering by clicking the popup menu item 
# 'Buffered output'that you see when you click on the 'Misc' item at the
# top of the command window.


SEIRactive = c('i','b0','b1','b2')

res3 = outeropt(data=logdata, times=SEIRtimes, pars=SEIRpars,
                proc=SEIRproc, lik=SEIRlik, coefs=res2$coefs,
                active=SEIRactive)


#  display the initial and estimated parameter values

SEIRparsEst = res3$pars

print(matrix(c(SEIRpars[SEIRactive],SEIRparsEst[SEIRactive]),4,2))

# Plot the estimated trajectories

DEfd3 = fd(res3$coefs,bbasis)

plot(DEfd3,lwd=2,ylim=c(5,14),col=c(4,2,3),lty=c(1:3))
legend(0,12,SEIRvarnames,col=c(4,2,3),lty=c(1:3),lwd=2)


# We can now employ CollocInferPlots to explore fit to the data

out3 = CollocInferPlots(pars=res3$pars,coefs=res3$coef,lik=SEIRlik,proc=SEIRproc,data=logdata,times=SEIRtimes)


# This function just automates the following calculations:

# Compare the smooth of the data to the data itself:

plotfit.fd(logdata[,3],SEIRtimes,DEfd3[3],ylab='Fit to Data')

# 2: We can also look at the discrepancy between the estimated trajectory and the
# differential equation in terms of its derivatives

traj = eval.fd(SEIRtimes,DEfd3)     # estimated trajectory
colnames(traj) = SEIRvarnames

dtraj = eval.fd(SEIRtimes,DEfd3,1)  # derivative of the estimated trajectory

# derivative as modeled by the ODE by ODE

ftraj = SEIRproc$more$fn(SEIRtimes,traj,res3$pars,SEIRproc$more$more)   

#  Plot the derivatives of the trajectories along with the derivatives
#  defined by the right side.

X11()
matplot(SEIRtimes,dtraj,type='l',lty=2,ylim =c(-10,10),col=c(4,2,3),
        ylab='SEIR derivatives' )
matplot(SEIRtimes,ftraj,type='l',lty=1,add=TRUE,col=c(4,2,3))

#  3. Plot the differences between the actual and predicted derivatives

X11()
matplot(SEIRtimes,dtraj-ftraj,type='l',ylim=c(-4,4), col=c(4,2,3),
        ylab='Residuals')
        
        

## The alternative is to exponentiate the state before we compare to the data.
# This can take a very long time and is only recommended if you really need 
# to do it, or have a couple of hours to wait. 

objs2 = LS.setup(SEIRpars, fn=SEIRfn, fd.obj=DEfd, more=betamore, data=data,
                 times=SEIRtimes, posproc=1, poslik=1, 
                 names=SEIRvarnames, SEIRparnames, lambda=SEIRlambda)

SEIRlik2  = objs2$lik
SEIRproc2 = objs2$proc

res2 = inneropt(data=data, times=SEIRtimes, pars=res3$pars,
                proc=SEIRproc2, lik=SEIRlik2, coefs=res3$coefs)

res3 = outeropt(data=data, times=SEIRtimes, pars=res3$pars,
                proc=SEIRproc2, lik=SEIRlik2, coefs=res3$coefs,
                active=c('i','b0','b1','b2'))


###############################################################################
# Some more basic setup operations
#
# Here we go through the steps necessary to set up the SEIR equations manually. 
# This allows us several options for dealing with the positivity of the 
# state vector. 
#
# 1. We can ignore it and hope for the best. 
#
# 2. We can take a log transform of the ODE and then exponentiate the solutions
# to compare to the data
#
# 3. We can take a log transform of the ODE and compare this to the log data. 
###############################################################################


# First of all, we need the values of the basis at the observation times and the 
# quadrature points. 

qpts = 0.5*(knots[1:(length(knots)-1)] + knots[2:length(knots)])

bvals.obs = Matrix(eval.basis(SEIRtimes,bbasis),sparse=TRUE)

bvals = list(bvals = Matrix(eval.basis(qpts,bbasis),sparse=TRUE),
            dbvals = Matrix(eval.basis(qpts,bbasis,1),sparse=TRUE))


### This proc object is just the standard squared error deviation
# from the right hand side of a differential equation

sproc = make.SSEproc()
sproc$bvals = bvals
sproc$more = make.SEIR()
sproc$more$more = betamore
sproc$more$qpts = qpts
sproc$more$weights = matrix(1,length(qpts),3)%*%diag(c(1e2,1e0,1e0))
sproc$more$names = SEIRvarnames
sproc$more$parnames = SEIRparnames


### However, ODEs are often much more numerically stable if represented on a
# log scale. The make.logtrans() function will take the right hand side functions
# and derivatives defined for any differential equation and provide the equivalent
# system for the log state. Note that this does affect the way  you represent
# your state when considering the observations. 

lsproc = make.SSEproc()
lsproc$bvals = bvals
lsproc$more = make.logtrans()
lsproc$more$more = make.SEIR()
lsproc$more$more$more = betamore
lsproc$more$qpts = qpts
lsproc$more$weights = matrix(1,length(qpts),3)%*%diag(c(1e2,1e0,1e0))
lsproc$more$names = SEIRvarnames
lsproc$more$parnames = SEIRparnames

### Lik objects, this is the standard squared error. 

slik = make.SSElik()
slik$bvals = eval.basis(SEIRtimes,bbasis)
slik$more = make.id()
slik$more$weights = array(1,dim(data))
slik$more$names = SEIRvarnames
slik$more$parnames = SEIRparnames

# Log transform transformation for the lik object. For this, we note that we 
# have represented the trajectory on the log scale and will need to transform 
# back, this makes the numerics much harder and it can take a very long time to 
# converge.  

lslik = make.logstate.lik()
lslik$bvals = slik$bvals
lslik$more$weights = slik$more$weights
lslik$more = slik
lslik$more$parnames = SEIRparnames

# Numerically things work much better on the log scale

DEfd = smooth.basis(SEIRtimes,logdata,fdPar(bbasis,1,0.5)) 

coefs = matrix(0,nbasis,3)
coefs[,3] = DEfd$fd$coefs[,3] 
 
res = FitMatchOpt(coefs=coefs, which=1:2, proc=lsproc, pars=SEIRpars,
                  meth='nlminb')

# This is the non-log scale run; once again, this can take a few hours

res2 = inneropt(data=data, times=SEIRtimes, pars=SEIRpars,
                proc=lsproc, lik=slik, coefs=res$coefs)

res3 = outeropt(data=data, times=SEIRtimes, pars=SEIRpars, proc=lsproc,
                lik=slik, coefs=res2$coefs, active=c('i','b0','b1','b2'))
                

## Or just log the observations, this is faster. 

res2 = inneropt(data=logdata, times=SEIRtimes, pars=SEIRpars,
                proc=lsproc, lik=slik, coefs=res$coefs)

res3 = outeropt(data=logdata, times=SEIRtimes, pars=SEIRpars,
                proc=lsproc, lik=slik, coefs=res2$coefs,
                active=c('i','b0','b1','b2'))
                

##########
# This demonstration illustrates the use of log transformations with
# CollocInfer. We use the SEIR equations with a seasonally varying
# infection rate for this purpose.
#
# The equations are given as
#
# Sdot = mu - beta(t)*S*(I+i) - nu*S        (Susceptibles)
# Edot = beta(t)*S*(I+i) - (sigma+nu)*E     (Exposed)
# Idot = sigma*E - (gamma+nu)*I              (Infectious)
#
#
# Here beta(t) - the infection rate - is parameterized by a sinusoidal function
# plus a constant.
#
# Other parameters are
# i - a visiting process
# nu - death rate
# sigma - the rate of movement from Exposed to Infectious.
# gamma - the rate of recovery from infection.
#
# It is generally more stable to solve the equations for the log states rather
# than the states themselves. CollocInfer contains a number of useful tools
# that let you make this transition without needing to re-code all of your
# differential equations.

library('CollocInfer')
            
            
#### labels for the state process

SEIRnames = c('S','E','I')

#### define the right side evaluation function

SEIRodefn = make.SEIR()$fn.ode


N = 5e6

####  define true parameter values and names

pars = c(7/5,0.02*N,0,0.02,365/8,365/5,17*(365/5)/N, 0, 0.08*17*(365/5)/N)
parnames = c('rho','mu','i','nu','sigma','gamma','b0','b1','b2')
names(pars) = parnames


#### A couple of functions to define the infection rate

beta.fun = function(t,p,more){
    return( p['b0'] + p['b1']*sin(2*pi*t) + p['b2']*cos(2*pi*t) )
}

beta.dfdp = function(t,p,more){
    dfdp =  cbind(rep(1,length(t)), sin(2*pi*t), cos(2*pi*t)) 
    colnames(dfdp) = c('b0','b1','b2')
    return(dfdp)
}

betamore = list(beta.fun=beta.fun,
                beta.dfdp=beta.dfdp,
                beta.ind=c('b0','b1','b2'))


#### Now create ODE paths


y0 = N*c(0.9,0,0.1)


y0 =N*c(.056,.00014,.000085)
names(y0) = SEIRnames
times = seq(0,3,1/52)

y = lsoda(y0,times=times,func=make.SEIR()$ode.fn,parms=list(p=pars,more=betamore))


data = y[,4,drop=FALSE]*7/5



# and we're going to need some basis values

rr = range(times)
knots = seq(rr[1],rr[2],1/52)
norder = 3
nbasis = length(knots)+norder-2

bbasis = create.bspline.basis(range=rr,norder=norder,nbasis=nbasis,breaks=knots)
qpts = 0.5*(knots[1:(length(knots)-1)] + knots[2:length(knots)])

bvals.obs = Matrix(eval.basis(times,bbasis),sparse=TRUE)

bvals = list(bvals = Matrix(eval.basis(qpts,bbasis),sparse=TRUE),
            dbvals = Matrix(eval.basis(qpts,bbasis,1),sparse=TRUE))


### Proc object, the first of these is just the standard squared error deviation
# from the right hand side of a differential equation

sproc = make.SSEproc()
sproc$bvals = bvals
sproc$more = make.SEIR()
sproc$more$more = betamore
sproc$more$qpts = qpts
sproc$more$weights = matrix(1,length(qpts),3)%*%diag(c(1e2,1e0,1e0))
sproc$more$names = SEIRnames
sproc$more$parnames = parnames


### However, ODEs are often much more numerically stable if represented on a
# log scale. The make.logtrans() function will take the right hand side functions
# and derivatives defined for any differential equation and provide the equivalent
# system for the log state. Note that this does affect the way  you represent
# your state when considering the observations. 

lsproc = sproc
lsproc$more = make.logtrans()
lsproc$more$more = make.SEIR()
lsproc$more$more$more = betamore
lsproc$more$qpts = qpts
lsproc$more$weights = matrix(1,length(qpts),3)%*%diag(c(1e2,1e0,1e0))
lsproc$more$names = SEIRnames
lsproc$more$parnames = parnames

### Lik objects, this is the standard squared error. 

slik = make.SSElik()
slik$bvals = eval.basis(times,bbasis)
slik$more = make.genlin()
slik$more$weights = rep(1,length(times))
slik$more$more = list(mat = matrix(0,1,3),sub=matrix(c(1,3,1),1,3))
slik$more$names = SEIRnames
slik$more$parnames = parnames

# Log transform transformation. For this, we note that we have represented
# the trajectory on the log scale and will need to transform back. 

lslik = make.logstate.lik()
lslik$bvals = slik$bvals
lslik$more$weights = slik$more$weights
lslik$more = slik
lslik$more$parnames = parnames


# Numerically things work much better on the log scale

dfd = data2fd(log(data/pars[1]),times,bbasis)

coefs = matrix(0,nbasis,3)
coefs[,3] = dfd$coefs
 
res = FitMatchOpt(coefs=coefs,which=1:2,proc=lsproc,pars=pars,meth='nlminb')

res2 = inneropt(data=data,times=times,pars=pars,proc=lsproc,lik=lslik,coefs=res$coefs)

res3 = outeropt(data=data,times=times,pars=pars,proc=lsproc,lik=lslik,coefs=res2$coefs,
  active=c('rho','i','b0','b1','b2'))


## Or just log the observations, this is faster. 

spars = pars
spars[1] = 1

tdata = log(data/pars[1])

dfd = data2fd(tdata,times,bbasis)

coefs = matrix(0,nbasis,3)
coefs[,3] = dfd$coefs
 
res = FitMatchOpt(coefs=coefs,which=1:2,proc=lsproc,pars=spars)

res2 = inneropt(data=tdata,times=times,pars=spars,proc=lsproc,lik=slik,coefs=res$coefs)

res3 = outeropt(data=tdata,times=times,pars=spars,proc=lsproc,lik=slik,coefs=res2$coefs,
  active=c('i','b0','b1','b2'),out.meth='nlminb')

# An example file fitting the FitzHugh-Nagumo equations to data in the
# new R Profiling Code. This will eventually be interfaced with the new R 
# "Partially Observed Markov Process (pomp)" class of objects. 

# The equations are a simplification of a famous set of equations developed
# by Hodgkin and Huxley in 1952 to describe the time course of the action
# potential in a squid neuron.

# The variables are:
#  V ... voltage or potential difference across the membrane of the neurone
#  R ... a combination of the effects of three ion channels that restore
#        the resting potential holding between spikes.
#  V is potentially measureable, but R is not since it simplifes ther
#    behavior of the actual ion channels.

#  The equations are;
#  DV = c(V - V^3/3 + R)
#  DR = -(b R + V - a)/c

#  The R equation is a simple first order linear constant coefficient dynamic
#  system with rate b/c and forced by (V - a)/c
#  The V equation is nonlinear due to the -c V^3 term, and is forced by c R.

#  The data are simulated by adding Gaussian error to a solution of the
#  differential equation.

#  Last modifed 2 Feb 2010 by Jim

library("CollocInfer")

#  Set up 41 time values rangeing from 0 to 20 in steps of 0.5

t = seq(0,20,0.5)

n = length(t)

#  Set up parameter values; a = b = 0.2 and c = 3.0

pars = c(0.2,0.2,3)
names(pars) = c('a','b','c')

#  initial values and variable labels

x0 = c(-1,1)
names(x0) = c('V','R')

#  Define the functions that evaluate the right sides of the equations
#  as well as various derivatives

fhn = make.fhn()

#  approximate the solution for these values over about three cycles
#  Here we use the function lsoda found in package odesolve that 
#  approximates the solution of the differential equation given a pair
#  of initial values.

solution = lsoda(x0,times=t,func=fhn$fn.ode,pars)

#  extract the function values at time points

y = solution[,2:3]

#  add noise to the function values to define data

sigerr = 0.5
data = y + sigerr*array(rnorm(2*n),dim(y))

#  put data for R variable to NA to indicate that R is not measured

data[,2] = NA

#  plot the solution for both variables and add points for V

matplot(t, y, "l")
# matpoints(t, data, pch="*")
points(t, data[,1], pch="*")

###############################
####  Basis object bbasis  ####
###############################

knots  = seq(0,20,0.2)
norder = 4
nbasis = length(knots) + norder - 2
range  = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	                            norder=norder,breaks=knots)

########################################
### Initial values for coefficients  ###
########################################

fd.data = array(data,c(n,1,2))

bfdPar = fdPar(bbasis, 2, 1e-2)

Vfd = smooth.basis(t,fd.data[,,1],bfdPar)$fd
plotfit.fd(fd.data[,,1], t, Vfd)

coefs0 = matrix(0,nbasis,2)
coefs0[,1] = Vfd$coefs

DEfd = fd(coefs0, bbasis, fdnames=list(NULL,NULL,c('V','R')))

######################################################################
### Set up likelihood and process functions for squared error loss ###
######################################################################

#  set up functions to evaluate values of ODE right side and values
#  of its derivatives

profile.obj = LS.setup(pars=pars, fn=fhn, lambda=1000, times=t,
                       fd.obj=DEfd)

lik  = profile.obj$lik

proc = profile.obj$proc

#############################################
####  set optimization control parameters ###
#############################################

#  control

control=list()                 

#  control.in

control.in = control
control.in$trace    = 0
control.in$rel.tol  = 1e-4
control.in$iter.max = 100

#  control.out

control.out = control
control.out$trace = 1
control.out$rel.tol = 1e-4

#####################################################
#  Estimate coefficients for R by fitting equation  #
#####################################################

res1 = FitMatchOpt(coefs0, which=2, pars, proc ,meth='nlminb',
                   control=control.in)
coefs1 = res1$coefs

#  define current fit to equation by the coefficients returned by 
#  FitMatchOpt

DEfd$coefs = coefs1

plot(DEfd)
lines(t, y[,2], lty=2)

###############################
#### Parameter Optimization ###
###############################

# Perturbed parameter starting values

spars = pars*exp(rnorm(3)*0.2)          
names(spars) = names(pars)

#  set smoothing level (value to be used for both variables)

lambda = 1

####################################################
### Estimate parameters using squared error loss ###
####################################################

control.in$trace    = 1 
Ires1 = inneropt(data=data,times=t,pars=spars,coefs=coefs1,lik,proc,
                 in.meth='nlminb',control.in=control.in)

control.in$trace    = 0
Ores1 = Profile.LS(fhn,data=data,times=t,pars=spars,coefs=coefs1,
                    basisvals=bbasis,lambda=lambda,names=names(x0),
                    in.meth='nlminb',out.meth='optim',
	              control.in=control.in,control.out=control.out)
	
####################################################
###         SSE with ProfileErr                  ###
####################################################

control.in$trace    = 0
control.out$trace   = 6

Ores2 = outeropt(data=data,times=t,pars=spars,coefs=coefs1,
                 lik=lik,proc=proc,
                 in.meth="nlminb",out.meth="optim",
                 control.in=control.in,control.out=control.out)

####################################################
###          Lets look at the result             ###
####################################################

DEfd = fd(Ores2$coefs,bbasis)   # Data and reconstructed trajectory

#  plot estimated and true solutions to the equation

plot(DEfd)
matlines(t,y,lty=2)

#  plot fit to V data

plotfit.fd(data[,1],t,DEfd[1])
lines(t,y[,1],lty=2)
 
#  Ores2 does not return lik and proc, 
#  so Ores$lik and Ores$proc changed to lik and proc, resp.

traj = as.matrix(proc$bvals$bvals   %*% Ores2$coefs) # Look at how well the
colnames(traj) = proc$more$names                     # derivative of the
dtraj = as.matrix(proc$bvals$dbvals %*% Ores2$coefs) # trajectory fits the 
ftraj = proc$more$fn(t,traj,Ores2$pars)              # right hand side. 

matplot(dtraj,type='l',col=2)
matplot(ftraj,type='l',col=4,add=TRUE) 
 
#  This doesn't work

Profile.covariance(pars=Ores$pars,times=t,data=data,coefs=Ores$coefs,lik=lik,proc=proc)
  
  
	

######################################################
# Finite differencing for process variance
######################################################

make.findif.var = function()
{

findif.var.fun <- function(times,y,p,more)
{
    x = more$var.fn(times,y,p,more$more)
}

findif.var.dfdx <- function(times,y,p,more)
{
    x1 = more$var.fn(times,y,p,more$more)
    x = array(0,c(dim(x1),ncol(y)))

    for(i in 1:ncol(y)){
        ty = y
        ty[,i] = y[,i] + more$eps
        x[,,,i] = (more$var.fn(times,ty,p,more$more)-x1)/more$eps
    }
    return(x)
}

findif.var.dfdp <- function(times,y,p,more)
{
    x1 = more$var.fn(times,y,p,more$more)
    x = array(0,c(dim(x1),length(p)))

    for(i in 1:length(p)){
        tp = p
        tp[i] = p[i] + more$eps
        x[,,,i] = (more$var.fn(times,y,tp,more$more)-x1)/more$eps        
    }
    return(x)
}

findif.var.d2fdx2 <- function(times,y,p,more)
{
    x1 = findif.var.dfdx(times,y,p,more)
    x = array(0,c(dim(x1),ncol(y)))
    
    for(i in 1:ncol(y)){
        ty = y
        ty[,i] = y[,i] + more$eps
        x[,,,,i] = (findif.var.dfdx(times,ty,p,more)-x1)/more$eps
    }
    return(x)
}

findif.var.d2fdxdp <- function(times,y,p,more)
{
    x1 = findif.var.dfdx(times,y,p,more)
    x = array(0,c(dim(x1),length(p)))
    
    for(i in 1:length(p)){
        tp = p
        tp[i] = p[i] + more$eps
        x[,,,,i] = (findif.var.dfdx(times,y,tp,more)-x1)/more$eps
    }

    return(x)

}


#make.findif.var <- function()
#{
    return(
        list(
            fn = findif.var.fun,
            dfdx = findif.var.dfdx,
            dfdp = findif.var.dfdp,
            d2fdx2 = findif.var.d2fdx2,
            d2fdxdp = findif.var.d2fdxdp
        )
    )
}

# Load some things in 

library('CollocInfer')

# The Chemostat equations represent a four-species Chemostat plus the resource 
# of Nitrogen. There are two species of Algae with varying defenses against
# Rotifers. The Rotifers themselves are divided into two class -- breeding
# and senescent, although these two are very tightly coupled. 
#
# A full description of these equations can be found in the user manual. 
# The five state variables for the equations are
# 
# N - nitrogen content in the Chemostat
# C1 - Algal type 1
# C2 - Algal type 2 
# B - Breeding Rotifers
# S - Senescent Rotifers
#
# The system has 16 parameters, also described in the user manual. Notable
# features include that only the sums C1+C2 and B+S can be observed. Further, 
# an unknown fraction of each is counted at each time. This requires us to 
# set up a model for the observation process along with the ODE. 


# First we generate some data 

data(ChemoData)

# The first two of these parameters give the fractions of Algae and Rotifers 
# that are counted. The remaining parameters are all positive and using 
# their logged values is helpful. 

logpars=c(ChemoPars[1:2],log(ChemoPars[3:16]))

# Parameters 'p1' and 'p2' represent relative palatability of the two algal
# clones, as such only one can be estimated and we fix p2 = 0. 

active = c(1:2,5,7:16)     

# We'll choose a fairly large value of lambda. 

lambda = rep(10000,5)  

# We need some basis functions

rr = range(ChemoTime)
knots = seq(rr[1],rr[2],by=0.5)
bbasis = create.bspline.basis(rr,norder=4,breaks=knots)

# We now need to define two functions. First, chemo.fun defines a map from the
# trajectory to its derivative

chemo.fun = function (times, y, p, more = NULL) 
{
    r = y
    p = exp(p)
    Q = p["p1"] * y[, "C1"] + p["p2"] * y[, "C2"]
    Qs = Q * exp(100 * (Q - p["Qstar"]))/(1 + exp(100 * (Q - 
        p["Qstar"]))) + p["Qstar"]/(1 + exp(100 * (Q - p["Qstar"])))
    r[, "N"] = p["delta"] * (p["NI"] - y[, "N"]) - p["rho"] * 
        y[, "C1"] * y[, "N"]/(p["KC1"] + y[, "N"]) - p["rho"] * 
        y[, "C2"] * y[, "N"]/(p["KC2"] + y[, "N"])
    r[, "C1"] = y[, "C1"] * (p["XC"] * p["rho"] * y[, "N"]/(p["KC1"] + 
        y[, "N"]) - p["p1"] * p["G"] * (y[, "B"] + y[, "S"])/(p["KB"] + 
        Qs) - p["delta"])
    r[, "C2"] = y[, "C2"] * (p["XC"] * p["rho"] * y[, "N"]/(p["KC2"] + 
        y[, "N"]) - p["p2"] * p["G"] * (y[, "B"] + y[, "S"])/(p["KB"] + 
        Qs) - p["delta"])
    r[, "B"] = y[, "B"] * (p["XB"] * p["G"] * Q/(p["KB"] + Qs) - 
        (p["delta"] + p["m"] + p["lambda"]))
    r[, "S"] = p["lambda"] * y[, "B"] - (p["delta"] + p["m"]) * 
        y[, "S"]
    return(r)
}

# Second, we need a map from the trajectory to the observations. We'll use 
# log observations in this case since the observations are positive and this
# helps to stabilize scales. 

chemo.obs = function(t,y,p,more)
{
  Algae = p[1]*(y[,'C1']+y[,'C2'])
  Rotifers = p[2]*(y[,'B']+y[,'S'])
  
  return( log( cbind(Algae,Rotifers) ) )

}


### From here we will set-up the objects needed to run profiling. Below we give
# LS.setup the parameters, maps from trajectories to derivatives and to
# observations, along with data, times, basis functions, variable names and
# trade-off parameter lambda. 
#
# Additionally, posproc and poslik indicate that we are modelling the log of the
# trajectory, so that we should exponentiate before mapping to derivatives and
# before mapping to observations. 

out = LS.setup(pars = logpars, fn = chemo.fun, basisvals=bbasis,lambda=lambda,
               data = log(ChemoData),times=ChemoTime,posproc=TRUE,poslik=TRUE,
               names = ChemoVarnames,likfn=chemo.obs)

lik = out$lik
proc = out$proc

# Because we don't have direct observations of any state, we'll use a starting
# smooth obtained from generating some ODE solutions. 

y0 = log(c(2,0.1,0.4,0.2,0.1))
names(y0) = ChemoVarnames

odetraj = IntegrateForward(y0,ChemoTime,logpars,proc)

DEfd   = smooth.basis(odetraj$times,odetraj$states,fdPar(bbasis,int2Lfd(2),1e-6))
coefs0 = DEfd$fd$coef

obsvals = lik$more$fn(ChemoTime,odetraj$states,ChemoPars,lik$more$more)

ChemoData  = exp(obsvals + 0.5*matrix(rnorm(2*length(ChemoTime)),length(ChemoTime),2))



## We can now call the inner optimization -- this just tries to fined the 
# coefficients that both fit the data and the differential equation well. 

res = inneropt(coefs=coefs0, pars=logpars, times=ChemoTime, data=log(ChemoData),
               lik=lik, proc=proc, in.meth='optim',control.in=list(trace=2))

# We'll form the trajectory and also the appropriate sum of exponentiated
# states to compare to the data. 

traj    = lik$bvals %*% res$coefs
obstraj = lik$more$fn(ChemoTime,traj,logpars,lik$more$more)

# Plot these against the data

X11()
par(mfrow=c(2,1))
plot(obstraj[,1],type='l',ylab='Chlamy',xlab='',cex.lab=1.5,cex.axis=1.5)
points(log(ChemoData[,1]))
plot(obstraj[,2],type='l',ylab='Brachionus',xlab='days',cex.lab=1.5,cex.axis=1.5)
points(log(ChemoData[,2]))

# The function outeropt now allows parameter estimation to take place through 
# profiling procedure. 

res2 = outeropt(pars=logpars,times=ChemoTime,data=log(ChemoData),coef=res$coefs,
    lik=lik,proc=proc,active=active,in.meth='optim',out.meth='nlminb')

# We'll extract the resulting parameters and coefficients. 

npars = res2$pars
C = res2$coefs

# And obtain an estimated trajectory and the exponentiated sum to comprare
# to the data. 

traj = lik$bvals%*%C
ptraj = lik$more$fn(ChemoTime,traj,npars,lik$more$more)

# Lets have a look at how much we changed our parameters on the original 
# scale. 

new.pars = npars
new.pars[3:16] = exp(new.pars[3:16])

print(ChemoPars)
print(new.pars)
print(new.pars/ChemoPars)

# Now we can produce a set of diagnostic plots. 

# Firstly, a representation of the trajectory compared to the data. 

X11()
par(mfrow=c(2,1))
plot(ChemoTime,ptraj[,1],type='l',ylab='Chlamy',xlab='',cex.lab=1.5)
points(ChemoTime,log(ChemoData[,1]))
plot(ChemoTime,ptraj[,2],type='l',ylab='Brachionus',xlab='days',cex.lab=1.5)
points(ChemoTime,log(ChemoData[,2]))


# Now we'll plot both the derivative of the trajectory and the value of the
# differential equation right hand side at each point. This represents the 
# fit to the model. 

traj2 = proc$bvals$bvals%*%C
dtraj2 = proc$bvals$dbvals%*%C

colnames(traj2) = ChemoVarnames
ftraj2 = proc$more$fn(proc2$more$qpts,traj2,npars,proc$more$more)


X11()
par(mfrow=c(5,1),mai=c(0.3,0.6,0.1,0.1))
for(i in 1:5){
  plot(proc$more$qpts,dtraj2[,i],type='l',xlab='',ylab=ChemoVarnames[i],
    cex.lab=1.5,ylim=c(-0.5,0.5))
  lines(proc$more$qpts,ftraj2[,i],col=2,lty=2)
  abline(h=0)
}
legend('topleft',legend=c('Smooth','Model'),lty=1:2,col=1:2,cex=1.2)

# Solving the differential equation from the estiamted initial condition
# of the trajectory allows us to compare the qualitative behavior of 
# our estimate to that of the differential equation. 

y0 = traj[1,]
names(y0) = ChemoVarnames
odetraj = IntegrateForward(y0,ChemoTime,npars,proc)


X11()
par(mfrow=c(2,1))
matplot(ChemoTime,traj,col=1,type='l',lwd=3,cex.lab=1.5,cex.axis=1.5,
    ylab='',cex.main=1.5,main='Reconstructed Trajectories')
legend(x='topright',legend=ChemoVarnames,lwd=3,col=1,lty=1:5)
matplot(ChemoTime,odetraj$states,col=1,type='l',lwd=3,cex.axis=1.5,cex.lab=1.5,
    ylab='',cex.main=1.5,main='ODE Solution')

# We can also compare the pattern of observations predicted by the differential
# equation and that estimated by our methods. 

otraj = lik$more$fn(ChemoTime,odetraj$states,npars,lik$more$more)

X11()
par(mfrow=c(2,1))
matplot(ChemoTime,ptraj,type='l',lwd=2,xlab='days',cex.lab=1.5,ylab='',
  cex.axis=1.5,cex.main=1.5,main='Predicted Observations -- Smooth')
matplot(ChemoTime,log(ChemoData),add=TRUE,pch = c(1,2))
legend('topright',legend=c('Algae','Rotifers'),pch=1:2,col=1:2)
matplot(ChemoTime,otraj,type='l',lwd=2,xlab='days',cex.lab=1.5,ylab='',
  cex.axis=1.5,cex.main=1.5,main='Predicted Observations -- ODE')
legend('topright',legend=c('Algae','Rotifers'),lty=1:2,col=1:2,lwd=2)

make.fhn <- function()
{

  fhn.fun <- function(times,y,p,more)
  {
    r = y;
    r[,'V'] = p['c']*(y[,'V'] - y[,'V']^3/3 + y[,'R'])
    r[,'R'] = -(y[,'V'] -p['a'] + p['b']*y[,'R'])/p['c'] 
    return(r)
  }


  fhn.fun.ode <- function(times,y,p)
  {
    r = y;
    dimnames(r) = dimnames(y);
    r['V'] = p['c']*(y['V'] - y['V']^3/3 + y['R'])
    r['R'] = -(y['V'] -p['a'] + p['b']*y['R'])/p['c'] 

    return(list(r))
  }


  fhn.dfdx <- function(times,y,p,more)
  {
    r = array(0,c(dim(y),2))
    dimnames(r) = list(NULL,colnames(y),colnames(y))

    r[,'V','V'] = p['c'] - p['c']*y[,'V']^2
    r[,'V','R'] =  p['c']
    r[,'R','V'] = (-1/p['c'])
    r[,'R','R'] = (-p['b']/p['c'])
    return(r)
  }


  fhn.dfdp <- function(times,y,p,more)
  {
    r = array(0,c(dim(y),length(p)))
    dimnames(r) = list(NULL,colnames(y),names(p))

    r[,'V','c'] =  (y[,'V']-y[,'V']^3/3+y[,'R']);
    r[,'R','a'] = 1/p['c'];
    r[,'R','b'] = (-y[,'R']/p['c']);
    r[,'R','c'] = ((y[,'V']-p['a']+p['b']*y[,'R'])/(p['c']^2));
    return(r)
  }


  fhn.d2fdx2 <- function(times,y,p,more)
  {
    r = array(0,c(dim(y),2,2))
    dimnames(r) = list(NULL,colnames(y),colnames(y),colnames(y))

    r[,'V','V','V'] = -2*p['c']*y[,'V']
    return(r)
  }


  fhn.d2fdxdp <- function(times,y,p,more)
  {
    r = array(0,c(dim(y),2,length(p)))
    dimnames(r) = list(NULL,colnames(y),colnames(y),names(p))

    r[,'V','V','c'] = 1 - y[,'V']^2
    r[,'V','R','c'] = 1
    r[,'R','V','c'] = 1/p['c']^2
    r[,'R','R','b'] = -1/p['c']
    r[,'R','R','c'] = p['b']/p['c']^2

    return(r)
  }



  return( 
    list(
        fn      = fhn.fun,
        fn.ode  = fhn.fun.ode,
        dfdx    = fhn.dfdx,
        dfdp    = fhn.dfdp,
        d2fdx2  = fhn.d2fdx2,
        d2fdxdp = fhn.d2fdxdp
    )
  )
}

 times = seq(0,20,0.5)
 FHN.xnames = c('V','R')
 FHN.fn = make.fhn()
 FHN.knots  = seq(0,20,2)
 FHN.norder  = 3
 FHN.nbasis = length(FHN.knots) + FHN.norder - 2
 FHN.range  = c(0,20)
 FHN.basis  = create.bspline.basis(FHN.range, FHN.nbasis,
                                   FHN.norder, FHN.knots)
 FHN.fdnames = list(NULL, NULL, FHN.xnames)
 FHN.data = matrix(c(
   -0.9508,    0.1941,
   -0.1886,    1.0975,
    1.4686,   -0.0005,
    1.9981,    1.1561,
    2.0249,    0.7667,
    2.0081,    0.0546,
    1.4857,   -0.2347,
    1.4184,   -1.6662,
    2.3930,   -0.3252,
    0.0610,   -1.8704,
    2.0342,   -2.0501,
    0.5523,   -0.9018,
   -0.7991,   -1.2990,
   -2.7791,   -0.2625,
   -2.1212,    0.2284,
   -1.8151,    0.6424,
   -1.2904,    0.1545,
   -2.1196,    0.9703,
   -0.7323,    0.9908,
   -0.8960,    1.4679,
    1.7302,    1.2176,
    2.3323,    1.0775,
    2.0664,    0.2541,
    2.3299,   -0.0338,
    2.1683,    0.2920,
    1.2035,   -1.4959,
    1.5007,   -0.8775,
    0.7062,   -1.4168,
    0.2399,   -1.0865,
    0.7983,   -0.6172,
   -1.4062,   -0.3967,
   -1.9705,   -0.9559,
   -1.3631,   -0.3275,
   -1.3702,    0.2982,
   -1.3165,    0.3683,
   -0.6459,    0.9082,
   -0.4809,    1.1491,
   -0.1056,    0.5921,
    1.4264,    0.8459,
    1.6757,   -0.4546,
    2.4930,    0.8772),41,2,byrow=TRUE)
 colnames(FHN.data) = c("V","R")
 FHN.xfd   = smooth.basis(times, FHN.data, FHN.basis,
                          fdnames=FHN.fdnames)$fd
 FHN.coefs = FHN.xfd$coefs
 FHN.pars0        = c(0.2, 0.2, 3.0)
 names(FHN.pars0) = c("a", "b", "c")
 FHN.lambda       = 1e4*c(1,1)
 FHN.x0           = c(-1,1)
 profile.obj = LS.setup(FHN.pars0,FHN.coefs,FHN.fn,FHN.basis,FHN.lambda,
                        times=times,names=c("V","R"))
 lik   = profile.obj$lik     #  lik object
 proc  = profile.obj$proc    #  proc object
 
f      = SplineCoefsErr(coefs,times,FHN.data,lik,proc,FHN.pars0)

dfdc   = SplineCoefsDC(coefs,times,FHN.data,lik,proc,FHN.pars0)

d2fdc2 = SplineCoefsDC2(coefs,times,FHN.data,lik,proc,FHN.pars0)

d2fdcdp = SplineCoefsDCDP(coefs,times,FHN.data,lik,proc,FHN.pars0)

#  Profile.LS argument correspondences

data      = FHN.data
fn        = FHN.fn
pars      = FHN.pars0
coefs     = FHN.coefs
coefs.0   = FHN.coefs
basisvals = FHN.basis
lambda    = FHN.lambda
fdobj       = NULL
more        = NULL
weights     = NULL 
quadrature  = NULL
active      = NULL
in.method   = NULL
out.method  = NULL
options.in  = NULL
options.out = NULL
eps         = 1e-6
poslik      = 0 
posproc     = 0 
discrete    = 0 
sgn         = 1


profile.obj = Profile.LS(FHN.fn,FHN.data,times,FHN.pars0,FHN.coefs,basisvals=FHN.basis,FHN.lambda)

library('fda')
library('odesolve')
library('maxLik')
library('MASS')
library('Matrix')
library('SparseM')
source('../R/ProfileR.R')
source('../R/sse.shortcut.R')
source('Circle.R')
source('../R/findif.ode.R')
source('../R/SSElik.R')
source('../R/SSEproc.R')
source('../R/makeid.R')
source('../R/inneropt.R')
source('../R/cproc.shortcut.R')
source('../R/Cproc.R')
source('../R/genlin.R')
source('../R/cvar.R')
source('../R/Multinorm.R')

# First Create Some Data

t = seq(0,20,0.05)
pars = c(1,1)
y = array(0,c(length(t),2))
y[,1] =10*sin(t)
y[,2] =10*cos(t)
data = y + 0.05*matrix(rnorm(length(t)*2),length(t),2)

# Now a basis object

knots = seq(0,20,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)


# Initial values for coefficients will be obtained by smoothing

fd.data = array(data,c(dim(data)[1],1,dim(data)[2]))

DEfd = data2fd( fd.data,t,bbasis,fdnames=list(NULL,NULL,NULL) )

coefs = matrix(DEfd$coefs,dim(DEfd$coefs)[1],dim(DEfd$coefs)[3])
colnames(coefs) = DEfd$fdnames[[3]]



###Now lets try some optimization

spars =c(1,1.1)        # Perturbed parameters
lambda =10000
control=list()                # Control parameters 
control$trace = 0
control$maxit = 1000
control$maxtry = 10
control$reltol = 1e-6
control$meth = "BFGS"

control.in = control
control.in$reltol = 1e-12
control.out = control
control.out$trace = 2

control.in$print.level = 0
control.in$iterlim = 1000


#### set up the lik and proc objects ####
profile.obj = sse.setup(pars=pars,coefs,make.Circle(),basisvals=bbasis,lambda,fd.obj=NULL,more=NULL,
    weights=NULL,times=t,quadrature=NULL,eps=1e-6)
 lik = profile.obj$lik
proc = profile.obj$proc
coefs = profile.obj$coefs



res0 = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
        control=control.out,times=t,data=data,lik=lik,proc=proc,pars=spars)

ncoefs = matrix(res0$par,102,2)

### Multinorm ####
var = c(1,0.01)
res2 = profile.Cproc(make.Circle(),data,t,pars=pars,coefs,bbasis,var=var, out.meth='BFGS', in.meth='nlminb',control.in=control.in,control.out=control.out)

### SSE####
res1 = profile.sse(make.Circle(),data,t,pars=spars,coefs,bbasis,lambda=lambda,in.meth='house',
out.meth='nlminb',control.in=control.in,control.out=control.out)

#### EM####
proc$more$more$v.more = list(mat=NULL,sub=matrix(c(1,1,3,2,2,3),2,3,byrow=T))
lik$more$v.more = list(mat=NULL,sub=matrix(c(1,1,4,2,2,4),2,3,byrow=T))

pars2 = c(pars,log(c(1e-4,0.0025)))

trfn = function(pars){ return( c(pars[1:2],exp(pars[3:4])) ) }

res2 = EM(pars2,t,data,ncoefs,lik,proc,50,control,tfn=trfn)



### A little experiment

par2 = -c(0.5,0.6,0.7,0.8,0.9,1,1.1,1.2,1.3,1.4,1.5)
sses = 0*par2
for(i in 1:length(par2)){
  spars = pars
  spars[2] = par2[i]
  
  res0 = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
        control=control.out,times=t,data=data,lik=lik,proc=proc,pars=spars)

  ncoefs = matrix(res0$par,102,2)
  devals = lik$bvals%*%ncoefs
  
  sses[i] = sum( (data-devals)^2 )
}



## Let's try

profile.obj = sse.setup(pars=pars,coefs,make.genlin(),basisvals=bbasis,lambda,fd.obj=NULL,
    more=list(mat=matrix(0,2,2),sub=matrix(c(1,2,1,2,1,2),2,3,byrow=TRUE)),
    weights=NULL,times=t,quadrature=NULL,eps=1e-6)
lik = profile.obj$lik
proc = profile.obj$proc
coefs = profile.obj$coefs


res0 = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
        control=control.out,times=t,data=data,lik=lik,proc=proc,pars=spars)

ncoefs = matrix(res0$par,102,2)



res1 = profile.sse(make.genlin(),data,t,pars=spars,coefs,bbasis,lambda=lambda,in.meth='nlminb',
more=list(mat=matrix(0,2,2),sub=matrix(c(1,2,1,2,1,2),2,3,byrow=TRUE)),
out.meth='house',control.in=control.in,control.out=control.out)

Profile.LS <- function(fn,data,times,pars,coefs=NULL,basisvals=NULL,lambda,
                        fd.obj=NULL,more=NULL,weights=NULL,quadrature=NULL,
                        in.meth='nlminb',out.meth='nls',
                        control.in=list(),control.out=list(),eps=1e-6,
                        active=NULL,posproc=FALSE,poslik=FALSE,discrete=FALSE,names=NULL,sparse=FALSE)
{
#    browser()
    if(is.null(active)){ active = 1:length(pars) }

    profile.obj = LS.setup(pars,coefs,fn,basisvals,lambda,fd.obj,more,
      data,weights,times,quadrature,eps=1e-6,posproc,poslik,discrete,names,sparse)

    dims = dim(data)

    lik   = profile.obj$lik
    proc  = profile.obj$proc
    coefs = profile.obj$coefs
    data  = profile.obj$data
    times = profile.obj$times

    if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
    if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
    if(file.exists('counter.tmp')){file.remove('counter.tmp')}

    Ires = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    ncoefs = Ires$coefs

    write.table(ncoefs,file='optcoefs.tmp',col.names=FALSE,row.names=FALSE)
    write.table(ncoefs,file='curcoefs.tmp',col.names=FALSE,row.names=FALSE)

    apars = pars[active]
    aparamnames = names(apars)

    ################  Gauss-Newton optimization  #########################
    if(out.meth == "ProfileGN"){
      res=Profile.GausNewt(pars=pars, times=times, data=data, coefs=ncoefs,
		               lik=lik, proc=proc, in.meth=in.meth,
                           control.in=control.in,
		               active=active, control=control.out)
      apars = res$pars[active]

      ncoefs = res$in.res$coefs
      g = res$in.res$df
      resid = res$in.res$f
    }

    ################  nls optimization  #########################

    if(out.meth == "nls"){
      if(is.null(control.out$trace)){control.out$trace=TRUE}
      if(is.null(control.out$maxiter)){control.out$maxiter=100}
      if(is.null(control.out$tol)){control.out$tol=1e-8}
      if(is.null(control.out$printEval)){control.out$printEval=TRUE}
      if(is.null(control.out$warnOnly)){control.out$warnOnly=TRUE}
      res = nls(~ProfileSSE(pars, allpars, times, data, coefs, lik, proc,
                            in.meth, control.in, active),
        data = list(allpars=pars, times=times, data=data, coefs=ncoefs,
                    lik=lik, proc=proc,
        in.meth=in.meth,control.in=control.in,active=active),
        start = list(pars=pars[active]),trace=control.out$trace,control=control.out)
      apars = res$m$getPars()

      g = res$m$gradient()
      resid = res$m$resid()
      if(file.exists('curcoefs.tmp'))
      	 ncoefs = as.matrix(read.table(file='curcoefs.tmp'))
      else
         ncoefs = coefs
    }

    names(apars) = aparamnames

    pars[active] = apars

    ncoefs = as.matrix(ncoefs)
    if(!is.null(proc$more$names)){ colnames(ncoefs) = proc$more$names }


     if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
     if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
     if(file.exists('counter.tmp')){file.remove('counter.tmp')}

    if(!is.null(fd.obj)){
      ncoefs = array(ncoefs,c(nrow(ncoefs)/dims[2],dims[2],dims[3]))
      fd.obj = fd(ncoefs,fd.obj$basis)
      return( list(pars=pars,fd=fd.obj,lik=lik,proc=proc,outer.result=res) )
    }
    else{
      return( list(pars=pars, coefs=ncoefs, lik=lik, proc=proc, outer.result=res,
                   data=data, times=times) )
    }
}

source('SEIRRV.R')

library('CollocInfer')
library('pomp.devel')

#source('../../R/OuterOptimization.R')
#source('../../R/InnerOptimization.R')
#source('../../R/ProfileCovariance.R')
#source('../../R/SSEproc.R')

# Extract some data

data(pertussis.sim)
truth = pertussis.sim[["SEIRR.small"]]

pars = coef(truth)
pars = pars[1:16]
pars[1:15] = exp(pars[1:15])

varnames = c('S','E','I','R1','R2')
parnames = names(pars)
active = (1:16)[-c(1:2,16)]

times = time(truth)
data = t(data.array(truth))
truestates = t(states(truth,varnames))

data = data[times<=20,]
truestates = truestates[times < 20,]
times = times[times<=20]

data = matrix(data,length(data),1)

# Basis functions

rr = range(times)
knots = seq(rr[1],rr[2],by=1/52)

mids = c(min(knots),(knots[1:(length(knots)-1)] + 1/104),max(knots))

bbasis = create.bspline.basis(rr,norder=4,breaks=knots)

# proc object

lambda = rep(100,5)

proc = make.SSEproc()
proc$more = make.findif.ode()
proc$more$more = list(fn=make.logtrans()$fn,eps=1e-8)
proc$more$more$more = list(fn=SEIRR)

proc$more$names = varnames
proc$more$parnames = parnames

proc$bvals = list(bvals = Matrix(eval.basis(mids,bbasis),sparse=TRUE),
                 dbvals = Matrix(eval.basis(mids,bbasis,1),sparse=TRUE));
#proc$bvals = list(bvals = eval.basis(mids,bbasis),
#                 dbvals = eval.basis(mids,bbasis,1));
proc$more$qpts = mids
proc$more$weights = lambda

# lik object

lik = make.SSElik()
lik$more = make.genlin()
lik$more$more = list(mat=matrix(0,1,5,byrow=TRUE), sub = matrix(c(1,3,11),1,3,byrow=TRUE))

lik$bvals = Matrix(eval.basis(times,bbasis),sparse=TRUE)
#lik$bvals = eval.basis(times,bbasis)
lik$more$weights = matrix(1,length(times),1)

lik2 = make.logstate.lik()
lik2$more = lik
lik2$bvals = lik$bvals

# Now we can try some smoothing
# start with the true states


DEfd = smooth.basis(times,log(truestates),fdPar(bbasis,1,0.0001))
coefs = DEfd$fd$coefs

res0 = inneropt(coefs=coefs,pars=res1$pars,times=times,data=data,lik=lik2,proc=proc,in.meth='SplineEst',control.in=list(trace=6))

traj = lik$bvals%*%res0$coefs
matplot(times,traj,type='l',lty=1)
matplot(times,log(truestates),type='l',lty=2,add=TRUE)


plot(times,exp(traj[,3])*pars['report.prob'],type='l')
points(times,data)

res1 = outeropt(coefs=res1$coefs,pars=res1$pars,times=times,data=data,lik=lik2,proc=proc,in.meth='SplineEst',control.in=list(trace=1))

traj = lik$bvals%*%res1$coefs
matplot(times,traj,type='l',lty=1)
matplot(times,log(truestates),type='l',lty=2,add=TRUE)


plot(times,exp(traj[,3])*res1$pars['report.prob'],type='l')
points(times,data)

make.diagnostics = function()
{
    diagnostics.fn = function(t,x,p,more)
    {
        force = array(0,dim(x))

        force[,more$which] = more$psi %*% matrix(p,ncol(more$psi),length(more$which))

        return(more$fn(t,x,more$p,more$more) + force)
    }


    diagnostics.dfdx = function(t,x,p,more)
    {
      return(return(more$dfdx(t,x,more$p,more$more)))

    }

    diagnostics.dfdp = function(t,x,p,more)
    {
        force = array(0,c(dim(x),length(p)))

        k = ncol(more$psi)
        whichp = 0
        for(i in 1:length(more$which)){
          force[,more$which[i],whichp+(1:k)] = more$psi
          whichp = whichp + k
        }
       return(force)
    }


    diagnostics.d2fdx2 = function(t,x,p,more)
    {
      return(return(more$d2fdx2(t,x,more$p,more$more)))

    }

    diagnostics.d2fdxdp = function(t,x,p,more)
    {
      return(array(0,c(nrow(x),ncol(x),ncol(x),length(p))))
    }

    return( list( fn = diagnostics.fn,
                  dfdx = diagnostics.dfdx,
                  dfdp = diagnostics.dfdp,
                  d2fdx2 = diagnostics.d2fdx2,
                  d2fdxdp = diagnostics.d2fdxdp,
                  more = NULL
                )
          )
}

source('Devel/Colloc.MCMC.R')

walk.var = diag(c(0.005,0.005,0.05))
cscale = .3
                                         
prior = function(pars){ return( sum(dnorm(pars/c(1,1,10),log=TRUE))) }
nstep = 10000


hmm = Colloc.MCMC(FhNtimes,FhNdata,FhNpars,Ires2$coefs,srklik,srkproc,prior,walk.var,cscale,nstep,in.meth='SplineEst',control.in=control.in)


hmm = Colloc.MCMC(seq(0,20,len=401),data,FhNpars,Ires2$coefs,srklik,srkproc,prior,walk.var,cscale,nstep,in.meth='SplineEst',control.in=control.in)

Qfn = function(pars,times,data,coefs,lik,proc,oldpars,tfn=NULL,active=1:length(pars))   # EM algorithm Q function
{
   
   cpars = oldpars
   cpars[active] = pars

    if( !is.null(tfn)){
    cpars = tfn(cpars)
    oldpars = tfn(oldpars)
    }

    f = SplineCoefsErr(coefs,times,data,lik,proc,cpars)

    H1 = SplineCoefsDC2(coefs,times,data,lik,proc,cpars)    
    V = SplineCoefsDC2(coefs,times,data,lik,proc,oldpars)

   F = f + 0.5*sum(diag(H1%*%ginv(V)))

    return( F )
}



EM = function(pars,times,data,coefs,lik,proc,niter=10,in.meth,control.in,tfn=NULL,active=1:length(pars))  # EM algorithm
{
    tpars = pars[active]
 
    for(i in 1:niter){

      pars2 = pars
      if(!is.null(tfn)){ 
        pars2 = tfn(pars) 
        print(pars2)
      } 

#       Cres = nlminb(coefs,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
#        control=control.in,times=times,data=data,lik=lik,proc=proc,pars=pars2)

#        coefs = Cres$par
        Ires = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
        coefs = Ires$coefs
        Cres = Ires$res
    
        Pres = nlminb(tpars,Qfn,gr=NULL,hessian=T,control=control.in,
            times=times,data=data,coefs=coefs,lik=lik,proc=proc,oldpars=pars,tfn=tfn,active=active)

        tpars = Pres$par

        pars[active] = tpars

        print(c(i,Pres$obj,pars))
    }

    return( list(pars,coefs,Pres=Pres,Cres=Cres) )
}

DE2x = function(y0,times,pars,proc)
{
  parms = list(proc=proc,pars=pars)
  out = lsoda(y0,times,oderhs,parms)
  return(out[,2:ncol(out)])
}


oderhs = function(t,r,parms)
{
  proc = parms$proc
  pars = parms$pars
  r = matrix(r,1,length(r))
  colnames(r) = proc$more$names

  y = as.vector(proc$more$fn(t,r,pars,proc$more$more))

  return(list(y))
}

Smooth.sse <- function(fn, data, times, pars, coefs=NULL, basisvals=NULL,
                       lambda,fd.obj=NULL,more=NULL,weights=NULL,
	                     quadrature=NULL, in.meth='nlminb', control.in, eps=1e-6,
                       pos=0, discrete=0, names=NULL)
{

    profile.obj = sse.setup(pars, coefs, fn, basisvals, lambda,fd.obj, more,
                            data, weights, times, quadrature, eps=1e-6, pos,
                            discrete, names=names)

    dims = dim(data)

    lik = profile.obj$lik
    proc= profile.obj$proc
    coefs = profile.obj$coefs
    data  = profile.obj$data
    times = profile.obj$times

    Ires = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    ncoefs = Ires$coefs
    Ires = Ires$res
    ncoefs = as.matrix(ncoefs)
    if(!is.null(proc$more$names)){ colnames(ncoefs) = proc$more$names }

    if(!is.null(fd.obj)){
      ncoefs = array(ncoefs,c(row(ncoefs)/dims[2],dims[2],dims[3]))
      fd.obj = fd(ncoefs,fd.obj$basis)
      return( list(fd=fd.obj,lik=lik,proc=proc,res=Ires) )
    }
    else{
      return( list(coefs=ncoefs,lik=lik,proc=proc,res=Ires,data=data,
                   times=times) )
    }
}

###############################################################################


Profile.sse <- function(fn,data,times,pars,coefs=NULL,basisvals=NULL,lambda,
                        fd.obj=NULL,more=NULL,weights=NULL,quadrature=NULL,
                        in.meth='nlminb',out.meth='nls',
                        control.in,control.out,eps=1e-6,active=NULL,pos=0,
                        discrete=0,names=NULL)
{
    if(is.null(active)){ active = 1:length(pars) }

    profile.obj = sse.setup(pars,coefs,fn,basisvals,lambda,fd.obj,more,
      data,weights,times,quadrature,eps=1e-6,pos,discrete,names)

    dims = dim(data)

    lik   = profile.obj$lik
    proc  = profile.obj$proc
    coefs = profile.obj$coefs
    data  = profile.obj$data
    times = profile.obj$times
   
    if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
    if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
    if(file.exists('counter.tmp')){file.remove('counter.tmp')}
    

    Ires = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    ncoefs = Ires$coefs

    write.table(ncoefs,file='optcoefs.tmp',col.names=FALSE,row.names=FALSE)
    write.table(ncoefs,file='curcoefs.tmp',col.names=FALSE,row.names=FALSE)
    
    apars = pars[active]
    aparamnames = names(apars)
    
    if(out.meth == "ProfileGN"){
      res=Profile.GausNewt(pars=pars,times=times,data=data,coefs=ncoefs,
		    lik=lik,proc=proc,in.meth=in.meth,control.in=control.in,
		    active=active,control=control.out)
      apars = res$pars[active]

      ncoefs = res$in.res$coefs
      g = res$in.res$df
      resid = res$in.res$f
    }
    if(out.meth == "nls"){
      res = nls(~ProfileSSE(pars, allpars, times, data, coefs, lik, proc,
                            in.meth, control.in, active),
        data = list(allpars=pars, times=times, data=data, coefs=ncoefs,
                    lik=lik, proc=proc,
        in.meth=in.meth,control.in=control.in,active=active),
        start = list(pars=pars[active]),trace=control.out$trace)   
      apars = res$m$getPars()

      g = res$m$gradient()
      resid = res$m$resid()
      if(file.exists('curcoefs.tmp'))
      	 ncoefs = as.matrix(read.table(file='curcoefs.tmp'))
      else 
         ncoefs = coefs
    }

    names(apars) = aparamnames

    pars[active] = apars

    ncoefs = as.matrix(ncoefs)
    if(!is.null(proc$more$names)){ colnames(ncoefs) = proc$more$names }

   
     if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
     if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
     if(file.exists('counter.tmp')){file.remove('counter.tmp')}
    
    if(!is.null(fd.obj)){
      ncoefs = array(ncoefs,c(nrow(ncoefs)/dims[2],dims[2],dims[3]))
      fd.obj = fd(ncoefs,fd.obj$basis)
      return( list(pars=pars,fd=fd.obj,lik=lik,proc=proc,res=res) )
    }
    else{
      return( list(pars=pars, coefs=ncoefs, lik=lik, proc=proc, res=res,
                   data=data, times=times) )
    }    
}

###############################################################################

sse.setup = function(pars, coefs=NULL, fn, basisvals=NULL, lambda, fd.obj=NULL,
                     more=NULL, data=NULL, weights=NULL, times=NULL,
                     quadrature=NULL, eps=1e-6, pos=0, discrete=0, names=NULL)
{
    colnames = names

    if(!is.null(fd.obj)){            # If an fd object is provided, it overrides
      basisvals = fd.obj$basis       # the basis and function values
      
      if(!is.null(fd.obj$coefs)){
        coefs = fd.obj$coefs
      }
      if(!is.null(fd.obj$fdnames) & is.null(colnames)){
        colnames = fd.obj$fdnames[[length(fd.obj$fdnames)]]
      }
    }
        
    lik = make.SSElik()
    
    if(pos==0) 
       lik$more = make.id()
    else
      lik$more = make.exp()
    
    
    if(length(dim(coefs))>2){
      if(is.null(colnames)){
        colnames = dimnames(coefs)[[3]]
      }
      nrep = dim(coefs)[2]
      coefs = matrix(coefs,dim(coefs)[1]*dim(coefs)[2],dim(coefs)[3])
    }
    else{
      nrep = 1
      if(is.null(colnames)){
        colnames = colnames(coefs)
      }
    }


    proc = make.SSEproc()
    
    if(is.list(fn)){
      procmore = fn
      procmore$more = more
    }
    else if(is.function(fn)){
      procmore = make.findif.ode()
      procmore$more$fn = fn
      procmore$more$more = more
      procmore$more$eps = eps
    }
    else{
      stop('fn must be either a list of functions or a function')
    }
    
    if(pos==0) proc$more = procmore
    else { proc$more = make.logtrans()
           proc$more$more = procmore}
           
    
    proc$more$names = colnames
    proc$more$parnames = names(pars)


    if(is.basis(basisvals)){
      if(is.null(times)){
        stop(paste('if basisvals is is a basis object,',
                   ' you must specify the observation times'))
      }

      lik$bvals = Matrix(diag(rep(1,nrep)) %x% 
                 eval.basis(times,basisvals),sparse=TRUE)
           
      if(is.null(quadrature) | is.null(quadrature$qpts)){
        knots = c(basisvals$rangeval[1],basisvals$params,basisvals$rangeval[2])
        qpts = knots[-length(knots)] + diff(knots)
      }
      else{
        qpts = quadrature$qpts
      }

      proc$bvals = list()
      if(discrete==0){
        proc$bvals$bvals  = Matrix(diag(rep(1,nrep)) %x% 
                                   eval.basis(qpts,basisvals,0),sparse=TRUE)
        proc$bvals$dbvals = Matrix(diag(rep(1,nrep)) %x%
                                   eval.basis(qpts,basisvals,1),sparse=TRUE)
        proc$more$weights = matrix(1/length(qpts),length(qpts)*nrep,ncol(coefs))
        #proc$more$weights = 1/length(qpts)
        proc$more$qpts = qpts
      }
      else
        {
       len = length(times)
       basis = eval.basis(times,basisvals,0)
       proc$bvals = list(bvals = Matrix(basis[1:(len-1),], sparse=TRUE),
                         dbvals= Matrix(basis[2:len,],     sparse=TRUE))
       proc$more$weights = matrix(1/(len-1),(len-1)*nrep,ncol(coefs))
       #proc$more$weights = 1/(len-1)
       proc$more$qpts = times[1:(len-1)]
       }
      
      
    }
    else{                                   # quadrature is ignored if basisvals
                                            # is not a basis object
      if(discrete & (is.matrix(basisvals) | is.null(basisvals))){
        if(is.null(basisvals)){ basisvals = Diagonal(nrow(coefs)) }
        lik$bvals = basisvals
        proc$bvals = list(bvals  = basisvals[1:(nrow(basisvals)-1),],
                          dbvals = basisvals[2:nrow(basisvals),])
        proc$more$weights = matrix(1/(nrow(basisvals)-1),
                                   nrow(basisvals)-1,ncol(coefs))
        #proc$more$weights = 1/(nrow(basisvals)-1)
        proc$more$qpts = times[1:(length(times)-1)]
      }                                    
      else{                                      
        lik$bvals = Matrix(diag(rep(1,nrep))%x%basisvals$bvals.obs,sparse=TRUE)
  
        proc$bvals =  list(bvals=Matrix(diag(rep(1,nrep)) %x% 
                                        basisvals$bvals,sparse=TRUE),
                          dbvals=Matrix(diag(rep(1,nrep)) %x%
                                        basisvals$dbvals,sparse=TRUE))
        proc$more$qpts = rep(basisvals$qpts,nrep)
        
        if(!is.null(basisvals$qwts))
          proc$more$weights = matrix(basisvals$qwts, 
                                     length(basisvals$qwts)*nrep,ncol(coefs))
        else
          #proc$more$weights = 1/length(proc$more$qpts)
          proc$more$weights = matrix(1/length(proc$more$qpts),
                                       length(proc$more$qpts)*nrep,ncol(coefs))    
      }
    }
 
    if( is.null(weights) ){
      lik$more$weights = matrix(1,ncol(coefs))
    }
    else{
      lik$more$weights = matrix(weights,nrow(lik$bvals)*nrep,ncol(coefs))
    }

    if(!is.null(data)){
      if(length(dim(data))==2){
        if(nrep>1){stop('data dimensions must match coefficient dimensions')}
        if(dim(data)[1] != length(times) | dim(data)[2]!= dim(coefs)[2]){
        stop('data dimensions, times and coefficient dimensions do not match')}
      }
      if(length(dim(data))==3){
         if(dim(data)[2] != nrep | dim(data)[3]!=dim(coefs)[2] | 
            dim(data)[1]!=length(times)){
        stop('data dimensions, times and coefficient dimensions do not match')}
        data = matrix(data,dim(data)[1]*dim(data)[2],dim(data)[3])
        times = rep(times,nrep)
     }
    }

    if(length(lambda)==1){ lambda = rep(lambda,ncol(coefs)) }

#    print(length(proc$more$weights))
    proc$more$weights = proc$more$weights%*%diag(lambda)

    return( list(lik=lik,proc=proc,coefs=coefs,data=data,times=times) )

}

########### Likelihood for Rates of Change ################ 
# 
# Here we note that the derivative is modeled as a respose
# dependent on the state, and represented as "y" in 
# in calls to gradient evalutations
########################################################### 


make.exp.Cproc <- function()
{

exp.Cproc <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals$bvals%*%coefs))
   ddevals = (as.matrix(bvals$dbvals%*%coefs))*devals

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames
    
   f = more$fn(ddevals,more$qpts,devals,pars,more$more)

   return( sum(f) )
}


exp.dCproc.dc <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals$bvals%*%coefs))
   ddevals = (as.matrix(bvals$dbvals%*%coefs))*devals

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames
    
   g1 = more$dfdx(ddevals,more$qpts,devals,pars,more$more)
   g2 = more$dfdy(ddevals,more$qpts,devals,pars,more$more)

   g = as.vector( t(bvals$bvals)%*%(g1*devals) + 
                 t(bvals$dbvals)%*%(g2*devals) +
                 t(bvals$bvals)%*%(g2*ddevals) )

   return(g)
}


exp.dCproc.dp <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals$bvals%*%coefs))
   ddevals = (as.matrix(bvals$dbvals%*%coefs))*devals

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

   g = more$dfdp(ddevals,more$qpts,devals,pars,more$more)

   g = apply(g,2,sum)

   return(g)
}



exp.d2Cproc.dc2 <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals$bvals%*%coefs))
   ddevals = (as.matrix(bvals$dbvals%*%coefs))*devals

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

  g1 = more$dfdx(ddevals,more$qpts,devals,pars,more$more)
  g2 = more$dfdy(ddevals,more$qpts,devals,pars,more$more)

  H1 = more$d2fdx2(ddevals,more$qpts,devals,pars,more$more)
  H2 = more$d2fdxdy(ddevals,more$qpts,devals,pars,more$more)
  H3 = more$d2fdy2(ddevals,more$qpts,devals,pars,more$more)

 # H = array(0,c(rep(dim(bvals$bvals)[2],2),rep(dim(devals)[2],2)))
   H = list(len=dim(bvals$bvals)[2])
   
  for(i in 1:dim(devals)[2]){
    ibvals = diag(devals[,i])%*%bvals$bvals
    idbvals = diag(ddevals[,i])%*%bvals$bvals+diag(devals[,i])%*%bvals$dbvals
    H[[i]] = list(len=dim(devals))
    for(j in 1:dim(devals)[2]){
        jbvals = diag(devals[,j])%*%bvals$bvals
        jdbvals = diag(ddevals[,j])%*%bvals$bvals+diag(devals[,j])%*%bvals$dbvals
        H[[i]][[j]] = t(ibvals)%*%diag(H1[,i,j])%*%jbvals +
            t(ibvals)%*%diag(H2[,i,j])%*%jdbvals + 
            t(idbvals)%*%diag(H2[,j,i])%*%jbvals + 
            t(idbvals)%*%diag(H3[,i,j])%*%jdbvals
    }
    H[[i]][[i]] = H[[i]][[i]] + t(ibvals)%*%diag(g1[,i])%*%bvals$bvals +
                t(idbvals)%*%diag(g2[,i])%*%bvals$bvals +
                t(ibvals)%*%diag(g2[,i])%*%bvals$dbvals    
    
#    t(bvals$dbvals)%*%diag(devals[,i]*g2[,i])%*%bvals$bvals +
#                t(bvals$bvals)%*%diag(devals[,i]*g2[,i]*devals[,i])%*%bvals$dbvals
#                t(bvals$bvals)%*%diag(ddevals[,i]*g2[,i]*devals[,i]+devals[,i]*g1[,i]*devals[,i])%*%bvals$bvals
  }

  H = blocks2mat(H)

  return(H)
}



exp.d2Cproc.dcdp <- function(coefs,bvals,pars,more) 
{ 
   devals = exp(as.matrix(bvals$bvals%*%coefs))
   ddevals = (as.matrix(bvals$dbvals%*%coefs))*devals

    colnames(devals) = more$names
    colnames(ddevals) = more$names
    names(pars) = more$parnames

   H1 = more$d2fdxdp(ddevals,more$qpts,devals,pars,more$more)
   H2 = more$d2fdydp(ddevals,more$qpts,devals,pars,more$more)

   H = c()

   for(i in 1:length(pars)){
      H = cbind(H,as.vector(t(bvals$bvals)%*%(devals*H1[,,i] + ddevals*H2[,,i]) +
            t(bvals$dbvals)%*%(devals*H2[,,i])))
   }

   return(H)
}



    return(
        list(
            fn = exp.Cproc,
            dfdc = exp.dCproc.dc,
            dfdp = exp.dCproc.dp,
            d2fdc2 = exp.d2Cproc.dc2,
            d2fdcdp = exp.d2Cproc.dcdp
        )
    ) 
} 

# Load some things in 

library('CollocInfer')

# The Chemostat equations represent a four-species Chemostat plus the resource 
# of Nitrogen. There are two species of Algae with varying defenses against
# Rotifers. The Rotifers themselves are divided into two class -- breeding
# and senescent, although these two are very tightly coupled. 
#
# A full description of these equations can be found in the user manual. 
# The five state variables for the equations are
# 
# N - nitrogen content in the Chemostat
# C1 - Algal type 1
# C2 - Algal type 2 
# B - Breeding Rotifers
# S - Senescent Rotifers
#
# The system has 16 parameters. Notable features include that only the sums 
# C1+C2 and B+S can be observed. Further, an unknown fraction of each is counted 
# at each time. This requires us to set up a model for the observation process 
# along with the ODE. 

# First we load up some data

data(ChemoData)

# The first two of these parameters give the fractions of Algae and Rotifers 
# that are counted. The remaining parameters are all positive and using 
# their logged values is helpful. 

logpars=c(ChemoPars[1:2],log(ChemoPars[3:16]))

# Parameters 'p1' and 'p2' represent relative palatability of the two algal
# clones, as such only one can be estimated and we fix p2 = 0. 

active = c(1:2,5,7:16)     


# We need some basis functions

rr = range(ChemoTime)
knots = seq(rr[1],rr[2],by=0.5)
bbasis = create.bspline.basis(rr,norder=4,breaks=knots)

# smooth obtained from generating some ODE solutions

y0 = log(c(2,0.1,0.4,0.2,0.1))  
names(y0) = ChemoVarnames

odetraj = lsoda(y0,ChemoTime,func=chemo.ode,logpars)

DEfd   = smooth.basis(ChemoTime,odetraj[,2:6],fdPar(bbasis,int2Lfd(2),1e-6))
coefs0 = DEfd$fd$coef


# We need a measurement model

ChemoMeas = function(t,x,p,more)
{
  return( cbind( log(exp(x[,'C1'])+exp(x[,'C2'])) + log(p['a1']), log(exp(x[,'B'])+exp(x[,'S']))+log(p['a2']) ) )
}


# From here we can employ the usual setup functions

out = LS.setup(pars = logpars,coefs = coefs0,fn=chemo.fun,
        basisvals=bbasis,lambda=c(1e3,2e2,2e2,1e3,1e3)/2,data=ChemoData,times=ChemoTime,
        posproc=TRUE,names=ChemoVarnames,likfn=ChemoMeas)


lik = out$lik
proc = out$proc


# Now, with parameters fixed, we'll estiamte coefficients. 

control.in = list()
control.in$trace = 2
control.in$maxit = 1000
control.in$reltol = 1e-6

res1 = inneropt(coefs=coefs0, pars=logpars, times=ChemoTime, data=log(ChemoData),
               lik=lik, proc=proc, in.meth='optim', control.in=control.in)

# We'll plot agreement with the data

out1 = CollocInferPlots(res1$coefs,logpars,lik,proc,ChemoTime,log(ChemoData))


# And conduct the outer optimization

res2 = outeropt(coefs=coefs0, pars=logpars, times=ChemoTime, data=log(ChemoData),
               lik=lik, proc=proc, in.meth='optim', control.in=control.in)
               
# along with diagnostic plots

out2 = CollocInferPlots(res2$coefs,res2$pars,lik,proc,ChemoTime,log(ChemoData))

###############################################################

# The following provides a manual setup that employs the builtin genin
# functions for measurement or process models that involve linear combinations
# of variables. 

mids = c(min(knots),(knots[1:(length(knots)-1)] + 0.25),max(knots))

bvals.obs = eval.basis(ChemoTime,bbasis)

bvals.proc = list(bvals  = eval.basis(mids,bbasis),
                  dbvals = eval.basis(mids,bbasis,1));


# We'll choose a fairly large value of lambda. 

lambda = c(1e3,2e2,2e2,1e3,1e3)


# We can now set up the proc object. We will want to take a log transformation
# of the state here for numerical stability. In general it is better to do 
# finite differencing AFTER the log transformation rather than before it. 

proc       = make.SSEproc()              # Sum of squared errors
proc$bvals = bvals.proc                  # Basis values

proc$more          = make.findif.ode()   # Finite differencing
proc$more$qpts     = mids                # Quadrature points
proc$more$weights  = rep(1,5)*lambda     # Quadrature weights (including lambda)
proc$more$names    = ChemoVarnames       # Variable names
proc$more$parnames = ChemoParnames       # Parameter names

proc$more$more = list(fn=make.logtrans()$fn,eps=1e-8) # Log transform

proc$more$more$more = list(fn=chemo.fun) # ODE function

# For the lik object we need to both represent the linear combination transform
# and we need to model the observation process. 

# First to represent the observation process, we can use the genlin
# functions. These produce a linear combination of the the states 
# (they can be used in proc objects for linear systems, too).  

temp.lik      = make.SSElik()
temp.lik$more = make.genlin()

# Genlin requires a more object with two elements. The 'mat' element
# gives a template for the matrix defining the linear combination. This is
# all zeros 2x5 in our case for the two observations from five states. 
# The 'sub' element specifies which elements of the parameters should be
# substituted into the mat element. 'sub' should be a kx3 matrix, each
# row defines the row (1) and column (2) of 'mat' to use and the element
# of the parameter vector (3) to add to it. 

temp.lik$more$more = list(mat=matrix(0,2,5,byrow=TRUE), 
                          sub = matrix(c(1,2,1,1,3,1,2,4,2,2,5,2),4,3,byrow=TRUE))
#temp.lik$more$weights = matrix(c(100,1),length(ChemoTime),2)

temp.lik$more$weights = c(100,1)

# Finally, we tell CollocInfer that the trajectories are represented on
# the log scale and must be exponentiated before comparing them to the data. 

lik       = make.logstate.lik()
lik$more  = temp.lik
lik$bvals = bvals.obs

# Now lets try running this

# Because we don't have direct observations of any state, we'll use a starting 
# smooth obtained from generating some ODE solutions

y0 = log(c(2,0.1,0.4,0.2,0.1))  
names(y0) = ChemoVarnames

odetraj = lsoda(y0,ChemoTime,func=chemo.ode,logpars)

DEfd   = smooth.basis(ChemoTime,odetraj[,2:6],fdPar(bbasis,int2Lfd(2),1e-6))
coefs0 = DEfd$fd$coef

# Now, with parameters fixed, we'll estiamte coefficients. 

control.in = list()
control.in$trace = 2
control.in$maxit = 1000
control.in$reltol = 1e-6

res = inneropt(coefs=coefs0, pars=logpars, times=ChemoTime, data=ChemoData,
               lik=lik, proc=proc, in.meth='optim', control.in=control.in)

# We'll for the trajectory and also the appropriate sum of exponentiated
# states to compare to the data. 

coefs1  = matrix(res$coefs,dim(coefs0))
traj    = lik$bvals %*% coefs1
obstraj = lik$more$more$fn(ChemoTime,exp(traj),logpars,lik$more$more$more)

# Plot these against the data

X11()
par(mfrow=c(2,1))
plot(obstraj[,1],type='l',ylab='Chlamy',xlab='',cex.lab=1.5,cex.axis=1.5)
points(ChemoData[,1])
plot(obstraj[,2],type='l',ylab='Brachionus',xlab='days',cex.lab=1.5,cex.axis=1.5)
points(ChemoData[,2])


# Now we can continue with the outer optimization

res2 = outeropt(pars=logpars,times=ChemoTime,data=ChemoData,coef=coefs1,
    lik=lik,proc=proc,active=active,in.meth='optim',out.meth='nlminb')

# We'll extract the resulting parameters and coefficients. 

npars = res2$pars
C = as.matrix(res2$coefs,dim(C))

# And obtain an estimated trajectory and the exponentiated sum to comprare
# to the data. 

traj = lik$bvals%*%C
ptraj = lik$more$more$fn(ChemoTime,exp(traj),npars,lik$more$more$more)

# Lets have a look at how much we changed our parameters on the original 
# scale. 

new.pars = npars
new.pars[3:16] = exp(new.pars[3:16])

print(ChemoPars)
print(new.pars)
print(new.pars/ChemoPars)

# Now we can produce a set of diagnostic plots. 

# Firstly, a representation of the trajectory compared to the data. 

X11()
par(mfrow=c(2,1))
plot(ChemoTime,ptraj[,1],type='l',ylab='Chlamy',xlab='',cex.lab=1.5)
points(ChemoTime,ChemoData[,1])
plot(ChemoTime,ptraj[,2],type='l',ylab='Brachionus',xlab='days',cex.lab=1.5)
points(ChemoTime,ChemoData[,2])


# Now we'll plot both the derivative of the trajectory and the value of the
# differential equation right hand side at each point. This represents the 
# fit to the model. 

traj2 = proc$bvals$bvals%*%C
dtraj2 = proc$bvals$dbvals%*%C

colnames(traj2) = ChemoVarnames
ftraj2 = proc$more$fn(proc2$more$qpts,traj2,npars,proc$more$more)


X11()
par(mfrow=c(5,1),mai=c(0.3,0.6,0.1,0.1))
for(i in 1:5){
  plot(mids,dtraj2[,i],type='l',xlab='',ylab=ChemoVarnames[i],
    cex.lab=1.5,ylim=c(-0.5,0.5))
  lines(mids,ftraj2[,i],col=2,lty=2)
  abline(h=0)
}
legend('topleft',legend=c('Smooth','Model'),lty=1:2,col=1:2,cex=1.2)

# Solving the differential equation from the estiamted initial condition
# of the trajectory allows us to compare the qualitative behavior of 
# our estimate to that of the differential equation. 

y0 = traj[1,]
names(y0) = ChemoVarnames
odetraj = lsoda(y0,ChemoTime,func=chemo.ode,parms=npars)


X11()
par(mfrow=c(2,1))
matplot(ChemoTime,traj,col=1,type='l',lwd=3,cex.lab=1.5,cex.axis=1.5,
    ylab='',cex.main=1.5,main='Reconstructed Trajectories')
legend(x='topright',legend=ChemoVarnames,lwd=3,col=1,lty=1:5)
matplot(ChemoTime,odetraj[,2:6],col=1,type='l',lwd=3,cex.axis=1.5,cex.lab=1.5,
    ylab='',cex.main=1.5,main='ODE Solution')

# We can also compare the pattern of observations predicted by the differential
# equation and that estimated by our methods. 

otraj = lik$more$more$fn(ChemoTime,exp(odetraj[,2:6]),npars,lik$more$more$more)

X11()
par(mfrow=c(2,1))
matplot(ChemoTime,ptraj,type='l',lwd=2,xlab='days',cex.lab=1.5,ylab='',
  cex.axis=1.5,cex.main=1.5,main='Predicted Observations -- Smooth')
matplot(ChemoTime,ChemoData,add=TRUE,pch = c(1,2))
legend('topright',legend=c('Algae','Rotifers'),pch=1:2,col=1:2)
matplot(ChemoTime,otraj,type='l',lwd=2,xlab='days',cex.lab=1.5,ylab='',
  cex.axis=1.5,cex.main=1.5,main='Predicted Observations -- ODE')
legend('topright',legend=c('Algae','Rotifers'),lty=1:2,col=1:2,lwd=2)

Smooth.LS <- function(fn, data, times, pars, coefs=NULL, basisvals=NULL,
                       lambda,fd.obj=NULL,more=NULL,weights=NULL,
	                     quadrature=NULL, in.meth='nlminb', control.in=list(), eps=1e-6,
                       posproc=FALSE, poslik=FALSE, discrete=FALSE, names=NULL, sparse=FALSE)
{
      
    dims = dim(data)

    profile.obj = LS.setup(pars, coefs, fn, basisvals, lambda,fd.obj, more,
                            data, weights, times, quadrature, eps=1e-6, posproc,
                            poslik, discrete, names=names, sparse=sparse)

    lik   = profile.obj$lik
    proc  = profile.obj$proc
    coefs = profile.obj$coefs
    data  = profile.obj$data
    times = profile.obj$times

    Ires   = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
    ncoefs = Ires$coefs
    Ires   = Ires$res
    ncoefs = as.matrix(ncoefs)
    if(!is.null(proc$more$names)){ colnames(ncoefs) = proc$more$names }

    if(!is.null(fd.obj)){
      if(length(dims)>2){
        ncoefs = array(ncoefs,c(length(ncoefs)/(dims[2]*dims[3]),dims[2],dims[3]))
      } else{
         ncoefs = array(ncoefs,c(length(ncoefs)/dims[2],dims[2]))
      }
      fd.obj = fd(ncoefs,fd.obj$basis)
      return( list(fd=fd.obj,lik=lik,proc=proc,inner.result=Ires) )
    }
    else{
      return( list(coefs=ncoefs,lik=lik,proc=proc,inner.result=Ires,data=data,
                   times=times) )
    }
}

library('CollocInfer')

# The per-individual growth rates for the Rosenzweig-Macarthur model are given below:

RosMac = function(t,x,p,more)
{
  p = exp(p); x = exp(x)
  dx = x;
  
  dx[,'C'] = p['rho']*(1- x[,'C']/p['kappaC']) - p['gamma']*x[,'B']/(p['kappaB']+x[,'C']) 
  dx[,'B'] = p['chi']*p['gamma']*x[,'C']/(p['kappaB']+x[,'C']) - p['delta']

  return(dx)
}


# We can now obtain some data (from Becks et. al., 2010, Ecology Letters)

data(ChemoRMData)

time = ChemoRMTime
data = log(ChemoRMData)

par(mar=c(5,5,1,1))
matplot(time,data,pch=c('C','B'),xlab='days',ylab='log(Obs)',cex.lab=2.5,cex.axis=2.5,cex=1.5)


# and set up some names for the variables and the parameters

varnames = RMvarnames
parnames = RMparnames

# Define some asis functions

rr = range(time)
knots = seq(rr[1],rr[2],by=1)

mids = c(min(knots),(knots[1:(length(knots)-1)] + 0.5),max(knots))

bbasis = create.bspline.basis(rr,norder=4,breaks=knots)

# An inital set of parameters and coefficients

coef0 = smooth.basis(time,data,fdPar(bbasis,int2Lfd(2),10))$fd$coef
colnames(coef0) = varnames

#pars = c(log(c(0.4,5e5)),rep(0,4))
pars = log(ChemoRMPars)
names(pars) = parnames

# Whic parameters to we wish to estimate?

activepars = 3:6


## Get profiling objects

out = LS.setup(pars=pars,coefs=coef0,basisvals=bbasis,fn=RosMac,lambda=c(5e4,5e2),
          times=time)
          
          
lik = out$lik
proc = out$proc


## Gradient Matching to Start With

res1 = ParsMatchOpt(pars,coef0,proc,active=3:6)


## And profile

res2 = outeropt(data,time,res1$pars,coef0,lik,proc,active=activepars)

# plot the results

out2 = CollocInferPlots(res2$coefs,res2$pars,lik,proc,times=time,data=data,
          cex.lab=2.5,cex.axis=2.5,cex=1.5,lwd=3)

## Now we can look at the covariance

covar = Profile.covariance(res2$pars,times=time,data=data,
          coefs=res2$coefs,lik=lik,proc=proc,active=activepars)
CIs = cbind( res2$pars[activepars] - 2*sqrt(diag(covar)),
               res2$pars[activepars] + 2*sqrt(diag(covar)) )
rownames(CIs) = parnames[activepars]
exp(CIs)

# We can also examine forward prediction error

whichtimes = cbind(1:102,6:107)

lambdafac = c(0.1,0.5,1,5,10)
FPEs = 0*lambdafac
for(ilam in 1:length(lambdafac)){
  t.res = Profile.LS(RosMac,data,time,res2$pars,res2$coefs,bbasis,
                      lambdafac[ilam]*c(5e4,5e2),active=activepars,out.meth='nlminb')
  FPEs[ilam] = forward.prediction.error(time,data,t.res$coefs,
                                   lik,proc,t.res$pars,whichtimes)
}
FPEs

##
## Gillespie simulator for forced SEIR model
##
##    For given parameter values and initial conditions, compute
##    the deterministic SEIR solution and some Gillespie realizations.
##    Plot the results and save to a file (gillespieInc.csv).
##
## Created:  7 Mar 2008 by David Earn
## Changed: 17 Mar 2008
##

compute.gillespie <- TRUE; # FALSE means read gillespie from file

#if (interactive()) {
#  par(ask=TRUE);
#} else {
#  # postscript(psfile);
#  pdffile <- "gillespieInc.pdf";
#  pdf(pdffile, width=8.5, height=11);
#}

require(odesolve);  ## for lsoda

## SET PARAMETER VALUES
N <- 5*10^6; ## population size
nu <- 0.02; ## birth rate (1/yr)
mu <- 0.02; ## death rate (1/yr)
R0 <- 17; ## reproductive number
latent.days <- 8;  ## mean latent period (days)
infectious.days <- 5;  ## mean infectious period (days)
alpha <- 0.08; ## seasonal forcing amplitude

## SET INITIAL CONDITIONS
## Chosen to be close to attractor.
s0 <- 0.0576*N;
e0 <- 0.000165*N;
i0 <- 0.0001*N;
if (N>=10^4) {
  s0 <- round(s0);
  e0 <- round(e0);
  i0 <- round(i0);
}

## SET SIMULATION TIME (yrs)
tstart <- 0;
tend <- 5;
tby <- 1/52;
#tend <- 0.05;
#tby <- 0.001;
report.times <- seq(from=tstart, to=tend, by=tby);

## SET NUMBER OF GILLESPIE REALIZATIONS
Nreal <- 1;

## SET DERIVED PARAMETERS
sigma <- 365/latent.days;
gamma <- 365/infectious.days;
beta0 <- R0 * gamma / N; # FIX: this is approximate
Ivisitors <- 0;

## DEFINE PARMS AND IC VECTORS FOR CONVENIENCE
parms <- c( 
           N=N,
           nu=nu,
           mu=mu,
           R0=R0,
           sigma=sigma,
           gamma=gamma,
           beta0=beta0,
           Ivisitors=Ivisitors,
           alpha=alpha
           );
## we save cumulative incidence as well so we can
## plot incidence when we are done
ic <- c( S=s0, E=e0, I=i0, R=N-s0-e0-i0, cumInc=0 );
cat("Initial conditions:\n");
print(ic);

## SEASONALLY FORCED TRANSMISSION RATE FUNCTION
betafun <- function( t, parms ) {
  beta0 <- parms["beta0"];
  alpha <- parms["alpha"];
  return( beta0 * (1 + alpha*cos(2*pi*t) ))
}

## DERIVATIVE FUNCTION FOR SEIR MODEL
deriv.seir <- function( t, x, parms ) {
  with(as.list(x,parms),{
    dx <- x; ## dx is same length as x and has same component names
    dx["S"] <- nu*N - betafun(t,parms)*S*I - mu*S;
    dx["E"] <- betafun(t,parms)*S*I - (sigma+mu)*E;
    dx["I"] <- sigma*E - (gamma+mu)*I;
    dx["R"] <- gamma*I - mu*R;
    ## integrate incidence to get cumulative incidence: to get
    ## incidence we will take adjacent differences of solution
    dx["cumInc"] <- betafun(t,parms)*S*I;
    return(list(dx))
  });
}
    
## RUN DETERMINISTIC MODEL
lsoda.out <- lsoda( y=ic, times=report.times, func=deriv.seir, parms=parms );

## FUNCTION TO EXTRACT LAST COLUMN OF A MATRIX
lastcol <- function( x ) {
  return( x[,ncol(x)] )
}

## PLOT THE DETERMINISTIC SOLUTION
par(mfrow=c(2,1)); #ncol,nrow
t <- lsoda.out[,1];
## extract deterministic cumulative incidence:
detinc <- lastcol(lsoda.out);
## convert to incidence:
detinc <- c(0,diff(detinc));
## plot incidence:
plot(t,detinc,typ="l",col="dark red",lwd=5,xlab="Time (years)",ylab="Incidence",ylim=c(0,1.1*max(detinc)));

#########################
## GILLESPIE ALGORITHM ##
#########################
## Note: This not the most general formulation of the Gillespie
##       algorithm.  More generally we would consider a transition
##       matrix with columns for event names, event rates,  and
##       a column for each state variable.  In each row, the state
##       variable column would contain an integer indicating by
##       how much it increases or decreases as a result of the
##       event in question.  In the SEIR case, these integers
##       would all be -1, 0 or 1 and at most two in any row would
##       be non-zero.

## EVENT RATES
event.rates.seir <- function( t, x, parms ) {
  with(as.list(x,parms),{
    transmission <- as.vector(betafun(t,parms)*S*(I+Ivisitors));
      ## as.vector prevents s2e becoming s2e.beta0
    rates <- c(snew=nu*N, ## new susceptibles
               s2d=mu*S,e2d=mu*E,i2d=mu*I,r2d=mu*R, ## death
               s2e=transmission,
               e2i=sigma*E, ## becoming infectious
               i2r=gamma*I  ## recovery
               );
    return(rates)
  });
}

## GLOBAL VECTORS GIVING COMPARTMENT INCREMENTS AND DECREMENTS
event.names <- c(
  "snew", "s2d", "e2d", "i2d", "r2d", "s2e", "e2i", "i2r" );
event.plus <- NULL;
event.plus[event.names] <- c(
  "S",    NA,   NA,   NA,   NA,   "E",   "I",   "R" );
event.minus <- NULL;
event.minus[event.names] <- c(
  NA,    "S",   "E",   "I",   "R",   "S",   "E",   "I" );
event.counts <- NULL; # vector of counts of each type of event
event.counts[event.names] <- 0;
                
## TIME TO NEXT GILLESPIE EVENT
time.to.next.event <- function( event.rates ) {
  total.rate <- sum(event.rates);
  stopifnot(total.rate > 0);
  u <- runif(1);
  stopifnot(u>0);
  return(log(1/u)/total.rate)
  ##
  ## Note: we could instead
  ##
  ##           return(rexp(1,total.rate))
  ##
  ##       which would definitely be preferable if we were
  ##       dealing with non-exponential distributions that
  ##       aren't so easy to invert.  However, if the stage
  ##       durations are not exponentially distributed then
  ##       the algorithm changes.  In the special case of
  ##       Erlang distributed stage durations we can stick
  ##       with the identical algorithm at the expense of
  ##       adding "hidden state" variables.
}

## FUNCTION TO RETURN LAST ELEMENT OF AN OBJECT
## Strange that this is not available already in R.
last <- function(x) {
  return(x[length(x)])
}

## TYPE OF NEXT GILLESPIE EVENT
## FIX: depends on global vector event.names
select.event.type <- function( event.rates ) {
  ne <- length(event.rates);
  event.divisions <- c(0,cumsum(event.rates));
  event.divisions <- event.divisions/event.divisions[ne+1];
    ## Note that event.divisions[ne+1] == sum(event.rates)
  r <- runif(1);
  event.names.index <- 0;
  event.names.index <- last(which(event.divisions < r));
  stopifnot(event.names.index <= ne);
  return(event.names[event.names.index])
}

## UPDATE DISCRETE STATE
## FIX: depends on global vectors event.plus and event.minus
##      (This would be cured by passing a transition matrix.)
update.state <- function(x,event.rates,incidence.count) {
  ## determine event type
  event.name <- select.event.type( event.rates );
  ## increment and decrement appropriate compartments
  if (!is.na(event.plus[event.name])) {
    x[event.plus[event.name]] <- x[event.plus[event.name]] + 1;
  }
  if (!is.na(event.minus[event.name])) {
    x[event.minus[event.name]] <- x[event.minus[event.name]] - 1;
  }
  ## keep track of numbers of each event type for later analysis
  event.counts[event.name] <<- event.counts[event.name] + 1;
    ## N.B. <<- is global assign
  ## INCREMENT INCIDENCE IF THIS WAS AN e2i EVENT:
  ## FIX: This is an ugly hack... keeping track of a quantity
  ##      that is not itself a state variable would be easier
  ##      with a transition matrix formulation.
  ##      Having added a compartment for incidence in the
  ##      deterministic model, it would have been better here
  ##      to increment x["cumInc"] rather than create a new
  ##      global variable for incidence...
  if (event.name == "e2i") {
    ##cat("incidence.count =", incidence.count, "\n");
    incidence.count <<- incidence.count + 1;
  }
  return(x)
}

## RUN GILLESPIE REALIZATION
gillespie <- function( ic, times, event.rates.func, parms ) {
  with(as.list(parms), {
    ## create matrix in which to return simulation results
    nt <- length(times); ## number of time points at which to save
    result <- matrix(0,nrow=nt,ncol=1+length(ic));
    incidence <- matrix(0,nrow=nt,ncol=2);
    ## set and save initial state
    it <- 1; ## index of time points at which to save
    t <- times[it]; ## current time
    x <- ic; ## current state
    result[it,] <- c(t,x);
    ## iterate Gillespie algorithm
    event.count <- 0;
    while (it < nt) {
      event.count <- event.count + 1;
      if (x["E"]==0 && x["I"]==0) {
        cat(sprintf("Extinct at time %g after %d events\n", t, event.count));
        break; # Beware: this also stops the birth-death process
      }
      event.rates <- event.rates.func(t,x,parms);
      dt <- time.to.next.event(event.rates);
      if (FALSE) { # debugging code
        ##if (sum(x) > N) {
        ##if (event.count %% 1000 == 0) {
        cat("ireal=", ireal, " it=",it," dt=", dt, " t=", t, " x=", x,
            " sum(x)=", sum(x), "\n");
      }
      t <- t+dt;
      if (t > times[it+1]) {
        it <- it+1;
        result[it,] <- c(times[it],x); # prevalence is saved here
        incidence[it,] <- c(times[it],incidence.count);
        if (it %% 10 == 0) {
          cat("ireal=", ireal, "it=", it, " inc=", incidence[it,2], " SEIR=", result[it,], "\n");
        }
        incidence.count <<- 0; # restart incidence counter
      }
      x <- update.state(x,event.rates,incidence.count);
    }
    ## return(result) # return full SEIR at each save point
    return(incidence) # return incidence between save points
  })
}

#############################
## END GILLESPIE FUNCTIONS ##
#############################

Nvar <- length(ic);
times <- lsoda.out[,1];
all.results <- matrix(0,nrow=length(times),ncol=1+Nvar*(1+Nreal));
all.results[,1] <- times;
all.incidence <- matrix(0,nrow=length(times),ncol=2+Nreal);
all.incidence[,1] <- times;
all.incidence[,2] <- detinc;

outfile <- "gillespieInc.csv";
if (compute.gillespie) {
  ## COMPUTE SEQUENCE OF GILLESPIE REALIZATIONS
  for (ireal in 1:Nreal) {
    incidence.count <- 0; # FIX: this is ugly...
    gillespie.out <- gillespie(ic=ic,times=report.times,
                               event.rates.func=event.rates.seir,
                               parms=parms);
    inc <- gillespie.out[,2];
    all.incidence[,ireal+2] <- inc;
  }
  write.csv(all.incidence,outfile,quote=FALSE,row.names=FALSE);
} else {
  ## READ SAVED GILLESPIE REALIZATIONS FROM FILE
  all.incidence <- read.csv(outfile,quote="",comment.char="#");
}


## PLOT THE ENSEMBLE MEAN OF THE GILLESPIE REALIZATIONS
t <- all.incidence[,1];
if (Nreal > 1) {
  meanreal <- rowMeans(all.incidence[,-c(1,2)]);
} else {
  meanreal <- all.incidence[,-c(1,2)];
}
points(t,meanreal,lwd=3);
title(main=sprintf("Determinstic SEIR (red) and mean of %d Gillespie realizations (circles)", Nreal));

## PLOT THE GILLESPIE REALIZATIONS
matplot(t,all.incidence[,-c(1,2)],typ="l",lty=1,
        xlab="Time (years)",
        ylab="Incidence");
points(t,meanreal,lwd=3);
title(main=sprintf("%d Gillespie realizations (lines) and mean (circles), N = %g", Nreal, N));

## SAVE TIME REQUIRED FOR THIS RUN IN CASE WE WANT TO REDO IT
ptm <- as.vector(proc.time());
## dump proc.time to output file (multiple formats is just
## laziness... should have a function that computes hours,mins,secs
## and outputs in one nice format
if(compute.gillespie){
  cat("#      user   system  elapsed\n", 
      "# seconds:\n",
      sprintf("# %8.2f %8.2f %8.2f\n", ptm[1], ptm[2], ptm[3]),
      "# minutes:\n",
      sprintf("# %8.2f %8.2f %8.2f\n", ptm[1]/60, ptm[2]/60, ptm[3]/60),
      "# hours:\n",
      sprintf("# %8.2f %8.2f %8.2f\n", ptm[1]/60/60, ptm[2]/60/60, ptm[3]/60/60),
      file=outfile,append=TRUE);
}
cat("#      user   system  elapsed\n", 
    "# seconds:\n",
    sprintf("# %8.2f %8.2f %8.2f\n", ptm[1], ptm[2], ptm[3]),
    "# minutes:\n",
    sprintf("# %8.2f %8.2f %8.2f\n", ptm[1]/60, ptm[2]/60, ptm[3]/60),
    "# hours:\n",
    sprintf("# %8.2f %8.2f %8.2f\n", ptm[1]/60/60, ptm[2]/60/60, ptm[3]/60/60));

## SAVE EVENT COUNTS FOR ANALYSIS
if (compute.gillespie) {
  event.count <- sum(event.counts);
  events.per.second <- event.count / ptm[1];
  print(event.counts);
  cat(sprintf("# total event.count: %d,  events.per.second: %g\n", event.count, events.per.second));
  cat(sprintf("# total event.count: %d,  events.per.second: %g\n", event.count, events.per.second),file=outfile,append=TRUE);
}

make.SEIR <- function()
{
SEIR.ode <- function(t,y,parms)
{

    p = parms$p
    more = parms$more

#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)

    r = y

    r['S'] = p['mu'] - beta*y['S']*(p['i']+y['I']) - p['nu']*y['S']
    r['E'] = beta*y['S']*y['I'] - p['sigma']*y['E'] - p['nu']*y['E']
    r['I'] = p['sigma']*y['E'] - p['gamma']*y['I'] - p['nu']*y['I']

    return(list(r))
}


SEIR.fun <- function(t,y,p,more)
{

#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)

    r = y

    r[,'S'] = p['mu'] - beta*y[,'S']*(p['i']+y[,'I']) - p['nu']*y[,'S']
    r[,'E'] = beta*y[,'S']*(p['i']+y[,'I']) - p['sigma']*y[,'E'] - p['nu']*y[,'E']
    r[,'I'] = p['sigma']*y[,'E'] - p['gamma']*y[,'I'] - p['nu']*y[,'I']

    return(r)
}


SEIR.dfdx <- function(t,y,p,more)
{
#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)

    r = array(0,c(length(t),ncol(y),ncol(y)))

    dimnames(r) = list(NULL,colnames(y),colnames(y))

    r[,'S','S'] = -beta*(p['i']+y[,'I']) - p['nu']
    r[,'S','I'] = -beta*y[,'S']

    r[,'E','S'] = beta*(p['i']+y[,'I'])
    r[,'E','E'] = -p['sigma'] - p['nu']
    r[,'E','I'] = beta*y[,'S']

    r[,'I','E'] = p['sigma']
    r[,'I','I'] = -p['gamma'] - p['nu']

    return(r)
}

SEIR.dfdp <- function(t,y,p,more)
{
 #   p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)
    dbetadp = more$beta.dfdp(t,p,more$betadef)

    r = array(0,c(length(t),ncol(y),length(p)))

    dimnames(r) = list(NULL,colnames(y),names(p))

    r[,'S',more$beta.ind] = -diag(y[,'S']*(p['i']+y[,'I']))%*%dbetadp
    r[,'E',more$beta.ind] = diag(y[,'S']*(p['i']+y[,'I']))%*%dbetadp


    r[,'S','mu'] = 1

    r[,'S','i'] = -beta*y[,'S']
    r[,'E','i'] = beta*y[,'S']

    r[,'S','nu'] = -y[,'S']
    r[,'E','nu'] = -y[,'E']
    r[,'I','nu'] = -y[,'I']

    r[,'E','sigma'] = -y[,'E']
    r[,'I','sigma'] = y[,'E']
    
    r[,'I','gamma'] = -y[,'I']
    return(r)
}


SEIR.d2fdx2 <- function(t,y,p,more)
{
#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)

    r = array(0,c(length(t),ncol(y),ncol(y),ncol(y)))

    dimnames(r) = list(NULL,colnames(y),colnames(y),colnames(y))

    r[,'S','S','I'] = -beta
    r[,'S','I','S'] = -beta

    r[,'E','S','I'] = beta
    r[,'E','I','S'] = beta

    return(r)
}


SEIR.d2fdxdp <- function(t,y,p,more)
{
#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)
    dbetadp = more$beta.dfdp(t,p,more$betadef)

    r = array(0,c(length(t),ncol(y),ncol(y),length(p)))
    dimnames(r) = list(NULL,colnames(y),colnames(y),names(p))

    r[,'S','S',more$beta.ind] = -diag(p['i']+y[,'I'])%*%dbetadp
    r[,'S','I',more$beta.ind] = -diag(y[,'S'])%*%dbetadp
    r[,'E','S',more$beta.ind] = diag(p['i']+y[,'I'])%*%dbetadp
    r[,'E','I',more$beta.ind] = diag(y[,'S'])%*%dbetadp


    r[,'S','S','i'] = -beta
    r[,'E','S','i'] = beta
    
    r[,'S','S','nu'] = -1
    r[,'E','E','nu'] = -1
    r[,'I','I','nu'] = -1
    
    r[,'E','E','sigma'] = -1
    r[,'I','E','sigma'] = 1
    
    r[,'I','I','gamma'] = -1

    return(r)
}



  return(
    list(
        ode.fn = SEIR.ode,
        fn = SEIR.fun,
        dfdx = SEIR.dfdx,
        dfdp = SEIR.dfdp,
        d2fdx2 = SEIR.d2fdx2,
        d2fdxdp = SEIR.d2fdxdp
    )
  )
}


make.var.SEIR <- function()
{

SEIR.var.fun <- function(t,y,p,more)
{
#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)

    r = array(0,c(length(t),ncol(y),ncol(y)))
    dimnames(r) = list(NULL,colnames(y),colnames(y))
    
    r[,'S','S'] = p['mu'] + beta*y[,'S']*(p['i']+y[,'I']) + p['nu']*y[,'S']
    r[,'E','E'] = beta*y[,'S']*(p['i']+y[,'I']) + p['sigma']*y[,'E'] + p['nu']*y[,'E']
    r[,'I','I'] = p['sigma']*y[,'E'] + p['gamma']*y[,'I'] + p['nu']*y[,'I']

    r[,'S','E'] = -beta*y[,'S']*(p['i']+y[,'I'])
    r[,'E','S'] = r[,'S','E']

    r[,'E','I'] = p['sigma']*y[,'E']
    r[,'I','E'] = r[,'E','I']

    return(r)
}

SEIR.var.dfdx <- function(t,y,p,more)
{
    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)

    r = array(0,c(length(t),ncol(y),ncol(y),ncol(y)))
    dimnames(r) = list(NULL,colnames(y),colnames(y),colnames(y))


    r[,'S','S','S'] = beta*(p['i']+y[,'I']) + p['nu']
    r[,'S','S','I'] = beta*y[,'S']

    r[,'E','E','S'] = beta*(p['i']+y[,'I'])
    r[,'E','E','E'] = p['sigma'] + p['nu']
    r[,'E','E','I'] = beta*y[,'S']

    r[,'I','I','E'] = p['sigma']
    r[,'I','I','I'] = p['gamma'] + p['nu']

    r[,'S','E','S'] = -beta*(p['i']+y[,'I'])
    r[,'S','E','I'] = -beta*y[,'S']
    r[,'E','S',] = r[,'S','E',]

    r[,'E','I','E'] = p['sigma']
    r[,'I','E',] = r[,'E','I',]

    return(r)
}

SEIR.var.dfdp <- function(t,y,p,more)
{
#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)
    dbetadp = more$beta.dfdp(t,p,more$betadef)

    r = array(0,c(length(t),ncol(y),ncol(y),length(p)))
    dimnames(r) = list(NULL,colnames(y),colnames(y),names(p))

    r[,'S','S',more$beta.ind] = diag(y[,'S']*(p['i']+y[,'I']))%*%dbetadp   
    r[,'E','E',more$beta.ind] = diag(y[,'S']*(p['i']+y[,'I']))%*%dbetadp    
    r[,'S','E',more$beta.ind] = -diag(y[,'S']*(p['i']+y[,'I']))%*%dbetadp
    r[,'E','S',more$beta.ind] = r[,'S','E',more$beta.ind]

    r[,'S','S','mu'] = 1

    r[,'S','S','i'] = beta*y[,'S']
    r[,'S','E','i'] = -beta*y[,'S']
    r[,'E','S','i'] = r[,'S','E','i']
    r[,'E','E','i'] = beta*y[,'S']
    
    r[,'S','S',nu] = y[,'S']
    r[,'E','E',nu] = y[,'E']
    r[,'I','I',nu] = y[,'I']
    
    r[,'E','E','sigma'] = y[,'E']
    r[,'E','I','sigma'] = y[,'E']
    r[,'I','E','sigma'] = y[,'E']
    
    r[,'I','I','gamma'] = y[,'I']

    return(r)
}


SEIR.var.d2fdx2 <- function(t,y,p,more)
{
#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)

    r = array(0,c(length(t),rep(ncol(y),4)))
    dimnames(r) = list(NULL,colnames(y),colnames(y),colnames(y),colnames(y))

    r[,'S','S','S','I'] = beta
    r[,'S','S','I','S'] = beta

    r[,'E','E','S','I'] = beta
    r[,'E','E','I','S'] = beta

    r[,'S','E','S','I'] = -beta
    r[,'S','E','I','S'] = -beta
    r[,'E','S',,] = r[,'S','E',,]

    return(r)
}

SEIR.var.d2fdxdp <- function(t,y,p,more)
{
#    p = more$p.fun(t,more$pdef)
    beta = more$beta.fun(t,p,more$betadef)
    dbetadp = more$beta.dfdp(t,p,more$betadef)

    r = array(0,c(length(t),rep(ncol(y),3),length(p)))
    dimnames(r) = list(NULL,colnames(y),colnames(y),colnames(y),names(p))

    r[,'S','S','S',more$beta.ind] = diag(p['i']+y[,'I'])%*%dbetadp
    r[,'S','S','I',more$beta.ind] = diag(y[,'S'])%*%dbetadp    

    r[,'E','E','S',more$beta.ind] = diag(p['i']+y[,'I'])%*%dbetadp
    r[,'E','E','I',more$beta.ind] = diag(y[,'S'])%*%dbetadp
    
    r[,'S','E','S',more$beta.ind] = -diag(p['i']+y[,'I'])%*%dbetadp
    r[,'S','E','I',more$beta.ind] = -diag(y[,'S'])%*%dbetadp

    r[,'S','S','S','i'] = beta
    r[,'E','E','S','i'] = beta
    r[,'S','E','S','i'] = -beta
    
    r[,'S','S','S','nu'] = 1
    r[,'E','E','E','nu'] = 1
    r[,'I','I','I','nu'] = 1
    
    r[,'E','E','E','sigma'] = 1
    r[,'E','I','E','sigma'] = 1
    r[,'I','E','I','sigma'] = 1

    r[,'I','I','I','gamma'] = 1
    
    r[,'E','S',,] = r[,'S','E',,]

    return(r)
}



  return(
    list(
        var.fn = SEIR.var.fun,
        var.dfdx = SEIR.var.dfdx,
        var.dfdp = SEIR.var.dfdp,
        var.d2fdx2 = SEIR.var.d2fdx2,
        var.d2fdxdp = SEIR.var.d2fdxdp
    )
  )
}

# An example file fitting the FitzHugh-Nagumo equations to data in the
# new R Profiling Code. This will eventually be interfaced with the new R 
# "Partially Observed Markov Process (pomp)" class of objects. 

library('fda')
library('odesolve')
library('maxLik')
library('MASS')
library('Matrix')
library('SparseM')
source('ProfileR.R')
source('sse.shortcut.R')
source('fhn.R')
source('findif.ode.R')
source('SSElik.R')
source('SSEproc.R')
source('makeid.R')
source('inneropt.R')

# First Create Some Data

t = seq(0,20,0.05)

pars = c(0.2,0.2,3)
names(pars) = c('a','b','c')

x0 = c(-1,1)
names(x0)= c('V','R')
y = lsoda(x0,times=t,func=make.fhn()$fn.ode,pars)
y = y[,2:3]

data = y + matrix(rnorm(802),401,2)



# Now a basis object

knots = seq(0,20,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)


# Initial values for coefficients will be obtained by smoothing

fd.data = array(data,c(dim(data)[1],1,dim(data)[2]))

DEfd = data2fd( fd.data,t,bbasis,fdnames=list(NULL,NULL,c('V','R')) )

coefs = matrix(DEfd$coefs,dim(DEfd$coefs)[1],dim(DEfd$coefs)[3])
colnames(coefs) = DEfd$fdnames[[3]]

# Usual meta-parameters; quadrature points, weights and knots

lambda = c(10000,10000)
qpts = knots
qwts = rep(1/length(knots),length(knots))

qwts = qwts%*%t(lambda)
weights = array(1,dim(data))


# Now I define a measurement process log likelihood along with some
# additional features: in this case it's squared error. 

varnames = c('V','R')
parnames = c('a','b','c')


likmore = make.id()
likmore$weights = weights

lik = make.SSElik()
lik$more = likmore
#lik$bvals = as.matrix.csr(eval.basis(t,bbasis))
lik$bvals = Matrix(eval.basis(t,bbasis),sparse=TRUE)

# Proc is a process log likelihood -- in this case treated as squared
# discrepancy from the ODE definition. 

procmore = make.fhn()
procmore$names = varnames
procmore$parnames = parnames

procmore$weights = qwts
procmore$qpts = qpts


proc = make.SSEproc()
proc$more = procmore
#proc$bvals = list(bvals=as.matrix.csr(eval.basis(procmore$qpts,bbasis,0)),
#		dbvals = as.matrix.csr(eval.basis(procmore$qpts,bbasis,1)))
proc$bvals = list(bvals=Matrix(eval.basis(procmore$qpts,bbasis,0),sparse=TRUE),
		dbvals = Matrix(eval.basis(procmore$qpts,bbasis,1),sparse=TRUE))




###Now lets try some optimization

spars = c(0.2,0.2,2)          # Perturbed parameters


control=list()                # Control parameters 
control$trace = 0
control$maxit = 1000
control$maxtry = 10
control$reltol = 1e-6
control$meth = "BFGS"

control.in = control
control.in$reltol = 1e-12
control.out = control
control.out$trace = 2

control.in$print.level = 0
control.in$iterlim = 1000

# We'll try a simple SSE setup:


res = sse.setup(pars=pars,coefs=coefs,fn=make.fhn(),basisvals=bbasis,lambda=lambda,times=t)

res = smooth.sse(make.fhn(),data,t,pars,coefs,bbasis,lambda=lambda,control.in=control.in)

res = profile.sse(make.fhn(),data,t,pars,coefs,bbasis,lambda=lambda,out.meth='nls',
	control.in=control.in,control.out=control.out)


# Alternative is simply to use the functional data object


res = sse.setup(pars=pars,fd.obj=DEfd,fn=make.fhn(),lambda=lambda,times=t)

res = smooth.sse(pars=pars,fd.obj=DEfd,fn=make.fhn(),lambda=lambda,times=t,data=fd.data,control.in=control.in)

res = profile.sse(fn=make.fhn(),data=fd.data,times=t,pars=pars,fd.obj=DEfd,lambda=lambda,out.meth='house',
	control.in=control.in,control.out=control.out)


# Start with the inner optimization, with various optimization methods

f = SplineCoefsErr(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)
g = SplineCoefsDC(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)
h = SplineCoefsDC2(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)
g2 = SplineCoefsDP(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)
h2 = SplineCoefsDCDP(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)


res = optim(coefs,SplineCoefsErr,gr=SplineCoefsDC,hessian=T,   		
		method="BFGS",control=control.out,
		times=t,data=data,lik=lik,proc=proc,pars=spars)

res0 = nlminb(coefs+2,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
	control=control.out,times=t,data=data,lik=lik,proc=proc,pars=spars)


res2 = maxNR(SplineCoefsErr,start=as.vector(coefs),times=t,data=data,lik=lik,proc=proc,pars=spars,sgn=-1,
	grad=SplineCoefsDC,hess=SplineCoefsDC2,print.level=2,iterlim=100)


res3 = SplineEst.NewtRaph(coefs,t,data,lik,proc,spars)


# record the coefficients for the sake of good starting values

ncoefs = array(res0$par,c(bbasis$nbasis,ncol(data)))

ProfileEnv = new.env()
assign('optcoef',ncoefs,3,ProfileEnv)
assign('curcoefs',ncoefs,3,ProfileEnv)

# Test outer objective criterion

f = ProfileErr(pars,pars,t,data,ncoefs,lik,proc,in.meth="nlminb",control.in=control.in)  
g = ProfileDP(pars,pars,t,data,ncoefs,lik,proc,sum=FALSE)                            


# There are specific criteria for SSE so that a Gauss-Newton iteration can be used

res4 = ProfileSSE(pars,t,data,ncoefs,lik,proc,in.meth="nlminb",control.in) 

# Gauss-Newton function coded in R. 

res5 = Profile.GausNewt(spars,t,data,ncoefs,lik,proc,in.meth="nlminb",control.in)
 
# the alternative standard function is NLS

res6 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth="nlminb",control.in=control.in),start = list(pars=pars),
	trace=TRUE)

# for which we can try a Newey-West type covariance estimate

g = res6$m$gradient()
df = diag(res6$m$resid())%*%g
C6 = NeweyWest.Var(t(g)%*%g, df[1:401,]+df[402:802,],5)


# Try using a simple second-derivative optimizer for the inner optimization:

res7 = Profile.GausNewt(spars,t,data,ncoefs,lik,proc,in.meth='house',control.in)

# nls with a number of alternative inner optimizations: self defined:
 
res8 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='house',control.in=control.in),
	start = list(pars=spars),trace=TRUE)

# nlminb:


res9 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='nlminb',control.in=control.in),
	start = list(pars=spars),trace=TRUE)

# maxNR:


res10 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='maxNR',control.in=control.in),
	start = list(pars=spars),trace=TRUE)



# When squared error is not being employed, things proceed somewhat more slowly
# However, this allows the smoothing criteria to fit into the pomp framework
# fairly readily. 


res11 = optim(pars,ProfileErr,allpars=pars,times=t,data=data,coef=ncoefs,lik=lik,proc=proc,hessian=T,
	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP,method="BFGS")

g = ProfileDP(res11$par,res11$par,t,data,ncoefs,lik,proc,sum=FALSE)  

gg = apply(g,2,sum)

H = 0*res11$hess

for(i in 1:length(pars)){
	tpars = res11$par
	tpars[i] = tpars[i] + 1e-4

	tf = ProfileErr(tpars,tpars,t,data,ncoefs,lik,proc,in.meth="nlminb",control.in=control.in)  
	tg = ProfileDP(tpars,tpars,t,data,ncoefs,lik,proc,sum=TRUE)                            

	H[,i] = (tg-gg)*1e4
}
	

C11 = NeweyWest.Var(H,g,5)


# optim searches a much larger space, which can be a problem, but it finds a better
# minimum than 

res12 = nlminb(pars,ProfileErr,allpars=pars,times=t,data=data,coef=ncoefs,lik=lik,proc=proc,
	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP)


# Now lets see what happens for a finite-difference approximation

proc2more = make.findif.ode()
proc2more$more = list()
proc2more$more$fn = fhn.fun
proc2more$names = varnames
proc2more$parnames = parnames

proc2more$more$eps = 1e-6

proc2more$weights = qwts
proc2more$qpts = qpts

proc2 = make.SSEproc()
proc2$more = proc2more
proc2$bvals = list(bvals=eval.basis(procmore$qpts,bbasis,0),
		dbvals = eval.basis(procmore$qpts,bbasis,1))


res13 = Profile.GausNewt(pars,t,data,ncoefs,lik,proc2,in.meth='nlminb',control.in)

res14 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc2,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='nlminb',control.in=control.in),
	start = list(pars=spars),trace=TRUE)



# Now we'll only observe the first component

data2 = data
data2[,2] = NA

res15 = Profile.GausNewt(pars,t,data2,ncoefs,lik,proc,in.meth='nlminb',control.in)

res16 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc2,in.meth,control.in),
	data = list(times=t,data=data2,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='nlminb',control.in=control.in),
	start = list(pars=spars),trace=TRUE)



# Lets suppose that I've measured a linear combination

source('genlin.R')

lik2more = make.genlin()
lik2more$more = list()
lik2more$weights = weights[,1]

lik2more$more = list()
lik2more$more$mat = matrix(c(1,0),1,2)
lik2more$more$sub = matrix(0,0,3)

lik2 = lik;
lik2$more = lik2more;

data3 = as.matrix(data[,1],nrow(data),1)

res17 = Profile.GausNewt(pars,t,data3,ncoefs,lik2,proc,in.meth='house',control.in)

# Now lets add estimating a set of parameters in lik to the mix

lik3more = lik2more
lik3more$more$mat = matrix(0,1,2)
lik3more$more$sub = matrix(c(1,1,4,1,2,5),2,3,byrow=T)

lik3 = lik2
lik3$more = lik3more

proc2 = proc
proc2$more$parnames = c(proc$more$parnames,'l1','l2')

pars2 = c(pars,1,0)
names(pars2) = proc2$more$parnames

res18 = Profile.GausNewt(pars2,t,data3,ncoefs,lik3,proc2,in.meth='nlminb',control.in)


res19 = optim(pars2,ProfileErr,allpars=pars2,times=t,data=data3,ncoefs,lik=lik3,proc=proc2,
	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP,method="BFGS")


res20 = nlminb(pars2,ProfileErr,allpars=pars2,times=t,data=data3,coef=ncoefs,lik=lik3,proc=proc2,
	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP)

f = ProfileErr(res20$par,res20$par,t,data3,ncoefs,lik3,proc2,in.meth="nlminb",control.in=control.in)  
g = ProfileDP(res20$par,res20$par,t,data3,ncoefs,lik3,proc2,sum=FALSE)  

gg = apply(g,2,sum)

H = matrix(0,5,5)

for(i in 1:5){
	tpars = res20$par
	tpars[i] = tpars[i] + 1e-4

	tf = ProfileErr(tpars,tpars,t,data3,ncoefs,lik3,proc2,in.meth="nlminb",control.in=control.in)  
	tg = ProfileDP(tpars,tpars,t,data3,ncoefs,lik3,proc2,sum=TRUE)                            

	H[,i] = (tg-gg)*1e4
}

C20 = NeweyWest.Var(0.5*(H+t(H)),g,5)



res21 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data3,coefs=ncoefs,lik=lik3,proc=proc2,
	in.meth='nlminb',control.in=control.in),
	start = list(pars=pars2),trace=TRUE)

ff =  ProfileSSE(res20$par,t,data3,ncoefs,lik3,proc2,in.meth="nlminb",control.in) 


res22 = maxNR(ProfileErr,start=pars2,allpars=pars2,times=t,data=data3,coef=ncoefs,lik=lik3,proc=proc2,
	in.meth='nlminb',control.in=control.in,sgn=-1,grad=ProfileDP,print.level=2,iterlim=100)



# Now we'll set up some repeat experiments

x02 = c(1,-1)
names(x02)= c('V','R')
y2 = lsoda(x02,times=t,func=fhn.fun.ode,pars)
y2 = y2[,2:3]

data2 = y2 + matrix(rnorm(802),401,2)

replik = lik
replik$bvals = diag(rep(1,2))%x%lik$bvals
replik$more$weights = rbind(lik$more$weights,lik$more$weights)

repproc = proc
repproc$bvals = list(bvals = diag(rep(1,2))%x%proc$bvals$bvals,
  dbvals=diag(rep(1,2))%x%proc$bvals$dbvals)
repproc$more$weights = rbind(proc$more$weights,proc$more$weights)

reptimes = c(t,t+max(t))

repdata = rbind(data,data2)

coefs3 = solve( t(replik$bvals)%*%replik$bvals )%*%( t(replik$bvals)%*%repdata )

res23 = nlminb(coefs3,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
	control=control.out,times=reptimes,data=repdata,lik=replik,proc=repproc,pars=spars)


ncoefs = array(res23$par,dim(coefs3))

ProfileEnv = new.env()
assign('optcoef',ncoefs,3,ProfileEnv)
assign('curcoefs',ncoefs,3,ProfileEnv)

res24 = Profile.GausNewt(spars,reptimes,repdata,ncoefs,replik,repproc,in.meth="nlminb",control.in)
 


# Lets try this assuming we have functional data

fd.data2 = array(0,c(nrow(data2),2,2))

fd.data2[,2,] = data2
fd.data2[,1,] = data


DEfd2 = data2fd(fd.data2,t,bbasis,fdnames=list(NULL,NULL,c('V','R')) )

res = sse.setup(pars=pars,fd.obj=DEfd2,fn=make.fhn(),lambda=100,times=t)

res = smooth.sse(pars=pars,fd.obj=DEfd2,fn=make.fhn(),lambda=100,times=t,data=fd.data2,control.in=control.in)

res = profile.sse(fn=make.fhn(),data=fd.data2,times=t,pars=pars,fd.obj=DEfd2,,lambda=100,out.meth='nls',
	control.in=control.in,control.out=control.out)


# Alternatively, we can just do the sse setup thing

coefs2 = DEfd2$coefs


dimnames(coefs2) = list(NULL,NULL,c('V','R'))


res = sse.setup(pars=pars,coefs=coefs,fn=make.fhn(),basisvals=bbasis,lambda=100,times=t)

res = smooth.sse(make.fhn(),data,t,pars,coefs,bbasis,lambda=100,control.in=control.in)

res = profile.sse(make.fhn(),data,t,pars,coefs,bbasis,lambda=100,out.meth='nls',
	control.in=control.in,control.out=control.out)


# Alternative is simply to use the functional data object


res = sse.setup(pars=pars,fd.obj=DEfd,fn=make.fhn(),lambda=100,times=t)

res = smooth.sse(pars=pars,fd.obj=DEfd,fn=make.fhn(),lambda=100,times=t,data=fd.data,control.in=control.in)

res = profile.sse(fn=make.fhn(),data=fd.data,times=t,pars=pars,fd.obj=DEfd,,lambda=100,out.meth='nls',
	control.in=control.in,control.out=control.out)


# Start with the inner optimization, with various optimization methods

f = SplineCoefsErr(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)
g = SplineCoefsDC(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)
h = SplineCoefsDC2(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)
g2 = SplineCoefsDP(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)
h2 = SplineCoefsDCDP(coefs,times=t,data=data,lik=lik,proc=proc,pars=spars)


res = optim(coefs,SplineCoefsErr,gr=SplineCoefsDC,hessian=T,   		
		method="BFGS",control=control.out,
		times=t,data=data,lik=lik,proc=proc,pars=spars)

res0 = nlminb(coefs+2,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
	control=control.out,times=t,data=data,lik=lik,proc=proc,pars=spars)


res2 = maxNR(SplineCoefsErr,start=as.vector(coefs),times=t,data=data,lik=lik,proc=proc,pars=spars,sgn=-1,
	grad=SplineCoefsDC,hess=SplineCoefsDC2,print.level=2,iterlim=100)


res3 = SplineEst.NewtRaph(coefs,t,data,lik,proc,spars)


# record the coefficients for the sake of good starting values

ncoefs = array(res0$par,c(bbasis$nbasis,ncol(data)))

ProfileEnv = new.env()
assign('optcoef',ncoefs,3,ProfileEnv)
assign('curcoefs',ncoefs,3,ProfileEnv)

# Test outer objective criterion

f = ProfileErr(pars,pars,t,data,ncoefs,lik,proc,in.meth="nlminb",control.in=control.in)  
g = ProfileDP(pars,pars,t,data,ncoefs,lik,proc,sum=FALSE)                            


# There are specific criteria for SSE so that a Gauss-Newton iteration can be used

res4 = ProfileSSE(pars,t,data,ncoefs,lik,proc,in.meth="nlminb",control.in) 

# Gauss-Newton function coded in R. 

res5 = Profile.GausNewt(spars,t,data,ncoefs,lik,proc,in.meth="nlminb",control.in)
 
# the alternative standard function is NLS

res6 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth="nlminb",control.in=control.in),start = list(pars=pars),
	trace=TRUE)

# for which we can try a Newey-West type covariance estimate

g = res6$m$gradient()
df = diag(res6$m$resid())%*%g
C6 = NeweyWest.Var(t(g)%*%g, df[1:401,]+df[402:802,],5)


# Try using a simple second-derivative optimizer for the inner optimization:

res7 = Profile.GausNewt(spars,t,data,ncoefs,lik,proc,in.meth='house',control.in)

# nls with a number of alternative inner optimizations: self defined:
 
res8 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='house',control.in=control.in),
	start = list(pars=spars),trace=TRUE)

# nlminb:


res9 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='nlminb',control.in=control.in),
	start = list(pars=spars),trace=TRUE)

# maxNR:


res10 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='maxNR',control.in=control.in),
	start = list(pars=spars),trace=TRUE)



# When squared error is not being employed, things proceed somewhat more slowly
# However, this allows the smoothing criteria to fit into the pomp framework
# fairly readily. 


res11 = optim(pars,ProfileErr,allpars=pars,times=t,data=data,coef=ncoefs,lik=lik,proc=proc,hessian=T,
	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP,method="BFGS")

g = ProfileDP(res11$par,res11$par,t,data,ncoefs,lik,proc,sum=FALSE)  

gg = apply(g,2,sum)

H = 0*res11$hess

for(i in 1:length(pars)){
	tpars = res11$par
	tpars[i] = tpars[i] + 1e-4

	tf = ProfileErr(tpars,tpars,t,data,ncoefs,lik,proc,in.meth="nlminb",control.in=control.in)  
	tg = ProfileDP(tpars,tpars,t,data,ncoefs,lik,proc,sum=TRUE)                            

	H[,i] = (tg-gg)*1e4
}
	

C11 = NeweyWest.Var(H,g,5)


# optim searches a much larger space, which can be a problem, but it finds a better
# minimum than 

res12 = nlminb(pars,ProfileErr,allpars=pars,times=t,data=data,coef=ncoefs,lik=lik,proc=proc,
	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP)


# Now lets see what happens for a finite-difference approximation

proc2more = make.findif.ode()
proc2more$more = list()
proc2more$more$fn = fhn.fun
proc2more$names = varnames
proc2more$parnames = parnames

proc2more$more$eps = 1e-6

proc2more$weights = qwts
proc2more$qpts = qpts

proc2 = make.SSEproc()
proc2$more = proc2more
proc2$bvals = list(bvals=eval.basis(procmore$qpts,bbasis,0),
		dbvals = eval.basis(procmore$qpts,bbasis,1))


res13 = Profile.GausNewt(pars,t,data,ncoefs,lik,proc2,in.meth='nlminb',control.in)

res14 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc2,in.meth,control.in),
	data = list(times=t,data=data,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='nlminb',control.in=control.in),
	start = list(pars=spars),trace=TRUE)



# Now we'll only observe the first component

data2 = data
data2[,2] = NA

res15 = Profile.GausNewt(pars,t,data2,ncoefs,lik,proc,in.meth='nlminb',control.in)

res16 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc2,in.meth,control.in),
	data = list(times=t,data=data2,coefs=ncoefs,lik=lik,proc=proc,
	in.meth='nlminb',control.in=control.in),
	start = list(pars=spars),trace=TRUE)



# Lets suppose that I've measured a linear combination

source('genlin.R')

lik2more = make.genlin()
lik2more$more = list()
lik2more$weights = weights[,1]

lik2more$more = list()
lik2more$more$mat = matrix(c(1,0),1,2)
lik2more$more$sub = matrix(0,0,3)

lik2 = lik;
lik2$more = lik2more;

data3 = as.matrix(data[,1],nrow(data),1)

res17 = Profile.GausNewt(pars,t,data3,ncoefs,lik2,proc,in.meth='house',control.in)

# Now lets add estimating a set of parameters in lik to the mix

lik3more = lik2more
lik3more$more$mat = matrix(0,1,2)
lik3more$more$sub = matrix(c(1,1,4,1,2,5),2,3,byrow=T)

lik3 = lik2
lik3$more = lik3more

proc2 = proc
proc2$more$parnames = c(proc$more$parnames,'l1','l2')

pars2 = c(pars,1,0)
names(pars2) = proc2$more$parnames

res18 = Profile.GausNewt(pars2,t,data3,ncoefs,lik3,proc2,in.meth='nlminb',control.in)


res19 = optim(pars2,ProfileErr,allpars=pars2,times=t,data=data3,ncoefs,lik=lik3,proc=proc2,
	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP,method="BFGS")


res20 = nlminb(pars2,ProfileErr,allpars=pars2,times=t,data=data3,coef=ncoefs,lik=lik3,proc=proc2,
	in.meth='nlminb',control.in=control.in,control=control.out,gr=ProfileDP)

f = ProfileErr(res20$par,res20$par,t,data3,ncoefs,lik3,proc2,in.meth="nlminb",control.in=control.in)  
g = ProfileDP(res20$par,res20$par,t,data3,ncoefs,lik3,proc2,sum=FALSE)  

gg = apply(g,2,sum)

H = matrix(0,5,5)

for(i in 1:5){
	tpars = res20$par
	tpars[i] = tpars[i] + 1e-4

	tf = ProfileErr(tpars,tpars,t,data3,ncoefs,lik3,proc2,in.meth="nlminb",control.in=control.in)  
	tg = ProfileDP(tpars,tpars,t,data3,ncoefs,lik3,proc2,sum=TRUE)                            

	H[,i] = (tg-gg)*1e4
}

C20 = NeweyWest.Var(0.5*(H+t(H)),g,5)



res21 = nls(~ProfileSSE(pars,times,data,coefs,lik,proc,in.meth,control.in),
	data = list(times=t,data=data3,coefs=ncoefs,lik=lik3,proc=proc2,
	in.meth='nlminb',control.in=control.in),
	start = list(pars=pars2),trace=TRUE)

ff =  ProfileSSE(res20$par,t,data3,ncoefs,lik3,proc2,in.meth="nlminb",control.in) 


res22 = maxNR(ProfileErr,start=pars2,allpars=pars2,times=t,data=data3,coef=ncoefs,lik=lik3,proc=proc2,
	in.meth='nlminb',control.in=control.in,sgn=-1,grad=ProfileDP,print.level=2,iterlim=100)



# Now we'll set up some repeat experiments

x02 = c(1,-1)
names(x02)= c('V','R')
y2 = lsoda(x02,times=t,func=fhn.fun.ode,pars)
y2 = y2[,2:3]

data2 = y2 + matrix(rnorm(802),401,2)

replik = lik
replik$bvals = diag(rep(1,2))%x%lik$bvals
replik$more$weights = rbind(lik$more$weights,lik$more$weights)

repproc = proc
repproc$bvals = list(bvals = diag(rep(1,2))%x%proc$bvals$bvals,
  dbvals=diag(rep(1,2))%x%proc$bvals$dbvals)
repproc$more$weights = rbind(proc$more$weights,proc$more$weights)

reptimes = c(t,t+max(t))

repdata = rbind(data,data2)

coefs3 = solve( t(replik$bvals)%*%replik$bvals )%*%( t(replik$bvals)%*%repdata )

res23 = nlminb(coefs3,SplineCoefsErr,gradient=SplineCoefsDC,hessian=SplineCoefsDC2,
	control=control.out,times=reptimes,data=repdata,lik=replik,proc=repproc,pars=spars)


ncoefs = array(res23$par,dim(coefs3))

ProfileEnv = new.env()
assign('optcoef',ncoefs,3,ProfileEnv)
assign('curcoefs',ncoefs,3,ProfileEnv)

res24 = Profile.GausNewt(spars,reptimes,repdata,ncoefs,replik,repproc,in.meth="nlminb",control.in)
 


# Lets try this assuming we have functional data

fd.data2 = array(0,c(nrow(data2),2,2))

fd.data2[,2,] = data2
fd.data2[,1,] = data


DEfd2 = data2fd(fd.data2,t,bbasis,fdnames=list(NULL,NULL,c('V','R')) )

res = sse.setup(pars=pars,fd.obj=DEfd2,fn=make.fhn(),lambda=lambda,times=t)

res = smooth.sse(pars=pars,fd.obj=DEfd2,fn=make.fhn(),lambda=lambda,times=t,data=fd.data2,control.in=control.in,in.meth='house')

res = profile.sse(fn=make.fhn(),data=fd.data2,times=t,pars=pars,fd.obj=DEfd2,,lambda=lambda,out.meth='nls',
  control.in=control.in,control.out=control.out)


# Alternatively, we can just do the sse setup thing

coefs2 = DEfd2$coefs
dimnames(coefs2) = list(NULL,NULL,c('V','R'))


res = sse.setup(pars=pars,coefs=coefs2,fn=make.fhn(),basisvals=bbasis,lambda=10000,times=t)

res = smooth.sse(fn=make.fhn(),data=fd.data2,times=t,pars=pars,coefs=coefs2,basisvals=bbasis,
  lambda=10000,control.in=control.in)

res = profile.sse(fn=make.fhn(),data=fd.data2,times=t,pars=pars,coefs=coefs2,basisvals=bbasis,
  lambda=1e8,out.meth='nls',control.in=control.in,control.out=control.out,in.meth='house')

####### Squared Process Error ######################

#  this file contains functions for evaluating the total SRK2 for ODE
#  and its derivative values:

#    fn      = SRK2proc
#    dfdc    = dSRK2proc.dc
#    dfdp    = dSRK2proc.dp
#    d2fdc2  = d2SRK2proc.dc2
#    d2fdcdp = d2SRK2proc.dcdp

#  It uses function make.SRK2lik but substitutes derivative value
#  for data value and quadrature point values for time values

################################################################################

make.SRK2proc <- function()
{

    ##############################################################################

    SRK2proc <- function(coefs,bvals,pars,more)
    {
       names(pars) = more$parnames
       vals = SRK2fns()$SRK2common(coefs,bvals,pars,more)

       f = with(vals,{
         f = sum( w1*( (devals2-devals1) - diag(h/4)%*%fdevals1 - diag(h/2)%*%fdevals1a - diag(h/4)%*%fdevals1b)^2 ) +
            sum( w3*( (devals1a-devals1) - diag(2*h/3)%*%fdevals1)^2 )
       })

       return( f )

    }

    ##############################################################################


    dSRK2proc.dc <- function(coefs,bvals,pars,more)
    {
       names(pars) = more$parnames
       vals1 = SRK2fns()$SRK2bvals(bvals)
       vals2 = SRK2fns()$dSRK2dx(coefs,bvals,pars,more,return.diffs=TRUE)

       g = with(c(vals1,vals2),{
           g11 = array(0,c(nrow(diffs1),ncol(diffs1)))
           g21 = array(0,c(nrow(diffs1),ncol(diffs1)))
           g12 = array(0,c(nrow(diffs2),ncol(diffs2)))
           g22 = array(0,c(nrow(diffs2),ncol(diffs2)))
    
           for(i in 1:ncol(g11)){
              g11[,i] = apply(dfdx11[,,i]*diffs1,1,sum)
              g12[,i] = apply(dfdx12[,,i]*diffs1,1,sum)
              g21[,i] = apply(dfdx21[,,i]*diffs2,1,sum)
              g22[,i] = apply(dfdx22[,,i]*diffs2,1,sum)
           }
    
    
           g = 2*(t(bvals1)%*%(g11+g21)+t(bvals1a)%*%(g12+g22) + t(bvals2)%*%diffs1)
       })

       return(g)
    }



    ##############################################################################

    dSRK2proc.dp <- function(coefs,bvals,pars,more)
    {
      vals = SRK2fns()$dSRK2dp(coefs,bvals,pars,more,return.diffs=TRUE)

      g = with(vals,{
          g = matrix(0,dim(dfdpvals1)[1],dim(dfdpvals1)[3])
    
          for(i in 1:ncol(g)){
            g[,i] = apply(dfdp1[,,i]*diffs1,1,sum) + apply(dfdp2[,,i]*diffs2,1,sum)
          }
    
          g = 2*apply(g,2,sum)
      })

      return(g)
    }




    ##############################################################################

    d2SRK2proc.dc2 <- function(coefs,bvals,pars,more)
    {
       names(pars) = more$parnames
       vals1 = SRK2fns()$SRK2bvals(bvals)
       vals2 = SRK2fns()$d2SRK2dx2(coefs,bvals,pars,more)
  
       H = with(c(vals1,vals2),{  
          d2fdx212 = 0*d2fdx211
          d2fdx222 = 0*d2fdx211
       
        
           for(k in 1:ncol(diffs1)){
             for(i in 1:ncol(diffs1)){
              for(j in 1:ncol(diffs1)){
                  d2fdx111[,i,j,k] = d2fdx111[,i,j,k]*diffs1[,i] + w1*dfdx11[,i,j]*dfdx11[,i,k]
                  d2fdx122[,i,j,k] = d2fdx122[,i,j,k]*diffs1[,i] + w1*dfdx12[,i,j]*dfdx12[,i,k]
                  d2fdx112[,i,j,k] = d2fdx112[,i,j,k]*diffs1[,i] + w1*dfdx11[,i,j]*dfdx12[,i,k]
                  d2fdx211[,i,j,k] = d2fdx211[,i,j,k]*diffs2[,i] + w3*dfdx21[,i,j]*dfdx21[,i,k]
                  d2fdx212[,i,j,k] = w3*dfdx21[,i,j]*dfdx22[,i,k]
                  d2fdx222[,i,j,k] = w3*dfdx22[,i,j]*dfdx22[,i,k]
               }
             }
           }
    
           H = list(len=dim(bvals$bvals)[2])
            for(i in 1:dim(diffs1)[2]){
              H[[i]] = list(len=dim(diffs1)[2])
              for(j in 1:dim(diffs1)[2]){
                  H[[i]][[j]] = t(bvals1)%*%diag(as.vector(apply(d2fdx111[,,i,j]+d2fdx211[,,i,j],1,sum)))%*%bvals1 +
                       t(bvals1a)%*%diag(apply(d2fdx122[,,i,j]+d2fdx222[,,i,j],1,sum))%*%bvals1a +
                       t(bvals1)%*%diag(apply(d2fdx112[,,i,j]+d2fdx212[,,i,j],1,sum))%*%bvals1a +
                       t(bvals1a)%*%diag(apply(d2fdx112[,,j,i]+d2fdx212[,,j,i],1,sum))%*%bvals1 +
                       t(bvals2)%*%diag(w1*dfdx11[,i,j])%*%bvals1 +
                       t(bvals1)%*%diag(w1*dfdx11[,j,i])%*%bvals2 +
                       t(bvals2)%*%diag(w1*dfdx12[,i,j])%*%bvals1a +
                       t(bvals1a)%*%diag(w1*dfdx12[,j,i])%*%bvals2
              }
              H[[i]][[i]] = H[[i]][[i]] + t(bvals2)%*%diag(w1)%*%bvals2
            }

            H = 2*blocks2mat(H)
        })

        return(H)
    }

    ##############################################################################

    d2SRK2proc.dcdp <- function(coefs,bvals,pars,more)
    {
       names(pars) = more$parnames
       vals1 = SRK2fns()$SRK2bvals(bvals)
       vals2 = SRK2fns()$d2SRK2dxdp(coefs,bvals,pars,more)
      
       H = with(c(vals1,vals2),{

           for(k in 1:length(pars)){
             for(i in 1:ncol(diffs1)){
              for(j in 1:ncol(diffs1)){
                  d2fdx11[,i,j,k] = d2fdx11[,i,j,k]*diffs1[,i] + w1*dfdx11[,i,j]*dfdp1[,i,k]
                  d2fdx21[,i,j,k] = d2fdx21[,i,j,k]*diffs2[,i] + w3*dfdx21[,i,j]*dfdp2[,i,k]
                  d2fdx12[,i,j,k] = d2fdx12[,i,j,k]*diffs1[,i] + w1*dfdx12[,i,j]*dfdp1[,i,k]
                  d2fdx22[,i,j,k] = d2fdx22[,i,j,k]*diffs2[,i] + w3*dfdx22[,i,j]*dfdp2[,i,k]
              }
             }
           }
    
          H = c()
 
          for(i in 1:ncol(diffs1)){
              H = rbind(H,as.matrix(t(bvals1)%*%apply(d2fdx11[,,i,]+d2fdx21[,,i,],c(1,3),sum) +
                          t(bvals1a)%*%apply(d2fdx12[,,i,]+d2fdx22[,,i,],c(1,3),sum) +
                          t(bvals2)%*%diag(w1)%*%dfdp1[,i,]))
          }
      H})

      return(2*H)
    }

    ##############################################################################

    return(
        list(
            fn = SRK2proc,
            dfdc = dSRK2proc.dc,
            dfdp = dSRK2proc.dp,
            d2fdc2 = d2SRK2proc.dc2,
            d2fdcdp = d2SRK2proc.dcdp
       )
    )
}


########################################################

SRK2fns = function()
{
    SRK2bvals = function(bvals){
       if(is.null(bvals$I)){ bvals$I = SRK2fns()$SRKindeces(nrow(bvals$bvals)) }

       bvals1 = bvals$bvals[bvals$I[,1],]
       bvals2 = bvals$bvals[bvals$I[,2],]
       bvals1a = bvals$bvals[bvals$I[,3],]

       return(list(bvals1 = bvals1,
                   bvals2 = bvals2,
                   bvals1a = bvals1a)
             )

    }

    #####################################

    SRK2indeces = function(m)
    {
      if( m%%2 == 0){ error('Number of quadrature points must be odd.') }
      I = cbind( seq(1,m-2,2),seq(1,m-2,2)+2, seq(1,m-2,2)+1)
      return(I)
    }

    #####################################

    SRK2common = function(coefs,bvals,pars,more){
       devals = as.matrix(bvals$bvals%*%coefs)  
       colnames(devals) = more$names
       if(is.null(bvals$I)){ bvals$I = SRK2indeces(nrow(devals)) }
       
        h = more$qpts[bvals$I[,2]] - more$qpts[bvals$I[,1]]

       q1 = more$qpts[bvals$I[,1]]
       q2 = more$qpts[bvals$I[,2]]
       q3 = more$qpts[bvals$I[,3]]

       devals1 = devals[bvals$I[,1],]
       devals2 = devals[bvals$I[,2],]
       devals1a = devals[bvals$I[,3],]

       fdevals1 = more$fn(q1,devals1,pars,more$more)
       fdevals1a = more$fn(q3,devals1a,pars,more$more)

       devals1b = devals1 - diag(h/3)%*%fdevals1 + diag(h)%*%fdevals1a    #  -devals1 + devals1a
       
       fdevals1b = more$fn(q3,devals1b,pars,more$more)

       w1 = more$weights[bvals$I[,1]]
       w3 = more$weights[bvals$I[,3]]
       
       diffs1 = diag(w1)%*%( (devals2-devals1) - diag(h/4)%*%fdevals1 - diag(h/2)%*%fdevals1a - diag(h/4)%*%fdevals1b)
       diffs2 = diag(w3)%*%( (devals1a-devals1) - diag(2*h/3)%*%fdevals1)       

       return(list(devals1 = devals1,
                   devals2 = devals2,
                   devals1a = devals1a,
                   devals1b = devals1b,
                   fdevals1 = fdevals1,
                   fdevals1a = fdevals1a,
                   devals1b = devals1b,
                   fdevals1b = fdevals1b,
                   diffs1 = diffs1,
                   diffs2 = diffs2,
                   h = h,
                   w1 = w1,
                   w3 = w3,
                   q1 = q1,
                   q2 = q2,
                   q3 = q3)
             )
    }

    #####################################

    dSRK2dx = function(coefs,bvals,pars,more,return.diffs=FALSE)
    {
       names(pars) = more$parnames
       vals = SRK2fns()$SRK2common(coefs,bvals,pars,more)
 #      attach(vals)

       return.list = with(vals,{
           dfdxvals1 = more$dfdx(q1,devals1,pars,more$more)
           dfdxvals1a = more$dfdx(q3,devals1a,pars,more$more)
           dfdxvals1b = more$dfdx(q3,devals1b,pars,more$more)
    
           dfdx11 = 0*dfdxvals1
           dfdx12 = 0*dfdxvals1
           dfdx21 = 0*dfdxvals1
           dfdx22 = 0*dfdxvals1
            
           for(i in 1:dim(dfdx11)[2]){
    
            for(j in 1:dim(dfdx11)[3]){
              dfdx11[,i,j] =  - h/4*dfdxvals1[,i,j] + h^2/12*apply(dfdxvals1b[,i,]*dfdxvals1[,,j],1,sum) - 
                  h/4*dfdxvals1b[,i,j]
                  
              dfdx21[,i,j] =  - 2*h/3*dfdxvals1[,i,j]
    
              dfdx12[,i,j] = - h/2*dfdxvals1a[,i,j] - h^2/4*apply(dfdxvals1b[,i,]*dfdxvals1a[,,j],1,sum)
              }
    
              dfdx11[,i,i] = dfdx11[,i,i] - 1
              dfdx21[,i,i] = dfdx21[,i,i] - 1
              dfdx22[,i,i] = 1
           }
    
          if(return.diffs){
            return.list = list(dfdx11=dfdx11,dfdx12=dfdx12,dfdx21=dfdx21,dfdx22=dfdx22,
                        dfdxvals1=dfdxvals1,dfdxvals1a=dfdxvals1a,dfdxvals1b=dfdxvals1b,
                        diffs1=diffs1,diffs2=diffs2)
          }
          else{
            return.list = list(dfdx11=dfdx11,dfdx12=dfdx12,dfdx21=dfdx21,dfdx22=dfdx22,
                        dfdxvals1=dfdxvals1,dfdxvals1a=dfdxvals1a,dfdxvals1b=dfdxvals1b)
          }
      return.list})
      
      return(return.list)
    }

    #####################################

    dSRK2dp = function(coefs,bvals,pars,more,return.diffs=FALSE)
    {
       names(pars) = more$parnames
       vals = SRK2fns()$SRK2common(coefs,bvals,pars,more)
      
       return.list=with(vals,{
           fdevals1b = more$fn(q3,devals1b,pars,more$more)
    
           dfdpvals1 = more$dfdp(q1,devals1,pars,more$more)
           dfdpvals1a = more$dfdp(q3,devals1a,pars,more$more)
           dfdpvals1b = more$dfdp(q3,devals1b,pars,more$more)
    
           dfdxvals1b = more$dfdx(q3,devals1b,pars,more$more)
    
           dfdp1 = 0*dfdpvals1
           dfdp2 = 0*dfdpvals1
    
           for(i in 1:dim(dfdpvals1)[2]){
            for(j in 1:dim(dfdpvals1)[3]){
              dfdp1[,i,j] = -h/4*dfdpvals1[,i,j]-h/2*dfdpvals1a[,i,j] - h/4*dfdpvals1b[,i,j] -
                h^2/4*apply(dfdxvals1b[,i,]*(dfdpvals1a[,,j]-dfdpvals1[,,j]/3),1,sum)
              dfdp2[,i,j] = -2*h/3*dfdpvals1[,i,j]
             }
           }
           
           
           
          if(return.diffs){
            return.list = list(dfdp1=dfdp1,dfdp2=dfdp2,
              dfdpvals1=dfdpvals1,dfdpvals1a=dfdpvals1a,dfdpvals1b=dfdpvals1b,
                        diffs1=diffs1,diffs2=diffs2)
          }
          else{
            return.list = list(dfdp1=dfdp1,dfdp2=dfdp2,
              dfdpvals1=dfdpvals1,dfdpvals1a=dfdpvals1a,dfdpvals1b=dfdpvals1b)
          }
          
      return.list})

      return(return.list)
      
    }

    #####################################
    
    d2SRK2dxdp = function(coefs,bvals,pars,more)
    {  
      names(pars) = more$parnames
      vals1 = SRK2fns()$SRK2common(coefs,bvals,pars,more)
      vals2 = SRK2fns()$dSRK2dx(coefs,bvals,pars,more,return.diffs=FALSE)
      vals3 = SRK2fns()$dSRK2dp(coefs,bvals,pars,more)
      
      return.list = with(c(vals1,vals2,vals3),{    
    
           d2fdxdpvals1 = more$d2fdxdp(q1,devals1,pars,more)
           d2fdxdpvals1a = more$d2fdxdp(q3,devals1a,pars,more)
           d2fdxdpvals1b = more$d2fdxdp(q3,devals1b,pars,more)
    
           d2fdx2vals1b =  more$d2fdx2(q3,devals1b,pars,more)
    
           d2fdx11 = 0*d2fdxdpvals1;
           d2fdx21 = 0*d2fdxdpvals1;
           d2fdx12 = 0*d2fdxdpvals1a;
           d2fdx22 = 0*d2fdxdpvals1a;
    
           for(k in 1:length(pars)){
             for(i in 1:ncol(devals1)){
               for(j in 1:ncol(devals1)){
                 d2fdx11[,i,j,k] = -h/4*d2fdxdpvals1[,i,j,k] + h^2/12*apply(d2fdxdpvals1b[,i,,k]*dfdxvals1[,,j],1,sum) +
                             h^2/12*apply(dfdxvals1b[,i,]*d2fdxdpvals1[,,j,k],1,sum) - h/4*d2fdxdpvals1b[,i,j,k] -
                             h^2/4*apply(d2fdx2vals1b[,i,,j]*(dfdpvals1a[,,k] - dfdpvals1[,,k]/3),1,sum)
    
                 d2fdx21[,i,j,k] = -2*h/3*d2fdxdpvals1[,i,j,k]
    
                 d2fdx12[,i,j,k] = -h/2*d2fdxdpvals1a[,i,j,k] - h^2/4*apply(d2fdxdpvals1b[,i,,k]*dfdxvals1a[,,j],1,sum) -
                             h^2/4*apply(dfdxvals1b[,i,]*d2fdxdpvals1a[,,j,k],1,sum)
    
                 for(l in 1:ncol(devals1)){
                    d2fdx11[,i,j,k] = d2fdx11[,i,j,k] + 
                      h^3/12*apply(d2fdx2vals1b[,i,l,]*(dfdpvals1a[,,k] - dfdpvals1[,,k]/3),1,sum)*dfdxvals1[,l,j]
                    d2fdx12[,i,j,k] = d2fdx12[,i,j,k] - 
                      h^3/4*apply(d2fdx2vals1b[,i,l,]*(dfdpvals1a[,,k] - dfdpvals1[,,k]/3),1,sum)*dfdxvals1a[,l,j]
                 }
               }
    
             }
           }
           
           return.list=list(d2fdx11 = d2fdx11,
                            d2fdx12 = d2fdx12,
                            d2fdx21 = d2fdx21,
                            d2fdx22 = d2fdx22,
                            dfdx11 = dfdx11,
                            dfdx12 = dfdx12,
                            dfdx21 = dfdx21,
                            dfdx22 = dfdx22,
                            dfdp1 = dfdp1,
                            dfdp2 = dfdp2,
                            diffs1 = diffs1,
                            diffs2 = diffs2,
                            w1 = w1,
                            w3 = w3)
      return.list})
                            
      return(return.list)     
           
    }    

    #####################################
    
    d2SRK2dx2 = function(coefs,bvals,pars,more)
    {
      names(pars) = more$parnames
      vals1 = SRK2fns()$SRK2common(coefs,bvals,pars,more)
      vals2 = SRK2fns()$dSRK2dx(coefs,bvals,pars,more,return.diffs=FALSE) 
       
      return.list = with(c(vals1,vals2),{        
           d2fdx2vals1 =  more$d2fdx2(q3,devals1,pars,more)
           d2fdx2vals1a =  more$d2fdx2(q3,devals1a,pars,more)
           d2fdx2vals1b =  more$d2fdx2(q3,devals1b,pars,more)
       
           d2fdx111 = array(0,c(nrow(devals1),ncol(devals1),ncol(devals1),ncol(devals1)))
           d2fdx112 = array(0,c(nrow(devals1),ncol(devals1),ncol(devals1),ncol(devals1)))
           d2fdx122 = array(0,c(nrow(devals1),ncol(devals1),ncol(devals1),ncol(devals1)))
    
           d2fdx211 = array(0,c(nrow(devals1),ncol(devals1),ncol(devals1),ncol(devals1)))
    
    
           for(i in 1:ncol(devals1)){
            for(j in 1:ncol(devals1)){
              for(k in 1:ncol(devals1)){
                d2fdx111[,i,j,k] = -h/4*d2fdx2vals1[,i,j,k] + h^2/12*apply(dfdxvals1b[,i,]*d2fdx2vals1[,,j,k],1,sum) +
                    h^2/12*(apply(d2fdx2vals1b[,i,,k]*dfdxvals1[,,j],1,sum) + apply(d2fdx2vals1b[,i,j,]*dfdxvals1[,,k],1,sum))-
                    h/4*d2fdx2vals1b[,i,j,k]
                d2fdx211[,i,j,k] = -2*h/3*d2fdx2vals1[,i,j,k]
                
                d2fdx122[,i,j,k] = -h/2*d2fdx2vals1a[,i,j,k] - h^2/4*apply(dfdxvals1b[,i,]*d2fdx2vals1a[,,j,k],1,sum)
    
                d2fdx112[,i,j,k] = - h^2/4*apply(d2fdx2vals1b[,i,j,]*dfdxvals1a[,,k],1,sum)
    
                for(l in 1:ncol(devals1)){
                  d2fdx111[,i,j,k] = d2fdx111[,i,j,k] - h^3/36*apply(d2fdx2vals1b[,i,,l]*dfdxvals1[,,j],1,sum)*dfdxvals1[,l,k]
                  d2fdx122[,i,j,k] = d2fdx122[,i,j,k] - h^3/4*apply(d2fdx2vals1b[,i,,l]*dfdxvals1a[,,j],1,sum)*dfdxvals1a[,l,k]
                  d2fdx112[,i,j,k] = d2fdx112[,i,j,k] + h^3/12*apply(d2fdx2vals1b[,i,,l]*dfdxvals1[,,j],1,sum)*dfdxvals1a[,l,k]
                }
              }
            }
          }    
           return.list=list(d2fdx111 = d2fdx111,
                            d2fdx112 = d2fdx112,
                            d2fdx122 = d2fdx122,
                            d2fdx211 = d2fdx211,
                            dfdx11 = dfdx11,
                            dfdx12 = dfdx12,
                            dfdx21 = dfdx21,
                            dfdx22 = dfdx22,
                            diffs1 = diffs1,
                            diffs2 = diffs2,
                            w1 = w1,
                            w3 = w3)    
    
      return.list})
      
      return(return.list)
    
    }
    
    return(list(SRK2bvals=SRK2bvals,
                SRK2common=SRK2common,
                SRK2indeces=SRK2indeces,
                dSRK2dx=dSRK2dx,
                dSRK2dp=dSRK2dp,
                d2SRK2dx2=d2SRK2dx2,
                d2SRK2dxdp=d2SRK2dxdp
                )
    )
}

## Assume that FhNEx.R demo has already been run (at least lines 1 through 31
## and 73 through 76

srkproc = make.SRK2proc()

srktimes = seq(0,20,len=81)
#srktimes = seq(0,20,len=801)
#coefs = eval.fd(srktimes, DEfd)
#coefs = DEfd$coefs
more = proc$more
bvals = list(bvals=diag(rep(1,81)),I=SRK2fns()$SRK2indeces(81))
#bvals = list(bvals=diag(rep(1,801)),I=SRK2fns()$SRK2indeces(801))
#bvals = list(bvals=cbind( rbind(diag(40)%x%matrix(c(1,0),2,1),rep(0,40)), c(rep(0,80),1),c(rep(0,80),1)),I=SRK2fns()$SRK2indeces(81))
coefs=matrix(0,81,2)
#coefs=matrix(0,801,2)
coefs[c(bvals$I[,1], length(srktimes)),]=FhNdata
#coefs[c(bvals$I[,1], length(srktimes)),]=data
coefs[bvals$I[,3],]=(FhNdata[1:40,]+FhNdata[2:41,])/2
#coefs[bvals$I[,3],]=(data[1:400,]+data[2:401,])/2


more$weights = matrix(8/3,81,2)
#more$weights = matrix(8/3,801,2)
more$qpts = srktimes

srkproc$bvals = bvals
srkproc$more = more


srklik = lik
srklik$bvals = t(cbind(rbind(diag(40)%x%matrix(c(1,0),2,1),rep(0,40)),c(rep(0,80),1)))
#srklik$bvals = t(cbind(rbind(diag(400)%x%matrix(c(1,0),2,1),rep(0,400)),c(rep(0,800),1)))
#srklik$bvals =  cbind(diag(41),rep(0,41))

# Now try some optimization

pres = ParsMatchOpt(FhNpars,coefs,srkproc)
npars = pres$pars

# Smoothing can be done more specifically with 'inneropt'

Ires2 = inneropt(FhNdata,times=FhNtimes,FhNpars,coefs,srklik,srkproc)
#Ires2 = inneropt(data,times=seq(0,20,len=401),FhNpars,coefs,srklik,srkproc)
# And we can also do profiling

Ores2 = outeropt(FhNdata,FhNtimes,npars,coefs,srklik,srkproc)









### The rest of this is just finite-differencing checks on my derivatives

f = make.SRK2proc()$fn(coefs,bvals,pars,more)
gp = make.SRK2proc()$dfdp(coefs,bvals,pars,more)
gc = make.SRK2proc()$dfdc(coefs,bvals,pars,more)

Hcc = make.SRK2proc()$d2fdc2(coefs,bvals,pars,more)
Hcp = make.SRK2proc()$d2fdcdp(coefs,bvals,pars,more)

dfdplist = SRK2fns()$dSRK2dp(coefs,bvals,pars,more,return.diffs=TRUE)

d2fdxdplist = SRK2fns()$d2SRK2dxdp(coefs,bvals,pars,more)


ed2fdxdp11 = 0*d2fdxdplist$d2fdx11
ed2fdxdp12 = 0*d2fdxdplist$d2fdx12 
ed2fdxdp21 = 0*d2fdxdplist$d2fdx21
ed2fdxdp22 = 0*d2fdxdplist$d2fdx22 
for(i in 1:ncol(coefs)){
  for(j in 1:ncol(coefs)){
    for(k in 1:length(pars)){
     ed2fdxdp11[,,i,j] = d2fdxdplist$dfdx11[,i,j]*d2fdxdplist$dfdp1[,i,k] 
     ed2fdxdp12[,,i,j] = d2fdxdplist$dfdx12[,i,j]*d2fdxdplist$dfdp1[,i,k]
     ed2fdxdp21[,,i,j] = d2fdxdplist$dfdx21[,i,j]*d2fdxdplist$dfdp2[,i,k]
     ed2fdxdp22[,,i,j] = d2fdxdplist$dfdx22[,i,j]*d2fdxdplist$dfdp2[,i,k]
    }
  }
}


eps = 1e-6

agp = 0*gp
aHcp = 0*Hcp

adfdp1 = 0*dfdplist$dfdp1
adfdp2 = 0*dfdplist$dfdp2 

ad2fdxdp11 = 0*d2fdxdplist$d2fdx11
ad2fdxdp12 = 0*d2fdxdplist$d2fdx12 
ad2fdxdp21 = 0*d2fdxdplist$d2fdx21
ad2fdxdp22 = 0*d2fdxdplist$d2fdx22 

for(i in 1:length(pars)){
  tpars = pars
  tpars[i] = pars[i] + eps

  tf =  make.SRK2proc()$fn(coefs,bvals,tpars,more)
  tgc = make.SRK2proc()$dfdc(coefs,bvals,tpars,more)
  
  trl =  SRK2fns()$dSRK2dp(coefs,bvals,tpars,more,return.diffs=TRUE)
  
  adfdp1[,,i] = (trl$diffs1-dfdplist$diffs1)/eps
  adfdp2[,,i] = (trl$diffs2-dfdplist$diffs2)/eps

  trl2 = SRK2fns()$dSRK2dx(coefs,bvals,tpars,more,return.diffs=FALSE)

  ad2fdxdp11[,,,i] = (trl2$dfdx11-d2fdxdplist$dfdx11)/eps
  ad2fdxdp12[,,,i] = (trl2$dfdx12-d2fdxdplist$dfdx12)/eps
  ad2fdxdp21[,,,i] = (trl2$dfdx21-d2fdxdplist$dfdx21)/eps
  ad2fdxdp22[,,,i] = (trl2$dfdx22-d2fdxdplist$dfdx22)/eps

  agp[i] = (tf-f)/eps
  aHcp[,i] = (tgc-gc)/eps
}



agc = 0*gc
aHcc = 0*Hcc
aHcp2 = 0*Hcp

for(i in 1:length(coefs)){
  tcoefs = coefs
  tcoefs[i] = coefs[i] + eps

  tf =  make.SRK2proc()$fn(tcoefs,bvals,pars,more)
  tgc = make.SRK2proc()$dfdc(tcoefs,bvals,pars,more)
  tgp = make.SRK2proc()$dfdp(tcoefs,bvals,pars,more)

  agc[i] = (tf-f)/eps
  aHcc[,i] = (tgc-gc)/eps
  aHcp2[i,] = (tgp-gp)/eps
}



dfdxlist = SRK2fns()$dSRK2dx(coefs,bvals,pars,more,return.diffs=TRUE)
d2fdx2list = SRK2fns()$d2SRK2dx2(coefs,bvals,pars,more)


adfdx11 = 0*dfdxlist$dfdx11
adfdx12 = 0*dfdxlist$dfdx12
adfdx21 = 0*dfdxlist$dfdx21
adfdx22 = 0*dfdxlist$dfdx22

ad2fdx111 = 0*d2fdx2list$d2fdx111
ad2fdx122 = 0*d2fdx2list$d2fdx122
ad2fdx112 = 0*d2fdx2list$d2fdx112
ad2fdx211 = 0*d2fdx2list$d2fdx211

for(i in 1:ncol(coefs)){
    tcoefs1 = coefs
    tcoefs1[bvals$I[,1],i] = tcoefs1[bvals$I[,1],i] + eps
    tcoefs2 = coefs
    tcoefs2[bvals$I[,3],i] = tcoefs2[bvals$I[,3],i] + eps

    trl1 =  SRK2fns()$dSRK2dx(tcoefs1,bvals,pars,more,return.diffs=TRUE)
    trl2 =  SRK2fns()$dSRK2dx(tcoefs2,bvals,pars,more,return.diffs=TRUE)
    
    adfdx11[,,i] = (trl1$diffs1-dfdxlist$diffs1)/eps
    adfdx21[,,i] = (trl1$diffs2-dfdxlist$diffs2)/eps

    adfdx12[,,i] = (trl2$diffs1-dfdxlist$diffs1)/eps
    adfdx22[,,i] = (trl2$diffs2-dfdxlist$diffs2)/eps
    
    ad2fdx111[,,,i] = (trl1$dfdx11-d2fdx2list$dfdx11)/eps
    ad2fdx122[,,,i] = (trl2$dfdx12-d2fdx2list$dfdx12)/eps
    ad2fdx112[,,,i] = (trl2$dfdx11-d2fdx2list$dfdx11)/eps
    ad2fdx211[,,,i] = (trl1$dfdx21-d2fdx2list$dfdx21)/eps
}

FhNtimes = seq(0,1000,25)
FhNpars =  c(0.7,0.8,0.008)
names(FhNpars) = c('a','b','c')

knots = seq(0,1000,2)
norder = 3
nbasis = length(knots) + norder - 2

bbasis = create.bspline.basis(range=range(FhNtimes),nbasis=nbasis,
	norder=norder,breaks=knots)
	
coefs = matrix(0,bbasis$nbasis,2)
colnames(coefs) = c('V','R')

profile.obj = LS.setup(pars=FhNpars,coefs=coefs,fn=make.fhn.input()$fn,basisvals=bbasis,lambda=1e8,times=FhNtimes,
                  more = list(infn=function(t){return(0.2*(t>500))}))
lik = profile.obj$lik
proc= profile.obj$proc

# Let's start off with a smooth

FhNdata = DE2x(c(-1,1),FhNtimes,FhNpars,proc)
matplot(FhNtimes,FhNdata,type='b')

fd.obj = smooth.basis(FhNtimes,FhNdata,fdPar(bbasis,1,0.01))
plotfit.fd(FhNdata,FhNtimes,fd.obj$fd)

coefs = fd.obj$fd$coefs

# Now we can look at doing the inner optimization

resI = inneropt(FhNdata,FhNtimes,FhNpars,coefs,lik,proc,in.meth="SplineEst")

traj = proc$bvals$bvals%*%resI$coefs
matplot(proc$more$qpts,traj,type='l')
matplot(FhNtimes,FhNdata,add=TRUE)

# And the outer optimization

resO =  outeropt(FhNdata,FhNtimes,FhNpars,coefs,lik,proc)

traj = proc$bvals$bvals%*%resO$coefs
matplot(proc$more$qpts,traj,type='l')
matplot(FhNtimes,FhNdata,add=TRUE)

dtraj = proc$bvals$dbvals%*%resO$coefs
ftraj = proc$more$fn(proc$more$qpts,traj,FhNpars,proc$more$more)

matplot(proc$more$qpts,dtraj,type='l',lty=1)
matplot(proc$more$qpts,ftraj,type='l',lty=2,add=TRUE)

#### Henon map examples
#
# This example demonstrates the use of CollocInfer on a discrete-time system.
# The Henon Map is a classical dynamical system that exhibits chaos.
# It's equations are given as
#
# x[t+1] = 1 - a*x[t]^2 + y[t]
# y[t+1] = b*x[t]

# To ensure reproducibility
set.seed((2004*2007)/2014)

###############################
####   Data Generation  #######
###############################
hpars = c(1.4,0.3)

ntimes = 200

x = c(-1,1)
X = matrix(0,ntimes+20,2)
X[1,] = x

for(i in 2:(ntimes+20)){ X[i,] = make.Henon()$ode(i,X[i-1,],hpars,NULL) }

X = X[20+1:ntimes,]

par(mar=c(5,5,1,1))
plot(X,xlab='x',ylab='y',cex.lab=2.5,cex.axis=2.5,cex=1.5)


Y = X + 0.05*matrix(rnorm(ntimes*2),ntimes,2)

t = 1:ntimes

coefs = as.matrix(Y)

###############################
####  Optimization Control  ###
###############################
control=list(trace = 0,maxit = 1000,maxtry = 10,reltol = 1e-6,meth = "BFGS")

control.in = control
control.in$reltol = 1e-12

control.out = control
control.out$trace = 2

###############################
####     Optimization       ###
###############################

hpars2 = c(1.3,0.4)          # Perturbed parameters
names(hpars2)=names(hpars)
lambda = 10000

### SSE for discrete process####

Ires1	= Smooth.LS(make.Henon(),data=Y,times=t,pars=hpars2,coefs=coefs,basisvals=NULL,
  lambda=lambda,in.meth='nlminb',control.in=control.in,discrete=TRUE)
  
Ores1 = Profile.LS(make.Henon(),data=Y,t,pars=hpars2,coefs,basisvals=NULL,
  lambda=lambda,in.meth='nlminb',out.meth='nls',control.in=control.in,
  control.out=control.out,discrete=TRUE)

# Add some plots
   
parest = Ores1$pars
  
Fit = Ores1$coef

X11()  
par(mfrow=c(2,1),mar=c(5,5,1,1))
plot(t,Fit[,1],type='l',ylab='x',xlab='time',lty=2,cex.lab=2.5,cex.axis=2.5,lwd=3)
points(t,Y[,1],col=2,pch=8,cex=1.5)
plot(t,Fit[,2],type='l',lty=2,ylab='y',xlab='time',cex.lab=2.5,cex.axis=2.5,lwd=3)
points(t,Y[,2],col=2,cex=1.5,pch=8)

# Also compare prediction and new estimate -- equivalent of derivative plots

pred = Ores1$proc$more$fn(t,Fit,Ores1$pars,Ores1$proc$more$more)

X11()
par(mfrow=c(2,1),mar=c(5,5,1,1))
plot(t,pred[,1],type='l',ylab='x',xlab='time',cex.lab=2.5,cex.axis=2.5,lwd=3)
points(t[-ntimes],Fit[-1,1],col=2,type='l',cex=1.5,pch=8)
plot(t,pred[,2],type='l',ylab='y',xlab='time',cex.lab=2.5,cex.axis=2.5,lwd=3)
points(t[-ntimes],Fit[-1,2],col=2,type='l',cex=1.5,pch=8)

# and look at the deviation

X11()
par(mar=c(5,5,1,1))
matplot(t[-ntimes],Fit[-1,]-pred[-ntimes,],xlab='time',ylab='Model Residuals',cex.lab=2.5,cex.axis=2.5,pch=c('x','y'),cex=1.5)


### ProfileErr with LSproc ####

profile.obj = LS.setup(pars=hpars2,coefs=coefs,fn=make.Henon(),basisvals=NULL,
  lambda=lambda,times=t,discrete=TRUE)
lik = profile.obj$lik
proc= profile.obj$proc
   
Ires2 = inneropt(data=Y,times=t,pars=hpars2,coefs,lik,proc,in.meth='nlminb',control.in)

Ores2 = outeropt(data=Y,times=t,pars=hpars2,coefs=coefs,lik=lik,proc=proc,
  in.meth="nlminb",out.meth="nlminb",control.in=control.in,control.out=control.out)

    
### Dproc with the multinorm functions

var = c(1,0.01)

Ires3 = Smooth.multinorm(make.Henon(),data=Y,t,pars=hpars2,coefs,basisvals=NULL,
  var=var,in.meth='nlminb',control.in=control.in,discrete=TRUE)

Ores3 = Profile.multinorm(fn=make.Henon(),data=Y,times=t,pars=hpars2,coefs=coefs,
  basisvals=NULL,var=var,fd.obj=NULL,more=NULL,quadrature=NULL,in.meth='nlminb',
  out.meth='optim',control.in=control.in,control.out=control.out,eps=1e-6,
  active=NULL,,discrete=TRUE)

Ores3$pars

make.genlin <- function()
{
genlin<-list()
genlin$fun.ode <- function(t,y,p,more)
{
    n = ncol(y)

    more = checkmore.genlin(more,n)

    pmat = more$mat

    pmat[more$sub[,1:2,drop=F]] = pmat[more$sub[,1:2,drop=F],drop=F] + p[more$sub[,3,drop=F]]

    r = pmat%*%y

    if(!is$null(more$force)){

        fs = matrix(0,length(t),length(more$force))

        for(i in 1:length(more$force)){
            if(is.fd(more$force[[i]])){
                fs[,i] = eval.fd(t,more$force[[i]])
            }
            else{
                fs[,i] = more$force[[i]](t,more$force.input)
            }
        }

        b = more$force.mat;
        b[more$force.sub[,1:2,drop=F]] = p[more$forc.sub[,3,drop=F]];

        r = r + b%*%t(fs);
    }
    return(r)
}






genlin$fn <- function(t,y,p,more)   # We get z = Ax for pmat = A
{

    n = ncol(y)

    more = checkmore.genlin(more,n)
    pmat = more$mat


    pmat[more$sub[,1:2,drop=F]] = pmat[more$sub[,1:2,drop=F],drop=F] + p[more$sub[,3,drop=F]]

    r1 = y%*%t(pmat)


    if( !is.null(more$force) ){
    
        fs = matrix(0,length(t),length(more$force))
        
        for(i in 1:length(more$force)){
            if(is.fd(more$force[[i]])){
                fs[,i] = eval.fd(t,more$force[[i]])
            }
            else{
                fs[,i] = more$force[[i]](t,more$force_input)
            }
        }

        b = more$force.mat
        b[more$force.sub[,1:2,drop=F]] = p[more$force.sub[,3,drop=F]]

        r1 = r1 + fs%*%t(b)
    }
    return(r1)
}






genlin$dfdx <- function(t,y,p,more)
{
    n = ncol(y)

    more = checkmore.genlin(more,n)
    pmat = more$mat
    pmat[more$sub[,1:2,drop=F]] = pmat[more$sub[,1:2,drop=F],drop=F] + p[more$sub[,3,drop=F]];

    r = array(0,c(dim(y)[1],nrow(pmat),n))

    for(i in 1:nrow(pmat)){
        for(j in 1:n){
            r[,i,j] = pmat[i,j]
        }
    }
    return(r)
}







genlin$dfdp <- function(t,y,p,more)
{
    n = ncol(y)

    more = checkmore.genlin(more,n)


    r = array(0,c(dim(y)[1],nrow(more$mat),length(p)))

    if(nrow(more$sub)>0){
        for(i in 1:nrow(more$sub)){
            r[,more$sub[i,1],more$sub[i,3]] = y[,more$sub[i,2]]
        }
    }

    if(!is.null(more$force)){
    

        fs = matrix(0,length(t),length(more$force))

        for(i in 1:length(more$force)){
            if(is.fd(more$forc[[i]])){
                fs[,i] = eval.fd(t,more$force[[i]])
            }
            else{
                fs[,i] = more$force[[i]](t,more$force.input)
            }
        }

        for(i in 1:nrow(more$force.sub)){
           r[,more$force.sub[i,1],more$force.sub[i,3]] =  r[,more$force.sub[i,1],more$force.sub[i,3]] +
               fs[,more$force.sub[i,2]]
        }
    }
    return(r)
}







genlin$d2fdxdp <- function(t,y,p,more)
{
    n = ncol(y)

    more = checkmore.genlin(more,n)

    r = array(0,c(dim(y)[1],nrow(more$mat),n,length(p)))

    if(nrow(more$sub)>0){
        for(i in 1:nrow(more$sub)){
            r[,more$sub[i,1],more$sub[i,2],more$sub[i,3]] = 1
        }
    }
    return(r)
}

genlin$d2fdx2 <- function(t,y,p,more)
{
    more = checkmore.genlin(more,n)
    n = ncol(y)
    r = array(0,c(dim(y)[1],nrow(more$mat), n, n))
}

checkmore.genlin <- function(more,n)    # checks additional arguments to genlin
{
    if(is.null(more)){
        more$sub = cbind(kronecker(matrix(1:n,n,1),matrix(1,n,1)),
            kronecker(matrix(1,n,1),matrix(1:n,n,1)),1:n^2)  
        more$mat = matrix(0,n,n)      
        }
    else{
        if(is.null(more$sub)){
            more$sub = cbind(kronecker(matrix(1:n,n,1),matrix(1,n,1)),
                kronecker(matrix(1,n,1),matrix(1:n,n,1)),1:n^2)
        }
        else{
            if(ncol(more$sub)==1){                      # can just specify which params to use
                more$sub = cbind(kronecker(matrix(1:n,n,1),matrix(1,n,1)),
                    kronecker(matrix(1,n,1),matrix(1:n,n,1)),more$sub)
            }
        }
        if(is.null(more$mat)){ more$mat = matrix(0,n,n) }
    
        if(!is.null(more$force)){
            m = length(more$force)
            if(is.null(more$force.mat)){ more$force.mat = matrix(0,n,m) }
            if(is.null(more$force.sub)){
                more$force.sub = cbind(kronecker(matrix(1:n,m,1),matrix(1,m,1)),
                    kronecker(matrix(1,n,1),matrix(1:m,n,1)),1:(n*m))
            }
            if(ncol(more$force.sub)==1 | is.vector(more$force.sub)){
                more$force.sub = 
                    cbind(more$force.sub,more$force.sub,nrow(more$sub)+length(more$force.sub))
            }
            else{                               # one force per collumn, and specify which params
                if(ncol(more$force.sub)==2){
                    more$force.sub = cbind(more$force.sub[,1],more$force.sub[,1],more$force.sub[,2])
                }
            }
        }
    }   
    return(more)
}



    return(genlin)
}

Colloc.MCMC = function(times,data,pars,coefs,lik,proc,prior,walk.var,cscale,nstep,in.meth='SplineEst',control.in=NULL)
{
  #  parhist = matrix(0,nstep,length(pars))                     # Store parameter history
    coefhist = matrix(0,nstep,length(coefs))
tfhist = rep(0,nstep)
    acc = rep(0,nstep)
    
 

    
    f = SplineCoefsErr(coefs,times,data,lik,proc,pars,sgn=-1)   # Complete data log posterior
#print(proc$fn(coefs,bvals,pars,more))
#    H = SplineCoefsDC2(coefs,times,data,lik,proc,pars,sgn=-1)
#    G = SplineCoefsDCDP(coefs,times,data,lik,proc,pars,sgn=-1)
    
#    dcdp = ginv(H)%*%G
 
  tcoefs = coefs
   
        
#     ei = eigen(tH)
 #    eta = rnorm(length(coefs))
  #   logq = sum(eta^2)/2   

#     coefs = coefs + ei$vectors%*%diag(1/sqrt(ei$values*(ei$values>0)))%*%eta            
 

               # Initialize
  #  bestcoefhist[1,]=tcoefs
    coefhist[1,] = tcoefs



       tH = -1*SplineCoefsDC2(tcoefs,times,data,lik,proc,pars,sgn=-1)
         ei = eigen(tH)
    #     print(sum(abs(ei$values)-ei$values))
    #     print(ei$values)
    
    eta = 0        # cscale = 0 defaults to Collocation MCMC
   # logq = 0
    for(i in 2:nstep){
     #   tcoefs=coefs

                                                   # Now a Gaussian error about the minimum
         
          
   #    if(cscale>0){
         
    
         
         eta = rnorm(length(coefs))
  #       logq = -sum(eta^2)/2 - sum(log(ei$values[ei$values>0])/2)
   #       logq = sum(dnorm(eta,log=TRUE))
         
         eta = cscale*ei$vectors%*%diag(1/sqrt(ei$values*(ei$values>0)))%*%eta
    #   }
       
       tf =  SplineCoefsErr(as.vector(coefs)+eta,times,data,lik,proc,pars,sgn=-1) 
         
                      
#                 print(proc$fn(matrix(as.vector(tcoefs),nrow=ncol(lik$bvals)),bvals,pars,more)) 
print(c(tf,f ))
       if( runif(1) < exp( tf-f)){             # Acceptance probability
          tcoefs = as.vector(coefs)+eta
         
                    
          f = tf
#          H = SplineCoefsDC2(tcoefs,times,data,lik,proc,pars,sgn=-1)
#          G = SplineCoefsDCDP(tcoefs,times,data,lik,proc,pars,sgn=-1)
#          dcdp = ginv(H)%*%G

          acc[i] = 1
       }
       
       
       coefhist[i,] = tcoefs
       tfhist[i]=tf
     #  bestcoefhist[i,] = coefs
    }

   return(list(coefhist=coefhist, acc = acc, tf=tfhist))
}

Colloc.MCMC = function(times,data,pars,coefs,lik,proc,prior,walk.var,cscale,nstep,in.meth='SplineEst',control.in=NULL)
{
    parhist = matrix(0,nstep,length(pars))                     # Store parameter history
    coefhist = matrix(0,nstep,length(coefs))
    bestcoefhist = matrix(0,nstep,length(coefs))
    acc = rep(0,nstep)
    
    ei = eigen(walk.var)                                       # Random walk covariance
    S = ei$vectors%*%diag(sqrt(ei$values))

     pr = prior(pars)
    
    f = SplineCoefsErr(coefs,times,data,lik,proc,pars,sgn=-1)  + pr  # Complete data log posterior
#    H = SplineCoefsDC2(coefs,times,data,lik,proc,pars,sgn=-1)
#    G = SplineCoefsDCDP(coefs,times,data,lik,proc,pars,sgn=-1)
    
#    dcdp = ginv(H)%*%G
 
    tcoefs = coefs
  #  
#     ei = eigen(tH)
#     eta = rnorm(length(coefs))
#     logq = sum(eta^2)/2   
#
#     coefs = coefs + ei$vectors%*%diag(1/sqrt(ei$values*(ei$values>0)))%*%eta            
# 

    parhist[1,] = pars                              # Initialize
    bestcoefhist[1,]=tcoefs
    coefhist[1,] = tcoefs

    eta = 0        # cscale = 0 defaults to Collocation MCMC
    logq = 0
    for(i in 2:nstep){
       print(c(i,pars))

       delta = S %*% rnorm(length(pars))   # Random walk step
       
       # Find the nearest parameters in the history

       dists = apply( (parhist[1:(i-1),] - matrix(pars+delta,i-1,length(pars),byrow=TRUE))^2,1,sum)
       whichrow = sort( dists,decreasing=FALSE,index.return=TRUE)$ix[1]
       tcoefs = bestcoefhist[whichrow,]
       
       # Minimization
         
       res = inneropt(times=times,data=data,coefs=matrix(as.vector(tcoefs), nrow=ncol(lik$bvals),length(coefs)/ncol(lik$bvals)),lik=lik,proc=proc,
            pars=pars+delta,in.meth=in.meth,control.in=control.in)
    
       tcoefs = res$coefs                                                  # Now a Gaussian error about the minimum
       tH = SplineCoefsDC2(tcoefs,times,data,lik,proc,pars+delta,sgn=-1)
         
       tpr = prior(pars+delta)
       if(cscale>0){
         ei = eigen(tH)
         eta = rnorm(length(coefs))
  #       logq = -sum(eta^2)/2 - sum(log(ei$values[ei$values>0])/2)
          logq = sum(dnorm(eta,log=TRUE))
         
         eta = cscale*ei$vectors%*%diag(sqrt(ei$values*(ei$values>0)))%*%eta
       }
       
       tf =  SplineCoefsErr(as.vector(tcoefs)+eta,times,data,lik,proc,pars+delta,sgn=-1) + tpr - logq
       
print(c(tf,f,logq,pars+delta))
       if( runif(1) < exp( tf-f)){             # Acceptance probability
          coefs = as.vector(tcoefs)+eta
          pars = pars + delta
          pr = tpr
          
          f = tf
#          H = SplineCoefsDC2(tcoefs,times,data,lik,proc,pars,sgn=-1)
#          G = SplineCoefsDCDP(tcoefs,times,data,lik,proc,pars,sgn=-1)
#          dcdp = ginv(H)%*%G

          acc[i] = 1
       }
       
       parhist[i,] = pars
       coefhist[i,] = coefs
       bestcoefhist[i,] = res$coefs
    }

   return(list(parhist=parhist, coefhist=coefhist, acc = acc))
}

LS.setup = function(pars, coefs=NULL, fn, basisvals=NULL, lambda, fd.obj=NULL,
                     more=NULL, data=NULL, weights=NULL, times=NULL,
                     quadrature=NULL, eps=1e-6, posproc=FALSE, poslik = FALSE,
                     discrete=FALSE, names=NULL, sparse=FALSE)
{
    colnames = names

    if(!is.null(fd.obj)){            # If an fd object is provided, it overrides
      basisvals = fd.obj$basis       # the basis and function values

      if(!is.null(fd.obj$coefs)){
        coefs = fd.obj$coefs
      }
      if(!is.null(fd.obj$fdnames) & is.null(colnames)){
        colnames = fd.obj$fdnames[[length(fd.obj$fdnames)]]
      }
    }

    lik = make.SSElik()

    if(!poslik)
       lik$more = make.id()
    else
      lik$more = make.exp()


    if(length(dim(coefs))>2){
      if(is.null(colnames)){
        colnames = dimnames(coefs)[[3]]
      }
      nrep = dim(coefs)[2]
      coefs = matrix(coefs,dim(coefs)[1]*dim(coefs)[2],dim(coefs)[3])
    }
    else{
      nrep = 1
      if(is.null(colnames)){
        colnames = colnames(coefs)
      }
    }

    proc = make.SSEproc()

    if(is.list(fn)){
      procmore = fn
      procmore$more = more
    }
    else if(is.function(fn)){
      procmore = make.findif.ode()
      procmore$more$fn = fn
      procmore$more$more = more
      procmore$more$eps = eps
    }
    else if(inherits(fn,'pomp')){
      procmore = make.findif.ode()
      procmore$more$fn = pomp.skeleton
      procmore$more$eps = eps
      procmore$more$more =  list(pomp.obj = fn)
    }
    else{
      stop('fn must be either a list of functions or a function')
    }

    if(!posproc) proc$more = procmore
    else { proc$more = make.logtrans()
           proc$more$more = procmore}


    proc$more$names    = colnames
    proc$more$parnames = names(pars)


    if(is.basis(basisvals)){
      if(is.null(times)){
        stop(paste('if basisvals is is a basis object,',
                   ' you must specify the observation times'))
      }

      if(sparse){
        lik$bvals = spam(diag(rep(1,nrep)) %x%
                   eval.basis(times,basisvals))
      } else{
        lik$bvals = diag(rep(1,nrep)) %x% eval.basis(times,basisvals)
      }

      if(is.null(quadrature) | is.null(quadrature$qpts)){
        knots = c(basisvals$rangeval[1],basisvals$params,basisvals$rangeval[2])
        qpts = knots[-length(knots)] + diff(knots)/2
      }
      else{
        qpts = quadrature$qpts
      }

      proc$bvals = list()
      if(!discrete){
        if(sparse){
          proc$bvals$bvals  = spam(diag(rep(1,nrep)) %x%
                                     eval.basis(qpts,basisvals,0))
          proc$bvals$dbvals = spam(diag(rep(1,nrep)) %x%
                                     eval.basis(qpts,basisvals,1))
        }else{
          proc$bvals$bvals  = diag(rep(1,nrep)) %x% eval.basis(qpts,basisvals,0)
          proc$bvals$dbvals = diag(rep(1,nrep)) %x% eval.basis(qpts,basisvals,1)
        }
        proc$more$weights = matrix(1/length(qpts),length(qpts)*nrep,ncol(coefs))
        #proc$more$weights = 1/length(qpts)
        proc$more$qpts = qpts
      }
      else{
       len = length(times)
       basis = eval.basis(times,basisvals,0)
       if(sparse){
         proc$bvals = list(bvals = spam(basis[1:(len-1),]),
                           dbvals= spam(basis[2:len,]))
       } else{
         proc$bvals = list(bvals = basis[1:(len-1),],
                           dbvals= basis[2:len,])
       }
       proc$more$weights = matrix(1/(len-1),(len-1)*nrep,ncol(coefs))
       #proc$more$weights = 1/(len-1)
       proc$more$qpts = times[1:(len-1)]
       }


    }
    else{                                   # quadrature is ignored if basisvals
                                            # is not a basis object
      if(discrete & (is.matrix(basisvals) | is.null(basisvals))){
        if(is.null(basisvals)){ basisvals = Diagonal(nrow(coefs)) }
        if(sparse){
          lik$bvals = spam(diag(rep(1,nrep)) %x%basisvals)
          proc$bvals = list(bvals  = spam(diag(rep(1,nrep)) %x% basisvals[1:(nrow(basisvals)-1),]),
                            dbvals = spam(diag(rep(1,nrep)) %x% basisvals[2:nrow(basisvals),]))
        }else{
          lik$bvals = diag(rep(1,nrep)) %x%basisvals
          proc$bvals = list(bvals  = diag(rep(1,nrep)) %x% basisvals[1:(nrow(basisvals)-1),],
                            dbvals =diag(rep(1,nrep)) %x% basisvals[2:nrow(basisvals),])
        }
        proc$more$weights = matrix(1/(nrow(basisvals)-1),
                                   nrow(basisvals)-1,ncol(coefs))
        #proc$more$weights = 1/(nrow(basisvals)-1)
        proc$more$qpts = times[1:(length(times)-1)]
      }
      else{
        if(sparse){
          lik$bvals = spam(diag(rep(1,nrep))%x%basisvals$bvals.obs)

          proc$bvals =  list(bvals=spam(diag(rep(1,nrep)) %x%
                                          basisvals$bvals),
                            dbvals=spam(diag(rep(1,nrep)) %x%
                                          basisvals$dbvals))
        } else{
          lik$bvals = diag(rep(1,nrep))%x%basisvals$bvals.obs

          proc$bvals =  list(bvals=diag(rep(1,nrep)) %x% basisvals$bvals,
                            dbvals= diag(rep(1,nrep)) %x%basisvals$dbvals)
        }
        proc$more$qpts = rep(basisvals$qpts,nrep)

        if(!is.null(basisvals$qwts))
          proc$more$weights = matrix(basisvals$qwts,
                                     length(basisvals$qwts)*nrep,ncol(coefs))
        else
          #proc$more$weights = 1/length(proc$more$qpts)
          proc$more$weights = matrix(1/length(proc$more$qpts),
                                       length(proc$more$qpts)*nrep,ncol(coefs))
      }
    }

    if( is.null(weights) ){
      lik$more$weights = matrix(1,ncol(coefs))
    }
    else{
      lik$more$weights = matrix(weights,nrow(lik$bvals)*nrep,ncol(coefs))
    }

    if(!is.null(data)){
      if(length(dim(data))==2){
        if(nrep>1){stop('data dimensions must match coefficient dimensions')}
        if(dim(data)[1] != length(times) | dim(data)[2]!= dim(coefs)[2]){
        stop('data dimensions, times and coefficient dimensions do not match')}
      }
      if(length(dim(data))==3){
         if(dim(data)[2] != nrep | dim(data)[3]!=dim(coefs)[2] |
            dim(data)[1]!=length(times)){
        stop('data dimensions, times and coefficient dimensions do not match')}
        data = matrix(data,dim(data)[1]*dim(data)[2],dim(data)[3])
        times = rep(times,nrep)
     }
    }

 #   if(length(lambda)==1){ lambda = as.matrix(rep(lambda,ncol(coefs))) }

    if(length(lambda) > 1){ proc$more$weights = proc$more$weights%*%diag(lambda) }
    else{ proc$more$weights = as.numeric(lambda)*proc$more$weights }

    return( list(lik=lik,proc=proc,coefs=coefs,data=data,times=times) )

}

##########################################
##       FitzHugh-Nagumo Example       ###
##########################################

# Obtain some pre-generated data

FhNdata

# Now we want to set up a basis expansion; this makes use of
# routines in the fda library

knots  = seq(0,20,0.5)
norder = 3
nbasis = length(knots) + norder - 2
range  = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)
	
	
# We'll start off by creating a smooth of each state variable to get initial
# values for the parameters.

bfdPar = fdPar(bbasis,lambda=1,int2Lfd(1))
DEfd = smooth.basis(FhNtimes,FhNdata,bfdPar,fdnames=list(NULL,c('V','R')) )$fd

coefs = DEfd$coefs
colnames(coefs) = FhNvarnames

#### Option 1: pre-defined set-up for squared error

lambda = 1000

# First just optimize the coefficients

Ires1	= Smooth.LS(make.fhn(),FhNdata,FhNtimes,FhNpars,coefs,bbasis,lambda,
  in.meth='nlminb')

# Let's have a look at this

IDEfd1 = fd(Ires1$coefs,bbasis)
plot(IDEfd1)
matplot(FhNtimes,FhNdata,add=TRUE)


# Now we can do the profiling

Ores1 = Profile.LS(make.fhn(),FhNdata,FhNtimes,FhNpars,coefs=coefs,
  basisvals=bbasis,lambda=lambda)

# And look at the result

ODEfd1 = fd(Ores1$coefs,bbasis)
plot(ODEfd1)
matplot(FhNtimes,FhNdata,add=TRUE)
  
# If we only coded the FitzHugh Nagumo funciton with no derivatives we would just
# have make.fhn()$fn, in which case we default to estimating the derivatives by
# finite differencing

Ires1a	= Smooth.LS(make.fhn()$fn,FhNdata,FhNtimes,FhNpars,coefs,bbasis,lambda,
  in.meth='nlminb')

# Now we can do the profiling

Ores1a = Profile.LS(make.fhn()$fn,FhNdata,FhNtimes,FhNpars,coefs=coefs,
  basisvals=bbasis,lambda=lambda)
  
  
  
#### Option 2:  set-up functions for proc and lik objects and then call
# optimizers

profile.obj = LS.setup(pars=FhNpars,fn=make.fhn(),lambda=lambda,times=FhNtimes,
      coefs=coefs,basisvals=bbasis)
lik = profile.obj$lik
proc= profile.obj$proc

# Now we can get initial parameter estimates from "gradient matching"

pres = ParsMatchOpt(FhNpars,coefs,proc)
npars = pres$pars

# Smoothing can be done more specifically with 'inneropt'

Ires2 = inneropt(FhNdata,times=FhNtimes,npars,coefs,lik,proc)

# And we can also do profiling

Ores2 = outeropt(FhNdata,FhNtimes,npars,coefs,lik,proc)

#### Option 3:  set everything up manually

## lik object

lik2 = make.SSElik()                      # we are using squared error
lik2$bvals = eval.basis(FhNtimes,bbasis)  # values of the basis at observation times
lik2$more = make.id()                     # identity transformation
lik2$more$weights = c(1,0)                # only use data for V

## proc object

qpts = knots[1:(length(knots)-1)]+diff(knots)/2  # Collocation points at midpoints
                                                 # between knots

proc2 = make.SSEproc()                    # we are using squared error
proc2$bvals = list(bvals = eval.basis(qpts,bbasis),    # values and derivative of
                  dbvals = eval.basis(qpts,bbasis,1))  # basis at collocation points
proc2$more = make.fhn()                   # FitzHugh-Nagumo right hand side
proc2$more$names = FhNvarnames            # State variable names
proc2$more$parnames = FhNparnames         # Parameter names
proc2$more$qpts = qpts                    # Collocation points
proc2$more$weights  = c(1000,1000)        # Weight relative to observations of
                                          # each collocation point.
                                          
# We can also specify optimization methods

in.meth = 'nlminb'            # Inner Optimization
control.in = list(rel.tol=1e-12,iter.max=1000,eval.max=2000,trace=0)  # Optimization control

out.meth = 'optim'            # Outer Optimization
control.out = list(trace=6,maxit=100,reltol=1e-8,meth='BFGS') # Optimization control
                                          
                                          
# Now we will also remove the 'R' part of the data (ie, assume we did not measure
# it) and set the corresponding coefficients to zero

new.FhNdata = FhNdata
new.FhNdata[,2] = NA

new.coefs = coefs
new.coefs[,2] = 0

# We can now fix the smooth or 'V' and try and choose 'R' to make the differential
# equation match as well as possible.

fres = FitMatchOpt(coefs=new.coefs,which=2,pars=FhNpars,proc2)
new.coefs2 = fres$coefs

# And we can call the same inner optimization as above, this time with our
# own control parameters and method

Ires3 = inneropt(new.FhNdata,FhNtimes,FhNpars,new.coefs2,lik2,proc2,
  in.meth=in.meth,control.in=control.in)

# And we can also do profiling with specified controls

Ores3 = outeropt(new.FhNdata,FhNtimes,FhNpars,coefs=new.coefs2,lik=lik2,proc=proc2,
  in.meth=in.meth,out.meth=out.meth,control.in=control.in,control.out=control.out)

# We can also use finite differencing to calculate derivatives of the right hand side of the
# FitzHugh-Nagumo equations, this is defined by modifying the proc object.

proc2a = make.SSEproc()                    # we are using squared error
proc2a$bvals = list(bvals = eval.basis(qpts,bbasis),    # values and derivative of
                  dbvals = eval.basis(qpts,bbasis,1))  # basis at collocation points
proc2a$more = make.findif.ode()                   # FitzHugh-Nagumo right hand side
proc2a$more$names = FhNvarnames            # State variable names
proc2a$more$parnames = FhNparnames         # Parameter names
proc2a$more$qpts = qpts                    # Collocation points
proc2a$more$weights  = c(1000,1000)        # Weight relative to observations of
                                           # each collocation point.
proc2a$more$more = list(fn = make.fhn()$fn, eps=1e-6) # Tell findif that the function
                                                      # to difference is fhn and the
                                                      # difference stepsize


Ires3a = inneropt(new.FhNdata,FhNtimes,FhNpars,new.coefs2,lik2,proc2a,
  in.meth=in.meth,control.in=control.in)

# And we can also do profiling with specified controls

Ores3a = outeropt(new.FhNdata,FhNtimes,FhNpars,coefs=new.coefs2,lik=lik2,proc=proc2a,
  in.meth=in.meth,out.meth=out.meth,control.in=control.in,control.out=control.out)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

##########
# This demonstration illustrates the use of log transformations with
# CollocInfer. We use the SEIR equations with a seasonally varying
# infection rate for this purpose.
#
# The equations are given as
#
# Sdot = mu - beta(t)*S*(I+i) - nu*S        (Susceptibles)
# Edot = beta(t)*S*(I+i) - (sigma+nu)*E     (Exposed)
# Idot = sigma*E - (gamma+nu)*I              (Infectious)
# 
# Here beta(t) - the infection rate - is parameterized by a sinusoidal function
# plus a constant.
#
# Traditionally, there is an additional state
#
# Rdot = gamma*I - nu*R
#
# However, since we only observe I, R contributes nothing to the data fit and
# we have removed it from the system. 
#
# Other parameters are
# i - a visiting process
# nu - death rate
# sigma - the rate of movement from Exposed to Infectious.
# gamma - the rate of recovery from infection.
#
# It is generally more stable to solve the equations for the log states rather
# than the states themselves. CollocInfer contains a number of useful tools
# that let you make this transition without needing to re-code all of your
# differential equations.

library('CollocInfer')
            
            
#### Get some data and parameters

SEIRvarnames = SEIRvarnames
SEIRparnames = SEIRparnames

SEIRtimes = SEIRtimes
SEIRdata = SEIRdata

SEIRpars = SEIRpars


#### Now format the data so that S and E measurements are listed as NA

data = cbind(matrix(NA,length(SEIRdata),2),SEIRdata)

# We'll also look at the log observations

logdata = log(data)



#### define the right side evaluation function

SEIRfn = make.SEIR()


#### A couple of functions to define the infection rate

beta.fun = function(t,p,more){
    return( p['b0'] + p['b1']*sin(2*pi*t) + p['b2']*cos(2*pi*t) )
}

beta.dfdp = function(t,p,more){
    dfdp =  cbind(rep(1,length(t)), sin(2*pi*t), cos(2*pi*t)) 
    colnames(dfdp) = c('b0','b1','b2')
    return(dfdp)
}

betamore = list(beta.fun=beta.fun,
                beta.dfdp=beta.dfdp,
                beta.ind=c('b0','b1','b2'))


# Create a collocation basis to represent the state vector

rr = range(SEIRtimes)
knots = seq(rr[1],rr[2],2/52)
norder = 3
nbasis = length(knots)+norder-2

bbasis = create.bspline.basis(range=rr,norder=norder,nbasis=nbasis,breaks=knots)

# To get an initial estimate of the states we smooth the observed I component
# and set the other coefficients to zero.  

DEfd = smooth.basis(SEIRtimes,logdata[,3],fdPar(bbasis,1,0.1))

plotfit.fd(log(SEIRdata),SEIRtimes,DEfd$fd)

coefs = cbind(matrix(0,bbasis$nbasis,2),DEfd$fd$coefs)
DEfd = fd(coefs,bbasis)


# We will want to represent the state variables on the log scale so that they remain
# always positive. To do this, we set the 'posproc' component of LS.setup to 1. We
# will also compare the logstate to the log of the data directly, and therefore set
# 'poslik' to 0.

# We call LS.setup first and use the outputted lik and proc objects to pull the 
# coefficients for the unobserved state variables into line with the 
# differential equation. 

objs = LS.setup(SEIRpars,fn=SEIRfn,fd.obj=DEfd,more=betamore,data=data,times=SEIRtimes,
  posproc=TRUE,poslik=FALSE,names=SEIRvarnames,lambda=c(100,1,1))

proc = objs$proc
lik = objs$lik

res1 = FitMatchOpt(coefs=coefs,which=1:2,proc=proc,pars=SEIRpars,meth='nlminb')


# Let's have a look at the result

DEfd1 = fd(res1$coefs,bbasis)
plot(DEfd1,ylim=c(5,13))
points(SEIRtimes,logdata[,3])

# We can now run an initial smooth using the estimated coefficients as starting points. 

res2 = inneropt(data=logdata,times=SEIRtimes,pars=SEIRpars,proc=proc,lik=lik,coefs=res1$coefs,in.meth='nlminb')

# Has this changed much?

DEfd2 = fd(res2$coefs,bbasis)

plot(DEfd2,lwd=2,ylim=c(5,13))
lines(DEfd1)


# And we can call the optimizing functions. 

res3 = outeropt(data=logdata,times=SEIRtimes,pars=SEIRpars,proc=proc,lik=lik,coefs=res2$coefs,
  active=c('i','b0','b1','b2'))


# Some plots

## First, the estimated trajectories

DEfd3 = fd(res3$coefs,bbasis)
plot(DEfd3,lwd=2,ylim=c(5,14))


# Let's compare this to the data

plotfit.fd(logdata[,3],SEIRtimes,DEfd3[3],ylab='Fit to Data')


# We can also look at the discrepancy between the estimated trajectory and the
# differential equation

traj = eval.fd(SEIRtimes,DEfd3)     # estimated trajectory
colnames(traj) = SEIRvarnames

dtraj = eval.fd(SEIRtimes,DEfd3,1)  # derivative of the estimated trajectory

ftraj = proc$more$fn(SEIRtimes,traj,res3$pars,proc$more$more)   # Trajectory predicted by ODE


X11()
matplot(SEIRtimes,dtraj,type='l',lty=2,ylim =c(-10,10),ylab='SEIR derivatives' )
matplot(SEIRtimes,ftraj,type='l',lty=1,add=TRUE)

X11()
matplot(SEIRtimes,dtraj-ftraj,type='l',ylim=c(-4,4),ylab='Fit to Model')





## The alternative is to exponentiate the state before we compare to original data.
# This can take a very long time and is only recommended if you really need to do
# it, or have a couple of hours to wait. 


objs2 = LS.setup(SEIRpars,fn=SEIRfn,fd.obj=DEfd,more=betamore,data=data,times=SEIRtimes,
  posproc=TRUE,poslik=TRUE,names=SEIRvarnames,SEIRparnames,lambda=c(100,1,1))

lik2 = objs2$lik
proc2 = objs2$proc

res2 = inneropt(data=data,times=SEIRtimes,pars=res3$pars,proc=proc2,lik=lik2,coefs=res3$coefs)

res3 = outeropt(data=data,times=SEIRtimes,pars=res3$pars,proc=proc2,lik=lik2,coefs=res3$coefs,
  active=c('i','b0','b1','b2'))



###############################################################################
# Some more basic setup operations
#
# Here we go through the steps necessary to set up the SEIR equations manually. 
# This allows us several options for dealing with the positivity of the 
# state vector. 
#
# 1. We can ignore it and hope for the best. 
#
# 2. We can take a log transform of the ODE and then exponentiate the solutions
# to compare to the data
#
# 3. We can take a log transform of the ODE and compare this to the log data. 
###############################################################################


# First of all, we need the values of the basis at the observation times and the 
# quadrature points. 


qpts = 0.5*(knots[1:(length(knots)-1)] + knots[2:length(knots)])

bvals.obs = Matrix(eval.basis(times,bbasis),sparse=TRUE)

bvals = list(bvals = Matrix(eval.basis(qpts,bbasis),sparse=TRUE),
            dbvals = Matrix(eval.basis(qpts,bbasis,1),sparse=TRUE))


### This proc object is just the standard squared error deviation
# from the right hand side of a differential equation

sproc = make.SSEproc()
sproc$bvals = bvals
sproc$more = make.SEIR()
sproc$more$more = betamore
sproc$more$qpts = qpts
sproc$more$weights = matrix(1,length(qpts),3)%*%diag(c(1e2,1e0,1e0))
sproc$more$names = SEIRvarnames
sproc$more$parnames = SEIRparnames


### However, ODEs are often much more numerically stable if represented on a
# log scale. The make.logtrans() function will take the right hand side functions
# and derivatives defined for any differential equation and provide the equivalent
# system for the log state. Note that this does affect the way  you represent
# your state when considering the observations. 

lsproc = make.SSEproc()
lsproc$bvals = bvals
lsproc$more = make.logtrans()
lsproc$more$more = make.SEIR()
lsproc$more$more$more = betamore
lsproc$more$qpts = qpts
lsproc$more$weights = matrix(1,length(qpts),3)%*%diag(c(1e2,1e0,1e0))
lsproc$more$names = SEIRvarnames
lsproc$more$parnames = SEIRparnames

### Lik objects, this is the standard squared error. 

slik = make.SSElik()
slik$bvals = eval.basis(times,bbasis)
slik$more = make.id()
slik$more$weights = array(1,dim(data))
slik$more$names = SEIRvarnames
slik$more$parnames = SEIRparnames

# Log transform transformation for the lik object. For this, we note that we 
# have represented the trajectory on the log scale and will need to transform 
# back, this makes the numerics much harder and it can take a very long time to 
# converge.  

lslik = make.logstate.lik()
lslik$bvals = slik$bvals
lslik$more$weights = slik$more$weights
lslik$more = slik
lslik$more$parnames = SEIRparnames


# Numerically things work much better on the log scale

dfd = data2fd(logdata[,3],times,bbasis)

coefs = matrix(0,nbasis,3)
coefs[,3] = dfd$coefs
 
res = FitMatchOpt(coefs=coefs,which=1:2,proc=lsproc,pars=SEIRpars,meth='nlminb')

res2 = inneropt(data=logdata,times=SEIRtimes,pars=SEIRpars,proc=lsproc,lik=lslik,coefs=res$coefs)

res3 = outeropt(data=data,times=SEIRtimes,pars=SEIRpars,proc=lsproc,lik=lslik,coefs=res2$coefs,
  active=c('i','b0','b1','b2'))


## Or just log the observations, this is faster. 

res2 = inneropt(data=logdata,times=SEIRtimes,pars=SEIRpars,proc=lsproc,lik=slik,coefs=res$coefs)

res3 = outeropt(data=logdata,times=SEIRtimes,pars=SEIRpars,proc=lsproc,lik=slik,coefs=res2$coefs,
  active=c('i','b0','b1','b2'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

## Groundwater level measurements as a function of rainfall.  
#
# The data were collected in North Vancouver near a site of a 
# mud slide that caused two fatalities in 2004.
#
# The groundwater levels are a relatively smooth process with a
# rather high signal to noise ratio.  Rainfall events, however,
# are sporadic and can be considered as events with times and 
# intensities, called a marked point process in statistical theory.
#
# Groundwater level is modeled by a first order linear differential
# equation forced by rainfall.
#
# A constant coefficient version of the equation is
# 
# $$\dot{G}(t) = - \beta G(t) + \alpha R(t - \delta) + \mu$$
#
# and a variable coefficient version is
#
# $$\dot{G}(t) = - \beta(t) G(t) + \alpha(t) R(t - \delta) + \mu(t)$$
#
# Coefficient \beta controls the speed of the response
# of groundwater to a rainfall event.  
#
# Coefficient \alpha controls the size of the response
# of groundwater to a rainfall event.   The gain in the system
# is defined as K = \alpha / \beta.
#
# Constant \mu is an adjustment to the overall level of
# groundwater required because the origin of the measurements
# can be viewed as arbitrary or irrelevant.
#
# Lag constant \delta allows a time lapse before groundwater
# begins to respond to a rainfall event.  It was estimated by
# inspecting plots to be three hours for the purposes of these
# analyses, and is therefore not actually estimated by these
# analyses themselves.
#
# The following code allows for each of the remaining three
# parameters to be either constant, or themselves functions 
# of time.  That is,
#
# Although the constant model does a fair job of 
# describing the data, allowing for a mild time-variation in
# these parameters substantially improved the fit.  We used
# five order 4 B-splines to model this time dependency.  
#
# Last modified 26 April 2010
#
## Setting up the data 
#

# The analyses requires access to the profiled estimation software.

library("CollocInfer")

# Input the data to be analyzed.

#load("groundwater")
#load("rainfall")

#  rainfall should be lagged by about three hours

#Ninput = length(rainfall)
#lag    = 3
#rainfall = c(rep(0,2*lag), rainfall[1:(Ninput-2*lag)])

#  a subset of the data are selected, running from day 79 into day 92
#  if all the data are used, R has to allocate additional storage

# index = 1597:3024  
#index = 1907:2221  #  here we select a smaller set of data 
#yobs = as.matrix(groundwater[index])
#zobs = as.matrix(rainfall[index])
#N = length(yobs)
#tobs = (index - index[1])


yobs = NSgroundwater
zobs = NSrainfall
tobs = NStimes

N    = length(tobs)
rangeval = c(0,N-1)



#  plot the groundwater data

par(mfrow = c(2,1))
plot(tobs, yobs, "p",  xlab="Time (hours)", 
                       ylab="Groundwater level (metres)")
plot(tobs, zobs, "p",  xlab="Time (hours)", 
                       ylab="Hourly rainfall (millimetres)")

#  set up cumulative rainfall

#  Set up a basis for rainfall itself: 
#     An order 1 or piece-wise constant spline

norder = 1
nbasis = N + norder - 2
rainbasis  = create.bspline.basis(rangeval, nbasis, norder)
rainfd = smooth.basis(tobs, zobs, rainbasis)$fd

#  plot the data

plotfit.fd(zobs, tobs, rainfd, nfine=N)

## The basis for representing groundwater: G(t)

# Define the knot sequence.  A knot is placed at each mid-hour
# point, giving maximum capacity to fit the data.  Variable
# rangeval is a vector of length 2 containing the lower and
# upper time limits of the observations, and is in file 
# NorthShoreData.mat


knots  = c(rangeval[1],
           seq(rangeval[1]+0.5, rangeval[2]-0.5, len=N-1), 
           rangeval[2])
norder   = 3
nbasis   = length(knots) + norder - 2
basisobj = create.bspline.basis(rangeval, nbasis, norder, knots)
 
# The constant coefficient basis is required for constant beta and alpha.  

conbasis = create.constant.basis(rangeval)

## Definition of functional basis objects for the coefficient functions

# Set up the basis for the coefficient function \beta(t) or
# \beta(G) determining the speed of response and recovery
#
# select the command that specifies the argument of \beta
#
# This basis is for \beta(t) as a function of time.  You may
# change the number of basis functions that are used.
#
# Here we use a constant basis for each coefficient, but at end
# we can do that analysis again with five order 5 B-spline basis functions.

nbetabasis = 1
#nbetabasis = 5
if (nbetabasis > 1) {
    betabasis = create.bspline.basis(rangeval, nbetabasis)
} else {
    betabasis = conbasis
}

# Set up the basis for the coefficient function \alpha(t)
# multiplying rainfall

nalphabasis = 1
#nalphabasis = 5
if (nalphabasis > 1) {
    alphabasis = create.bspline.basis(rangeval, nalphabasis)
} else {
    alphabasis = conbasis
}

#  store the bases and rainfall object in a list "more"

more = vector("list",0)
more$betabasis  = betabasis
more$alphabasis = alphabasis
more$rainfd     = rainfd

# Definition of the required named list containing the right side
#  evaluation functions.  

NSfn = make.NS()

## Prepare the constant coefficient analysis

# Set up the functional parameter object that defines the
# roughness penalty.  Here an important choice must be made:
# how large should the smoothing parameter \lambda be?
# One may be advised to begin with a lowish value, such as
# \lambda = 1, complete the analysis with this value, then
# increase the value to something like \lambda = 100, using
# as starting values for the parameter array pars at this stage
# the array newpars computed at the profiled estimation analysis
# for the previous smaller value.  

lambdaDE = 1e0  # A good value for the initial analysis.     
penorder = 1    # The penalty is first order
GfdPar   = fdPar(basisobj,penorder,lambdaDE)     

# Smooth the data with this roughness penalty to get initial
# values for coefficients defining G(t).

DEfd0 = smooth.basis(tobs, yobs, GfdPar)$fd

# plot the data and the fit

plotfit.fd(yobs, tobs, DEfd0, 
           xlab="Time (hours)", ylab="Groundwater level (metres)", 
           title="")

# extract the coefficient array

coefs0 = DEfd0$coefs

# Initial parameter values for constant bases

pars0 = matrix(0, nbetabasis + nalphabasis, 1) 

#pars0 = matrix(c(rep(res1$pars[1],nbetabasis), 
#                 rep(res1$pars[1],nalphabasis)), 
#                 nbetabasis + nalphabasis, 1) 

## Profiled estimation step

control.out = list()
control.out$trace  = 6
control.out$tol    = 1e-6

# This is the main optimization for profiled estimation.  
# It uses initial values for parameters and coefficients that
# are set up above.  This requires a lot of computation, and
# will take a number of minutes per iteration.  Find something
# else to do in the meantime.

lambda = 1e0

#  estimate the parameters using differencing

res0 = Profile.LS(make.NS()$fn, yobs, tobs, pars0, coefs0, basisobj, 
                  lambda, more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res0$pars  #  display the parameter estimates

res0$outer.result$value  # display the final function value


#  estimate the parameters using the derivative evaluation functions

lambda = 1e0

res1 = Profile.LS(NSfn, yobs, tobs, pars0, coefs0, basisobj, lambda,
                  more=more, out.meth='ProfileGN', 
                  control.out=control.out)

res1$pars  #  display the parameter estimates

res1$outer.result$value  # display the final function value

#  set up the functional data object for the fit

DEfd1 = fd(res1$coefs, basisobj)

#  increase lambda a few times, starting each time with 
#  parameters estimated from the last value

lambda = 1e2

res2 = Profile.LS(NSfn, yobs, tobs, res1$pars, res1$coefs, basisobj, lambda,
                  more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res2$pars  #  display the parameter estimates

DEfd2 = fd(res2$coefs, basisobj)

lambda = 1e4

res3 = Profile.LS(NSfn, yobs, tobs, res2$pars, res2$coefs, basisobj, lambda,
                  more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res3$pars  #  display the parameter estimates

DEfd3 = fd(res3$coefs, basisobj)

lambda = 1e6

res4 = Profile.LS(NSfn, yobs, tobs, res3$pars, res3$coefs, basisobj, lambda,
                  more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res4$pars  #  display the parameter estimates

DEfd4 = fd(res4$coefs, basisobj)

lambda = 1e8

res5 = Profile.LS(NSfn, yobs, tobs, res4$pars, res4$coefs, basisobj, lambda,
                  more = more, out.meth='ProfileGN', 
                  control.out=control.out)

res5$pars  #  display the parameter estimates

DEfd5 = fd(res5$coefs, basisobj)

#  compare fits to the data

par(mfrow=c(1,1))
plotfit.fd(yobs, tobs, DEfd1, 
           xlab="Time (hours)", ylab="Groundwater level (metres)", 
           title="")
lines(DEfd2)
lines(DEfd3)
lines(DEfd4)
lines(DEfd5, lty=2)

#  By the time we get to res4, the fit to the data is essentially
#  a soluton to the differential equation.  We see that it has
#  rather less capacity to fit the data, but still captures some
#  of the shapes in the data.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

# Load some things in 

library('CollocInfer')

# The Chemostat equations represent a four-species Chemostat plus the resource 
# of Nitrogen. There are two species of Algae with varying defenses against
# Rotifers. The Rotifers themselves are divided into two class -- breeding
# and senescent, although these two are very tightly coupled. 
#
# A full description of these equations can be found in the user manual. 
# The five state variables for the equations are
# 
# N - nitrogen content in the Chemostat
# C1 - Algal type 1
# C2 - Algal type 2 
# B - Breeding Rotifers
# S - Senescent Rotifers
#
# The system has 16 parameters, also described in the user manual. Notable
# features include that only the sums C1+C2 and B+S can be observed. Further, 
# an unknown fraction of each is counted at each time. This requires us to 
# set up a model for the observation process along with the ODE. 


# First we load up some data

data(ChemoData)

# The first two of these parameters give the fractions of Algae and Rotifers 
# that are counted. The remaining parameters are all positive and using 
# their logged values is helpful. 

logpars=c(ChemoPars[1:2],log(ChemoPars[3:16]))

# Parameters 'p1' and 'p2' represent relative palatability of the two algal
# clones, as such only one can be estimated and we fix p2 = 0. 

active = c(1:2,5,7:16)     

# We'll choose a fairly large value of lambda. 

lambda = rep(200,5)  

# We need some basis functions

rr = range(ChemoTime)
knots = seq(rr[1],rr[2],by=0.5)
bbasis = create.bspline.basis(rr,norder=4,breaks=knots)

# We will also have to set up the basis matrices manually. 

mids = c(min(knots),(knots[1:(length(knots)-1)] + 0.25),max(knots))

bvals.obs = eval.basis(ChemoTime,bbasis)

bvals.proc = list(bvals = eval.basis(mids,bbasis),
                  dbvals = eval.basis(mids,bbasis,1));


# We can now set up the proc object. We will want to take a log transformation
# of the state here for numerical stability. In general it is better to do 
# finite differencing AFTER the log transformation rather than before it. 

proc = make.SSEproc()                    # Sum of squared errors
proc$bvals = bvals.proc                  # Basis values
proc$more = make.findif.ode()            # Finite differencing
proc$more$more = list(fn=make.logtrans()$fn,eps=1e-8) # Log transform
proc$more$more$more = list(fn=chemo.fun) # ODE function
proc$more$qpts = mids                    # Quadrature points
proc$more$weights = rep(1,5)*lambda      # Quadrature weights (including lambda)
proc$more$names = ChemoVarnames          # Variable names
proc$more$parnames = ChemoParnames       # Parameter names


# For the lik object we need to both represent the linear combination transform
# and we need to model the observation process. 

# First to represent the observation process, we can use the genlin
# functions. These produce a linear combination of the the states 
# (they can be used in proc objects for linear systems, too).  

temp.lik = make.SSElik()
temp.lik$more = make.genlin()

# Genlin requires a more object with two elements. The 'mat' element
# gives a template for the matrix defining the linear combination. This is
# all zeros 2x5 in our case for the two observations from five states. 
# The 'sub' element specifies which elements of the parameters should be
# substituted into the mat element. 'sub' should be a kx3 matrix, each
# row defines the row (1) and column (2) of 'mat' to use and the element
# of the parameter vector (3) to add to it. 

temp.lik$more$more = list(mat=matrix(0,2,5,byrow=TRUE), 
  sub = matrix(c(1,2,1,1,3,1,2,4,2,2,5,2),4,3,byrow=TRUE))
temp.lik$more$weights = c(100,1)

# Finally, we tell CollocInfer that the trajectories are represented on
# the log scale and must be exponentiated before comparing them to the data. 

lik = make.logstate.lik()
lik$more = temp.lik
lik$bvals = bvals.obs


# Now lets try running this

# Because we don't have direct observations of any state, we'll use a starting 
# smooth obtained from generating some ODE solutions

y0 = log(c(2,0.1,0.4,0.2,0.1))
names(y0) = ChemoVarnames

odetraj = lsoda(y0,ChemoTime,func=chemo.ode,logpars)

DEfd = smooth.basis(ChemoTime,odetraj[,2:6],fdPar(bbasis,int2Lfd(2),1e-6))
C = DEfd$fd$coef


# Now, with parameters fixed, we'll estiamte coefficients. 

res = inneropt(coefs=C,pars=logpars,times=ChemoTime,data=ChemoData,
  lik=lik,proc=proc,in.meth='optim')

# We'll for the trajectory and also the appropriate sum of exponentiated
# states to compare to the data. 

C = matrix(res$coefs,dim(C))
traj = lik$bvals%*%C
obstraj = lik$more$more$fn(ChemoTime,exp(traj),logpars,lik$more$more$more)

# Plot these against the data

X11()
par(mfrow=c(2,1))
plot(obstraj[,1],type='l',ylab='Chlamy',xlab='',cex.lab=1.5,cex.axis=1.5)
points(ChemoData[,1])
plot(obstraj[,2],type='l',ylab='Brachionus',xlab='days',cex.lab=1.5,cex.axis=1.5)
points(ChemoData[,2])


# Now we can continue with the outer optimization

res2 = outeropt(pars=logpars,times=ChemoTime,data=ChemoData,coef=C,
    lik=lik,proc=proc,active=active,in.meth='optim',out.meth='nlminb')

# We'll extract the resulting parameters and coefficients. 

npars = res2$pars
C = as.matrix(res2$coefs,dim(C))

# And obtain an estimated trajectory and the exponentiated sum to comprare
# to the data. 

traj = lik$bvals%*%C
ptraj = lik$more$more$fn(ChemoTime,exp(traj),npars,lik$more$more$more)

# Lets have a look at how much we changed our parameters on the original 
# scale. 

new.pars = npars
new.pars[3:16] = exp(new.pars[3:16])

print(ChemoPars)
print(new.pars)
print(new.pars/ChemoPars)

# Now we can produce a set of diagnostic plots. 

# Firstly, a representation of the trajectory compared to the data. 

X11()
par(mfrow=c(2,1))
plot(ChemoTime,ptraj[,1],type='l',ylab='Chlamy',xlab='',cex.lab=1.5)
points(ChemoTime,ChemoData[,1])
plot(ChemoTime,ptraj[,2],type='l',ylab='Brachionus',xlab='days',cex.lab=1.5)
points(ChemoTime,ChemoData[,2])


# Now we'll plot both the derivative of the trajectory and the value of the
# differential equation right hand side at each point. This represents the 
# fit to the model. 

traj2 = proc$bvals$bvals%*%C
dtraj2 = proc$bvals$dbvals%*%C

colnames(traj2) = ChemoVarnames
ftraj2 = proc$more$fn(proc2$more$qpts,traj2,npars,proc$more$more)


X11()
par(mfrow=c(5,1),mai=c(0.3,0.6,0.1,0.1))
for(i in 1:5){
  plot(mids,dtraj2[,i],type='l',xlab='',ylab=ChemoVarnames[i],
    cex.lab=1.5,ylim=c(-0.5,0.5))
  lines(mids,ftraj2[,i],col=2,lty=2)
  abline(h=0)
}
legend('topleft',legend=c('Smooth','Model'),lty=1:2,col=1:2,cex=1.2)

# Solving the differential equation from the estiamted initial condition
# of the trajectory allows us to compare the qualitative behavior of 
# our estimate to that of the differential equation. 

y0 = traj[1,]
names(y0) = ChemoVarnames
odetraj = lsoda(y0,ChemoTime,func=chemo.ode,parms=npars)


X11()
par(mfrow=c(2,1))
matplot(ChemoTime,traj,col=1,type='l',lwd=3,cex.lab=1.5,cex.axis=1.5,
    ylab='',cex.main=1.5,main='Reconstructed Trajectories')
legend(x='topright',legend=ChemoVarnames,lwd=3,col=1,lty=1:5)
matplot(ChemoTime,odetraj[,2:6],col=1,type='l',lwd=3,cex.axis=1.5,cex.lab=1.5,
    ylab='',cex.main=1.5,main='ODE Solution')

# We can also compare the pattern of observations predicted by the differential
# equation and that estimated by our methods. 

otraj = lik$more$more$fn(ChemoTime,exp(odetraj[,2:6]),npars,lik$more$more$more)

X11()
par(mfrow=c(2,1))
matplot(ChemoTime,ptraj,type='l',lwd=2,xlab='days',cex.lab=1.5,ylab='',
  cex.axis=1.5,cex.main=1.5,main='Predicted Observations -- Smooth')
matplot(ChemoTime,ChemoData,add=TRUE,pch = c(1,2))
legend('topright',legend=c('Algae','Rotifers'),pch=1:2,col=1:2)
matplot(ChemoTime,otraj,type='l',lwd=2,xlab='days',cex.lab=1.5,ylab='',
  cex.axis=1.5,cex.main=1.5,main='Predicted Observations -- ODE')
legend('topright',legend=c('Algae','Rotifers'),lty=1:2,col=1:2,lwd=2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#### Henon map examples
#
# This example demonstrates the use of CollocInfer on a discrete-time system.
# The Henon Map is a classical dynamical system that exhibits chaos.
# It's equations are given as
#
# x[t+1] = 1 - a*x[t]^2 + y[t]
# y[t+1] = b*x[t]

###############################
####   Data Generation  #######
###############################
hpars = c(1.4,0.3)

ntimes = 200

x = c(-1,1)
X = matrix(0,ntimes+20,2)
X[1,] = x

for(i in 2:(ntimes+20)){ X[i,] = make.Henon()$ode(i,X[i-1,],hpars,NULL) }

X = X[20+1:ntimes,]

Y = X + 0.05*matrix(rnorm(ntimes*2),ntimes,2)

t = 1:ntimes

coefs = as.matrix(Y)

###############################
####  Optimization Control  ###
###############################
control=list(trace = 0,maxit = 1000,maxtry = 10,reltol = 1e-6,meth = "BFGS")

control.in = control
control.in$reltol = 1e-12

control.out = control
control.out$trace = 2

###############################
####     Optimization       ###
###############################

hpars2 = c(1.3,0.4)          # Perturbed parameters
names(hpars2)=names(hpars)
lambda = 10000

### SSE for discrete process####

Ires1	= Smooth.LS(make.Henon(),data=Y,times=t,pars=hpars2,coefs,basisvals=NULL,
  lambda=lambda,in.meth='nlminb',control.in=control.in,pos=FALSE,discrete=TRUE)
  
Ores1 = Profile.LS(make.Henon(),data=Y,t,pars=hpars2,coefs,basisvals=NULL,
  lambda=lambda,in.meth='nlminb',out.meth='nls',control.in=control.in,
  control.out=control.out,pos=FALSE,discrete=TRUE)

### ProfileErr with SSEproc ####

profile.obj = LS.setup(pars=hpars2,coefs=coefs,fn=make.Henon(),basisvals=NULL,
  lambda=lambda,times=t,discrete=TRUE)
lik = profile.obj$lik
proc= profile.obj$proc
   
Ires2 = inneropt(data=Y,times=t,pars=hpars2,coefs,lik,proc,in.meth='nlminb',control.in)

Ores2 = outeropt(data=Y,times=t,pars=hpars2,coefs=coefs,lik=lik,proc=proc,
  in.meth="nlminb",out.meth="nlminb",control.in=control.in,control.out=control.out)

    
### Dproc ############

var = c(1,0.01)

Ires3 = Smooth.multinorm(make.Henon(),data=Y,t,pars=hpars2,coefs,basisvals=NULL,
  var=var,in.meth='nlminb',control.in=control.in,pos=FALSE,discrete=TRUE)

Ores3 = Profile.multinorm(fn=make.Henon(),data=Y,times=t,pars=hpars2,coefs=coefs,
  basisvals=NULL,var=var,fd.obj=NULL,more=NULL,quadrature=NULL,in.meth='nlminb',
  out.meth='BFGS',control.in=control.in,control.out=control.out,eps=1e-6,
  active=NULL,pos=FALSE,discrete=TRUE)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

## Example Diagnostics -- Learning the FitzHugh-Nagumo Equations
#
# Demonstration estimation of function functions. This also provides
# a template for random-effects treatment within profiling.

library(fda)
library(odesolve)
library(MASS)
library('CollocInfer')

source('../Devel/Diagnostics.R')

# First Create Some Data

t = seq(0,20,0.05)

pars = c(0.2,0.2,3)
names(pars) = c('a','b','c')

x0 = c(-1,1)
names(x0)= c('V','R')
y = lsoda(x0,t,make.fhn()$fn.ode,pars)
y = y[,2:3]

data = y + 0.2*matrix(rnorm(802),401,2)

# Now a basis object

knots = seq(0,20,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)


# Initial values for coefficients will be obtained by smoothing

DEfd = data2fd(data,t,bbasis)
coefs = DEfd$coefs

names(coefs) = c('V','R')

# Usual meta-parameters; quadrature points, weights and knots

lambda = c(100,100)
qpts = knots
qwts = rep(1/length(knots),length(knots))

qwts = qwts%*%t(lambda)
weights = array(1,dim(data))


# Now I define a measurement process log likelihood along with some
# additional features: in this case it's squared error. 

varnames = c('V','R')
parnames = c('a','b','c')


likmore = make.id()
likmore$weights = weights

lik = make.SSElik()
lik$more = likmore
lik$bvals = eval.basis(t,bbasis)


# Proc is a process log likelihood -- in this case treated as squared
# discrepancy from the ODE definition. 

procmore = make.genlin()
procmore$names = varnames
procmore$parnames = parnames
procmore$more = list(mat=matrix(0,2,2),sub= matrix(c(1,1,1,1,2,2,2,1,3,2,2,4),4,3,byrow=TRUE))


procmore$weights = qwts
procmore$qpts = qpts


proc = make.SSEproc()
proc$more = procmore
proc$bvals = list(bvals=eval.basis(procmore$qpts,bbasis,0),
		dbvals = eval.basis(procmore$qpts,bbasis,1))



spars = c(0,1,-1,0)

Ires = inneropt(data,times=t,spars,coefs,lik,proc,in.meth='nlminb')

Ores = outeropt(data=data,times=t,pars=spars,coefs=Ires$coefs,lik=lik,proc=proc,
  in.meth="nlminb",out.meth="nlminb")



traj = as.matrix(proc$bvals$bvals %*% Ores$coefs)
dtraj = as.matrix(proc$bvals$dbvals %*% Ores$coefs)
ftraj = dtraj - proc$more$fn(proc$more$qpts,dtraj,Ores$pars,proc$more$more)



par(mfrow=c(2,2))
for(i in 1:2){
  for(j in 1:2){
    plot(traj[,i],ftraj[,j],type='l')
  }
}




## Now we estimate some forcing functions

fbasis = create.bspline.basis(range=range,nbasis=23,norder=4)


dproc = make.SSEproc()
dproc$more = make.diagnostics()
dproc$more$qpts = procmore$qpts
dproc$more$weights = procmore$weights
dproc$more$more = procmore
dproc$more$more$p = Ores$pars
dproc$more$more$which = 1:2
dproc$more$more$psi = eval.basis(procmore$qpts,fbasis)
dproc$bvals = list(bvals=eval.basis(procmore$qpts,bbasis,0),
		dbvals = eval.basis(procmore$qpts,bbasis,1))


dpars = rep(0,2*fbasis$nbasis)  
  
dOres = outeropt(data=data,times=t,pars=dpars,coefs=Ires$coefs,lik=lik,proc=dproc,
  in.meth="nlminb",out.meth="nlminb")  


# Trajectories

force = dproc$more$more$psi %*% matrix(dOres$par,fbasis$nbasis,2)
traj = dproc$bvals$bvals %*% dOres$coefs

plot(traj[,1],force[,1],type='l')

######################################################
# Finite differencing for ODE RHS
######################################################


make.findif.ode <- function()
{

findif.ode<-list()
findif.ode$fn <- function(times,y,p,more)
{
    x = more$fn(times,y,p,more$more)
}

findif.ode$dfdx <- function(times,y,p,more)
{
    x1 = more$fn(times,y,p,more$more)
    x = array(0,c(dim(x1),ncol(y)))

    for(i in 1:ncol(y)){
        ty = y
        ty[,i] = y[,i] + more$eps
        x[,,i] = (more$fn(times,ty,p,more$more)-x1)/more$eps
    }
    return(x)
}

findif.ode$dfdp <- function(times,y,p,more)
{
    x1 = more$fn(times,y,p,more$more)
    x = array(0,c(dim(x1),length(p)))

    for(i in 1:length(p)){
        tp = p
        tp[i] = p[i] + more$eps
        x[,,i] = (more$fn(times,y,tp,more$more)-x1)/more$eps        
    }
    return(x)
}

findif.ode$d2fdx2 <- function(times,y,p,more)
{
    x1 = findif.ode$dfdx(times,y,p,more)
    x = array(0,c(dim(x1),ncol(y)))
    
    for(i in 1:ncol(y)){
        ty = y
        ty[,i] = y[,i] + more$eps
        x[,,,i] = (findif.ode$dfdx(times,ty,p,more)-x1)/more$eps
    }
    return(x)
}

findif.ode$d2fdxdp <- function(times,y,p,more)
{
    x1 = findif.ode$dfdx(times,y,p,more)
    x = array(0,c(dim(x1),length(p)))
    
    for(i in 1:length(p)){
        tp = p
        tp[i] = p[i] + more$eps
        x[,,,i] = (findif.ode$dfdx(times,y,tp,more)-x1)/more$eps
    }

    return(x)

}


    return(findif.ode)
}

pomp.skeleton = function(times,y,p,more)
{
  # Turns a skeleton function from a 'pomp' object into the right hand side
  # of and ODE for use in CollocInfer
  x <- array(t(y),dim=c(ncol(y),1,nrow(y)),dimnames=list(colnames(y),NULL,NULL))
  params <- array(data=p,dim=c(length(p),1),dimnames=list(names(p),NULL))
  
  y = skeleton(more$pomp.obj,x=x,params=params,t=times)
  return(t(y[,1,]))
}




###

data(ricker)
x <- array(
           data=states(ricker),
           dim=c(2,3,52),
           dimnames=list(rownames(states(ricker)),NULL,NULL)
           )
p <- array(
           data=coef(ricker),
           dim=c(5,3),
           dimnames=list(names(coef(ricker)),NULL)
           )
p["log.r",] <- c(1,2,4)


x = trajectory(ricker)
x = t(x[,1])
p = p[,1]

times=time(ricker,t0=T)

bvals = create.bspline.basis(rangeval=range(times),norder=2,nbasis=length(times))

objs = LS.setup(p,x,pomp.skeleton,100,discrete=1,times = times,basisvals=bvals)

proc = objs$proc
lik = objs$lik

proc$more$more$more = list(pomp.obj=ricker)


res1 = inneropt(x,times,p,x,lik,proc,in.meth='maxNR',control.in=list(trace=2))


#### SIR


p <- array(
           data=coef(euler.sir),
           dim=c(15,3),
           dimnames=list(names(coef(euler.sir)),NULL)
           )
p["beta2",1:2] <- c(3,5)
params=p[,3,drop=TRUE]

x <- trajectory(euler.sir)
x = t(x[,1,])

Y = x + 0.5*matrix(rnorm(length(x)),nrow(x),ncol(x))

times=time(euler.sir,t0=TRUE)

## Still need a basis

bbasis = create.bspline.basis(range(times),norder=4,breaks=seq(0,4,len=51))
mids = seq(0.04,3.96,by=0.08)

obvals = eval.basis(times,bbasis)
bvals = list(bvals = eval.basis(mids,bbasis),dbvals = eval.basis(mids,bbasis,1))


lik = make.SSElik()
lik$more = make.id()
lik$more$weights = matrix(1,nrow(Y),ncol(Y))
lik$bvals = obvals


proc = make.SSEproc()
proc$bvals= bvals
proc$more$weights = 100*matrix(1,nrow(Y),ncol(Y))
proc$more = make.findif.ode()
proc$more$more = list(eps = 1e-6,fn=pomp.skeleton)
proc$more$more$more = list(pomp.obj = euler.sir)


objs = LS.setup(params,coefs,euler.sir,100,discrete=0,times = times,basisvals=bbasis)

proc = objs$proc
lik = objs$lik
proc$more$more$more = list(pomp.obj = euler.sir)



coefs = solve(t(obvals)%*%obvals,t(obvals)%*%Y)

res1 = inneropt(Y,times,params,coefs,lik,proc,in.meth='nlminb')

res2 = outeropt(Y,times,params,coefs,lik,proc,in.meth='nlminb',out.meth='nlminb')

make.fhn.input <- function()
{

fhn.fun <- function(times,y,p,more)
{
  I = more$infn(times)
  r = y;
  r[,'V'] = (y[,'V'] - y[,'V']^3/3 - y[,'R'])   + I 
  r[,'R'] = (y[,'V'] + p['a'] - p['b']*y[,'R'])*p['c'] 
  return(r)
}


fhn.dfdx <- function(times,y,p,more)
{
  r = array(0,c(dim(y),2))
  dimnames(r) = list(NULL,colnames(y),colnames(y))

  r[,'V','V'] = 1 - y[,'V']^2
  r[,'V','R'] =  -1
  r[,'R','V'] = p['c']
  r[,'R','R'] = -p['b']*p['c']
  return(r)
}


fhn.dfdp <- function(times,y,p,more)
{
  r = array(0,c(dim(y),length(p)))
  dimnames(r) = list(NULL,colnames(y),names(p))

  r[,'R','a'] = p['c'];
  r[,'R','b'] = -y[,'R']*p['c'];
  r[,'R','c'] = y[,'V']+p['a']-p['b']*y[,'R'];
  return(r)
}


fhn.d2fdx2 <- function(times,y,p,more)
{
  r = array(0,c(dim(y),2,2))
  dimnames(r) = list(NULL,colnames(y),colnames(y),colnames(y))

  r[,'V','V','V'] = -2*y[,'V']
  return(r)
}


fhn.d2fdxdp <- function(times,y,p,more)
{
  r = array(0,c(dim(y),2,length(p)))
  dimnames(r) = list(NULL,colnames(y),colnames(y),names(p))

  r[,'R','V','c'] = 1
  r[,'R','R','b'] = -p['c']
  r[,'R','R','c'] = -p['b']

  return(r)
}



  return( 
    list(
        fn = fhn.fun,
        dfdx = fhn.dfdx,
        dfdp = fhn.dfdp,
        d2fdx2 = fhn.d2fdx2,
        d2fdxdp = fhn.d2fdxdp
    )
  )
}

make.Henon <- function()
{

Henon.ode <- function(times,y,p,more)
{
    r = y
    r[1] = 1- p[1]*y[1]^2 + y[2]
    r[2] = p[2]*y[1]
    
    return(r)
}

Henon.fun <- function(times,y,p,more)
{
    r = y
    r[,1] = 1- p[1]*y[,1]^2 + y[,2]
    r[,2] = p[2]*y[,1]
    
    return(r)
}

Henon.dfdx <- function(times,y,p,more)
{
    r = array(0,c(length(times),ncol(y),ncol(y)))
      
    r[,1,1] = -2*p[1]*y[,1]
    r[,1,2] = 1
    r[,2,1] = p[2]
    
    return(r)
}

Henon.dfdp <- function(times,y,p,more)
{
    r = array(0,c(length(times),ncol(y),length(p)))
    
    r[,1,1] = -y[,1]^2
    r[,2,2] = y[,1]
    
    return(r)
}


Henon.d2fdx2 <- function(times,y,p,more)
{
    r = array(0,c(length(times),rep(ncol(y),3)))
    
    r[,1,1,1] = -2*p[1]
    
    return(r)
}


Henon.d2fdxdp <- function(times,y,p,more)
{
    r = array(0,c(length(times),ncol(y),ncol(y),length(p)))
    
    r[,1,1,1] = -2*y[,1]
    r[,2,1,2] = 1
    
    return(r)
}



  return( 
    list(
        fn = Henon.fun,
        ode = Henon.ode,
        dfdx = Henon.dfdx,
        dfdp = Henon.dfdp,
        d2fdx2 = Henon.d2fdx2,
        d2fdxdp = Henon.d2fdxdp
    )
  )
}

Profile.Dproc <- function(fn,data,times,pars,coefs=NULL,basisvals=NULL,var=c(1,0.04),
                        fd.obj=NULL,more=NULL,quadrature=NULL,
                        in.meth='nlminb',out.meth='nlminb',
                        control.in,control.out,eps=1e-6,active=NULL,pos=0)
{
    if(is.null(active)){ active = 1:length(pars) }

    profile.obj = Dproc.setup(pars,coefs,fn,basisvals,var,fd.obj,more,
    times,quadrature,eps=1e-6,pos=0)

  
    lik = profile.obj$lik
    proc= profile.obj$proc
    coefs = profile.obj$coefs
    
 #   if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
#    if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
#
#    ncoefs = inneropt(data,times,pars,coefs,lik,proc,in.meth,control.in)
#
    apars = pars[active]
    aparamnames = names(apars)

    res = outeropt(data,times,pars,ncoefs,lik,proc,in.meth,out.meth,control.in,control.out,active)
    
    apars = res$pars[active]
    names(apars) = aparamnames
    ncoefs = as.matrix(read.table(file='curcoefs.tmp'))
    
    pars[active] = apars

   
#    if(file.exists('curcoefs.tmp')){file.remove('curcoefs.tmp')}
#    if(file.exists('optcoefs.tmp')){file.remove('optcoefs.tmp')}
#

    if(!is.null(fd.obj)){
      fd.obj = fd(ncoefs,fd.obj$basis)
      return( list(pars=pars,fd=fd.obj,lik=lik,proc=proc,res$res) )
    }
    else{
      return( list(pars=pars,coefs=ncoefs,lik=lik,proc=proc,res$res) )
    }
}


Dproc.setup = function(pars,coefs=NULL,fn,basisvals=NULL,var=c(1,0.01),fd.obj=NULL,
  more=NULL,times=NULL,quadrature=NULL,eps=1e-6,pos=0)
{

   if(!is.null(fd.obj)){                 # If an fd object is provided, it overrides
      basisvals = fd.obj$basis            # the basis and function values

      if(!is.null(fd.obj$coefs)){
        coefs = fd.obj$coefs
      }

      colnames = fd.obj$fdnames[[3]]
    }
    else{
      colnames = NULL
    }

    # observation likelihood:


    lik = make.multinorm()
    lik$more = c(make.id(),make.cvar())
    lik$more$f.more = NULL
    lik$more$v.more= list(mat=var[1]*diag(rep(1,2)),sub=matrix(0,0,3))
    lik$bvals= Matrix(eval.basis(times,basisvals),sparse=TRUE)
    if(length(dim(coefs))>2){
      if(is.null(colnames)){
        colnames = dimnames(coefs)[[3]]
      }
      nrep = dim(coefs)[2]
      coefs = matrix(coefs,dim(coefs)[1]*dim(coefs)[2],dim(coefs)[3])
    }
    else{
      nrep = 1
      colnames = colnames(coefs)
    }

 
    if(pos==0){proc = make.Dproc()}
    else {proc = make.exp.Dproc()}
    
    proc$more = make.multinorm()
    proc$more$qpts=quadrature$qpts
    proc$bvals= Matrix(eval.basis(times,basisvals),sparse=TRUE)
    if(is.list(fn)){
      proc$more$more = c(fn,make.cvar())
      proc$more$more$f.more = NULL
      proc$more$more$v.more = list(mat=var[2]*diag(rep(1,2)),sub=matrix(0,0,3))
      proc$more$eps = eps
      proc$more$more$more = more
    }
    else if(is.function(fn)){
      proc$more$more = c(make.findif.ode(),make.cvar())
      proc$more$more$fn = fn
      proc$more$more$more = more
    }
    else{
      stop('fn must be either a list of functions or a function')
    }

    proc$more$names = colnames
    proc$more$parnames = names(pars)


    if(is.basis(basisvals)){
      if(is.null(times)){
        stop('if basisvals is is a basis object, you must specify the observation times')
      }
    
      lik$bvals = Matrix(diag(rep(1,nrep)) %x% eval.basis(times,basisvals),sparse=TRUE)
      proc$bvals = Matrix(diag(rep(1,nrep)) %x% eval.basis(times,basisvals),sparse=TRUE)
      proc$more$qpts=times[1:(length(times)-1)]
    }
   else{                                   # quadrature is ignored if basisvals
                                            # is not a basis object
      lik$bvals = basisvals$bvals.obs

      proc$bvals = basisvals$bvals.obs
      proc$more$qpts = basisvals$qpts


    }

    return( list(lik=lik,proc=proc,coefs=coefs) )

}

### CONSTANT VARIANCE FUNCTIONS

    


make.cvar <- function()
{

cvar<-list()
cvar$var.fn<- function(t,y,p,more)  
{
    n = ncol(y)
    
    more = checkmore.cvar(more,n)
    pmat = 0*more$mat
    
    pmat[more$sub[,1:2]] = pmat[more$sub[,1:2]] + p[more$sub[,3]]
    
    if(nrow(pmat) > 1){
        pmat = pmat - diag(diag(pmat))
        pmat[more$sub[,c(2,1)]] = pmat[more$sub[,c(2,1)]] + p[more$sub[,3]]    
    }
    
    pmat = pmat + more$mat    
    
    return( array(pmat,c(1,dim(pmat))) )
}



cvar$var.dfdx <- function(t,y,p,more)
{
   if( !is.null(more$mat) ){ ny = nrow(more$mat) }
   else{ ny = ncol(y) }
   nx = ncol(y)
   
    return( array(0,c(1,ny,ny,nx)) )
}


cvar$var.dfdp <- function(t,y,p,more)
{
    n = ncol(y)

    more = checkmore.cvar(more,n)

    r = array(0,c(1,dim(more$mat),length(p)))
    
    ind = cbind(rep(1,2*dim(more$sub)[1]), rbind( more$sub, more$sub[,c(2,1,3)]) )

    r[ind] = 1
    
    return(r)
}


cvar$var.d2fdxdp <- function(t,y,p,more)
{
   if( !is.null(more$mat) ){ ny = nrow(more$mat) }
   else{ ny = ncol(y) }  
   nx = ncol(y)
   
    return( array(0,c(1,rep(ny,2),nx,length(p))) )
}

cvar$var.d2fdx2 <- function(t,y,p,more)
{
    if( !is.null(more$mat) ){ ny = nrow(more$mat) }
    else{ ny = ncol(y) }
    nx = ncol(y)
    
    return( array(0,c(1,ny,ny,nx,nx)) )
}


checkmore.cvar <- function(more,n)    # checks additional arguments to cvar
{
    if(is.null(more)){ more$sub = matrix(1:n,n,3) }    # default to diagonal covariance
    else{ 
        if(is.null(more$sub)){ more$sub = matrix(0,0,3) }
    }
    if(is.null(more$mat)){ 
        if(dim(more$sub)[1] == 0){ more$mat = diag(rep(1,n)) }
        else{ more$mat = matrix(0,n,n) }
    }
    
    return(more)
}

    
return(cvar) 
} 

make.logtrans <- function()
{

logtrans.fun <- function(times,y,p,more)
{ 
	  y = exp(y)
    x = more$fn(times,y,p,more$more)
    x = x/y

    return(x)
}

logtrans.dfdx <- function(times,y,p,more)
{                  
     x1 = logtrans.fun(times,y,p,more)
     y = exp(y)
     x = more$dfdx(times,y,p,more$more)
     

     for(i in 1:dim(x)[2]){
	     for(j in 1:dim(x)[3]){
		      x[,i,j] = x[,i,j]*y[,j]/y[,i]
        }
        x[,i,i] = x[,i,i] - x1[,i]
     }
     return(x)
}

logtrans.dfdp <- function(times,y,p,more)
{
     y = exp(y)
     x = more$dfdp(times,y,p,more$more)
    
     for(i in 1:dim(x)[2]){
        for(j in 1:dim(x)[3]){
            x[,i,j] = x[,i,j]/y[,i]
        }
     }
     return(x)
}

logtrans.d2fdx2 <- function(times,y,p,more)
{  
     x1 = logtrans.dfdx(times,y,p,more)
     y = exp(y)
     x = more$d2fdx2(times,y,p,more$more)
      
     for(i in 1:dim(x)[2]){
        for(j in 1:dim(x)[3]){
           for(k in 1:dim(x)[4]){
              x[,i,j,k] = x[,i,j,k]*y[,j]*y[,k]/y[,i]
           }
        }
     }
     
     for(i in 1:dim(x)[2]){
        for(j in 1:dim(x)[3]){
           
           x[,i,i,j] = x[,i,i,j] - x1[,i,j]
           
           x[,i,j,i] = x[,i,j,i] - x1[,i,j]
           x[,i,j,j] = x[,i,j,j] + x1[,i,j]
          
        }
     }

     return(x)
}

logtrans.d2fdxdp <- function(times,y,p,more)
{   
     x1 = logtrans.dfdp(times,y,p,more)
     y = exp(y)
     x = more$d2fdxdp(times,y,p,more$more)
     
     
      for(i in 1:dim(x)[2]){
        for(j in 1:dim(x)[3]){
           for(k in 1:dim(x)[4]){
		          x[,i,j,k] = x[,i,j,k]*y[,j]/y[,i]
           }
        }
     }
     
     for(i in 1:dim(x)[2]){
        for(j in 1:dim(x)[4]){
           x[,i,i,j] = x[,i,i,j] - x1[,i,j]
        }
     }

     return(x)
}



  more = list(fn = logtrans.fun,
    dfdx = logtrans.dfdx,
    dfdp = logtrans.dfdp,
    d2fdx2 = logtrans.d2fdx2,
    d2fdxdp = logtrans.d2fdxdp,
    extras = NULL)
}

# An example file fitting the FitzHugh-Nagumo equations to data in the
# new R Profiling Code. This will eventually be interfaced with the new R 
# "Partially Observed Markov Process (pomp)" class of objects. 

library(fda)
library(odesolve)
library(maxLik)
library(MASS)
library('Matrix')
library('SparseM')

source('../R/ProfileR.R')
source('../R/fhn.R')
source('../R/findif.ode.R')
source('../R/SSElik.R')
source('../R/SSEproc.R')
source('../R/makeid.R')
source('../R/makeexp.R')
source('../R/genlin.R')
source('../R/cvar.R')
source('../R/Multinorm.R')
source('../R/Cproc.R')
source('../R/exp.Cproc.R')
source('../R/multinorm.shortcut.R')
source('../R/sse.shortcut.R')
source('../R/inneropt.R')

###############################
####   Data Generation  #######
###############################

t = seq(0,20,0.05)

pars = c(0.2,0.2,3)
names(pars) = c('a','b','c')
x0 = c(-1,1)
names(x0) = c('V','R')
fhn = make.fhn()
y = lsoda(x0,times=t,func=fhn$fn.ode,pars)
y = y[,2:3]

data = y + 0.05*array(rnorm(802),dim(y))



###############################
####  Basis Object      #######
###############################

knots = seq(0,20,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,
	norder=norder,breaks=knots)


# Initial values for coefficients will be obtained by smoothing

fd.data = array(data,c(dim(data)[1],1,dim(data)[2]))

DEfd = data2fd(fd.data,t,bbasis,fdnames=list(NULL,NULL,c('V','R')) )

coefs = matrix(as.vector(DEfd$coefs),dim(DEfd$coefs)[1],dim(DEfd$coefs)[3])
colnames(coefs) = DEfd$fdnames[[3]]

###############################
####  Optimization Control  ###
###############################


control=list()                # Control parameters 
control$trace = 0
control$maxit = 1000
control$maxtry = 10
control$reltol = 1e-6
control$meth = "BFGS"

control.in = control
control.in$reltol = 1e-12
control.out = control
control.out$trace = 2

control.in$print.level = 0
control.in$iterlim = 1000

#################################
### Initial Parameter Guesses ###
#################################

profile.obj = sse.setup(pars=pars,coefs=coefs,fn=make.fhn(),basisvals=bbasis,lambda=10000,times=t)
lik = profile.obj$lik
proc= profile.obj$proc

pres = ParsMatchOpt(pars,coefs,proc)

npars = pres$pars

#############################################################
### If We Only Observe One State, We Can Re-Smooth Others ### 
#############################################################

tcoefs = coefs
tcoefs[,2] = 0

fres = FitMatchOpt(coefs=tcoefs,which=2,pars=pres$pars,proc)

ncoefs = fres$coefs

###############################
#### Parameter Optimization ###
###############################

spars = c(0.2,0.2,2)          # Perturbed parameters
names(spars)=names(pars)
lambda = 10000

### SSE Shortcuts ####

Ires1	= Smooth.sse(make.fhn(),data,t,pars=spars,coefs,bbasis,lambda=lambda,in.meth='nlminb',control.in=control.in)
  

Ores1 = Profile.sse(make.fhn(),data=data,times=t,pars=spars,coefs=coefs,basisvals=bbasis,lambda=lambda,in.meth='nlminb',out.meth='nls',
	control.in=control.in,control.out=control.out)
	

### SSE with ProfileErr ###


Ires2 = inneropt(data,times=t,pars,coefs,lik,proc,in.meth='nlminb',control.in)

Ores2 = outeropt(data=data,times=t,pars=pars,coefs=coefs,lik=lik,proc=proc,in.meth="nlminb",out.meth="nlminb",
    control.in=control.in,control.out=control.out)


### Multinorm ####

var = c(1,0.01)

Ires3 = Smooth.multinorm(make.fhn(),data,t,pars=spars,coefs,bbasis,var=var,in.meth='nlminb',control.in=control.in)

Ores3 = Profile.multinorm(make.fhn(),data,t,pars=spars,coefs,bbasis,var=var, 
  out.meth='nlminb', in.meth='nlminb',control.in=control.in,control.out=control.out)



# Lets look at the result

DEfd = fd(Ores1$coefs,bbasis)   # Data and reconstructed trajectory

par(mfrow=c(2,1))
 plotfit.fd(data,t,DEfd)
 

traj = as.matrix(Ores1$proc$bvals$bvals%*%Ores1$coefs)    # Look at how well the
colnames(traj) = Ores1$proc$more$names                    # derivative of the
dtraj = as.matrix(Ores1$proc$bvals$dbvals%*%Ores1$coefs)  # trajectory fits the 
ftraj = Ores1$proc$more$fn(t,traj,Ores1$pars)             # right hand side. 

matplot(dtraj,type='l',col=2)
matplot(ftraj,type='l',col=4,add=TRUE) 
 
 
Profile.covariance(pars=Ores1$pars,times=t,data=data,coefs=Ores1$coefs,
  lik=Ores1$lik,proc=Ores1$proc)
  
  
  

# This demonstration file is intended to accompany the CollocInfer manual. 

library(CollocInfer)

# To ensure reproducibility
set.seed((2004*2007)/2014)

# This file carrys out the analysis for the Rosenzweig-MacArthur model that is
# given in the manual. We assume that the reader is familiar with the FitzHugh-Nagumo
# example that is first developed in the manual, so we will focus on the elaborations
# that this model requires. 

# First, we write down the three-species Rosenzweig-Macarthur model in a form 
# suitable for CollocInfer

RosMac2 = function(t,x,p,more){

  p = exp(p)
  dx = x

  dx[,'C1'] = p['rho1']*x[,'C1']*(1- x[,'C1']/p['kappaC1']- x[,'C2']/p['kappaC2']) - p['pi']*p['gamma']*x[,'C1']*x[,'B']/(p['kappaB']+p['pi']*x[,'C1']+x[,'C2'])
  dx[,'C2'] = p['rho2']*x[,'C2']*(1- x[,'C1']/p['kappaC1']- x[,'C2']/p['kappaC2']) - p['gamma']*x[,'C2']*x[,'B']/(p['kappaB']+p['pi']*x[,'C1']+x[,'C2'])
  dx[,'B'] = p['chi']*p['gamma']*(p['pi']*x[,'C1']+x[,'C2'])*x[,'B']/(p['kappaB']+p['pi']*x[,'C1']+x[,'C2']) - p['delta']*x[,'B']

  return(dx)
}

# We will define some interesting parameters

RMpars = c(0.2,0.025,0.125,2.2e4,1e5,5e6,1,1e9,0.3)
RMParnames = c('pi','rho1','rho2','kappaC1','kappaC2','gamma','chi','kappaB','delta') 

# Which we represent on the log scale

logpars = log(RMpars)
names(logpars) = RMParnames

# And we also need some initial conditions (with named entries)

RMVarnames = c('C1','C2','B')

x0 = c(50,50,2)
names(x0) = RMVarnames

# The following version of RosMac2 is suitable for use with lsoda

RosMac2ODE = function(t,z,p){
  p = exp(p)
  x = exp(z)
  dx = x

  dx['C1'] = p['rho1']*x['C1']*(1- x['C1']/p['kappaC1']-x['C2']/p['kappaC2']) - p['pi']*p['gamma']*x['C1']*x['B']/(p['kappaB']+p['pi']*x['C1']+x['C2'])
  dx['C2'] = p['rho2']*x['C2']*(1- x['C2']/p['kappaC2']- x['C1']/p['kappaC1']) - p['gamma']*x['C2']*x['B']/(p['kappaB']+p['pi']*x['C1']+x['C2'])
  dx['B'] = p['chi']*p['gamma']*(p['pi']*x['C1']+x['C2'])*x['B']/(p['kappaB']+p['pi']*x['C1']+x['C2']) - p['delta']*x['B']

  return(list(dx/x))
}

# With this we can solve the ODE at 200 successive days
time = 0:200
res0 = lsoda(log(x0),time,RosMac2ODE,p = logpars)

# and plot the solutions
matplot(exp(res0[,2:4]),type='l')

# We'll obtain data by adding noise
data = res0[,2:4] + 0.2*matrix(rnorm(603),201,3)

# and name the columns
colnames(data) = RMVarnames

# Giving us the following plot
matplot(data,cex.lab=2.5,cex.axis=2.5,cex=1.5,xlab='days',pch = c('1','2','B'))
matplot(res0[,2:4],type='l',lwd=3,add=TRUE)


# Now we need to set up the CollocInfer machinery

# First we'll define a basis with knots each time point

rr = range(time)
knots = seq(rr[1],rr[2],by=1)

bbasis = create.bspline.basis(rr,norder=4,breaks=knots)

# And obtain an initial set of parameters and coefficients from smoothing

coef0 = smooth.basis(time,data,fdPar(bbasis,int2Lfd(2),10))$fd$coef
colnames(coef0) = RMVarnames

# We will now create the profiling objects, but use the log transformation by
# setting posproc=TRUE 

out = LS.setup(pars=logpars,coefs=coef0,basisvals=bbasis,fn=RosMac2,lambda=1e5,
          times=time,posproc=TRUE)
          
          
lik = out$lik
proc = out$proc

# We'll do gradient matching to get parameter estimates corresponding to this
# smooth

res1 = ParsMatchOpt(logpars,coef0,proc)

# And now profiling
res3 = outeropt(data,time,res1$pars,coef0,lik,proc)

# Let's have a look at the parameters that we got
exp(res3$pars)

# and the agreement with data and model
out3 = CollocInferPlots(res3$coefs,res3$pars,lik,proc,times=time,data=data,
                  cex.lab=2.5,cex.axis=2.5,cex=1.5,lwd=3)


## Now we will compliate the model. In reality, we only observe the sum of C1 
# and C2. 

data2 = cbind( log( exp(data[,'C1'])+exp(data[,'C2'])), data[,'B'])
matplot(data2,cex.lab=2.5,cex.axis=2.5,pch=c('C','B'),cex=1.5,xlab='days')

# To deal with this, we need to define a transformation function from our 
# state variables to the expected observations. In this case (since the states
# are on the log scale) we exponentiate to get back to the original scale, add
# C1 and C2 and then take the log again. 
RMobsfn = function(t,x,p,more)
{
  x = exp(x)
  y = cbind( x[,'C1']+x[,'C2'],x[,'B'])
  return(log(y))
}

# We can now create new profiling objects that incorporate this transformation
# function by specfying likfn

out = LS.setup(pars=logpars,coefs=coef0,basisvals=bbasis,fn=RosMac2,lambda=1e5,
          times=time,posproc=TRUE,likfn=RMobsfn)
          
lik2 = out$lik
proc2 = out$proc

# To see how we perform in this situation, we'll start by setting the two 
# columns of the data smooth to zero

coef02 = coef0
coef02[,1:2] = 0

# We'll now pull these columns into line with the rotifer column (which we can
# still smooth. 

Fres3 = FitMatchOpt(coef02,1:2,res1$pars,proc2)

# And we'll run profiling and have a look at what we get. 
res32 = outeropt(data2,time,res1$pars,Fres3$coefs,lik2,proc2)
exp(res32$pars)
out32 = CollocInferPlots(res32$coefs,res32$pars,lik2,proc2,times=time,data=data2,
                  datanames=c('C','B'),cex.lab=2.5,cex.axis=2.5,cex=1.5,lwd=3)

# The section at the end of this demo goes through setting up lik2 and proc2
# manually rather than through LS.setup. 


### In this framework is is not unreasonable to expect that we have
# repeated experiments. When these are very well structured and all have common
# observation times, this can be easily accommodated in CollocInfer (it can 
# accommodate less regular replicated experiments, but requires work to set things
# up manuall. 

# We'll create a second experiment starting from new initial conditions

x03 = c(15,25,4)
names(x03) = RMVarnames

res03 = lsoda(log(x03),time,RosMac2ODE,p = logpars)

data03 =  res03[,2:4] + 0.2*matrix(rnorm(603),201,3)

# and set up a three dimensional array in which the experiment number is the
# second dimension and the third dimension is the variable being measured (this
# is to agree with conventions in the fda package)

alldat = array(0,c(201,2,3))
alldat[,1,] = data
alldat[,2,] = data03

# Nowe we'll smooth the second experiment

coef3 = smooth.basis(time,data03,fdPar(bbasis,int2Lfd(2),10))$fd$coef

# and create a three-dimensional array with all the coefficients together

coefs = array(0,c(dim(coef3)[1],2,3))
coefs[,1,] = coef0
coefs[,2,] = coef3

# These three dimensional arrays can be given to LSsetup which understands
# thi structure and knows what to do with it. 

out = LS.setup(pars=logpars,coefs=coefs,basisvals=bbasis,fn=RosMac2,lambda=1e5,
          times=time,data=alldat,posproc=TRUE,names=RMVarnames)
          
          
lik3 = out$lik
proc3 = out$proc

# We can now call the inner optimisation to use a model-based smooth
res13 = inneropt(data=out$data,times=out$times,pars=res1$pars,coefs=out$coefs,lik=lik3,proc=proc3)

# And use profiling to estimate parameters
res33 = outeropt(data=out$data,times=out$times,res1$pars,res13$coefs,lik3,proc3)

# These parameters should hopefully be closer to the truth than with only one experimental run
exp(res33$pars)

# And we can also examine the fit to the data and model. In this case, the times vector
# wraps around creating a few unpleasant graphical effects. 

out3 = CollocInferPlots(res33$coefs,res33$pars,lik3,proc3,times=out$times,data=out$data,datanames=c('B','C'),
                  cex.lab=2.5,cex.axis=2.5,cex=1.5,lwd=3)



###### Manual set-up

# Here we create lik2 and proc2 (corresponding to the indirectly observed 
# single-run experiment above in order to demonstrate their structure. 

# First we need to specify the matrices of basis values that we will use

# at observation time points
bvals.obs = eval.basis(time,bbasis)

# and quadrature times, these are midpoints between knots plus the end points
# The quadrature weights are all equal, but we have multiplied them by the lambda
# that we are using, in this case 1e5. 

qpts = c(knots[1],knots[1:(length(knots)-1)]+diff(knots)/2,knots[length(knots)])
qwts = 1e5*matrix(1,length(qpts),3)/length(qpts)

# basis values for proc is a list

bvals.quad = list(bvals  = eval.basis(qpts,bbasis), 
                  dbvals = eval.basis(qpts,bbasis,1))


# Now we create the lik object

# make.SSElik() sets up the squared error criteria
lik.m = make.SSElik()

# Attach the values of the basis expansion at the observation time points
lik.m$bvals = bvals.obs

# We need to specify the transformation of the state variables that is to be
# compared with the data. In this case, we will use finite differencing to 
# to compute the derivatives that we need; we can achieve this by first 
# employing make.findif.ode()
lik.m$more = make.findif.ode()

# and then telling findif.ode that the function it is finite differencing is
# RMobsfn
lik.m$more$more = list(fn = RMobsfn,eps=1e-6,more=NULL) 

# We also need to give lik.m a set of weights. This has to occur in 
# the more element of lik.m because it is used inside lik.m$fn. 
lik.m$more$weights = array(1,dim(data))


# We can also create the proc object manually. First we call make.SSEproc()
# in order to set up the squared error functions
proc.m = make.SSEproc()

# We also specify the basis values and their derivatives at the quadrature points
proc.m$bvals = bvals.quad

# Now we need to tell SSEproc about the right hand side of the ODE and its
# derivatives. Here we will use finite differencing again, as in lik.m:
proc.m$more = make.findif.ode()

# In fact, we are going to finite difference the right hand side of the 
# the ODE for the log transformed data. Here we specify the log transform
proc.m$more$more = list(fn = make.logtrans()$fn,eps=1e-6)

# and then give it the (non log-transform) Rosenzweig-MacArthur equations
proc.m$more$more$more$fn = RosMac2

# proc.m$more also needs to include some elements for internal processing. In 
# particular the following specify the quadrature points and weights
proc.m$more$weights = qwts
proc.m$more$qpts = qpts

# We will also tell it about the parameter and variable names. 
proc.m$more$parnames = RMParnames
proc.m$more$names = RMVarnames



# And let's check that this all works

Fres.m3 = FitMatchOpt(coef02,1:2,res1$pars,proc.m)
res.m32 = outeropt(data2,time,res1$pars,Fres3$coefs,lik2,proc.m)
exp(res.m32$pars)
out.m32 = CollocInferPlots(res.m32$coefs,res.m32$pars,lik.m,proc.m,times=time,data=data2)

# If you compare this to out32, you should have the same estimates. 

\name{FitMatch.rep}
\alias{FitMatchErr.rep}
\alias{FitMatchDC.rep}
\alias{FitMatchDC2.rep}
\title{Estimating Hidden States}
\description{Estimating hidden states of repeated processes to maximize agreement with the process.  }
\useage{
FitMatchErr.rep(coefs,allcoefs,which,pars,whichpars,proc,sgn=1)
FitMatchDC.rep(coefs,allcoefs,which,pars,whichpars,proc,sgn=1)
FitMatchDC2.rep(coefs,allcoefs,which,pars,whichpars,proc,sgn=1)
}
\arguments{
\item{coefs}{ Vector giving the current estimate of the coefficients for the hidden states. }
\item{allcoefs}{ Matrix giving the coefficients of all the states including initial values for \code{coefs}.} 
\item{which}{  Vector of indices of states to be estimated. }
\item{pars}{ Parameters to be used for the processes. }
\item{whichpars}{ A list of length the number of replicates, each elements specifies the indices of the vector \code{pars} that correspond to that replicate; defaults to the whole vector applying to each replicate. }
\item{proc}{ \code{proc} object defining the state process. }
\item{sgn}{ Is the minimizing (1) or maximizing (0)? }
}
\value{
\item{FitMatchErr.rep}{The value of the process likelihood at the current estimated states.}
\item{FitMatchDC.rep}{The derivative fo \code{FitMatchErr.rep} with respect to the elements \code{coefs} for the states being estimated.}
\item{FitMatchDC2.rep}{The second derivative fo \code{FitMatchErr.rep} with respect to the elements \code{coefs} for the states being estimated.}
}
\details{}
\seealso{}
\examples{}

\name{DE2x}
\alias{DE2x}
\title{Solve ODEs}
\description{ Solve the differential equation given in \code{proc$more$fn} }
\usage{
DE2x(y0,times,pars,proc)
}
\arguments{
\item{y0}{ Vector of initial conditions for the ODE.  }
\item{times}{ Vector of time points to evaluate the ODE.  }
\item{pars}{ Vector of parameters } 
\item{proc}{  \code{proc} object for the system }
}
\value{
A matrix giving the value of the states at each time point. 
}
\details{This is a wrapper function for \code{lsoda}.}
\seealso{forward.prediction.error}
\examples{
##################################################################
#### Set up lik and proc objects for FitzHugh-Nagumo System  #####
##################################################################

data(FhNdata)

knots = seq(0,20,0.2)
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range(FhNtimes),nbasis=nbasis,
	norder=norder,breaks=knots)

coefs = matrix(0,bbasis$nbasis,2)
colnames(coefs) = FhNvarnames

profile.obj = LS.setup(pars=FhNpars,coefs=coefs,fn=make.fhn(),basisvals=bbasis,lambda=1000,times=FhNtimes)
lik = profile.obj$lik
proc= profile.obj$proc

##############################################################
### Now we can call the ODE solver and compare to the data ###
##############################################################

y0 = c(-1,1)
x = DE2x(y0,FhNtimes,FhNpars,proc)

matplot(FhNtimes,FhNdata)
matplot(FhNtimes,x,type='l',add=TRUE)

}

\name{Colloc.MCMC}
\alias{Colloc.MCMC}
\title{Bayesian MCMC for Collocation Inference}
\description{ An MCMC algorithm for Collocation Inference  }
\usage{
Colloc.MCMC(times,data,pars,coefs,lik,proc,prior,walk.var,
  nstep,in.meth='house',control.in=NULL)
}
\arguments{
  \item{times}{ Vector observation times for the data.}
  \item{data}{  Matrix of observed data values. }
    \item{pars}{ Initial values of parameters to be estimated processes. }
  \item{coefs}{ Vector giving the current estimate of the coefficients in the spline. }
  \item{lik} { \code{lik} object defining the observation process. }
  \item{proc}{ \code{proc} object defining the state process. }
  \item{niter}{ Number of MCMC steps to take. }
  \item{walk.var}{ Random walk variance for parameters. }
  \item{in.meth}{ Inner optimization function to be used, currently one of 'nlminb', 'MaxNR', 'optim' or 'house'.
    The last calls \code{SplineEst.NewtRaph}. This is fast but has poor convergence.  }
  \item{control.in}{ Control object for inner optimization functions. }
}
\value{
    \item{parhist}{The Markov chain history of the parameters}
    \item{coefhist}{The Markov chain history of the coefficients. }
  }
}
\details{
The MCMC algorithm proceeds by taking a mean-zero Gaussian random walk step in the 
parameter space, minimizes  the inner optimization in coefficients and then takes a random
walk in coefficient space with variance given by the second derivative matrix of the 
inner optimization. 
}
\seealso{sse.setup, multinorm.setup, Profile.sse, Profile.multinorm, inneropt}
\examples{}

\name{setup}
\alias{setup}
\alias{LS.setup}
\alias{multinorm.setup}
\alias{SRK2.setup}
\title{Setup Functions for proc and lik objects}
\description{These functions set up lik and proc objects of squared error
and multinormal processes.}
\usage{
LS.setup(pars,coefs=NULL,fn,basisvals=NULL,lambda,fd.obj=NULL,
        more=NULL,data=NULL,weights=NULL,times=NULL,quadrature=NULL,eps=1e-6,
        pos=0,discrete=0,names=NULL)

multinorm.setup(pars,coefs=NULL,fn,basisvals=NULL,var=c(1,0.01),fd.obj=NULL,
        more=NULL,data=NULL,times=NULL,quadrature=NULL,eps=1e-6,pos=0,discrete=0,names=NULL)
}
\arguments{
\item{pars}{ Initial values of parameters to be estimated processes. }
\item{coefs}{ Vector giving the current estimate of the coefficients in the spline. }
\item{fn}{ A function giving the right hand side of a differential/difference equation.  The function should have arguments
\itemize{
  \item{times}{The times at which the RHS is being evaluated.}
  \item{x}{The state values at those times.}
  \item{p}{Parameters to be entered in the system.}
  \item{more}{An object containing additional inputs to \code{fn} }}
It should return a matrix of the same dimension of \code{x} giving the right hand side values.

If \code{fn} is given as a single function, its derivatives are estimated by finite-differencing with
stepsize \code{eps}. Alternatively, a list can be supplied with elements:
\itemize{
  \item{fn}{Function to calculate the right hand side should accept a matrix of state values at .}
  \item{dfdx}{Function to calculate the derivative with respect to \code{x}}
  \item{dfdp}{Function to calculate the derivative with respect to \code{p}}
  \item{d2fdx2}{Function to calculate the second derivative with respect to \code{x}}
  \item{d2fdxdp}{Function to calculate the second derivative with respect to \code{x} and \code{p}
}}
These functions take the same arguments as \code{fn} and should output multidimensional arrays with
the dimensions ordered according to time, state, deriv1, deriv2; here derivatives with respect to \code{x}
always precede derivatives with respect to \code{p}. }
\item{basisvals}{Values of the collocation basis to be used. This can either be a basis object from the \code{fda} package,
or a list elements:
\itemize{
  \item{bvals.obs}{A matrix giving the values of the basis at the observation times}
  \item{bvals}{A matrix giving the values of the basis at the quadrature times}
  \item{dbvals}{A matrix giving the derivative of the basis at the quadrature times}
}
For discrete systems, it may also be specified as a matrix, in which case \code{bvals$bvals} is obtained by deleting the last row
and \code{bvals$dbvals} is obtained by deleting the first/  

If left as NULL, it is taken from \code{fd.obj} for \code{discrete = 0} and defaults to an identity matrix
of the same dimension as the number of observations for \code{discrete=1} systems. 
}
\item{lambda}{(\code{LS.setup} only) Penalty value trading off fidelity to data with fidelity to differential equations.}
\item{var}{(\code{profile.Cproc} or \code{profile.Dproc}) A vector of length 2, giving  }
\item{fd.obj}{(Optional) A functional data object; if this is non-null, \code{coefs} and \code{basisvals} is extracted from here. }
\item{more}{An object specifying additional arguments to \code{fn}. }
\item{data}{The data to be used, this can be a matrix, or a three-dimensional array. If the latter, the middle
dimension is taken to be replicates. The data are returned, if replicated they are returned in a concatenated form.}
\item{weights}{(\code{LS.setup} only)  }
\item{times}{ Vector observation times for the data. If the data are replicated, times are returned in a concatenated form.}
\item{quadrature}{ Quadrature points, should contain two elements (if not NULL)
\itemize{
  \item{qpts}{Quadrature points; defaults to midpoints between knots}
  \item{qwts}{Quadrature weights; defaults to normalizing by the length of \code{qpts}.   } 
}}
\item{eps}{ Finite differencing step size, if needed. }
\item{pos}{ Should the state vector be constrained to be positive? If this is the case, the state is represented by
an exponentiated basis expansion. }
\item{discrete}{ Is this a discrete or continuous-time system?}
\item{names}{ The names of the state variables if not given by the column names of \code{coefs}.}
}
\value{A list with elements
\item{coefs}{Starting values for \code{coefs}}
\item{lik}{The \code{lik} object generated}
\item{proc}{The \code{proc} item generated}
\item{data}{The data matrix, concatenated if from a 3d array.}
\item{times}{The vector of observation times, concatenated if data is a 3d array.}
}
\details{These functions provide basic setup utilities for the collocation inference methods. They define
\code{lik} and \code{proc} objects for sum of squared errors and multivariate normal log likelihoods with
nonlinear transfer functions describing the evolution of the state vector.
\itemize{
  \item{LS.setup}{Creates sum of squares functions}
  \item{multinorm.setup}{Creates multinormal log likelihoods for a continuous-time system.}
}}
\seealso{inneropt, outeropt, Profile.LS, Profile.multinorm, Smooth.LS, Smooth.multinorm}
\examples{

# FitzHugh-Nagumo

t = seq(0,20,0.05)            # Observation times

pars = c(0.2,0.2,3)           # Parameter vector
names(pars) = c('a','b','c')

knots = seq(0,20,0.2)         # Create a basis
norder = 3
nbasis = length(knots) + norder - 2
range = c(0,20)

bbasis = create.bspline.basis(range=range,nbasis=nbasis,norder=norder,breaks=knots)

lambda = 10000               # Penalty value

coefs = matrix(0,nbasis,2)   # Coefficient matrix

profile.obj = LS.setup(pars=pars,coefs=coefs,fn=make.fhn(),basisvals=bbasis,lambda=lambda,times=t)


# Using multinorm

var = c(1,0.01)

profile.obj = multinorm.setup(pars=pars,coefs=coefs,fn=make.fhn(),basisvals=bbasis,var=var,times=t)


# Henon - discrete

hpars = c(1.4,0.3)
t = 1:200

coefs = matrix(0,200,2)
lambda = 10000

profile.obj = LS.setup(pars=hpars,coefs=coefs,fn=make.Henon(),basisvals=NULL,lambda=lambda,times=t,discrete=1)

}

\name{EM.rep}
\alias{EM.rep}
\alias{Qfn.rep}
\title{EM-Estimation from Collocation Inference}
\description{ EM algorithm for collocation estimation of parameters in repeated continuous-time
stochastic processes.  }
\useage{
EM.rep(pars,times,data,coefs,lik,proc,niter=10,control.in,tfn=NULL,active=1:length(pars),whichpars)
Qfn.rep(pars,times,data,coefs,lik,proc,oldpars,tfn=NULL,active=1:length(pars),whichpars)
}
\arguments{
\item{pars}{ Initial values of parameters to be estimated processes. }
\item{times}{ Vector observation times for the data.} 
\item{data}{  Matrix of observed data values. }
\item{coefs}{ Vector giving the current estimate of the coefficients in the spline. }
\item{lik} { \code{lik} object defining the observation process. }
\item{proc}{ \code{proc} object defining the state process. }
\item{niter}{ Number of EM steps to take. }
\item{control.in}{ Control object for inner optimization functions. }
\item{tfn}{ Name of a transformation function for parameters. }
\item{active}{ Incides indicating which parameters of \code{pars} should be estimated; defaults to all of them.  } 
\item{oldpars}{ Starting parameter values for the Q-function in the EM algorithm.}
\item{whichpars}{ A list of length the number of replicates, each elements specifies the indices of the vector \code{allpar} that correspond to that replicate; defaults to the whole vector applying to each replicate. }
}
\value{
  \item{Qfn.rep}{Returns the value of the Q-function in the Laplace-EM algorithm; entered into EM}
  \item{EM.rep}{Returns the result of the EM algorithm after \code{niter} steps. It results in a list
    \item{Pres}{Optimization with respect to \code{pars[active]}}
    \item{Cres}{Optimization with respect to \code{coefs}}
  }
}
\details{The Laplace-EM algorith proceeds by laplace approximations to the distribution of
\code{coefs} given \code{pars}. That is, we maximize the complete-data log likelihood for \code{coefs} and then
approximate this log likelihood with a second-order Taylor expansion about \code{coefs} at the maximizing value. The iteration has
the following steps

1. \code{C} = argmin \code{CDLL(pars,coefs)} = argmin \code{lik(pars,coefs)} + \code{proc(pars,coefs)}
2. \code{Qfn.rep(pars,newpars)} =  \code{CDLL(pars,C)} + [d2\code{CDLL(pars,C)}/d\code{C}2]\[d2\code{CDLL(newpars,C)}/d\code{C}2]
3. \code{newpars} = argmin \code{Qfn.rep(pars,newpars)}
}
\seealso{}
\examples{}

\name{ParsMatch.rep}
\alias{ParsMatchErr.rep}
\alias{ParsMatchDP.rep}
\title{Estimate of Parameters from Smooth}
\description{ Objective function and derivatives to estimate parameters with a fixed smooth of repeated processes.  }
\useage{
ParsMatchErr.rep(pars,coefs,proc,active=1:length(pars),allpars,whichpars,sgn=1)
ParsMatchDP.rep(pars,coefs,proc,active=1:length(pars),allpars,whichpars,sgn=1)
}
\arguments{
\item{pars}{ Initial values of parameters to be estimated processes. }
\item{coefs}{ Vector giving the current estimate of the coefficients in the spline. }
\item{proc}{ \code{proc} object defining the state process. }
\item{active}{ Incides indicating which parameters of \code{allpar} should be estimated; defaults to all of them.  } 
\item{allpar}{  Vector of all parameters, the assignment \code{allpar[active]=pars} is made initially.   }
\item{whichpars}{ A list of length the number of replicates, each elements specifies the indices of the vector \code{allpar} that correspond to that replicate; defaults to the whole vector applying to each replicate. }
\item{sgn}{ Is the minimizing (1) or maximizing (0)? }
}
\value{
\item{ParsMatchErr.rep}{The value of the process likelihood at the current estimated states.}
\item{ParsMatchDP.rep}{The derivative fo \code{ParsMatchErr.rep} with respect to \code{pars[active]}.}
}
\details{}
\seealso{}
\examples{}

\name{SplineEst.rep}
\alias{SplineEst.NewtRaph.rep}
\alias{SplineCoefsList.rep}
\alias{SplineCoefsErr.rep}
\alias{SplineCoefsDC.rep}
\alias{SplineCoefsDP.rep}
\alias{SplineCoefsDC2.rep}
\alias{SplineCoefsDCDP.rep}
\title{Spline Estimation Functions for Repeated Processes}
\description{Model-based smoothing; estimation,  objective criterion and derivatives. }
\useage{
SplineEst.NewtRaph.rep(coefs,times,data,lik,proc,pars,whichpars,control=list(reltol=1e-12,maxit=1000,maxtry=10,trace=0))  
SplineCoefsList.rep(coefs,times,data,lik,proc,pars,whichpars,sgn=1)
SplineCoefsErr.rep(coefs,times,data,lik,proc,pars,whichpars,sgn=1)
SplineCoefsDC.rep(coefs,times,data,lik,proc,pars,whichpars,sgn=1)
SplineCoefsDP.rep(coefs,times,data,lik,proc,pars,whichpars,sgn=1)
SplineCoefsDC2.rep(coefs,times,data,lik,proc,pars,whichpars,sgn=1)
SplineCoefsDCDP.rep(coefs,times,data,lik,proc,pars,whichpars,sgn=1)
}
\arguments{
\item{coefs}{ Vector giving the current estimate of the coefficients in the spline. }
\item{times}{ Vector observation times for the data.} 
\item{data}{  Matrix of observed data values. }
\item{lik} { \code{lik} object defining the observation process. }
\item{proc}{ \code{proc} object defining the state process. }
\item{pars}{ Parameters to be used for the processes. }
\item{whichpars}{ A list of length the number of replicates, each elements specifies the indices of the vector \code{pars} that correspond to that replicate; defaults to the whole vector applying to each replicate. }
\item{sgn}{ Is the minimizing (1) or maximizing (0)? }
\item{control}{ A list giving control parameters for Newton-Raphson optimization. It should contain
  \item{reltol}{ Relative tollerance criterion for the gradient and improvement before termination. }
  \item{maxit}{ Maximum number of iterations. }
  \item{maxtry}{ Maximum number of halving-steps to try before declaring no improvement is possible. }
  \itme{trace}{ How much iteration history to output; 0 surpresses all output, a positive value outputs parameters and improvement at each 
iteration. }
}
}
\value{
\item{SplineEst.NewtRaph.rep}{Returns a list that is the result of the optimization with elements
  \item{value}{The final objective criterion.}
  \item{coefs}{The optimizing value of the coefficients.}
  \item{g}{The gradient at the optimizing value.}
  \item{H}{The Hessian at the optimizing value.}
}
\item{SplineCoefsList.rep}{Collates the gradient calculations and returns a list with elements
  \item{value}{Output of \code{SplineCoefsErr.rep}}
  \item{gradient}{Output of \code{SplineCoefsDC.rep}}
  \item{Hessian}{Output of \code{SplineCoefsDC2.rep}}
}
\item{SplineCoefsErr.rep}{The complete data log likelihood for the smooth; the inner optimization objective. }
\item{SplineCoefsDC.rep}{The derivative fo \code{SplineCoefsErr.rep} with respect to \code{coefs}.}
\item{SplineCoefsDP.rep}{The derivative fo \code{SplineCoefsErr.rep} with respect to \code{pars}.}
\item{SplineCoefsDC2.rep}{The second derivative fo \code{SplineCoefsErr.rep} with respect to \code{coefs}.}
\item{SplineCoefsDCDP.rep}{The second derivative fo \code{SplineCoefsErr.rep} with respect to \code{coefs} and \code{pars}.}
The output of gradients is in terms of an array with dimensions corresponding to derivatives. Derivatives with with respect to coefficients
are given in dimensions before those that give derivatives with respect to parameters.
}
\details{\code{SplineEst.NewtRaph.rep} performs a simple Newton-Raphson estimate for the optimal value of the coefficients.
This estimate lacks the convergence checks of other estimation packages, but may yeild a fast solution when needed.}
\seealso{}
\examples{}

\name{Profile.rep}
\alias{Profile.GausNewt.rep}
\alias{ProfileSSE.rep}
\alias{ProfileErr.rep}
\alias{ProfileDP.rep}
\alias{ProfileErr.AllPar.rep}
\alias{ProfileDP.AllPar.rep}
\title{Profile Estimation with Collocation Inference}
\description{ Profile estimation and objective functions for collocation estimation of parameters in repeated continuous-time
stochastic processes.  }
\useage{
Profile.GausNewt.rep(pars,times,data,coefs,lik,proc,in.meth='nlminb',control.in=NULL,active=1:length(pars),control=list(reltol=1e-6,maxit=50,maxtry=15,trace=1)) 
ProfileSSE.rep(pars,times,data,coefs,lik,proc,whichpars,in.meth='nlminb',control.in=NULL,dcdp=NULL,oldpars=NULL,use.nls=TRUE,sgn=1)   
ProfileErr.rep(pars,allpars,times,data,coefs,lik,proc,whichpars,in.meth = "house",control.in=NULL,sgn=1,active=1:length(allpars))
ProfileDP.rep(pars,allpars,times,data,coefs,lik,proc,whichpars,in.meth = "house",control.in=NULL,sgn=1,sumlik=1,active=1:length(allpars)) 
ProfileErr.AllPar.rep(pars,times,data,coefs,lik,proc,whichpars,in.meth = "house",control.in=NULL,sgn=1)
ProfileDP.AllPar.rep(pars,times,data,coefs,lik,proc,whichpars,in.meth=NULL,control.in=NULL,sgn=1,sumlik=1)
}
\arguments{
\item{pars}{ Initial values of parameters to be estimated processes. }
\item{times}{ Vector observation times for the data.} 
\item{data}{  Matrix of observed data values. }
\item{coefs}{ Vector giving the current estimate of the coefficients in the spline. }
\item{lik} { \code{lik} object defining the observation process. }
\item{proc}{ \code{proc} object defining the state process. }
\item{whichpars}{ A list of length the number of replicates, each elements specifies the indices of the vector \code{allpar} that correspond to that replicate; defaults to the whole vector applying to each replicate. }
\item{in.meth}{ Inner optimization function currently one of 'nlminb', 'MaxNR', 'optim' or 'house'. The last calls \code{SplineEst.NewtRaph}. This is fast but has poor convergence.  }
\item{control.in}{ Control object for inner optimization function. }
\item{sgn}{ Is the minimizing (1) or maximizing (0)? }
\item{active}{ Incides indicating which parameters of \code{pars} should be estimated; defaults to all of them.  } 
\item{oldpars}{ Starting parameter values for the Q-function in the EM algorithm.}
\item{dcdp}{ Estimate for the gradient of the optimized coefficients with respect to parameters; used internally.  }
\item{use.nls}{ In ProfileSSE, is 'nls' being used in the outer-optimization?}
\item{sumlik}{ In ProfileDP and ProfileDP.AllPar; should the gradient be given for each observation, or summed over them? }
\item{control}{ A list giving control parameters for Newton-Raphson optimization. It should contain
  \item{reltol}{ Relative tollerance criterion for the gradient and improvement before termination. }
  \item{maxit}{ Maximum number of iterations. }
  \item{maxtry}{ Maximum number of halving-steps to try before declaring no improvement is possible. }
  \itme{trace}{ How much iteration history to output; 0 surpresses all output, a positive value outputs parameters and improvement at each 
iteration. }
}
\value{
\item{Profile.GausNewt.rep}{Output of a simple Gaus-Newton iteration to optimizing the objective function when the
observation likelihood takes the form of a sum of squared errors. Returns a list with the following elements:
  \item{pars}{The optimized value of the parameters.}
  \item{in.res}{The result of the inner optimization.}
  \item{value}{The value of the optimized sum of squared errors.}
}
\item{ProfileSSE.rep}{Output for the outer optimization when the observation likelihood is given by squared error. This is a list
with the following elements
  \item{f}{The value of the outer optimization criterion.}
  \item{df}{The derivative of \code{f} with respect to \code{pars}.}
  \item{coefs}{The optimized value of \code{coefs} for the current value of \code{pars}.}
  \item{dcdp}{The derivative of the optimized value of \code{coefs} at the current value of \code{pars}.}
}
\item{ProfileErr.rep}{The outer optimization criterion in the general case: the value of the observation likelihood at the profiled
estimates of \code{coefs}.}
\item{ProfileDP.rep}{The derivative of \code{ProfileErr.rep} with respect to \code{allpars[active]}.}
}
\details{ \code{Profile.GausNewt.rep} provides a simple implementation of Gauss-Newton optimization and may
not result in optimized values that are as good as other optimizers in \code{R}.

When \code{Profile.GausNewt.rep} is not being used, \code{ProfileSEE.rep} and \code{ProfileERR.rep} create the
following temporary files:
\item{counter.tmp}{The number of halving-steps taken on the current optimization step.}
\code{curcoefs.tmp}{The current estimates of the coefficients.}
\code{optcoefs.tmp}{The optimal estimates of the coefficients in the iteration history.}
These need to be removed manually when the optimization is finished. \code{optcoefs.tmp} will contain
the optimal value of \code{coefs} for plotting the estimated trajectories.
}
\seealso{}
\examples{}

\name{profile.covariance.rep}
\alias{profile.covariance.rep}
\title{profile.covariance.rep}
\description{ Newey-West estimate of covariance of parameter estimates from profiling for repeated processes. }
\useage{
profile.covariance.rep(pars,active=NULL,times,data,coefs,lik,proc,whichpars,in.meth,control.in,eps=1e-6)
}
\arguments{
\item{pars}{ Initial values of parameters to be estimated processes. }
\item{active}{ Incides indicating which parameters of \code{pars} should be estimated; defaults to all of them.  } 
\item{times}{ Vector observation times for the data.} 
\item{data}{  Matrix of observed data values. }
\item{coefs}{ Vector giving the current estimate of the coefficients in the spline. }
\item{lik} { \code{lik} object defining the observation process. }
\item{proc}{ \code{proc} object defining the state process. }
\item{whichpars}{ A list of length the number of replicates, each elements specifies the indices of the vector \code{allpar} that correspond to that replicate; defaults to the whole vector applying to each replicate. }
\item{in.meth}{ Inner optimization function currently one of 'nlminb', 'MaxNR', 'optim' or 'house'. The last calls \code{SplineEst.NewtRaph}. This is fast but has poor convergence.  }
\item{control.in}{ Control object for inner optimization functions. }
\item{eps}{ Step-size for finite difference estimate of second derivatives.  }
}
\value{Returns a Newey-West estimate of the covariance matrix of the parameter estimates. }
\details{Currently assumes a lag-5 auto-correlation among observation vectors. }
\seealso{}
\examples{}

\name{make.proc}
\alias{make.Dproc}
\alias{make.Cproc}
\alias{make.SSEproc}
\alias{make.RSK2proc}
\title{Process Distributions}
\description{Functions to define process distributions in the collocation inference package.}
\usage{
make.Dproc()

make.Cproc()

make.SSEproc()

make.RSK2proc()
}
\arguments{}
\value{A list of functions that the process distribution
\item{make.Cproc}{ creates functions to evaluate the distribution of the derivative of
the state vector given the current state for continuous-time systems.  }       
\item{make.Dproc}{ creates functions to evaluate the distribution of the next time point of
the state vector given the current state for discrete-state systems.  }
\item{make.SSEproc}{ treats the distribution of the derivative as an independent gaussian and
cacluates weighted sums of squared errors between derivatives and the prediction from the current state.}
\item{make.RSK2proc}{ calculates the order-2 stochastic Runge-Kutta penalty to provide higher-order numerical
convergence rates for SDEs.}
}
\details{All functions require \code{more} to specify this distribution. This should be a list containing
\itemize{
\item{\code{fn}}{ The distribution specified.}
\item{\code{dfdx}}{ The derivative of \code{fn} with respect to states.}
\item{\code{dfdp}}{ The derivative of \code{fn} with respect to parameters. }
\item{\code{d2fdx2}}{ The second derivative of \code{fn} with respect to states.}
\item{\code{d2fdxdp}}{ The cross derivative of \code{fn} with respect to states and parameters.}
}
For \code{Cproc} and \code{Dproc} this should specify the distribution; for \code{SSEproc} and \code{SRK2proc} it
should specify the right hand side of a differential equation. 
}
\seealso{LS.setup, multinorm.setup, SRK2.setup}
\examples{

# FitzHugh-Nagumo Equations

proc = make.SSEproc()
proc$more = make.fhn()

# Henon Map

proc = make.Dproc()
proc$more = make.Henon


# SEIR with multivariate normal transitions

proc = make.Cproc()
proc$more = make.multinorm()
proc$more$more = c(make.SEIR(),make.var.SEIR())

}

\name{EM}
\alias{EM}
\alias{Qfn}
\title{EM-Estimation for Collocation Inference}
\description{ EM algorithm for collocation estimation of parameters in continuous-time
stochastic processes.  }
\usage{
EM(pars,times,data,coefs,lik,proc,niter=10,
    in.meth,control.in,tfn=NULL,active=1:length(pars))

Qfn(pars,times,data,coefs,lik,proc,oldpars,
    tfn=NULL,active=1:length(pars))
}
\arguments{
  \item{pars}{ Initial values of parameters to be estimated processes. }
  \item{times}{ Vector observation times for the data.}
  \item{data}{  Matrix of observed data values. }
  \item{coefs}{ Vector giving the current estimate of the coefficients in the spline. }
  \item{lik} { \code{lik} object defining the observation process. }
  \item{proc}{ \code{proc} object defining the state process. }
  \item{niter}{ Number of EM steps to take. }
  \item{in.meth}{ Inner optimization function to be used, currently one of 'nlminb', 'MaxNR', 'optim' or 'house'.
    The last calls \code{SplineEst.NewtRaph}. This is fast but has poor convergence.  }
  \item{control.in}{ Control object for inner optimization functions. }
  \item{tfn}{ Name of a transformation function for parameters. }
  \item{active}{ Incides indicating which parameters of \code{pars} should be estimated; defaults to all of them.  }
  \item{oldpars}{ Starting parameter values for the Q-function in the EM algorithm.}
}
\value{
  \item{Qfn}{Returns the value of the Q-function in the Laplace-EM algorithm; entered into EM}
  \item{EM}{Returns the result of the EM algorithm after \code{niter} steps. It results in a list
  \itemize{
    \item{pars}{The (complete) optimized parameter vector}
    \item{coefs}{The coefficients optimized for \code{pars}}
    \item{Pres}{Optimization with respect to \code{pars[active]}}
    \item{Cres}{Optimization with respect to \code{coefs}}
  }}
}
\details{The Laplace-EM algorith proceeds by laplace approximations to the distribution of
\code{coefs} given \code{pars}. That is, we maximize the complete-data log likelihood for \code{coefs} and then
approximate this log likelihood with a second-order Taylor expansion about \code{coefs} at the maximizing value. The iteration has
the following steps

1. \code{C} = argmin \code{CDLL(pars,coefs)} = argmin \code{lik(pars,coefs)} + \code{proc(pars,coefs)}

2. \code{Qfn(pars,newpars)} =  \code{CDLL(pars,C)} + [d2\code{CDLL(pars,C)}/d\code{C}2][d2\code{CDLL(newpars,C)}/d\code{C}2]

3. \code{newpars} = argmin \code{Qfn(pars,newpars)}
}
\seealso{sse.setup, multinorm.setup, Profile.sse, Profile.multinorm, inneropt}
\examples{}
